C      CORRELATOR MODULE DEFILE
C
C***********************************************************************
C
C                    CORRELATION SETS TO DISPLAY.
C
C***********************************************************************
C
      SUBROUTINE DEFILE(LINE,*)
C
      INCLUDE 'log.inc'
C
      CHARACTER*4 BOMU
      LOGICAL PRNTFL
      CHARACTER*1 XCFLAG
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
C
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /WCCMIN/  WCCMIN
      COMMON /ZSLDEE/ ZSHAL,ZDEEP
      COMMON /DSLDEE/ DSHAL(21),DDEEP(21)
      COMMON /DDEEPM/ DDEEPM(21)
      COMMON /MAXNZ/  MAXNZ
C
      COMMON /RLEVEL/ RELEV1,RELEV2
             REAL*4 RELEV1(20),RELEV2(20)
      COMMON /WSYMBL/ SYMBL1,SYMBL2
             INTEGER*4 SYMBL1(20),SYMBL2(20)
      COMMON /WIDENT/ IDENT1,IDENT2
             INTEGER*4 IDENT1(20),IDENT2(20)
      COMMON /WNAMES/ WNAME1,WNAME2
             CHARACTER*20 WNAME1(20),WNAME2(20)
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /LABELL/ LDSHAR,LDCORR,LDSHAM,LDCORM
             CHARACTER*4 LDCORM(20),LDCORR(20)
             CHARACTER*4 LDSHAM(20),LDSHAR(20)
C
      COMMON /NCO/    NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG
             REAL*4 COLENG(LOG_LENGTH,20)
      COMMON /SLENTH/ SEALEN
             REAL*4 SEALEN(LOG_LENGTH,20)
      COMMON /WCCOEF/ WCCOE
             REAL*4 WCCOE(LOG_LENGTH,20)
C
      COMMON /CHARH/ FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
C
      include 'corrdb.inc'
      include 'wldwel.inc'
      include 'wldhdr.inc'
      include 'welldb.inc'
C
      SHDIST=0.0
      WCCMIN = 1.0E30
      ZSHAL =  1.0E30
      ZDEEP = -1.0E30
      MAXNZ = 0
      PRNTFL=.FALSE.
      IWPWCI=0
      CALL ANMODE
C
      DO 200 IPAIRS=1,NPAIRS
      NPS=IPAIRS
C
C          CHECK FOR ERRORS.
C
      ID1=WSNUMB(IPAIRS)
      ID2=WSNUMB(IPAIRS+1)
      CALL RWELLH
      WRITE (QTEKOT,9701) ID1,NAME1
      WRITE (QTEKOT,9702) ID2,NAME2
 9701 FORMAT (///,5X,'REFERENCE WELL (',I2,'): ',A20)
 9702 FORMAT (    5X,'MATCHING WELL  (',I2,'): ',A20)
      HWDIST = XYTODC * SQRT((WLXLOC(ID1)-WLXLOC(ID2))**2+
     1                       (WLYLOC(ID1)-WLYLOC(ID2))**2)
      SHDIST=SHDIST+HWDIST
      WRITE (QTEKOT,9703) HWDIST,BOMU(BOM)
 9703 FORMAT (/,5X,'DISTANCE BETWEEN WELLS: ',F10.1,1X,A4)
C
      IDENT1(NPS)=ID1
      IDENT2(NPS)=ID2
      HDISTC(NPS)=HWDIST
      CALL GETWEL(IWLPTR(ID1),IWELLR)
      WNAME1(NPS)=WELLDS
      SYMBL1(NPS)=IWPSCD
      RELEV1(NPS)=FDELEV
      DEPRMN=DEPMIN-FDELEV
      DEPRMX=DEPMAX-FDELEV
      ISL=ISHLLG(ID1)
      ICL=ICORLG(ID1)
      LDSHAR(NPS)=LOGNMM(ISL)
      LDCORR(NPS)=LOGNMM(ICL)
      CALL GETWEL(IWLPTR(ID2),IWELLR)
      WNAME2(NPS)=WELLDS
      SYMBL2(NPS)=IWPSCD
      RELEV2(NPS)=FDELEV
      DEPMMN=DEPMIN-FDELEV
      DEPMMX=DEPMAX-FDELEV
      ISL=ISHLLG(ID2)
      ICL=ICORLG(ID2)
      LDSHAM(NPS)=LOGNMM(ISL)
      LDCORM(NPS)=LOGNMM(ICL)
C
      NCORRL(NPS)=0
      CALL FINDCP(0,ID1,ID2)
      IF (NCPWEL .LT. 1) THEN
         WRITE (QTEKOT,9704)
 9704    FORMAT (/,'**** NO CORRELATION INTERPRETATIONS.')
         CPNUMB(NPS)=0
         ICP=0
         GO TO 202
        ENDIF
      ICP=0
      DO 201 I=1,NCPWEL
      IS=I
      IF (CPNUMB(NPS) .EQ. ICPWEL(I)) THEN
         ICP=CPNUMB(NPS)
         GO TO 2010
      END IF
  201 CONTINUE
 2010 IF (ICP .LT. 1) THEN
         WRITE (QTEKOT,9705)
 9705    FORMAT (/,'**** INVALID CORRELATION INTERPRETATION.')
         CPNUMB(NPS)=0
         GO TO 202
        ENDIF
      CALL RCPHDR(ICP)
      IF (NNNNCP .LT. 1) THEN
         WRITE (QTEKOT,9706)
 9706    FORMAT (/,'**** NO CORRELATIONS FOR SELECTED INTERPRETATION.')
         NNNNCP=0
         CPNUMB(NPS)=0
         ICP=0
        ELSE
         WRITE (QTEKOT,9716) IS,CPTITL
 9716    FORMAT (/,5X,'INTERPRETATION (',I1,'): ',A40)
        ENDIF
      NZ=NNNNCP
      NCORRL(NPS)=NZ
  202 IF (ICP .LT. 1) THEN
         DSHAL(NPS)=DEPRMN
         IF (DEPRMN .LT. ZSHAL) ZSHAL=DEPRMN
         DDEEP(NPS)=DEPRMX
         IF (DEPRMX .GT. ZDEEP) ZDEEP=DEPRMX
         GO TO 200
        ENDIF
      IWPWCI=IWPWCI+1
      WRITE (QTEKOT,9707) NZ
 9707 FORMAT (5X,'NUMBER OF CORRELATIONS IN SELECTED INTERPRETATION: ',
     1        I5)
      CALL REDCPI
      DO 111 I=1,NZ
      CALL REDCPR(Z1,Z2,XCFLAG,CORLEN,SEARLE,SKIP,CUTOFF,WCC)
      COMAT (I,NPS   ) = Z1
      COMAT (I,NPS+20) = Z2
      COLENG(I,NPS) = CORLEN
      SEALEN(I,NPS) = SEARLE
      WCCOE (I,NPS) = WCC
      IF ( WCCOE(I,NPS) .LT. WCCMIN ) WCCMIN = WCCOE(I,NPS)
  111 CONTINUE
C
C...  LOAD CORRELATION INTERPRETATION
C
C
C          REFERENCE WELL ELEVATIONS IN ASCENDING ORDER.
      IF (NZ .GT. MAXNZ) MAXNZ = NZ
      IF (WCCOE(1,NPS) .LT. WCCMIN) WCCMIN=WCCOE(1,NPS)
      IF (NZ .EQ. 1) GO TO 194
      DO 140 J=1,NZ-1
C      IF ( WCCOE(J,NPS) .LT. WCCMIN ) WCCMIN = WCCOE(J,NPS)
      Z1 =COMAT(J,NPS)
      Z1P=COMAT(J+1,NPS)
      IF (Z1P .LE. Z1) THEN
         PRNTFL=.TRUE.
         IF (Z1P .EQ. Z1) THEN
C
C           NON-REPEATING REFERENCE WELL ELEVATIONS.
C
            WRITE (QTEKOT,9912) Z1,BOMU(BOM)
 9912       FORMAT ('***** DUPLICATED ELEVATION IN REFERENCE WELL AT ',
     1               F7.1,' ',A4)
           ELSE
            WRITE (QTEKOT,9913) Z1P,Z1,BOMU(BOM)
 9913       FORMAT ('***** ELEVATION NOT IN ASCENDING ORDER. ',F7.1,
     1              ' AFTER ',F7.1,' ',A4)
           ENDIF
        ENDIF
C
C          NON-CROSSING CORRELATIONS
C
      IF (COMAT(J+1,NPS+20) .LT. COMAT(J,NPS+20)) THEN
         PRNTFL=.TRUE.
         WRITE (QTEKOT,9915) Z1P,BOMU(BOM)
 9915    FORMAT ('***** CROSSING CORRELATION AT ',F7.1,' ',A4)
        ENDIF
  140 CONTINUE
C
C         SHALLOWEST AND DEEPEST CORRELATIONS.
C
  194 DSHAL(NPS) =  COMAT( 1,NPS) - COLENG(1,NPS)
      IF ( DSHAL(NPS) .LT. ZSHAL ) ZSHAL = DSHAL(NPS)
      DSHALNPSM =  COMAT( 1,NPS+20) - COLENG(1,NPS)
      IF ( DSHALNPSM .LT. ZSHAL ) ZSHAL = DSHALNPSM
      DDEEP(NPS) =  COMAT(NZ,NPS) + COLENG(NZ,NPS)
      IF ( DDEEP(NPS) .GT. ZDEEP ) ZDEEP = DDEEP(NPS)
      DDEEPM(NPS) =  COMAT(NZ,NPS+20) + COLENG(NZ,NPS)
      IF ( DDEEPM(NPS) .GT. ZDEEP ) ZDEEP = DDEEPM(NPS)
  200 CONTINUE
      IF (PRNTFL) THEN
         WRITE (QTEKOT,9916)
 9916    FORMAT (//,'***** TAKE CORRECTIVE ACTION BEFORE ATTEMPTING')
         WRITE (QTEKOT,9917)
 9917    FORMAT (6X,'TO DISPLAY CORRELATIONS AGAIN.')
         NPAIRS=0
         MAXNZ=0
         CALL RETKEY
         RETURN 1
       ELSE
      WRITE (QTEKOT,9718) SHDIST,BOMU(BOM)
 9718 FORMAT (//8X,'CROSS-SECTION LENGTH: ',F11.1,1X,A4)
      ENDIF
      IF (WCCMIN .GE. 1.0) WCCMIN = 0.9
      NPS1 = NPS + 1
      IF (CPNUMB(NPS) .GT. 0) THEN
         DSHAL(NPS1) =  COMAT( 1,NPS+20) - COLENG(1,NPS)
C         IF ( DSHAL(NPS1) .LT. ZSHAL ) ZSHAL = DSHAL(NPS1)
         DDEEP(NPS1) =  COMAT(NZ,NPS+20) + COLENG(NZ,NPS)
C         IF ( DDEEP(NPS1) .GT. ZDEEP ) ZDEEP = DDEEP(NPS1)
        ELSE
         DSHAL(NPS1)=DEPMMN
         IF (DEPMMN .LT. ZSHAL) ZSHAL=DEPMMN
         DDEEP(NPS1)=DEPMMX
         IF (DEPMMX .GT. ZDEEP) ZDEEP=DEPMMX
        ENDIF
C
      IF ((MENU .EQ. 'PERS' .AND. IWPWCI .NE. NPAIRS) .OR.
     1    (MENU .EQ. 'TDIP' .AND. IWPWCI .NE. NPAIRS) .OR.
     2    (MENU .EQ. 'ADIP' .AND. IWPWCI .NE. NPAIRS)) THEN
         WRITE (QTEKOT,9931)
         NPAIRS=0
         MAXNZ=0
         CALL RETKEY
         RETURN 1
 9931    FORMAT (//,'**** FOR PLOTTING OR PRINTING PERSISTENT',1X,
     1              'CORRELATIONS,',/,5X,'ALL WELL PAIRS MUST',1X,
     2              'HAVE CORRELATION INTERPRETATIONS')
        ENDIF
      IF (MENU .EQ. 'TRAC' .AND. IWPWCI .NE. NPAIRS) THEN
         WRITE (QTEKOT,9932)
         NPAIRS=0
         MAXNZ=0
         CALL RETKEY
         RETURN 1
 9932    FORMAT (//,'**** FOR PLOTTING OR PRINTING MARKER',1X,
     1              'CORRELATIONS,',/,5X,'ALL WELL PAIRS MUST',1X,
     2              'HAVE A CORRELATION INTERPRETATION')
        ENDIF
C
      CALL RETKEY
      RETURN
      END
C***********************************************************************
C
C          CORRELATION BOX BOUNDARIES.
C
C***********************************************************************
C
      SUBROUTINE BXBOUN(YSTART)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
C
      IF ( DATUMF .EQ. 2 ) THEN
         XBOT=XTOP+((CEND+CSTART)/VSCALE)
      ELSE
         XBOT=XTOP+((CEND-CSTART)/VSCALE)
      END IF
      YLEFT=0.05+YSTART+(2.0*TKWD)+DSWH
      RETURN
      END
C***********************************************************************
C
C                  TOP AND BOTTOM FOR THE INTERVAL TO PLOT.
C
C***********************************************************************
C
      SUBROUTINE TOPBOT(I,TOPZ,BOTZ)
C
      INCLUDE 'log.inc'
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /DIGS/ DIGS1,DIGS2
             REAL*4 DIGS1,DIGS2
      COMMON /CODINC/ DINC
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /DATMZZ/ DATUMZ
             REAL*4 DATUMZ(21)
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /DSLDEE/ DSHAL(21),DDEEP(21)
      COMMON /DDEEPM/ DDEEPM(21)
      COMMON /RBOTZ/ RBOTZ
C
      IF (DATUMF .EQ. 2 ) THEN
         TOPZ = DATUMZ(I) - CSTART
         BOTZ = DATUMZ(I) + CEND
       ELSE
         TOPZ = CSTART
         BOTZ = CEND
         IF ( MENU .NE. 'TDIP' ) THEN
            IF (AELG .EQ. 1 ) THEN
               DEND1 = SEQDEP(MAX(IL1,IL3),DIGS1,DINC)
               DEND2 = SEQDEP(MAX(IL2,IL4),DIGS2,DINC)
               BOTZ = AMIN1(BOTZ,AMAX1(DEND1,DEND2))
            END IF
         END IF
      END IF
      RBOTZ = AMIN1(BOTZ, 100.0+AMAX1(DDEEP(I),DDEEPM(I)))
      RETURN
      END
C***********************************************************************
C
C                  DEPTH FOR THE CENTER AND WIDTH
C                  OF THE INTERVAL TO PLOT.
C
C***********************************************************************
C
      SUBROUTINE CENWID(TOPZ,BOTZ,CENTER,WIDTH)
C
         CENTER = 0.5*(TOPZ + BOTZ)
         WIDTH =  0.5*(BOTZ - TOPZ)
      RETURN
      END
      SUBROUTINE RPSECT(XSIZE,YSIZE)
C
C                   REPORT ON OPTION 'PC'.
C
C***********************************************************************
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /COFIPR/ COFIPR
             CHARACTER*40 COFIPR
      COMMON /SPEFIL/ SPEFIL
             CHARACTER*40 SPEFIL
      COMMON /PRINTC/ FYLEPR
             CHARACTER*40 FYLEPR
      COMMON /FYLPLO/ FYLPLO
             CHARACTER*40 FYLPLO
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /FFAULT/ FFAULT
             CHARACTER*40 FFAULT
      COMMON /IFAULT/ IFAULT
         INTEGER*2 IFAULT
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /FYLDAT/ NDATUM
             CHARACTER*40 NDATUM
      COMMON /ROTATE/ ROT
             CHARACTER*1 ROT  
      COMMON /ELOD/  ELOD
             CHARACTER*1 ELOD
      COMMON /FILCOLITH/ FILCOLITH
             CHARACTER*40 FILCOLITH
C
      CALL ANMODE
      IF ( MENU .EQ. 'SECT' ) WRITE(QTEKOT,2004)
      IF ( MENU .EQ. 'LITH' ) WRITE(QTEKOT,2005)
      IF ( MENU .EQ. 'PORO' ) WRITE(QTEKOT,2006)
      IF ( MENU .EQ. 'LIT2' ) WRITE(QTEKOT,2007)
      WRITE(QTEKOT,2000) COFIPR,SPEFIL
      IF ( MENU .EQ. 'LIT2' ) WRITE(QTEKOT,2010) FILCOLITH
      IF ( DATUMF .EQ. 2 ) WRITE(QTEKOT,2003) NDATUM
      IF ( IFAULT .EQ. 1 ) WRITE(QTEKOT,2001) FFAULT
      if (rot .eq. 'L') then
         WRITE(QTEKOT,2002) FYLEPR,FYLPLO,XSIZE,YSIZE
        else
         write(qtekot,2002) fylepr,fylplo,ysize,xsize
        ENDIF
      IF (ELOD .EQ. 'E') then
         WRITE(QTEKOT,2008)
        ELSE
         WRITE(QTEKOT,2009)
      ENDIF
      CALL RETKEY
      RETURN
 2000 FORMAT(    8X,'SOURCE FILE                   ',A40/
     3           8X,'PLOTTING SPECIFICATION FILE   ',A40)
 2001 FORMAT(    8X,'FAULT FILE                    ',A40)
 2002 FORMAT(    8X,'PRINTING FILE                 ',A40/
     3           8X,'PLOT FILE                     ',A40/
     4           8X,'PLOT LENGTH ALONG PAPER ROLL',F6.1,' INCHES '/
     5           8X,'PLOT WIDTH ACROSS PAPER ROLL',F6.1,' INCHES ')
 2003 FORMAT(    8X,'DATUM FILE                    ',A40)
 2004 FORMAT(///25X,'PLOTTING AND LISTING OF CORRELATION FILES'/
     1          25X,'*****************************************'//)
 2005 FORMAT(///25X,'PLOTTING OF PROPORTION OF SHALE'/
     1          25X,'*******************************'//)
 2006 FORMAT(///25X,'PLOTTING OF POROSITY'/
     1          25X,'*********************'//)
 2007 FORMAT(///25X,'PLOTTING OF LITHOLOGY'/
     1          25X,'*********************'//)
 2008 FORMAT(    8X,'PLOT VERTICAL SCALE IS ELEVATION'//)
 2009 FORMAT(    8X,'PLOT VERTICAL SCALE IS DEPTH'//)
 2010 FORMAT(    8X,'LITHOLOGY FILE                ',A40)
      END
C***********************************************************************
C
C              INITIALIZE A PLOTTER FILE
C
C***********************************************************************
C
      SUBROUTINE PLOTIN(J1STIM)
C
      CHARACTER*2  OPTION
      CHARACTER*10 PLOTTER
      CHARACTER*1  PTYPE
      LOGICAL ERROR
C
      COMMON /PLOTU/ IPLOTU,IPS_FLAG,IP_SIZE,P_MARGIN,IBW_COL
      COMMON /FYLPLO/ FYLPLO
             CHARACTER*40 FYLPLO
      COMMON /COLOPT/ ICOLOR(6)
C
      IF ( J1STIM .EQ. 0 ) FYLPLO = '*????*'
C
C        MENU.
C
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'INITIALIZE A PLOTTING FILE')
      LINE=2
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3, LINE+2,'FN - NAME OF THE PLOTTING FILE')
      CALL GTXTRJ(75, LINE+2,FYLPLO)
      LINE=LINE+2
C
      IF ( IPS_FLAG .EQ. 0) THEN
	 PLOTTER = 'CALCOMP'
        ELSE
	 PLOTTER = 'POSTSCRIPT'
	ENDIF
      CALL GTEXTS( 3, LINE+2,'PL - SELECT CODE -- CALCOMP(C) OR '//
     1         'POSTSCRIPT(P)')
      CALL GTXTRJ(75, LINE+2,PLOTTER)
      LINE=LINE+2
C
      IF (IPS_FLAG .GT. 0) THEN
	 CALL GTEXTS( 3,LINE+2,'PS - SET PAPER SIZE')
	 CALL GTXTIN(75,LINE+2,IP_SIZE)
	 CALL TXTCLR(ICOLOR(5))
	 CALL GTEXTS( 8,LINE+3,'1 = A (8.5 X 11)  4 = D (22 X 34)    '//
     1                         '7 = G (50 X 1000)')
	 CALL GTEXTS( 8,LINE+4,'2 = B (11 X 17)   5 = E (34 X 1000)  '//
     1                         '8 = A4 (8.75 X 11.75)')
         CALL GTEXTS( 8,LINE+5,'3 = C (17 X 22)   6 = F (44 X 1000)  '//
     1                         '9 = A3 (11.75 X 16.5)')
         CALL TXTCLR(ICOLOR(3))
	 LINE=LINE+5

         IF (IP_SIZE .LT. 3  .OR.  IP_SIZE .GT. 7) THEN
	    CALL GTEXTS( 3,LINE+2,'MA - SET MARGIN SIZE OF PAPER')
	    CALL GTXTRL(75,LINE+2,P_MARGIN,3)
	    LINE=LINE+2
	   ENDIF
	ENDIF
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
      IF (FYLPLO .NE. '*????*') THEN
         CALL GTEXTS( 3,LINE+3,'GO - PLOT SECTION')
         LINE = LINE + 1
        ENDIF
      LINE = LINE + 2
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF (FYLPLO .NE. '*????*'  .AND.  OPTION .EQ. 'GO') GO TO 51
C
      IF (OPTION .EQ. 'FN') THEN
         CALL AGETST(FYLPLO,40)
         IF ( FYLPLO .EQ. ' ' ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(10,LINE+6,'***** FILE NAME UNDEFINED.')
            CALL SCHOLD
	    GO TO 11
          END IF
       END IF
C
      IF (OPTION .EQ. 'PL') THEN
	 CALL AGETST(PTYPE,1)
         IPS_FLAG=-1
         IF (PTYPE .EQ. 'C') THEN
	    IPS_FLAG = 0
	    PLOTTER = 'CALCOMP'
	   ENDIF
         IF (PTYPE .EQ. 'P') THEN
	    IPS_FLAG = 1
	    PLOTTER = 'POSTSCRIPT'
	   ENDIF
	 IF (IPS_FLAG .LT. 0) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(10,LINE+6,'***** INVALID PLOTTER SELECTION.')
            CALL SCHOLD
	    IPS_FLAG=0
	    GO TO 11
          END IF
         ENDIF
      IF (OPTION .EQ. 'PS') THEN
         CALL AGETIN(IP_SIZE,ERROR)
	 IF (ERROR) GO TO 11
         IF (IPS_FLAG .EQ. 1) THEN
	    IF (IP_SIZE .LT. 1  .OR. IP_SIZE .GT. 9) THEN
               CALL TXTCLR(ICOLOR(6))
               CALL GTEXTS(10,LINE+6,'***** INVALID PAPER SIZE.')
               CALL SCHOLD
	       IP_SIZE = 1
	       GO TO 11
	      ENDIF
	   ENDIF
        ENDIF
C
      IF (IPS_FLAG .EQ. 1  .AND.  (IP_SIZE .LT. 3  .OR.  
     1                  IP_SIZE .GT. 7)) THEN
         IF (OPTION .EQ. 'MA') THEN
            CALL AGETRL(P_MARGIN,ERROR)
	    IF (ERROR) GO TO 11
	    IF (P_MARGIN .LT. 0.2   .OR.   P_MARGIN .GT. 1.0) THEN
               CALL TXTCLR(ICOLOR(6))
               CALL GTEXTS(10,LINE+6,'***** INVALID PAPER MARGIN SIZE.')
               CALL SCHOLD
	       P_MARGIN = 0.2
	       GO TO 11
	    ENDIF
	 ENDIF
       ELSE
	 P_MARGIN = 0.0
      ENDIF
      GO TO 15
C
C          OPEN PLOTTER FILE
C
   51 IPLOTU=72
      IF (IPS_FLAG .EQ. 1  .AND.  (IP_SIZE .LT. 3  .OR.  
     1                  IP_SIZE .GT. 7)) THEN
	 IF (P_MARGIN .LT. 0.2   .OR.   P_MARGIN .GT. 1.0) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(10,LINE+6,'***** INVALID PAPER MARGIN SIZE.')
            CALL GTEXTS(16,LINE+7,'IT MUST BE BETWEEN 0.2 AND 1.0 '//
     1                  'INCHES')
            CALL SCHOLD
	    GO TO 11
	 ENDIF
      END IF
      J1STIM = 1
      CALL RPPF
      RETURN
      END
C***********************************************************************
C
C                   REPORT ON OPTION 'PF'.
C
C***********************************************************************
      SUBROUTINE RPPF
C
      IMPLICIT NONE
      CHARACTER*20 PS_SIZE(9)
C
      COMMON /PLOTU/ IPLOTU,IPS_FLAG,IP_SIZE,P_MARGIN,IBW_COL
	     INTEGER IPLOTU,IPS_FLAG,IP_SIZE,IBW_COL
	     REAL P_MARGIN
      COMMON /FYLPLO/ FYLPLO
             CHARACTER*40 FYLPLO
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      DATA PS_SIZE/
     X   'A (8.5 X 11)',
     X   'B (11 X 17)',
     X   'C (17 X 22)',
     X   'D (22 X 34)',
     X   'E (34 X 100)',
     X   'F (44 X 100)',
     X   'G (50 X 100)',
     X   'A4 (8,75 X 11,75)',
     X   'A3 (11.75 X 16.5)'   /
C
      CALL ANMODE
      IF (IPS_FLAG .EQ. 0) THEN
         WRITE(QTEKOT,2000) FYLPLO

	ELSE
         WRITE(QTEKOT,2011) FYLPLO,PS_SIZE(IP_SIZE),P_MARGIN
	ENDIF
      CALL RETKEY
      RETURN
 2000 FORMAT(///25X,
     1       'INITIALIZATION OF PLOTTING FILE FOR CALCOMP FORMAT'/
     2   25X,'**************************************************'///
     3    8X,'FILE NAME           ',A40//)
 2011 FORMAT(///25X,
     1      'INITIALIZATION OF PLOTTING FILE FOR POSTSCRIPT FORMAT'/
     2  25X,'*****************************************************'///
     3   8X,'FILE NAME             ',A40//,
     4   8X,'PAPER SIZE            ',A20,/,
     5   8X,'MARGIN SIZE OF PAPER  ',F10.3)
      END
C***********************************************************************
C
C                    READ IN POSTING OPTIONS AND
C                       GEOMETRIC PARAMETERS.
C
C***********************************************************************
C
      SUBROUTINE READAT(J1STIM,OPTION,LINE,IOPT,NISECT)
C
      CHARACTER*1 EA
      CHARACTER*68 TXTMES
      LOGICAL ERROR
      CHARACTER*2 OPTION
      CHARACTER*1 AIFSC
      CHARACTER*1 ALITHF
      CHARACTER*4 BOMU
      CHARACTER*70 MTITL(8)
      CHARACTER*3 DATEXT(2)
      CHARACTER*5 DATSC(4)
      CHARACTER*4 LABEL
      LOGICAL XSFLAG
      LOGICAL PETROPHYSICS
C
      DATA DATEXT / 'YES','NO'/
      DATA DATSC / 'NONE','LEFT','RIGHT','BOTH'/
      DATA MTITL/
     1  'PLOTTING AND PRINTING OF CORRELATION FILES',
     2  'PLOT AND PRINT PERSISTENT CORRELATIONS IN A CROSS SECTION',
     3  'PLOT AND PRINT TRACED CORRELATIONS IN A CROSS SECTION',
     4  'PREPARATION OF APPARENT DIP DIAGRAMS',
     5  'PREPARATION OF TRUE DIP DIAGRAMS',
     6  'HARDCOPY DISPLAY OF THE PROPORTION OF SHALE',
     7  'HARDCOPY DISPLAY OF SHALE CORRECTED POROSITY' ,
     8  'DISPLAY OF LITHOLOGY' /
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      COMMON /COFIPR/ COFIPR
             CHARACTER*40 COFIPR
      COMMON /SPEFIL/ SPEFIL
             CHARACTER*40 SPEFIL
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /DATMZZ/ DATUMZ(21)
C
      COMMON /TITLE/ TITLE1,TITLE2
             CHARACTER*80 TITLE1,TITLE2
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER*4 IHFC,IHPFC,JUSTIF,FONT,FONTTL
C
      COMMON /CHARPP/ SON
             CHARACTER*1 SON
      COMMON /LOGMAX/ SHLLMX,CORLMX
      COMMON /DCI/ DCI
             CHARACTER*1 DCI
      COMMON /ROTATE/ ROT                               !KLP 11/13/89
             CHARACTER*1 ROT                            !KLP 11/13/89
      COMMON /DORIGIN/ DEPOR
             CHARACTER*1 DEPOR
      common /select/ pltsel                            ! klp 7/26/90
             character*1 pltsel                         ! klp 7/26/90
      COMMON /INCZ/ INCZ
      COMMON /FFAULT/ FFAULT
             CHARACTER*40 FFAULT
      COMMON /FYLDAT/ NDATUM
             CHARACTER*40 NDATUM
      COMMON /LOGSZ/ LOGSZ
             REAL*4 LOGSZ
      COMMON /MENUPP/  MENU
             CHARACTER*4 MENU
      COMMON /TRACNG/ TSTART,TEND
      COMMON /FYLTRA/ FILTRA
      CHARACTER*40 FILTRA
      COMMON /SHADOP/ SHADOP
             INTEGER*2 SHADOP
      COMMON /ZSLDEE/ ZSHAL,ZDEEP
      COMMON /DSLDEE/ DSHAL(21),DDEEP(21)
      COMMON /SHADEE/ ZSHALD,ZDEEPD
C
      COMMON /YSTARTI/ YSTARTI
      COMMON /YSTART/ YSTART
      COMMON /BBOTM/ BBOTM
      COMMON /WTHLEG/ WTHLEG
      COMMON /MAXNZ/  MAXNZ
C            NAME OF FILE WITH ANNOTATION IN THE STRATIGRAPHIC COLUMN.
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /IFSC/ IFSC
      COMMON /NCOCLA/ NCOCLA
             CHARACTER*1 NCOCLA
      COMMON /PORPAR/ PORMAX, PHISHALE
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /LITHF/ LITHF
      COMMON/UNCOHI/ UNCOHI
      COMMON /FILCOLITH/ FILCOLITH
      CHARACTER*40 FILCOLITH
      COMMON /ELOD/  ELOD
             CHARACTER*1 ELOD
C
      include 'wldwel.inc'
      include 'corrdb.inc'
C
      ZLSZ=0.10
      JUSTIF=0
      LOGSZ=0.12
C      XTOP=12.0
      TTLSZ=0.30
      WIDSZ=0.15
      WTHLEG = 5.0
      XSFLAG = (GWXMIN .NE. GWXMAX) .OR. (GWYMIN .NE. GWYMAX)
      UNCOHI = 0.02
C
      IF ( J1STIM .EQ. 0 ) THEN
         COFIPR = '*????*'
         SPEFIL = '*????*'
         SHADOP= 2
         FILTRA = '*????*'
         DCI = 'A'
         IERFAU = 0
         NPAIRS = 0
         J1STIM = 1
         NCOCLA = '4'
         PHISHALE = 0.23
         PORMAX = 0.25
         FILCOLITH = '*????*'
         DEPOR = 'K'
       END IF
      NISECT = NPAIRS
C
      PETROPHYSICS = MENU .EQ. 'LITH'  .OR.  MENU .EQ. 'PORO'
C
C        MENU.
C
      IFLAG = 0  ! new
   11 CALL MNMODE
C       IFLAG = 0
      BBOTM = -1.0
      YSTART = YSTARTI
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,MTITL(IOPT))
      LINE=3
      CALL TXTCLR(ICOLOR(5))
      CALL GTEXTS( 3,LINE+1,
     1     'SF - SOURCE FILE WITH CORRELATION INTERPRETATIONS')
      CALL GTXTRJ(79,LINE+1,COFIPR)
      IF (XSFLAG) THEN
         LINE = LINE + 1
         CALL GTEXTS( 3,LINE+1,
     1        'XS - SELECT INTERPRETATIONS TO PLOT FROM WINDOW POSTING')
         CALL MARROW(79,LINE+1)
        ENDIF 
      IF ( NPAIRS .GT. 0) THEN
         CALL GTEXTS( 3,LINE+2,'SP - FILE WITH PLOTTING SPECIFICATIONS')
         CALL GTXTRJ(79,LINE+2,SPEFIL)
         LINE = LINE + 1
      END IF
      IF ( NPAIRS .LT. 1 .OR . SPEFIL .EQ. '*????*') THEN
         CALL TXTCLR(ICOLOR(3))
         CALL GTEXTS(3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
         LINE = LINE + 3
         GO TO 14
      END IF
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'T1 - FIRST TITLE')
      CALL GTXTRJ(79,LINE+2,TITLE1)
      CALL GTEXTS( 3,LINE+3,'T2 - SECOND TITLE')
      CALL GTXTRJ(79,LINE+3,TITLE2)
      CALL GTXTRJ(79,LINE+4,DATSC(IFSC+1))
      IF (MENU .EQ. 'ADIP'  .OR. MENU .EQ. 'TDIP') THEN
         CALL GTEXTS( 3,LINE+4, 'SC - TEXT IN STRATIGRAPHIC '//
     1             'COLUMN TO THE LEFT(L) OR NONE(N)')
       ELSE
         CALL GTEXTS( 3,LINE+4, 'SC - TEXT IN STRAT. COLUMN TO '//
     1             'LEFT(L), RIGHT(R), BOTH(B), OR NONE(N)')
         CALL GTEXTS( 8,LINE+5, '')
      END IF
         IF (IFSC .EQ. 1  .OR.  IFSC .EQ. 3) THEN
            CALL GTEXTS( 3,LINE+5,'SL - NAME OF FILE '//
     1     'WITH TEXT FOR STRATIGRAPHIC COLUMN TO THE LEFT')
            CALL GTXTRJ(79,LINE+5,STRACOFL)
            LINE = LINE + 1
         END IF
         IF (IFSC .EQ. 2  .OR.  IFSC .EQ. 3) THEN
            CALL GTEXTS( 3,LINE+5,'SR - NAME OF FILE '//
     1     'WITH TEXT FOR STRATIGRAPHIC COLUMN TO THE RIGHT')
            CALL GTXTRJ(79,LINE+5,STRACOFR)
            LINE = LINE + 1
         END IF
      LINE = LINE + 1
      CALL GTXTRJ(79,LINE+4,DATSC(LITHF+1))
      IF (MENU .EQ. 'ADIP'  .OR. MENU .EQ. 'TDIP') THEN
         CALL GTEXTS( 3,LINE+4, 'LA - LITHOLOGY IN '//
     1             'STRATIGRAPHIC COLUMN TO LEFT(L) OR NONE(N)')
       ELSE
         CALL GTEXTS( 3,LINE+4, 'LA - LITHOLOGY IN COLUMN '//
     1             'TO LEFT(L), RIGHT(R), BOTH(B), OR NONE(N)')
      END IF
         IF (LITHF .EQ. 1  .OR.  LITHF .EQ. 3)  THEN
            CALL GTEXTS( 3,LINE+5,'LL - NAME OF '//
     1      'LITHOLOGY FILE FOR STRATIGRAPHIC COLUMN TO THE LEFT')
            CALL GTXTRJ(79,LINE+5,LFILEL)
            LINE = LINE + 1
         END IF
         IF (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)  THEN
            CALL GTEXTS( 3,LINE+5,'LR - NAME OF '//
     1      'LITHOLOGY FILE FOR STRATIGRAPHIC COLUMN TO THE RIGHT')
            CALL GTXTRJ(79,LINE+5,LFILER)
            LINE = LINE + 1
         END IF
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,LINE+5,
     1           'DA - USE '//DATUM//' AS DATUM, YES(Y) OR NO(N)')
      CALL GTXTRJ(79,LINE+5,DATEXT(DATUMF))
      IF (DATUMF .EQ. 2) THEN
         CALL GTEXTS( 3,LINE+6,
     1  'DF - DATUM FILE WITH DEPTHS FOR THE NEW REFERENCE SURFACE')
         CALL GTXTRJ(79,LINE+6,NDATUM)
         IF (NDATUM .NE. '*????*' )THEN
            CALL GTEXTS( 3,LINE+7,'AD - ELEVATION ABOVE '//
     1  'DATUM FOR STARTING PLOTTING, '//BOMU(BOM))
            CALL GTXTRL(79,LINE+7,ZSHALD,2)
            CALL GTEXTS( 3,LINE+8,'BD - DEPTH BELOW DATUM FOR '//
     1      'ENDING PLOTTING, ' // BOMU(BOM))
            CALL GTXTRL(79,LINE+8,ZDEEPD,2)
            LINE = LINE + 1
          ELSE
            LINE = LINE - 1
         END IF
       ELSE
C
         CALL GTEXTS( 3,LINE+6,
     1        'ND - STARTING DEPTH FOR PLOTTING, ' // BOMU(BOM))
         CALL GTXTRL(79,LINE+6,ZSHAL,2)
         CALL GTEXTS( 3,LINE+7,
     1        'XD - ENDING DEPTH FOR PLOTTING, ' // BOMU(BOM))
         CALL GTXTRL(79,LINE+7,ZDEEP,2)
      END IF
C
      CALL TXTCLR(ICOLOR(5))
      CALL GTEXTS( 3,LINE+8,
     1     'VS - VERTICAL DEPTH SCALE, ' // BOMU(BOM) // '/IN')
      CALL GTXTRL(79,LINE+8,VSCALE,2)
      IF (MENU .EQ. 'ADIP'  .OR. MENU .EQ. 'TDIP') THEN
        CALL GTEXTS( 3,LINE+9,
     1     'HS - HORIZONTAL SCALE, DEGREES/IN')
        CALL GTXTRL(79,LINE+9,HSCALE,4)
       ELSE
        CALL GTEXTS( 3,LINE+9,
     1     'HS - HORIZONTAL DISTANCE SCALE, ' // BOMU(BOM) // '/IN')
        CALL GTXTRL(79,LINE+9,HSCALE,2)
      END IF
      LINE=LINE+9
C
      IF (MENU .EQ. 'SECT') THEN
         CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS(3,LINE+1,
     ^'TL - FOR EACH CORRELATED INTERVAL, DISPLAY ALL TIE LINES(A)')
      CALL GTEXTS(8,LINE+2,
     ^'OR ONLY A LINE FROM CENTER TO CENTER(C)')
      CALL GTXTRJ(79,LINE+1,DCI)
         LINE = + LINE + 2
      END IF
      IF (MENU .EQ. 'ADIP'  .OR. MENU .EQ. 'TDIP') THEN
         WRITE (TXTMES,1201) BOMU(BOM)
 1201   FORMAT('ST - STARTING DEPTH FOR DIAGRAMS, ',A4)
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS(3,LINE+1,TXTMES)
         CALL GTXTRL(79,LINE+1,TSTART,2)
         WRITE (TXTMES,1202) BOMU(BOM)
 1202    FORMAT('ET - ENDING DEPTH FOR DIAGRAMS, ',A4)
         CALL GTEXTS(3,LINE+2,TXTMES)
         CALL GTXTRL(79,LINE+2,TEND,2)
         LINE = LINE + 2
      END IF
      IF (MENU .EQ. 'PERS') THEN
         WRITE (TXTMES,2201) BOMU(BOM)
 2201   FORMAT('ST - STARTING DEPTH FOR TRACING ',
     1         'FROM THE LEFTMOST WELL, ',A4)
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS(3,LINE+1,TXTMES)
         CALL GTXTRL(79,LINE+1,TSTART,2)
         WRITE (TXTMES,2202) BOMU(BOM)
 2202    FORMAT('ET - ENDING DEPTH FOR TRACING',
     1          ' FROM THE LEFTMOST WELL, ',A4)
         CALL GTEXTS(3,LINE+2,TXTMES)
         CALL GTXTRL(79,LINE+2,TEND,2)
         LINE = LINE + 2
      END IF
      IF (MENU .EQ. 'TRAC') THEN
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS(3,LINE+1,
     1  'MF - NAME OF THE MARKER FILE WITH ELEVATIONS TO TRACE ACROSS')
         CALL GTXTRJ(79,LINE+1,FILTRA)
         LINE = LINE + 1
      END IF
      IF (PETROPHYSICS) THEN
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS( 3,LINE+1,
     1 'NC - NUMBER OF CLASSES: FIVE(5), MERGE 4 & 5(4), MERGE 1 & 2 ')
         CALL GTEXTS(8,LINE+2,
     1 'AND 3 & 4 & 5(3), OR MERGE 1 & 2 & 3 AND 4 & 5(2)')
         CALL GTXTRJ(79,LINE+2,NCOCLA)
         LINE = LINE + 2
      END IF
      IF (MENU .EQ. 'PORO') THEN
         CALL GTEXTS( 3,LINE+1, 
     1             'MP - MAXIMUM VALUE IN POROSITY SCALE, SCALE (0-1)')
         CALL GTXTRL(79,LINE+1,PORMAX,2)
         CALL GTEXTS( 3,LINE+2, 'AP - APPARENT POROSITY OF SHALE, '//
     1                          'SCALE (0-1)')
         CALL GTXTRL(79,LINE+2,PHISHALE,2)
         LINE = LINE + 2
      END IF
      IF (MENU .EQ. 'LIT2') THEN
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS(3,LINE+1,
     1  'LC - NAME OF FILE WITH LITHOLOGIES TO TRACE ACROSS')
         CALL GTXTRJ(79,LINE+1,FILCOLITH)
         LINE = LINE + 1
      END IF
      IF (.NOT.(MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')) THEN ! 
         LINE = LINE + 1
         CALL TXTCLR(ICOLOR(3))
         CALL GTEXTS( 3,LINE,
     1            'FM - FAULT MODELING, YES(Y) OR NO(N)')
         CALL GTXTRJ(79,LINE,DATEXT(IFAULT))
         IF (IFAULT .EQ. 1) THEN
            CALL GTEXTS( 3,LINE+1,
     1     'FF - FILE WITH INFORMATION ABOUT THE FAULTS')
            CALL GTXTRJ(79,LINE+1,FFAULT)
            LINE = LINE + 1
         END IF
      END IF
      CALL TXTCLR(ICOLOR(5))
      CALL GTEXTS( 3,LINE+1,
     1      'MD - MORE DRAWING SPECIFICATIONS')
      CALL MARROW(79,LINE+1)
      CALL TXTCLR(ICOLOR(3))
C      LINE = LINE + 1
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
   12 IF ((NISECT .GT. 0) .AND. (SPEFIL .NE. '*????*')
     1    .AND.  .NOT. ( MENU .EQ. 'TRAC'  .AND.  FILTRA .EQ. '*????*')
     2    .AND.  .NOT. ( DATUMF .EQ. 2  .AND.  NDATUM .EQ. '*????*')
     3    .AND.  .NOT. ( (IFSC .EQ. 1  .OR.  IFSC .EQ. 3)  
     4            .AND.  STRACOFL .EQ. '*????*')
     5    .AND.  .NOT. ( (IFSC .EQ. 2  .OR.  IFSC .EQ. 3)  
     6            .AND.  STRACOFR .EQ. '*????*' )
     7    .AND.  .NOT. ( (LITHF .EQ. 1  .OR.  LITHF .EQ. 3)  
     8            .AND.  LFILEL .EQ. '*????*')
     9    .AND.  .NOT. ( (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)  
     &            .AND.  LFILER .EQ. '*????*' )
     1    .AND.  .NOT. ( IFAULT .EQ. 1  .AND.  FFAULT .EQ. '*????*') 
     2    .AND.  .NOT.( MENU .EQ. 'LIT2' .AND. FILCOLITH .EQ. '*????*')
     3    .AND. IFLAG .EQ. 0 )  THEN
        CALL GTEXTS(3,LINE+3,'GO - PLOT CROSS SECTION')
         LINE = LINE + 1
      ENDIF
   13 LINE = LINE + 3
C
   14 CALL TXTCLR(ICOLOR(4))
      LINE = LINE + 1
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
      IF (OPTION .EQ. 'RE') GO TO 900
   41 IF ((NISECT .GT. 0) .AND. (SPEFIL .NE. '*????*') 
     1   .AND.  .NOT. ( MENU .EQ. 'TRAC'  .AND.  FILTRA .EQ. '*????*')
     2   .AND.  .NOT. ( DATUMF .EQ. 2  .AND.  NDATUM .EQ. '*????*')
     3    .AND.  .NOT. ( (IFSC .EQ. 1  .OR.  IFSC .EQ. 3)  
     4            .AND.  STRACOFL .EQ. '*????*')
     5    .AND.  .NOT. ( (IFSC .EQ. 2  .OR.  IFSC .EQ. 3)  
     6            .AND.  STRACOFR .EQ. '*????*' )
     7    .AND.  .NOT. ( (LITHF .EQ. 1  .OR.  LITHF .EQ. 3)  
     8            .AND.  LFILEL .EQ. '*????*')
     9    .AND.  .NOT. ( (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)  
     &            .AND.  LFILER .EQ. '*????*' )
     1   .AND.  .NOT. ( IFAULT .EQ. 1  .AND.  FFAULT .EQ. '*????*')
     2    .AND.  .NOT.( MENU .EQ. 'LIT2' .AND. FILCOLITH .EQ. '*????*')
     3   .AND.  (OPTION .EQ. 'GO')) GO TO 51
C
   43 IF (OPTION .EQ. 'SF') THEN
         NISECT=0
         STRACOFL = '*????*'
         STRACOFR = '*????*'
         CALL AGETST(COFIPR,40)
         IF (COFIPR .EQ. ' ') THEN
            COFIPR = '*????*'
            GO TO 11
           ENDIF
         CALL CHKOTY(24,COFIPR,0,12,5,LINE+2,ICKERR)
         IF ( ICKERR .NE. 0 ) GO TO 11
         READ (24,9411,REC=1) LABEL,NUSF
 9411    FORMAT (A4,I5)
         DO 101 I=1,NUSF
         IF (I .LT. NUSF) THEN
            READ (24,FMT='(2I5)',REC=I+1) WSNUMB(I),CPNUMB(I)
           ELSE
            READ (24,FMT='(I5)',REC=I+1) WSNUMB(I)
           ENDIF
  101    CONTINUE
         CLOSE(24,STATUS='KEEP')
         NPAIRS=NUSF-1
         IF (NPAIRS .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS( 6,LINE+3,
     1                  '**** LESS THAN TWO WELLS IN SOURCE FILE')
            CALL SCHOLD
            GO TO 11
           ENDIF
         CALL DEFILE(LINE,*11)
         IF ((MENU .EQ. 'PERS'  .AND.  MAXNZ .EQ. 0)  .OR.
     1       (MENU .EQ. 'TRAC'  .AND.  MAXNZ .EQ. 0)  .OR.
     2       (MENU .EQ. 'ADIP'  .AND.  MAXNZ .EQ. 0)  .OR.
     3       (MENU .EQ. 'TDIP'  .AND.  MAXNZ .EQ. 0))  THEN
               OPTION = 'RE'
               GO TO 900
            ENDIF
         NISECT=NPAIRS
         TSTART = DSHAL(1)
         TEND = DDEEP(1) 
C         GO TO 15   ! 2001
        ENDIF
C
      IF (OPTION .EQ. 'XS' .AND. XSFLAG) THEN
         CALL XSMENU
         NISECT=0
         STRACOFL = '*????*'
         STRACOFR = '*????*'
         IF (NPAIRS .LT. 1) GO TO 11
         CALL DEFILE(LINE,*11)
         IF ((MENU .EQ. 'PERS'  .AND.  MAXNZ .EQ. 0)  .OR.
     1       (MENU .EQ. 'TRAC'  .AND.  MAXNZ .EQ. 0)  .OR.
     2       (MENU .EQ. 'ADIP'  .AND.  MAXNZ .EQ. 0)  .OR.
     3       (MENU .EQ. 'TDIP'  .AND.  MAXNZ .EQ. 0))  THEN
               OPTION = 'RE'
               GO TO 900
            ENDIF
         NISECT=NPAIRS
         TSTART = DSHAL(1)
         TEND = DDEEP(1)
         GO TO 11
        ENDIF
C
      IF (OPTION .EQ. 'SP') THEN
         CALL AGETST(SPEFIL,40)
         IF (SPEFIL .EQ. ' ') GO TO 111
         CALL GETSPE(LINE+2,*111)
         GO TO 112
  111    SPEFIL = '*????*'
         GO TO 113
  112    IF ( FFAULT .NE. '*????*' ) CALL REFAUL(LINE,IERFAU,*1122)
 1122     IF ( IERFAU .NE. 0) FFAULT = '*????*'
         IF ( NDATUM .NE. '*????*' ) CALL REDATU(LINE,IER,*1123)
 1123     IF ( IER .NE. 0) NDATUM = '*????*'
         IF ( STRACOFL .NE. '*????*' ) CALL CHKSC(LINE,1,IER,*1124)
 1124     IF ( IER .NE. 0) STRACOFL = '*????*'
        IF ( STRACOFR .NE. '*????*' ) CALL CHKSC(LINE,2,IER,*1125)
 1125     IF ( IER .NE. 0) STRACOFR = '*????*'
         IF ( LFILEL .NE. '*????*' ) CALL CHKLITHO(LINE,1,IER,*1127)
 1127     IF ( IER .NE. 0) LFILEL = '*????*'
         IF ( LFILER .NE. '*????*' ) CALL CHKLITHO(LINE,2,IER,*1128)
 1128     IF ( IER .NE. 0) LFILER = '*????*'
      ENDIF
  113 IF (OPTION .EQ. 'T1') CALL AGETTX(TITLE1)
      IF (OPTION .EQ. 'T2') CALL AGETTX(TITLE2)
      IF (OPTION .EQ. 'SC') THEN
         CALL AGETST(AIFSC,1)
         IF ( AIFSC .EQ. 'N' ) THEN
            IFSC = 0
          ELSE IF( AIFSC .EQ. 'L' ) THEN
            IFSC = 1
         END IF
         IF (MENU .EQ. 'ADIP'  .OR. MENU .EQ. 'TDIP') GO TO 1135
         IF( AIFSC .EQ. 'R' ) THEN
            IFSC = 2
          ELSE IF( AIFSC .EQ. 'B' ) THEN
            IFSC = 3
         END IF
      END IF
 1135 IF (OPTION .EQ. 'LA') THEN
         CALL AGETST(ALITHF,1)
         IF ( ALITHF .EQ. 'N' ) THEN
            LITHF = 0
          ELSE IF( ALITHF .EQ. 'L' ) THEN
            LITHF = 1
         END IF
         IF (MENU .EQ. 'ADIP'  .OR. MENU .EQ. 'TDIP') GO TO 114
         IF( ALITHF .EQ. 'R' ) THEN
            LITHF = 2
          ELSE IF( ALITHF .EQ. 'B' ) THEN
            LITHF = 3
         END IF
      END IF
  114 IF (OPTION .EQ. 'SL') THEN
         CALL AGETST(STRACOFL,40)
         IF ( STRACOFL .NE. '*????*' ) CALL CHKSC(LINE,1,IER,*1145)
 1145    IF ( IER .NE. 0) STRACOFL = '*????*'
      END IF
      IF (OPTION .EQ. 'SR') THEN
         CALL AGETST(STRACOFR,40)
         IF ( STRACOFR .NE. '*????*' ) CALL CHKSC(LINE,2,IER,*1146)
 1146    IF ( IER .NE. 0) STRACOFR = '*????*'
      END IF
      IF (OPTION .EQ. 'LL') THEN
         CALL AGETST(LFILEL,40)
         IF ( LFILEL .NE. '*????*' ) CALL CHKLITHO(LINE,1,IER,*1147)
 1147    IF ( IER .NE. 0) LFILEL = '*????*'
      END IF
      IF (OPTION .EQ. 'LR') THEN
         CALL AGETST(LFILER,40)
         IF ( LFILER .NE. '*????*' ) CALL CHKLITHO(LINE,2,IER,*1149)
 1149    IF ( IER .NE. 0) LFILER = '*????*'
      END IF
      IF (OPTION .EQ. 'TL') CALL AGETST(DCI,1)
      IF (OPTION .EQ. 'DA') THEN
         CALL AGETST(EA,1)
         IF (EA .EQ. 'Y') DATUMF=1
         IF (EA .EQ. 'N') DATUMF=2
        ENDIF
      IF ( OPTION .EQ. 'DF') THEN
         CALL AGETST(NDATUM,40)
         IF ( NDATUM .NE. '*????*' ) CALL REDATU(LINE,IER,*11)
      END IF
      IF (OPTION .EQ. 'ND') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) ZSHAL=TEMP
        ENDIF
      IF (OPTION .EQ. 'XD') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) ZDEEP  =TEMP
        ENDIF
      IF (OPTION .EQ. 'AD') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) ZSHALD=TEMP
        ENDIF
      IF (OPTION .EQ. 'BD') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) ZDEEPD =TEMP
        ENDIF
      IF (OPTION .EQ. 'VS') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) VSCALE=TEMP
        ENDIF
      IF (OPTION .EQ. 'HS') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) HSCALE=TEMP
        ENDIF
      IF (OPTION .EQ. 'ST') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) TSTART=TEMP
        ENDIF
      IF (OPTION .EQ. 'ET') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) TEND=TEMP
        ENDIF
      IF (OPTION .EQ. 'AP') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) PHISHALE=TEMP
        ENDIF
      IF (OPTION .EQ. 'MP') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) PORMAX=TEMP
        ENDIF
      IF (OPTION .EQ. 'MF') CALL AGETST(FILTRA,40)
      IF (OPTION .EQ. 'LC') CALL AGETST(FILCOLITH,40)
      IF (OPTION .EQ. 'NC') CALL AGETST(NCOCLA,1)
      IF (OPTION .EQ. 'FM'  .AND.  
     1      .NOT. (MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')) THEN !
         CALL AGETST(EA,1)
         IF (EA .EQ. 'Y') IFAULT=1
         IF (EA .EQ. 'N') IFAULT=2
        ENDIF
      IF (OPTION .EQ. 'FF') THEN
         CALL AGETST(FFAULT,40)
         CALL REFAUL(LINE,IERFAU,*11)
      END IF
      IF (OPTION .EQ. 'MD') CALL MDRAWS
      GO TO 15
   51 CALL TXTCLR(ICOLOR(6))
       iflag = 0   ! 2001
      IF (DATUMF .EQ. 2) THEN
         CSTART = ZSHALD
         CEND = ZDEEPD
         IF (  CSTART .LE. 0  .AND.  CEND .LE. ABS(CSTART) ) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** ENDING PLOTTING DEPTH SHALLOWER THAN STARTING DEPTH.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF (  CEND .LE. 0  .AND.  CSTART .LE. ABS(CEND) ) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** STARTING PLOTTING DEPTH DEEPER THAN ENDING DEPTH.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF (MENU .EQ. 'PERS' .AND. TSTART .LT. (DATUMZ(1)-CSTART)) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** STARTING TRACING SHALLOWER THAN STARTING PLOTTING.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF (MENU .EQ. 'PERS'  .AND.  TEND .GT. (DATUMZ(1)+CEND)) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** ENDING TRACING DEEPER THAN ENDING PLOTTING DEPTH.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF ((MENU .EQ. 'ADIP'  .OR. MENU .EQ. 'TDIP') 
     1                   .AND. TSTART .LT. (DATUMZ(1)-CSTART)) THEN
            CALL GTEXTS(15,LINE+2,
     1 '***** BEGINNING OF DIAGRAM SHALLOWER THAN STARTING PLOTTING.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF ((MENU .EQ. 'ADIP'  .OR. MENU .EQ. 'TDIP')  .AND.  
     1                      TEND .GT. (DATUMZ(1)+CEND)) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** END OF DIAGRAM DEEPER THAN ENDING PLOTTING DEPTH.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
       ELSE
         CSTART = ZSHAL
         CEND   = ZDEEP
         IF ( CSTART .GE. CEND ) THEN
            CALL GTEXTS(15,LINE+2,
     1    '***** ENDING PLOTTING DEPTH NOT DEEPER THAN STARTING DEPTH.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF (MENU .EQ. 'PERS'  .AND.  TSTART .LT. CSTART) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** STARTING TRACING SHALLOWER THAN STARTING PLOTTING.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF (MENU .EQ. 'PERS'  .AND.  TEND .GT. CEND) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** ENDING TRACING DEEPER THAN ENDING PLOTTING DEPTH.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF ((MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')  .AND.  
     1                         TSTART .LT. CSTART) THEN
            CALL GTEXTS(15,LINE+2,
     1'***** BEGINNING OF DIAGRAM SHALLOWER THAN STARTING PLOTTING.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF ((MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')  .AND.  
     1                    TEND .GT. CEND) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** END OF DIAGRAM DEEPER THAN ENDING PLOTTING DEPTH.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
      END IF
      IF ((MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')  .AND.  
     1                    DATUMF .EQ. 2) THEN
         CALL GTEXTS(15,LINE+2,'***** DA MUST BE YES.')
            LINE = LINE + 1
            IFLAG = 1
      END IF
      IF ((MENU .EQ. 'TDIP'  .AND.  NPAIRS .NE. 2)) THEN
         CALL GTEXTS(15,LINE+2,
     1        '***** ONLY TWO SEQUENTIAL INTERPRETATIONS ARE')
         CALL GTEXTS(21,LINE+3,
     1        'NECESSARY. DIAGRAMS MUST BE GENERATED ONE AT A TIME.')
            LINE = LINE + 2
            IFLAG = 1
      END IF
      IF ((MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')  .AND.  
     1                    HSCALE .GT. 10.0) THEN
         CALL GTEXTS(15,LINE+2,
     1     '***** WARNING.  HORIZONTAL SCALE GREATER THAN 10.0.')
         CALL GTEXTS(21,LINE+3,'RE -- STOP DISPLAY')
         CALL GTEXTS(21,LINE+4,
     1                    'GO -- PROCEED WITH PROCESS')
         CALL GTEXTS(23,LINE+5,'PLEASE ENTER YOUR SELECTIONS:')
         CALL AINPUT(53,LINE+5)
  151    CALL AGETST(OPTION,2)
         IF (OPTION .EQ. '  ') GO TO 51
C
         IF (OPTION .EQ. 'RE') GO TO 11
         IF (OPTION .EQ. 'GO') GO TO 61
         GO TO 151
C         CALL SCHOLD
   61    LINE = LINE + 5
      END IF
      IF ( PHISHALE .LT. 0.0 ) THEN
         CALL GTEXTS(15,LINE+2,
     1  '***** NO NEGATIVE APPARENT SHALE POROSITY ALLOWED.')
            LINE = LINE + 1
            IFLAG = 1
      END IF
      IF ( HSCALE .LE. 0.0  .OR.  VSCALE .LE. 0.0 
     1                      .OR.  PORMAX .LE. 0.0 ) THEN
         CALL GTEXTS(15,LINE+2,
     1  '***** NO NEGATIVE SCALES ALLOWED.')
            LINE = LINE + 1
            IFLAG = 1
      END IF
      IF ( PORMAX .GT. 1.0  .OR.  PHISHALE .GT. 1.0 ) THEN
         CALL GTEXTS(15,LINE+2,
     1  '***** POROSITY SHOULD BE A FRACTION (0-1).')
            LINE = LINE + 1
            IFLAG = 1
      END IF
         IF ( MENU .EQ. 'PERS'  .AND.  TSTART .GT. TEND ) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** ENDING TRACING DEPTH SHALLOWER THAN STARTING DEPTH.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF ( (MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')  .AND. 
     1                      TSTART .GT. TEND ) THEN
            CALL GTEXTS(15,LINE+2,
     1     '***** END OF DIAGRAM SHALLOWER THAN BEGINNING OF DIAGRAM.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF ( (MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')  .AND. 
     1         (IFSC .EQ. 2  .OR.  IFSC .EQ. 3)) THEN
            CALL GTEXTS(15,LINE+2,'***** IT IS NOT ALLOWED '//
     1     'TO ANNOTATE TEXT TO THE RIGHT.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF ( (MENU .EQ. 'ADIP'  .OR.  MENU .EQ. 'TDIP')  .AND. 
     1         (LITHF .EQ. 2  .OR.  LITHF .EQ. 3)) THEN
            CALL GTEXTS(15,LINE+2,'***** IT IS NOT ALLOWED '//
     1     'TO ANNOTATE LITHOLOGY TO THE RIGHT.')
            LINE = LINE + 1
            IFLAG = 1
         END IF
         IF ( MENU .EQ. 'SECT') THEN
            IF (.NOT.(DCI .EQ. 'A'  .OR.  DCI .EQ. 'C')) THEN
               CALL GTEXTS(15,LINE+2,
     1            '***** DISPLAY OF LINES MUST "A" OR "C."')
               LINE = LINE + 1
               IFLAG = 1
            END IF
         END IF
      IF ( IFLAG .EQ. 1 ) THEN
         CALL SCHOLD
         GO TO 11
      END IF
C
  900 RETURN
      END
      SUBROUTINE REDATU(LINE, IERFAU,*)
C
C                READS IN REFERENCE ELEVATIONS.
C
C***********************************************************************
C
      COMMON /FYLDAT/ NDATUM
             CHARACTER*40 NDATUM
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /DATMZZ/ DATUMZ(21)
      COMMON /DSLDEE/ DSHAL(21),DDEEP(21)
      COMMON /SHADEE/ ZSHALD,ZDEEPD
      COMMON /COLOPT/ ICOLOR(6)
C
      ZSHALD = -1.0E30
      ZDEEPD = -1.0E30
      CALL CHKOTY(34,NDATUM,0,11,6,LINE+2,ICKERR)
      IF ( ICKERR .NE. 0 ) THEN
         LINE = LINE+ 1
         RETURN 1
      END IF
      DO 500 I = 1, (NPAIRS+1)
      K = I
      READ (34,9000,REC=K+1,ERR=11) DATUMZ(K)
      AUX = DATUMZ(K) - DSHAL(K)
      IF ( AUX .GT. ZSHALD ) ZSHALD = AUX
      AUX = DDEEP(K) - DATUMZ(K)
      IF ( AUX .GT. ZDEEPD ) ZDEEPD = AUX
  500 CONTINUE
 9000 FORMAT(1F10.0)
      CLOSE(34)
      ICKERR=99
      RETURN
C
   11 CALL TXTCLR(ICOLOR(6))
      CALL GTEXTS(10,LINE+2,'*** NOT ENOUGH ELEVATIONS IN DATUM FILE.')
      CALL SCHOLD
      CLOSE(34)
      RETURN 1
      END
C***********************************************************************
C
C                  PREPARES A DRAWING SPECIFICATION FILE.
C
C***********************************************************************
C
      SUBROUTINE PRSPEC(J1STIM)
C
      CHARACTER*4 HESP /'SPEC'/
C
      COMMON /SPECAL/ PAR1, TITLE0, TITLE1, TITLE2, SON, AELG,
     1                AFSC,STRACOFL,STRACOFR, FYLEINTERP, DATUMF,
     2                NDATUM, IFAULT, FFAULT, ROT, DEPOR, PLTSEL,
     3                AFLITH,LFILEL, LFILER, ELOD
             CHARACTER*40 PAR1, FYLEINTERP
             CHARACTER*25 TITLE0
             CHARACTER*80 TITLE1
             CHARACTER*80 TITLE2
             CHARACTER*1 SON
             CHARACTER*1 AELG
             CHARACTER*1 AFSC
             CHARACTER*40 STRACOFL, STRACOFR
             CHARACTER*1 DATUMF
             CHARACTER*40 NDATUM
             CHARACTER*1 IFAULT
             CHARACTER*40 FFAULT
             CHARACTER*1 ROT
             CHARACTER*1 DEPOR
             CHARACTER*1 PLTSEL
             CHARACTER*1 AFLITH
             CHARACTER*40 LFILEL, LFILER
             CHARACTER*1 ELOD
      COMMON /PLATE/ PLATE
             CHARACTER*4 PLATE
      COMMON /SPECNU/ VSCALE, HSCALE, INCZ, SHLLMX, CORLMX
             REAL*4 VSCALE
             REAL*4 HSCALE
             INTEGER INCZ
             REAL*4 SHLLMX
             REAL*4 CORLMX
C
C
C         READ PARAMETERS
C
   11 CALL OPSPEC(J1STIM,*900)
C
C         START A NEW FILE
C
      CALL OPEND(68,PAR1,-1,81)
      WRITE (68,9000,REC=1) HESP,TITLE0
      WRITE (68,9001,REC=2) TITLE1
      WRITE (68,9001,REC=3) TITLE2
      WRITE (68,9006,REC=4) PLATE,SON,AELG,AFSC
      WRITE (68,9007,REC=5) STRACOFL, STRACOFR
      WRITE (68,9008,REC=6) ELOD, AFLITH
      WRITE (68,9007,REC=7) LFILEL, LFILER
      WRITE (68,9005,REC=8) DATUMF,NDATUM
      WRITE (68,9003,REC=9) VSCALE,HSCALE,INCZ, DEPOR
      WRITE (68,9004,REC=10) SHLLMX,CORLMX
      WRITE (68,9005,REC=11) IFAULT,FFAULT
      WRITE (68,9002,REC=12) ROT,FYLEINTERP
      CALL RPSPEC
      CLOSE (68,STATUS='KEEP')
      GO TO 11
  900 RETURN
 9000 FORMAT (A4,51X,A25)
 9001 FORMAT (A80)
 9002 FORMAT(39X,A1,A40)
 9003 FORMAT (F10.2,20X,F10.2,15X,I5,19X,A1)
 9004 FORMAT (F10.3,60X,F10.3)
 9005 FORMAT (19X,A1,20X,A40)
 9006 FORMAT(16X,A4,19X,A1,19X,A1,19X,A1)
 9007 FORMAT (2A40)
 9008 FORMAT (2(39X,A1))
      END
      SUBROUTINE OPSPEC(J1STIM,*)
C
C                   OPTIONS FOR COMMAND 'PC'.
C
C**********************************************************************
C
      LOGICAL FLAG
      LOGICAL ERROR
      CHARACTER*2 OPTION
      CHARACTER*4 BOMU
C
      COMMON /SPECAL/ PAR1, TITLE0, TITLE1, TITLE2, SON, AELG,
     1                AFSC,STRACOFL,STRACOFR, FYLEINTERP, DATUMF,
     2                NDATUM, IFAULT, FFAULT, ROT, DEPOR, PLTSEL,
     3                AFLITH,LFILEL, LFILER, ELOD
             CHARACTER*40 PAR1, FYLEINTERP
             CHARACTER*25 TITLE0
             CHARACTER*80 TITLE1
             CHARACTER*80 TITLE2
             CHARACTER*1 SON
             CHARACTER*1 AELG
             CHARACTER*1 AFSC
             CHARACTER*40 STRACOFL, STRACOFR
             CHARACTER*1 DATUMF
             CHARACTER*40 NDATUM
             CHARACTER*1 IFAULT
             CHARACTER*40 FFAULT
             CHARACTER*1 ROT
             CHARACTER*1 DEPOR
             CHARACTER*1 PLTSEL
             CHARACTER*1 AFLITH
             CHARACTER*40 LFILEL, LFILER
             CHARACTER*1 ELOD
      COMMON /PLATE/ PLATE
             CHARACTER*4 PLATE
      COMMON /SPECNU/ VSCALE, HSCALE, INCZ, SHLLMX, CORLMX
             REAL*4 VSCALE
             REAL*4 HSCALE
             INTEGER INCZ
             REAL*4 SHLLMX
             REAL*4 CORLMX
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /COLOPT/  ICOLOR(6)
C
      IF (J1STIM .EQ. 0) THEN
         PAR1 = '*????*'
         TITLE0 = 'KANSAS GEOLOGICAL SURVEY'
         TITLE1='****'
         TITLE2='****'
         PLATE = '    '
         SON='N'
         AELG='A'
         AFSC='N'
         STRACOFL = '*????*'
         STRACOFR = '*????*'
         AFLITH='N'
         LFILEL = '*????*'
         LFILER = '*????*'
         DATUMF='Y'
         NDATUM = '*????*'
         VSCALE= 50.0
         HSCALE=500.0
         INCZ  =10
         SHLLMX=-1.0
         CORLMX=-1.0
         IFAULT = 'N'
         FFAULT = '*????*'
         DEPOR = 'S'
         ROT = 'W'
         PLTSEL = 'B'
         FYLEINTERP = 'Ricardo A. Olea'
         ELOD = 'D'
      END IF
C
C        MENU.
C
   11 FLAG = .FALSE.
      CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'PREPARATION OF '//
     1     'SPECIFICATIONS FOR CROSS-SECTIONAL DISPLAY')
      CALL TXTCLR(ICOLOR(5))
      CALL GTEXTS( 3, 4,'FN - NAME OF THE FILE WITH THE '//
     1             'SPECIFICATIONS')
      CALL GTXTRJ(79, 4,PAR1)
      LINE = 3
      IF ( PAR1 .NE. '*????*' ) THEN
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS( 3,LINE+2,'T1 - FIRST TITLE')
         CALL GTXTRJ(79,LINE+2,TITLE1)
         CALL GTEXTS( 3,LINE+3,'T2 - SECOND TITLE')
         CALL GTXTRJ(79,LINE+3,TITLE2)
         CALL GTEXTS( 3,LINE+4, 'SC - TEXT IN STRATIGRAPHIC '//
     1             'COLUMN TO THE LEFT(L), RIGHT(R),')
         CALL GTEXTS( 8,LINE+5, 'BOTH(B), OR NONE(N)')
         CALL GTXTRJ(79,LINE+4,AFSC)
         LINE = LINE + 1
         IF (AFSC .EQ. 'L'  .OR.  AFSC .EQ. 'B') THEN
            CALL GTEXTS( 3,LINE+5,
     1  'SL - NAME OF FILE WITH COLUMN TEXT TO THE LEFT')
            CALL GTXTRJ(79,LINE+5,STRACOFL)
            LINE = LINE + 1
         END IF
         IF (AFSC .EQ. 'R'  .OR.  AFSC .EQ. 'B') THEN
            CALL GTEXTS( 3,LINE+5,
     1  'SR - NAME OF FILE WITH COLUMN TEXT TO THE RIGHT')
            CALL GTXTRJ(79,LINE+5,STRACOFR)
            LINE = LINE + 1
         END IF
         CALL GTEXTS( 3,LINE+5,'LA - LITHOLOGY IN STRATIGRAPHIC '//
     1             'COLUMN TO THE LEFT(L), RIGHT(R),')
         CALL GTEXTS( 8,LINE+6, 'BOTH(B), OR NONE(N)')
         CALL GTXTRJ(79,LINE+5,AFLITH)
            LINE = LINE + 1
         IF (AFLITH .EQ. 'L'  .OR.  AFLITH .EQ. 'B') THEN
            CALL GTEXTS( 3,LINE+6,
     1  'LL - NAME OF LITHOLOGY FILE FOR LEFT COLUMN')
            CALL GTXTRJ(79,LINE+6,LFILEL)
            LINE = LINE + 1
         END IF
         IF (AFLITH .EQ. 'R'  .OR.  AFLITH .EQ. 'B') THEN
            CALL GTEXTS( 3,LINE+6,
     1  'LR - NAME OF LITHOLOGY FILE FOR RIGHT COLUMN')
            CALL GTXTRJ(79,LINE+6,LFILER)
            LINE = LINE + 1
         END IF
         LINE = LINE + 1
         CALL TXTCLR(ICOLOR(3))
         CALL GTEXTS( 3,LINE+5,
     1              'DA - USE '//DATUM//' AS DATUM, YES(Y) OR NO(N)')
         CALL GTXTRJ(79,LINE+5,DATUMF)
         IF (DATUMF .EQ. 'N') THEN
            CALL GTEXTS( 3,LINE+6,
     1  'DF - DATUM FILE WITH ELEVATIONS FOR THE NEW REFERENCE SURFACE')
            CALL GTXTRJ(79,LINE+6,NDATUM)
            LINE = LINE + 1
         END IF
         CALL TXTCLR(ICOLOR(5))
         CALL GTEXTS( 3,LINE+ 6,
     1        'VS - VERTICAL DEPTH SCALE, ' // BOMU(BOM) // '/IN')
         CALL GTXTRL(79,LINE+ 6,VSCALE,2)
         CALL GTEXTS( 3,LINE+ 7,
     1        'HS - HORIZONTAL DISTANCE SCALE, ' // BOMU(BOM) // '/IN')
         CALL GTXTRL(79,LINE+ 7,HSCALE,2)
C
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS( 3,LINE+8,
     1        'MS - MAXIMUM VALUE FOR SHALE LOG.  ENTER A NEGATIVE')
         CALL GTXTRL(79,LINE+8,SHLLMX,2)
         CALL GTEXTS( 8,LINE+9,
     1        'VALUE TO SELECT THE MAXIMUM VALUE ON EACH LOG.')
         CALL GTEXTS( 3,LINE+10,
     1      'MC - MAXIMUM VALUE FOR CORRELATION LOG.  ENTER A NEGATIVE')
         CALL GTXTRL(79,LINE+10,CORLMX,2)
         CALL GTEXTS( 8,LINE+11,
     1        'VALUE TO SELECT THE MAXIMUM VALUE ON EACH LOG.')
         LINE=LINE+11
C
         CALL TXTCLR(ICOLOR(5))
         CALL GTEXTS( 3,LINE+1,
     1           'FM - FAULT MODELING, YES(Y) OR NO(N)')
         CALL GTXTRJ(79,LINE+1,IFAULT)
         IF (IFAULT .EQ. 'Y') THEN
            CALL GTEXTS( 3,LINE+2,
     1         'FF - FILE WITH INFORMATION ABOUT THE FAULTS')
            CALL GTXTRJ(79,LINE+2,FFAULT)
            LINE = LINE + 1
         END IF
         CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,
     1      'MD - MORE DRAWING SPECIFICATIONS')
      CALL MARROW(79,LINE+2)
      END IF
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,LINE+3,'RE - RETURN TO FILE MANAGEMENT MENU')
      IF ( PAR1 .NE. '*????*' )
     1   CALL GTEXTS( 3,LINE+4,'GO - PREPARE THE FILE')
C
      LINE = LINE + 6
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN 1
C
      IF ((PAR1 .NE. '*????*')  .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'FN') CALL AGETST(PAR1,40)
      IF (OPTION .EQ. 'AG') CALL AGETTX(TITLE0)
      IF (OPTION .EQ. 'T1') CALL AGETTX(TITLE1)
      IF (OPTION .EQ. 'T2') CALL AGETTX(TITLE2)
      IF (OPTION .EQ. 'LW') CALL AGETST(SON,1)
      IF (OPTION .EQ. 'PW') CALL AGETST(AELG,1)
      IF (OPTION .EQ. 'SC') CALL AGETST(AFSC,1)
      IF (OPTION .EQ. 'SL') CALL AGETST(STRACOFL,40)
      IF (OPTION .EQ. 'SR') CALL AGETST(STRACOFR,40)
      IF (OPTION .EQ. 'LA') CALL AGETST(AFLITH,1)
      IF (OPTION .EQ. 'LL') CALL AGETST(LFILEL,40)
      IF (OPTION .EQ. 'LR') CALL AGETST(LFILER,40)
      IF (OPTION .EQ. 'DA') CALL AGETST(DATUMF,1)
      IF (OPTION .EQ. 'DF') CALL AGETST(NDATUM,40)
      IF (OPTION .EQ. 'VS') CALL AGETRL(VSCALE,ERROR)
      IF (OPTION .EQ. 'HS') CALL AGETRL(HSCALE,ERROR)
      IF (OPTION .EQ. 'DT') CALL AGETIN(INCZ,ERROR)
      IF (OPTION .EQ. 'MS') CALL AGETRL(SHLLMX,ERROR)
      IF (OPTION .EQ. 'MC') CALL AGETRL(CORLMX,ERROR)
      IF (OPTION .EQ. 'FM') CALL AGETST(IFAULT,1)
      IF (OPTION .EQ. 'FF') CALL AGETST(FFAULT,40)
      IF (OPTION .EQ. 'PS') CALL AGETST(PLTSEL,1)
      IF (OPTION .EQ. 'MD') CALL PCMPTW
      GO TO 15
C
C          PARAMETER CHECKING.
C
   51 CALL TXTCLR(ICOLOR(6))
      CALL CHKOLF(68,PAR1,26,2,LINE+2,ICKERR,*11)
      IF ( HSCALE .LE. 0.0  .OR.  VSCALE .LE. 0.0 ) THEN
         CALL GTEXTS(15,LINE+2,
     1  '***** NO NEGATIVE SCALES ALLOWED.')
            LINE = LINE + 1
           FLAG = .TRUE.
      END IF
      IF ( INCZ .LE. 0.0 ) THEN
         CALL GTEXTS(15,LINE+2,
     1  '***** NO NEGATIVE TICK MARK DISTANCES ALLOWED.')
            LINE = LINE + 1
           FLAG = .TRUE.
      END IF
      IF (SON .EQ. 's' .OR. SON .EQ. 'S') THEN
         SON = 'S'
      ELSE IF (SON .EQ. 'n' .OR. SON .EQ. 'N') THEN
         SON = 'N'
      ELSE
         CALL GTEXTS(15,LINE+2,
     1               '***** LW MUST BE S OR N.')
         LINE = LINE + 1
         FLAG = .TRUE.
      END IF
      IF (AELG .EQ. 'a' .OR. AELG .EQ. 'A') THEN
         AELG = 'A'
      ELSE IF (AELG .EQ. 'e' .OR. AELG .EQ. 'E') THEN
         AELG = 'E'
      ELSE
         CALL GTEXTS(15,LINE+2,
     1               '***** PW MUST BE A OR E.')
         LINE = LINE + 1
         FLAG = .TRUE.
      END IF
      IF (AFSC .EQ. 'l' .OR. AFSC .EQ. 'L') THEN
         AFSC = 'L'
       ELSE IF (AFSC .EQ. 'r' .OR. AFSC .EQ. 'R') THEN
         AFSC = 'R'
       ELSE IF (AFSC .EQ. 'b' .OR. AFSC .EQ. 'B') THEN
         AFSC = 'B'
      ELSE IF (AFSC .EQ. 'n' .OR. AFSC .EQ. 'N') THEN
         AFSC = 'N'
      ELSE
         CALL GTEXTS(15,LINE+2,
     1               '***** SF MUST BE Y OR N.')
         LINE = LINE + 1
         FLAG = .TRUE.
      END IF
      IF (DATUMF .EQ. 'y' .OR. DATUMF .EQ. 'Y') THEN
         DATUMF = 'Y'
      ELSE IF (DATUMF .EQ. 'n' .OR. DATUMF .EQ. 'N') THEN
         DATUMF = 'N'
      ELSE
         CALL GTEXTS(15,LINE+2,
     1               '***** DA MUST BE Y OR N.')
         LINE = LINE + 1
         FLAG = .TRUE.
      END IF
      IF (IFAULT .EQ. 'y' .OR. IFAULT .EQ. 'Y') THEN
         IFAULT = 'Y'
      ELSE IF (IFAULT .EQ. 'n' .OR. IFAULT .EQ. 'N') THEN
         IFAULT = 'N'
      ELSE
         CALL GTEXTS(15,LINE+2,
     1               '***** NF MUST BE Y OR N.')
         LINE = LINE + 1
         FLAG = .TRUE.
      END IF
      IF (ELOD .EQ. 'e'  .OR.  ELOD .EQ. 'E') THEN
         ELOD = 'E'
       ELSE IF (ELOD .EQ. 'd'  .OR.  ELOD .EQ. 'D') THEN
         ELOD = 'D' 
       ELSE
         CALL GTEXTS(15,LINE + 4,
     1               '***** ED MUST BE E OR D.')
         LINE = LINE + 1 
         FLAG = .TRUE.
      END IF
      IF (ROT .EQ. 'w' .OR. ROT .EQ. 'W') THEN
         ROT = 'W'
      ELSE IF (ROT .EQ. 'l' .OR. ROT .EQ. 'L') THEN
         ROT = 'L'
      ELSE
         CALL GTEXTS(15,LINE+2,
     1               '***** DS MUST BE W OR L.')
         LINE = LINE + 1
         FLAG = .TRUE.
      END IF
      IF (PLTSEL .NE. 'T' .AND. PLTSEL .NE. 'V' .AND.
     ^    PLTSEL .NE. 'B') THEN
         CALL GTEXTS(15,LINE+2,
     1               '***** PS MUST BE T, V, OR B.')
         LINE = LINE + 1
         FLAG = .TRUE.
      END IF
      IF ( FLAG ) THEN
         CALL SCHOLD
         GO TO 11
      END IF
C
      J1STIM = 1
      RETURN
      END
      SUBROUTINE RPSPEC
C
C                 DISPLAY CONTENT OF FILE CONTAINING
C                 SPECIFICATIONS FOR THE PLOTTING OF CROSS-SECTIONS.
C
C***********************************************************************
C
      CHARACTER*4 BOMU
C
      COMMON /SPECAL/ PAR1, TITLE0, TITLE1, TITLE2, SON, AELG,
     1                AFSC,STRACOFL,STRACOFR, FYLEINTERP, DATUMF,
     2                NDATUM, IFAULT, FFAULT, ROT, DEPOR, PLTSEL,
     3                AFLITH,LFILEL, LFILER, ELOD
             CHARACTER*40 PAR1, FYLEINTERP
             CHARACTER*25 TITLE0
             CHARACTER*80 TITLE1
             CHARACTER*80 TITLE2
             CHARACTER*1 SON
             CHARACTER*1 AELG
             CHARACTER*1 AFSC
             CHARACTER*40 STRACOFL, STRACOFR
             CHARACTER*1 DATUMF
             CHARACTER*40 NDATUM
             CHARACTER*1 IFAULT
             CHARACTER*40 FFAULT
             CHARACTER*1 ROT
             CHARACTER*1 DEPOR
             CHARACTER*1 PLTSEL
             CHARACTER*1 AFLITH
             CHARACTER*40 LFILEL, LFILER
             CHARACTER*1 ELOD
      COMMON /PLATE/ PLATE
             CHARACTER*4 PLATE
      COMMON /SPECNU/ VSCALE, HSCALE, INCZ, SHLLMX, CORLMX
             REAL*4 VSCALE
             REAL*4 HSCALE
             INTEGER INCZ
             REAL*4 SHLLMX
             REAL*4 CORLMX
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /COLOPT/  ICOLOR(6)
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      CHARACTER*13 TDEPOR(2) /'SEA LEVEL', 'KELLY BUSHING'/
C
      CALL ANMODE
      WRITE (QTEKOT,9000) PAR1,TITLE0,FYLEINTERP,TITLE1,TITLE2
      IF (PLATE .NE. '    ') THEN
         WRITE (QTEKOT,9019) PLATE
       ELSE
         WRITE (QTEKOT,9018)
      END IF 
      IF ( SON .EQ. 'S' ) THEN
         WRITE (QTEKOT,9001)
       ELSE
         WRITE (QTEKOT,9002)
      END IF
      IF ( AELG .EQ. 'A' ) THEN
         WRITE (QTEKOT,9003)
       ELSE
         WRITE (QTEKOT,9004)
      END IF
      IF ( DEPOR .EQ. 'S' ) THEN
         ITD = 1
       ELSE
         ITD = 2
      END IF
         WRITE (QTEKOT,9020) TDEPOR(ITD)
      IF ( DATUMF .EQ. 'Y' ) THEN
         WRITE (QTEKOT,9005) DATUM
       ELSE
         WRITE (QTEKOT,9006) NDATUM
      END IF
      IF ( AFSC .EQ. 'L'  .OR.  AFSC .EQ. 'B' )
     1   WRITE (QTEKOT,9015) STRACOFL
      IF ( AFSC .EQ. 'R'  .OR.  AFSC .EQ. 'B' )
     1   WRITE (QTEKOT,9017) STRACOFR
       IF ( AFSC .EQ. 'N')
     1   WRITE (QTEKOT,9016)
      IF ( AFLITH .EQ. 'L'  .OR.  AFLITH .EQ. 'B' )
     1   WRITE (QTEKOT,9021) LFILEL
      IF ( AFLITH .EQ. 'R'  .OR.  AFLITH .EQ. 'B' )
     1   WRITE (QTEKOT,9023) LFILER
      IF ( AFLITH .EQ. 'N')
     1   WRITE (QTEKOT,9022)
      IF ( ELOD .EQ. 'E' ) THEN
         WRITE (QTEKOT,9024)
       ELSE
         WRITE (QTEKOT,9025)
      END IF
      WRITE (QTEKOT,9007) VSCALE,BOMU(BOM),HSCALE,BOMU(BOM),INCZ,
     1                    BOMU(BOM),SHLLMX,CORLMX
      IF ( IFAULT .EQ. 'Y' ) THEN
         WRITE (QTEKOT,9008) FFAULT
       ELSE
         WRITE (QTEKOT,9009)
      END IF
      IF ( ROT .EQ. 'W' ) THEN
         WRITE (QTEKOT,9010)
       ELSE
         WRITE (QTEKOT,9011)
      END IF
C      IF ( PLTSEL .EQ. 'T' ) THEN
C         WRITE (QTEKOT,9012)
C       ELSE IF ( PLTSEL .EQ. 'V' ) THEN
C            WRITE (QTEKOT,9013)
C          ELSE
C         WRITE ( QTEKOT,9014)
C      END IF
      CALL RETKEY
      RETURN
 9000 FORMAT(///21X,'FILE WITH SPECIFICATIONS TO PLOT A CROSS-SECTION'/
     1          21X,'************************************************'//
     2           2X,'FILE NAME:   ',2X,A40/
     3           2X,'AGENCY:      ',2X,A25/
     4           2X,'PROCESSED BY:',2X,A40/
     5           2X,'TITLE:       ',2X,A80/
     6           2X,'             ',2X,A80)
 9001 FORMAT (   2X,'WELL LABELS:',2X,'BY SEQUENTIAL NUMBER')
 9002 FORMAT (   2X,'WELL LABELS:',2X,'USE THE ACTUAL WELL NAME')
 9003 FORMAT (   2X,'LOGS:      ',3X,'DISPLAY THEM ALL')
 9004 FORMAT (   2X,'LOGS:      ',3X,
     1              'DISPLAY THOSE AT THE EXTREME WELLS ONLY')
 9005 FORMAT (   2X,'DATUM FOR DISPLAYS:',2X,A15)
 9006 FORMAT (   2X,'DATUM FOR DISPLAYS:',2X,A40)
 9007 FORMAT (   2X,'VERT. SCALE: ',F10.2,' ',A4,'/IN'/
     1           2X,'HOR. SCALE: ',2X,F10.2,' ',A4,'/IN'/
     2           2X,'TICK MARKS: ',2X,'EVERY',I4,' ',A4/
     4           2X,'MAX. SHALE: ',2X,F10.3/
     5           2X,'MAX. CORR.: ',2X,F10.3)
 9008 FORMAT (   2X,'FAULTING:  ',3X,'NORMAL FAULT MODELLING'/
     1           2X,'FAULT FILE:',3X,A40)
 9009 FORMAT (   2X,'FAULTING:  ',3X,'NO FAULTS CONSIDERED')
 9010 FORMAT (   2X,'DEPTH SCALE:',2X,'ALONG THE PAPER WIDTH')
 9011 FORMAT (   2X,'DEPTH SCALE:',2X,'ALONG THE PAPER LENGTH')
 9012 FORMAT (   2X,'DISPLAY:    ',2X,'ONLY AT THE TERMINAL')
 9013 FORMAT (   2X,'DISPLAY:    ',2X,'ONLY AT THE VERSATEC PLOTTER')
 9014 FORMAT (   2X,'DISPLAY:    ',2X,
     1              'BOTH AT THE TERMINAL AND AT THE VERSATEC PLOTTER')
 9015 FORMAT (   2X,'STRATIGRAPHIC COLUMN TO THE LEFT:  ',3X,'YES'/
     1           5X,'STRATIGRAPHIC COLUMN FILE:',3X,A40)
 9016 FORMAT (   2X,'STRATIGRAPHIC COLUMN:  ',3X,'NO')
 9017 FORMAT (   2X,'STRATIGRAPHIC COLUMN TO THE RIGHT:  ',3X,'YES'/
     1           5X,'STRATIGRAPHIC COLUMN FILE:',3X,A40)
 9018 FORMAT (   2X,'PLATE NUMBER: NONE')
 9019 FORMAT (   2X,'PLATE NUMBER: ',A4)
 9020 FORMAT (2X,'DEPTH SCALE ORIGIN: ',3X,A13)
 9021 FORMAT (   2X,'LITHOLOGY TO THE LEFT:  ',3X,'YES'/
     1           5X,'LITHOLOGY FILE:',3X,A40)
 9022 FORMAT (   2X,'LITHOLOGY:  ',3X,'NO')
 9023 FORMAT (   2X,'LITHOLOGY TO THE RIGHT:  ',3X,'YES'/
     1           5X,'LITHOLOGY FILE:',3X,A40)
 9024 FORMAT (   2X,'PLOT VERTICAL SCALE IS ELEVATION')
 9025 FORMAT (   2X,'PLOT VERTICAL SCALE IS DEPTH')
      END
      SUBROUTINE GETSPE(LINE,*)
C
C                READS IN PLOTTING SPECIFICATIONS FOR
C                THE DISPLAY OF A CROSS-SECTION.
C
C***********************************************************************
C
      CHARACTER*1 AFSC
      CHARACTER*1 AFLITH
      CHARACTER*1 AELGAL
      CHARACTER*1 ADATUM
      CHARACTER*1 AFAULT
      CHARACTER*4 HESP
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      COMMON /SPEFIL/ SPEFIL
             CHARACTER*40 SPEFIL
      COMMON /TITLE0/ TITLE0
             CHARACTER*25 TITLE0
      COMMON /TITLE/ TITLE1,TITLE2
             CHARACTER*80 TITLE1,TITLE2
      COMMON /PLATENO/PLATENO
             CHARACTER*4 PLATENO
      COMMON /CHARPP/ SON
             CHARACTER*1 SON
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /IFAULT/ IFAULT
             INTEGER*2 IFAULT
      COMMON /IFSC/ IFSC
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /FYLDAT/ NDATUM
             CHARACTER*40 NDATUM
      COMMON /INCZ/ INCZ
      COMMON /LOGMAX/ SHLLMX,CORLMX
      COMMON /FFAULT/ FFAULT
             CHARACTER*40 FFAULT
      COMMON /ROTATE/ ROT
             CHARACTER*1 ROT
      COMMON /DORIGIN/ DEPOR
             CHARACTER*1 DEPOR
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /PRINTINTERP/ FYLEINTERP
             CHARACTER*40 FYLEINTERP
      COMMON /LITHF/ LITHF
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /ELOD/  ELOD
             CHARACTER*1 ELOD
C
      CALL CHKOTY(68,SPEFIL,0,81,7,LINE,ICKERR)
      IF ( ICKERR .NE. 0 ) RETURN 1
      READ (68,9000,REC=1) HESP,TITLE0
      READ (68,9001,REC=2) TITLE1
      READ (68,9001,REC=3) TITLE2
      READ (68,9006,REC=4) PLATENO,SON,AELGAL,AFSC
      READ (68,9007,REC=5) STRACOFL, STRACOFR
      READ (68,9008,REC=6) ELOD, AFLITH
      READ (68,9007,REC=7) LFILEL, LFILER
      READ (68,9005,REC=8) ADATUM,NDATUM
      READ (68,9003,REC=9) VSCALE,HSCALE,INCZ, DEPOR
      READ (68,9004,REC=10) SHLLMX,CORLMX
      READ (68,9005,REC=11) AFAULT,FFAULT
      READ (68,9002,REC=12) ROT,FYLEINTERP
      PLTSEL = 'B'
      IF ( AELGAL .EQ. 'E' ) THEN
         AELG = 0
       ELSE
         AELG = 1
      END IF
      IF ( AFSC .EQ. 'N' ) THEN
         IFSC = 0
       ELSE IF( AFSC .EQ. 'L' ) THEN
         IFSC = 1
       ELSE IF( AFSC .EQ. 'R' ) THEN
         IFSC = 2
       ELSE 
         IFSC = 3
      END IF
      IF ( AFLITH .EQ. 'N' ) THEN
         LITHF = 0
       ELSE IF( AFLITH .EQ. 'L' ) THEN
         LITHF = 1
       ELSE IF( AFLITH .EQ. 'R' ) THEN
         LITHF = 2
       ELSE 
         LITHF = 3
      END IF
      IF ( ADATUM .EQ. 'Y' ) THEN
         DATUMF = 1
       ELSE
         DATUMF = 2
      END IF
      IF ( AFAULT .EQ. 'Y' ) THEN
         IFAULT = 1
       ELSE
         IFAULT = 2
      END IF
      CLOSE (68,STATUS='KEEP')
      RETURN
 9000 FORMAT (A4,51X,A25)
 9001 FORMAT (A80)
 9002 FORMAT(39X,A1,A40)
 9003 FORMAT (F10.2,20X,F10.2,15X,I5,19X,A1)
 9004 FORMAT (F10.3,60X,F10.3)
 9005 FORMAT (19X,A1,20X,A40)
 9006 FORMAT(16X,A4,19X,A1,19X,A1,19X,A1)
 9007 FORMAT (2A40)
 9008 FORMAT (2(39X,A1))
      END
      SUBROUTINE MDRAWS
C
C             MORE DRAWING SPECIFICATIONS IN THE PREPARATION
C             OF A CROSS-SECTION.
C
C*********************************************************************
C
      INTEGER*4 ORAELG, ORINCZ
      LOGICAL FLAG
      LOGICAL ERROR
      CHARACTER*1 EA
      CHARACTER*1 ORSON, ORROT, ORPLTSEL, ORELOD
      CHARACTER*2 OPTION
      CHARACTER*4 BOMU,ORPLATENO
      CHARACTER*7 EXTALL(2)
      DATA EXTALL/'E','A'/
      CHARACTER*25 ORTITLE0
      CHARACTER*40 ORFYLEINTERP
C
      COMMON /TITLE0/ TITLE0
             CHARACTER*25 TITLE0
      COMMON /PLATENO/ PLATENO
             CHARACTER*4 PLATENO
      COMMON /CHARPP/ SON
             CHARACTER*1 SON
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /INCZ/ INCZ
      COMMON /LOGMAX/ SHLLMX,CORLMX
      COMMON /DORIGIN/ DEPOR
             CHARACTER*1 DEPOR
      COMMON /ROTATE/ ROT
             CHARACTER*1 ROT
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /MENUPP/  MENU
             CHARACTER*4 MENU
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /PRINTINTERP/ FYLEINTERP
             CHARACTER*40 FYLEINTERP
      COMMON /ELOD/  ELOD
             CHARACTER*1 ELOD
C
C         ORIGINAL PARAMETERS.
C
      ORTITLE0 = TITLE0
      ORPLATENO = PLATENO
      ORSON = SON
      ORAELG = AELG
      ORINCZ = INCZ
      ORSHLLMX = SHLLMX
      ORCORLMX = CORLMX
      ORROT = ROT
      ORPLTSEL = PLTSEL
      ORFYLEINTERP = FYLEINTERP
      ORELOD = ELOD
C
  11  CALL MNMODE
      FLAG = .FALSE.
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40, 2,'MORE SPECIFICATIONS FOR THE DRAWING OF '//
     1          'A CROSS-SECTION')
      CALL TXTCLR(ICOLOR(5))
      LINE=2
      LINE = LINE + 1
      CALL GTEXTS( 3,LINE+1,'AG - AGENCY')
      CALL GTXTRJ(79,LINE+1,TITLE0)
      LINE = LINE + 1
      CALL GTEXTS( 3,LINE+1,'PB - INTERPRETER')
      CALL GTXTRJ(79,LINE+1,FYLEINTERP)
      CALL GTEXTS( 3,LINE+2,
     1     'PT - PLATE NUMBER, BLANK TO AVOID POSTING')
      CALL GTXTRJ(79,LINE+2,PLATENO)
      CALL GTEXTS( 3,LINE+3,
     1     'LW - LABEL WELLS BY SEQUENTIAL NUMBER(S) OR NAME(N)')
      CALL GTXTRJ(79,LINE+3,SON)
      IF (MENU .NE. 'TDIP') THEN
         CALL GTEXTS( 3,LINE+4,
     1        'PW - POST ALL(A) OR ONLY EXTREME WIRELINE LOGS(E)')
         CALL GTXTRJ(79,LINE+4,EXTALL(AELG+1))
         LINE = LINE + 1
      END IF
      LINE = LINE + 3
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+1,
     1    'DT - INTERVAL BETWEEN DEPTH TICK MARKS, ' // BOMU(BOM))
      CALL GTXTIN(79,LINE+1,INCZ)
      LINE = LINE + 1
      CALL GTEXTS( 3,LINE+1,
     1    'ED - PLOT VERTICAL SCALE AS ELEVATION(E) OR DEPTH (D)')
      CALL GTXTRJ(79,LINE+1,ELOD)
      LINE = LINE + 1
      CALL GTEXTS(3,LINE+1,
     ^ 'DO - DEPTH SCALE ORIGING, SEA LEVEL(S) OR SURFACE (KB)')
      CALL GTXTRJ(79,LINE+1,DEPOR)
      line = line + 1
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,LINE+1,
     1     'MS - MAXIMUM VALUE FOR SHALE LOG.  ENTER A NEGATIVE')
      CALL GTXTRL(79,LINE+1,SHLLMX,2)
      CALL GTEXTS( 8,LINE+2,
     1     'VALUE TO SELECT THE MAXIMUM VALUE ON EACH LOG.')
      CALL GTEXTS( 3,LINE+3,
     1 'MC - MAXIMUM VALUE FOR CORRELATION LOG.  ENTER A NEGATIVE')
      CALL GTXTRL(79,LINE+3,CORLMX,2)
      CALL GTEXTS( 8,LINE+4,
     1     'VALUE TO SELECT THE MAXIMUM VALUE ON EACH LOG.')
      LINE = LINE + 4
      CALL GTEXTS(3,LINE+1,
     ^ 'DS - DEPTH SCALE ALONG PAPER WIDTH(W) OR ALONG PAPER LENGTH(L)')
      CALL gtxtrj(79,line+1,rot)
      line = line + 1
C      CALL gtexts(3,line+1,
C     ^  'PS - PLOT SELECTION:  TERMINAL(T), VERSATEC(V), OR BOTH(B)')
C      CALL gtxtrj(79,line+1,pltsel)
C      LINE = LINE + 2
      CALL TXTCLR(ICOLOR(5))
      CALL GTEXTS( 3,LINE+2,
     1   'RE - RETURN TO PREVIOUS MENU IGNORING CHANGES.')
      LINE=LINE+2
      CALL GTEXTS( 3,LINE+1,'GO - COMMIT THE SELECTION')
      LINE=LINE+1
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. ' ') GO TO 11
C
      IF (OPTION .EQ. 'RE') THEN
         SON = ORSON
         AELG = ORAELG
         INCZ = ORINCZ
         ROT = ORROT
         PLTSEL = ORPLTSEL
         ELOD = ORELOD
         RETURN
      END IF
C
      IF (OPTION .EQ. 'GO') GO TO 51
      IF (OPTION .EQ. 'AG') CALL AGETTX(TITLE0)
      IF (OPTION .EQ. 'PB') CALL AGETTX(FYLEINTERP)
      IF (OPTION .EQ. 'PT') CALL AGETTX(PLATENO)
      IF (OPTION .EQ. 'LW') THEN
         CALL AGETST(EA,1)
         IF (EA .EQ. 'S'  .OR.  EA .EQ. 'N') SON = EA
      ENDIF
      IF (OPTION .EQ. 'PW') THEN
         CALL AGETST(EA,1)
         IF (EA .EQ. 'E') AELG = 0
         IF (EA .EQ. 'A') AELG = 1
        ENDIF

      IF (OPTION .EQ. 'DT') THEN
         CALL AGETIN(ITEMP,ERROR)
         IF (.NOT. ERROR) INCZ=ITEMP
        ENDIF
      IF (OPTION .EQ. 'MS') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) SHLLMX=TEMP
        ENDIF
      IF (OPTION .EQ. 'MC') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) CORLMX=TEMP
        ENDIF
      IF (OPTION .EQ. 'DO') CALL AGETST(DEPOR,1)
      IF (OPTION .EQ. 'ED') CALL AGETST(ELOD,1)
      IF (OPTION .EQ. 'DS') CALL AGETST(ROT,1)
      if (OPTION .EQ. 'PS') CALL agetst(PLTSEL,1)
      GO TO 15
C
C        INSPECT AND COMMIT WHEN CORRECT.
C
   51 CALL TXTCLR(ICOLOR(6))
      IF ( INCZ .LE. 0.0 ) THEN
         CALL GTEXTS(15,LINE+4,
     1  '***** NO NEGATIVE TICK MARK DISTANCES ALLOWED.')
            LINE = LINE + 1
            FLAG = .TRUE.
      END IF
      IF (DEPOR .EQ. 's'  .OR.  DEPOR .EQ. 'S') THEN
         DEPOR = 'S'
       ELSE IF (DEPOR .EQ. 'k'  .OR.  DEPOR .EQ. 'K') THEN
         DEPOR = 'K' 
       ELSE
         CALL GTEXTS(15,LINE + 4,
     1               '***** DO MUST BE S OR K.')
         LINE = LINE + 1 
         FLAG = .TRUE.
      END IF
      IF (ELOD .EQ. 'e'  .OR.  ELOD .EQ. 'E') THEN
         ELOD = 'E'
       ELSE IF (ELOD .EQ. 'd'  .OR.  ELOD .EQ. 'D') THEN
         ELOD = 'D' 
       ELSE
         CALL GTEXTS(15,LINE + 4,
     1               '***** ED MUST BE E OR D.')
         LINE = LINE + 1 
         FLAG = .TRUE.
      END IF
      IF (ROT .EQ. 'w'  .OR.  ROT .EQ. 'W') THEN
         ROT = 'W'
       ELSE IF (ROT .EQ. 'l'  .OR.  ROT .EQ. 'L') THEN
         ROT = 'L' 
       ELSE
         CALL GTEXTS(15,LINE + 4,
     1               '***** DS MUST BE W OR L.')
         LINE = LINE + 1 
         FLAG = .TRUE.
      END IF
      IF (PLTSEL .EQ. 't'  .OR.  PLTSEL .EQ. 'T') THEN
         PLTSEL = 'T'
       ELSE IF (PLTSEL .EQ. 'v'  .OR.  PLTSEL .EQ. 'V') THEN
         PLTSEL = 'V'
       ELSE IF (PLTSEL .EQ. 'b'  .OR.  PLTSEL .EQ. 'B') THEN
         PLTSEL = 'B'
       ELSE
         CALL GTEXTS(15,LINE + 4, 
     1               '***** PS MUST BE T, V, OR B.') 
         LINE = LINE + 1 
         FLAG = .TRUE.  
      END IF
      IF ( FLAG ) THEN
         CALL SCHOLD
         GO TO 11
      END IF
      RETURN
      END
      SUBROUTINE PCMPTW
C
C             'PC' MENU, PART II.
C
C*********************************************************************
C
      INTEGER*4 ORINCZ
      LOGICAL FLAG
      LOGICAL ERROR
      CHARACTER*1 EA
      CHARACTER*1 ORAELG, ORSON, ORROT, ORPLTSEL, ORELOD
      CHARACTER*2 OPTION
      CHARACTER*4 BOMU, ORPLATE
      CHARACTER*25 ORTITLE0
C
      COMMON /SPECAL/ PAR1, TITLE0, TITLE1, TITLE2, SON, AELG,
     1                AFSC,STRACOFL,STRACOFR, FYLEINTERP, DATUMF,
     2                NDATUM, IFAULT, FFAULT, ROT, DEPOR, PLTSEL,
     3                AFLITH,LFILEL, LFILER, ELOD
             CHARACTER*40 PAR1, FYLEINTERP
             CHARACTER*25 TITLE0
             CHARACTER*80 TITLE1
             CHARACTER*80 TITLE2
             CHARACTER*1 SON
             CHARACTER*1 AELG
             CHARACTER*1 AFSC
             CHARACTER*40 STRACOFL, STRACOFR
             CHARACTER*1 DATUMF
             CHARACTER*40 NDATUM
             CHARACTER*1 IFAULT
             CHARACTER*40 FFAULT
             CHARACTER*1 ROT
             CHARACTER*1 DEPOR
             CHARACTER*1 PLTSEL
             CHARACTER*1 AFLITH
             CHARACTER*40 LFILEL, LFILER
             CHARACTER*1 ELOD
      COMMON /PLATE/PLATE
             CHARACTER*4 PLATE
      COMMON /SPECNU/ VSCALE, HSCALE, INCZ, SHLLMX, CORLMX
             REAL*4 VSCALE
             REAL*4 HSCALE
             INTEGER INCZ
             REAL*4 SHLLMX
             REAL*4 CORLMX
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
C
C         ORIGINAL PARAMETERS.
C
      ORTITLE0 = TITLE0
      ORPLATE = PLATE
      ORSON = SON
      ORAELG = AELG
      ORINCZ = INCZ
      ORROT = ROT
      ORPLTSEL = PLTSEL
      ORELOD = ELOD
C
  11  CALL MNMODE
      FLAG = .FALSE.
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40, 2,'MORE SPECIFICATIONS FOR THE DRAWING OF '//
     1          'A CROSS-SECTION')
      CALL TXTCLR(ICOLOR(3))
      LINE=2
      LINE = LINE + 1
      CALL GTEXTS( 3,LINE+1,'AG - AGENCY')
      CALL GTXTRJ(79,LINE+1,TITLE0)
      LINE = LINE + 1
      CALL GTEXTS( 3,LINE+1,'PB - INTERPRETER')
      CALL GTXTRJ(79,LINE+1,FYLEINTERP)
      CALL GTEXTS( 3,LINE+2,
     1     'PT - PLATE NUMBER, BLANK TO AVOID POSTING')
      CALL GTXTRJ(79,LINE+2,PLATE)
      CALL GTEXTS( 3,LINE+3,
     1     'LW - LABEL WELLS BY SEQUENTIAL NUMBER(S) OR NAME(N)')
      CALL GTXTRJ(79,LINE+3,SON)
      CALL GTEXTS( 3,LINE+4,
     1        'PW - POST ALL(A) OR ONLY EXTREME WIRELINE LOGS(E)')
      CALL GTXTRJ(79,LINE+4,AELG)
      LINE = LINE + 4
      CALL GTEXTS( 3,LINE+1,
     1    'DT - INTERVAL BETWEEN DEPTH TICK MARKS, ' // BOMU(BOM))
      CALL GTXTIN(79,LINE+1,INCZ)
      LINE = LINE + 1
      CALL GTEXTS( 3,LINE+1,
     1    'ED - PLOT VERTICAL SCALE AS ELEVATION(E) OR DEPTH (D)')
      CALL GTXTRJ(79,LINE+1,ELOD)
      LINE = LINE + 1
      CALL GTEXTS(3,LINE+1,
     ^ 'DO - DEPTH SCALE ORIGING, SEA LEVEL(S) OR SURFACE (KB)')
      CALL GTXTRJ(79,LINE+1,DEPOR)
      line = line + 1
      CALL GTEXTS(3,LINE+1,
     ^ 'DS - DEPTH SCALE ALONG PAPER WIDTH(W) OR ALONG PAPER LENGTH(L)')
      CALL gtxtrj(79,line+1,rot)
      line = line + 1
C      CALL gtexts(3,line+1,
C     ^  'PS - PLOT SELECTION:  TERMINAL(T), VERSATEC(V), OR BOTH(B)')
C      CALL gtxtrj(79,line+1,pltsel)
C      LINE = LINE + 2
      CALL GTEXTS( 3,LINE+1,
     1   'RE - RETURN TO PREVIOUS MENU IGNORING CHANGES.')
      LINE=LINE+1
      CALL GTEXTS( 3,LINE+1,'GO - COMMIT THE SELECTION')
      LINE=LINE+1
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. ' ') GO TO 11
C
      IF (OPTION .EQ. 'RE') THEN
         SON = ORSON
         AELG = ORAELG
         INCZ = ORINCZ
         ROT = ORROT
         PLTSEL = ORPLTSEL
         ELOD = ORELOD
         RETURN
      END IF
C
      IF (OPTION .EQ. 'GO') GO TO 51
      IF (OPTION .EQ. 'AG') CALL AGETTX(TITLE0)
      IF (OPTION .EQ. 'PB') CALL AGETTX(FYLEINTERP)
      IF (OPTION .EQ. 'PT') CALL AGETTX(PLATE)
      IF (OPTION .EQ. 'LW') THEN
         CALL AGETST(EA,1)
         IF (EA .EQ. 'S'  .OR.  EA .EQ. 'N') SON = EA
      ENDIF
      IF (OPTION .EQ. 'PW') CALL AGETST(AELG,1)
      IF (OPTION .EQ. 'DT') THEN
         CALL AGETIN(ITEMP,ERROR)
         IF (.NOT. ERROR) INCZ=ITEMP
        ENDIF
      IF (OPTION .EQ. 'DO') CALL AGETST(DEPOR,1)
      IF (OPTION .EQ. 'ED') CALL AGETST(ELOD,1)
      IF (OPTION .EQ. 'DS') CALL AGETST(ROT,1)
C      if (OPTION .EQ. 'PS') CALL agetst(PLTSEL,1)
      GO TO 15
C
C        INSPECT AND COMMIT WHEN CORRECT.
C
   51 CALL TXTCLR(ICOLOR(6))
      IF ( INCZ .LE. 0.0 ) THEN
         CALL GTEXTS(15,LINE+4,
     1  '***** NO NEGATIVE TICK MARK DISTANCES ALLOWED.')
            LINE = LINE + 1
            FLAG = .TRUE.
      END IF
      IF (AELG .EQ. 'e'  .OR.  AELG .EQ. 'E') THEN
         AELG = 'E'
       ELSE IF (AELG .EQ. 'a'  .OR.  AELG .EQ. 'A') THEN
         AELG = 'A' 
       ELSE
         CALL GTEXTS(15,LINE + 4,
     1               '***** PW MUST BE E OR A.')
         LINE = LINE + 1 
         FLAG = .TRUE.
      END IF
      IF (ELOD .EQ. 'e'  .OR.  ELOD .EQ. 'E') THEN
         ELOD = 'E'
       ELSE IF (ELOD .EQ. 'd'  .OR.  ELOD .EQ. 'D') THEN
         ELOD = 'D' 
       ELSE
         CALL GTEXTS(15,LINE + 4,
     1               '***** ED MUST BE E OR D.')
         LINE = LINE + 1 
         FLAG = .TRUE.
      END IF
      IF (ROT .EQ. 'w'  .OR.  ROT .EQ. 'W') THEN
         ROT = 'W'
       ELSE IF (ROT .EQ. 'l'  .OR.  ROT .EQ. 'L') THEN
         ROT = 'L' 
       ELSE
         CALL GTEXTS(15,LINE + 4,
     1               '***** DS MUST BE W OR L.')
         LINE = LINE + 1 
         FLAG = .TRUE.
      END IF
      IF (DEPOR .EQ. 's'  .OR.  DEPOR .EQ. 'S') THEN
         DEPOR = 'S'
       ELSE IF (DEPOR .EQ. 'k'  .OR.  DEPOR .EQ. 'K') THEN
         DEPOR = 'K' 
       ELSE
         CALL GTEXTS(15,LINE + 4,
     1               '***** DO MUST BE S OR K.')
         LINE = LINE + 1 
         FLAG = .TRUE.
      END IF
      IF (PLTSEL .EQ. 't'  .OR.  PLTSEL .EQ. 'T') THEN
         PLTSEL = 'T'
       ELSE IF (PLTSEL .EQ. 'v'  .OR.  PLTSEL .EQ. 'V') THEN
         PLTSEL = 'V'
       ELSE IF (PLTSEL .EQ. 'b'  .OR.  PLTSEL .EQ. 'B') THEN
         PLTSEL = 'B'
       ELSE
         CALL GTEXTS(15,LINE + 4, 
     1               '***** PS MUST BE T, V, OR B.') 
         LINE = LINE + 1 
         FLAG = .TRUE.  
      END IF
      IF ( FLAG ) THEN
         CALL SCHOLD
         GO TO 11
      END IF
      RETURN
      END
