*********************************************************************
C
C                     PLOT APPARENT DIP DIAGRAMS
C                     **************************
C
C*********************************************************************
C
      SUBROUTINE ADIDXX(J1STIM,NUWELL)
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 OPTION
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /DIGS/  DIGS1,DIGS2
      COMMON /DIGZ12/  DIGZS1,DIGZS2
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CODINC/ DINC
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /SIZES/ XSIZE,YSIZE
      COMMON /WSYMBL/ SYMBL1,SYMBL2
             INTEGER*4 SYMBL1(20),SYMBL2(20)
      COMMON /WIDENT/ IDENT1,IDENT2
             INTEGER*4 IDENT1(20),IDENT2(20)
      COMMON /WNAMES/ WNAME1,WNAME2
             CHARACTER*20 WNAME1(20),WNAME2(20)
      COMMON /WHDIST/ HDISTC
             REAL*4 HDISTC(20)
      COMMON /RLEVEL/ RELEV1,RELEV2
             REAL*4 RELEV1(20),RELEV2(20)
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /YSTART/ YSTART
C      COMMON /IFAULT/ IFAULT
C             INTEGER*2 IFAULT
      COMMON /WTHLEG/ WTHLEG
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      COMMON /LABELL/ LDSHAR,LDCORR,LDSHAM,LDCORM
             CHARACTER*4 LDCORM(20),LDCORR(20)
             CHARACTER*4 LDSHAM(20),LDSHAR(20)
      COMMON /SELECT/ PLTSEL
             CHARACTER*1 PLTSEL
      COMMON /DIPEXT/ SUMDEG, DIPMIN, DIPMAX, DEGINT, DELTAD
             REAL*4 DIPMIN(20), DIPMAX(20), DEGINT(20), DELTAD(20)
      COMMON /FLASTR/ FLASTR
             LOGICAL FLASTR
      COMMON /IFSC/ IFSC
      COMMON /RBOTZ/ RBOTZ
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /WIDTHSC/ WIDTHSCL, WIDTHSCR
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
      COMMON /LITHF/ LITHF
      COMMON /LITHFLAG/ NLITH, LITHFLAG, LITHLEGTOT
         INTEGER*4 LITHFLAG(10)
      COMMON /XTOPIM/ XTOPIM
      COMMON /TITLEADIP/ TITLEADIP
             CHARACTER*22 TITLEADIP
      COMMON /LOGPOS/ AELG
             INTEGER AELG
C
      include 'wldwel.inc'
      include 'wldhdr.inc'
C
      MENU='ADIP'
      NISECT=0
      FLASTR = .TRUE.
   11 DO 12 I = 1, NLITH
   12 LITHFLAG(I) = 0
C
C          DATA ENTRY.
C
      CALL READAT(J1STIM,OPTION,LINE,4,NISECT)
      IF (OPTION .EQ. 'RE') RETURN
      IF (OPTION .NE. 'GO') GO TO 11
      J1STIM = 1
C     
C           CALCULATION OF APPARENT DIPS.
C
      CALL APEDIP
C
C          CORRELATION BOX BOUNDARIES.
C
      CALL BXBOUN(YSTART)

C
C         CALCULATE SIZE OF PLOT.
C
      YSP2=YSTART
      XSIZE=0.5+XBOT
      IF (AELG .EQ. 0) THEN
          NW = 1
         ELSE
          NW = NPAIRS
      ENDIF
      WLEG = 0.0
      IF (LITHF .EQ. 1  ) THEN
         WLEG = WLEG + 1.0
         IF (IFSC .EQ. 0) WLEG = WLEG + 0.2
      END IF
      YSIZE=(YSTART+NW*(0.1+(2.0*TKWD)+DSWH)+(SUMDEG/HSCALE))
     1                     + IFSC*(WIDTHSCL + 0.2) + WLEG +0.1
      CALL TOOBIG(LINE,*11)
C
C          INITIALIZE PLOTTING DEVICE
C
      CALL RPTRAC(XSIZE,YSIZE+0.5+WTHLEG+0.5)
      IF (PLTSEL .EQ. 'V') THEN
         CALL MNMODE
         CALL BUSY(0,15,2,1)
        ENDIF
      CALL GMPINI(XSIZE,YSIZE+0.5+WTHLEG+1.0)
C
C          DIGITIZED LOG FILE READING
C
      DO 1600 NPS=1,NPAIRS
      JJ=NPS
      ID1=WSNUMB(NPS)
      ID2=WSNUMB(NPS+1)
      CALL RWELLH
C
C          STRATIGRAPHIC COLUMN
C
      IF (NPS .EQ. 1  .AND.  IFSC .EQ. 1 )
     1   CALL STRACO(STRACOFL, 1, YSP2)
C
      HDIST = XYTODC * SQRT((WLXLOC(ID1)-WLXLOC(ID2))**2+
     1                       (WLYLOC(ID1)-WLYLOC(ID2))**2)
      DIGZS1=DEPRMN
      DIGZS2=DEPMMN
      IL1=(DEPRMX-DEPRMN)/DINC+1.05
      IL2=(DEPMMX-DEPMMN)/DINC+1.05
      IL3=IL1
      IL4=IL2
      IF (NPS .EQ. 1) THEN
         CALL REALOG(LOG1,IL1,RLOG1,CLG1MN,CLG1MX)
         CALL REALOG(LOG3,IL3,RLOG3,SLG3MN,SLG3MX)
        ELSE
         DO 102 I=1,IL1
         RLOG1(I)=RLOG2(I)
         RLOG3(I)=RLOG4(I)
  102    CONTINUE
        ENDIF
      CALL REALOG(LOG2,IL2,RLOG2,CLG2MN,CLG2MX)
      CALL REALOG(LOG4,IL4,RLOG4,SLG4MN,SLG4MX)
      DIGS1 = DIGZS1 - DATUM1
      DIGS2 = DIGZS2 - DATUM2
C
C          DRAW THE WELL LOGS.
C
      IDSHAR = LDSHAR(JJ)
      IDCORR = LDCORR(JJ)
      IDSHAM = LDSHAM(JJ)
      IDCORM = LDCORM(JJ)
      DIGS1=DIGZS1-RELEV1(JJ)
      DIGS2=DIGZS2-RELEV2(JJ)
      YSP1=YSP2
      CALL TOPBOT(JJ+1,TOPZM,BOTZM)
      CALL TOPBOT(JJ,TOPZR,BOTZR)
      IF (JJ .EQ. 1  .AND.  LITHF .EQ. 1) 
     1   CALL LITHANNOT(LFILEL, 1, YSP1,RLOG3,IL3,DIGS1,
     2                  TOPZR,BOTZR,YSP2)
      YSP1=YSP2
      CALL PLODIP(TOPZR,RBOTZ,YSP1, YSP2, NPS)
      IF ((AELG .GT. 0 ) .OR. (JJ .EQ. 1))
     1CALL PPTSPE(IDENT1(JJ),WNAME1(JJ),RLOG3,IL3,RLOG1,IL1,DIGS1,
     2            TOPZR,BOTZR,YSP1,SYMBL1(JJ),JJ,NPAIRS,'R')
 1550 IF ( JJ .EQ. NPAIRS ) GO TO 1600
      IF ( AELG .EQ. 0 ) GO TO 1600
      YSP2=0.1+YSP1+(2.0*TKWD)+DSWH+(DEGINT(JJ)/HSCALE)
      CALL PPTSPE(IDENT2(JJ),WNAME2(JJ),RLOG4,IL4,RLOG2,IL2,DIGS2,
     1            TOPZM,BOTZM,YSP2,SYMBL2(JJ),JJ,NPAIRS,'M')
 1600 CONTINUE
C
C          DISPLAY LEGENDS
C
      IF (NPAIRS .EQ. 1) THEN
         TITLEADIP = 'APPARENT DIP DIAGRAM'
       ELSE
         TITLEADIP = 'APPARENT DIP DIAGRAMS'
      END IF
      CALL LEGEND
      CALL INDEXM(NUWELL)
      LITHLEGTOT = 0
      DO 700 I = 1, NLITH
  700 LITHLEGTOT = LITHLEGTOT + LITHFLAG(I)
      HILITHLEG = XTOPIM - 1.1 - 0.9*(LITHLEGTOT+1)/2.0
      IF (LITHLEGTOT .GT. 0  .AND.  
     1    HILITHLEG .GE. 7.0 ) CALL LITHLEGEND
C
C          DISPLAY TITLE
C
      CALL DTITLE
C
C          CLOSE PLOTTING FILE.
C
      CALL GMPFIN
      CALL SCHOLD
      CALL XINITT
      GO TO 11
      END
C***********************************************************************
C
C                  CALCULATION OF APPARENT DIPS.
C
C***********************************************************************
C
      SUBROUTINE APEDIP
C
      INCLUDE 'log.inc'
C
      LOGICAL STENFL
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /NCO/    NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /TRACNG/ TSTART,TEND
      COMMON /ADIPC/ ADIP
             REAL*4 ADIP(LOG_LENGTH,20)
      COMMON /ADIPSG/ ADIPSG
             LOGICAL ADIPSG(LOG_LENGTH,20)
      COMMON /DIPINT/ IDIPST, IDIPEN
             INTEGER*4 IDIPST(20), IDIPEN(20)
      COMMON /DIPEXT/ SUMDEG, DIPMIN, DIPMAX, DEGINT, DELTAD
             REAL*4 DIPMIN(20), DIPMAX(20), DEGINT(20), DELTAD(20)
      COMMON /AZIMUT/ AZIMUT(20)
C
      include 'wldwel.inc'
      include 'wldhdr.inc'
C
      SUMDEG = 0.0
      DO 800 J = 1,NPAIRS
      ID1=WSNUMB(J)
      ID2=WSNUMB(J+1)
      STENFL = .TRUE.
      IDIPST(J) = -1
      IDIPEN(J) = -1
      DIPMIN(J) = 1.0E30
      DIPMAX(J) = -1.0E30
C
C           DISTANCE BETWEEN WELLS.
C
      DX = WLXLOC(ID2) - WLXLOC(ID1)
      DY = WLYLOC(ID2) - WLYLOC(ID1)
      HDIST = XYTODC * SQRT(DX**2 + DY**2)
C
C          AZIMUTH
C
      AZIMUT(J) = ATAN2(DY,DX)
C
C          FOCUS SEARCH WITHIN GIVEN BOUNDARIES.
C
      DO 500 I = 1,NCORRL(J)
      IF ( COMAT(I,J) .LT. TSTART ) GO TO 500
      IF ( COMAT(I,J) .GT. TEND  ) GO TO 700
C
C          POINTERS
C
      IF( STENFL ) THEN
         STENFL = .FALSE.
         IDIPST(J) = I
      END IF
      IDIPEN(J) = I
C
C          APPARENT DIP.
C
      J20 = J + 20
      DZ = COMAT(I,J20) - COMAT(I,J)
      ADIP(I,J) = 57.29578*ATAN2(DZ,HDIST)
      IF ( ADIP(I,J) .LT. 0.0 ) THEN
         ADIP(I,J) = - ADIP(I,J)
         ADIPSG(I,J) = .FALSE.
       ELSE
         ADIPSG(I,J) = .TRUE.
      END IF
C
C          EXTREME VALUES
C
      IF( ADIP(I,J) .LT. DIPMIN(J) ) DIPMIN(J) = ADIP(I,J)
      IF( ADIP(I,J) .GT. DIPMAX(J) ) DIPMAX(J) = ADIP(I,J)
  500 CONTINUE
  700 IF ( IDIPEN(J) .EQ. -1 ) THEN
         DIPMIN(J) = 0.0
         DIPMAX(J) = 0.5*HSCALE
      END IF
      IF ( IDIPST(J) .EQ. IDIPEN(J) ) THEN
         DIPMIN(J) =  ADIP(1,J) - SYMSZ/HSCALE
         DIPMAX(J) =  ADIP(1,J) + SYMSZ/HSCALE
      END IF
      CALL GEXTRE(DIPMIN(J), DIPMAX(J), DELTAD(J))
      DEGINT(J) =  DIPMAX(J) - DIPMIN(J)
      SUMDEG = SUMDEG + DEGINT(J)
  800 CONTINUE
      RETURN
      END
C***********************************************************************
C
C                  PLOTTING OF APPARENT DIPS.
C
C***********************************************************************
C
      SUBROUTINE PLODIP(TOPZR,BOTZR,YSP1, YSP2, J)
C
      INCLUDE 'log.inc'
C
      CHARACTER*12  TITLE /'Dip, degrees'/
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /DIPEXT/ SUMDEG, DIPMIN, DIPMAX, DEGINT, DELTAD
             REAL*4 DIPMIN(20), DIPMAX(20), DEGINT(20), DELTAD(20)
      COMMON /DIPINT/ IDIPST, IDIPEN
             INTEGER*4 IDIPST(20), IDIPEN(20)
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /ADIPC/ ADIP
             REAL*4 ADIP(LOG_LENGTH,20)
      COMMON /ADIPSG/ ADIPSG
             LOGICAL ADIPSG(LOG_LENGTH,20)
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /WCCOEf/ WCCOE
             REAL*4 WCCOE(LOG_LENGTH,20)
      COMMON /AZIMUT/ AZIMUT(20)
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /LITHF/ LITHF
C
      TAILLN = 0.5*SYMSZ

C
C          DIAGRAM BOUNDARIES.
C      
      IF (AELG .EQ. 1  .OR.
     1   ((AELG .EQ. 0)  .AND.  (J .EQ. 1)  .AND.  
     2    (LITHF .EQ. 1  .OR.  LITHF .EQ. 3))) 
     3   YLEFT=0.05+YSP1+(2.0*TKWD)+DSWH
      YRIGHT=YLEFT+(DEGINT(J)/HSCALE)
      BBOT = AMIN1(XBOT,XTOP + ((BOTZR - TOPZR)/VSCALE))
C
C          POST TADPOLE HEADS.
C
      DO 500 I = IDIPST(J), IDIPEN(J)
      DEPTH = XTOP + ((COMAT(I,J) - TOPZR)/VSCALE)
      DIP = YLEFT + ((ADIP(I,J) - DIPMIN(J))/HSCALE)
      CALL PENSET(WCCOE(I,J),NUPEN)
      CALL GMPLCR(NUPEN)
      CALL GMPOIL(DEPTH, DIP, 11, 0.5*SYMSZ,0.01)
      IF(ADIP(I,J) .EQ. 0.0)  GO TO 500
C
C          TADPOLE TAILS.
C
C             Rotate the azimuth in 180 degrees for negative dips.
      IF ( ADIPSG(I,J) ) THEN
         AZIM = AZIMUT(J)
       ELSE
         IF ( AZIMUT(J) .GT. 0.0 ) THEN
           AZIM = AZIMUT(J) - 3.14159
          ELSE
           AZIM = 3.14159 + AZIMUT(J)
         END IF
      END IF
C             Post
      XTAIL = DEPTH - TAILLN*SIN(AZIM)
      YTAIL = DIP + TAILLN*COS(AZIM)
      CALL GMPMOV(DEPTH,DIP)
      CALL GMPDRW(XTAIL, YTAIL)
  500 CONTINUE
c
c          DIP SCALE
C
      CALL GMPLCR(1)
      TZLSZ = 1.25*ZLSZ
      CALL GMPTXT(TITLE,XTOP-2.0*TZLSZ,0.5*(YLEFT+YRIGHT),
     1             TZLSZ,90.0,JUSTIF)
      DELDIP = DIPMAX(J) - DIPMIN(J)
      IF (DELDIP .GT. 0) THEN
         IF (DELDIP .GT .10.0) THEN
            NODECP = 1
          ELSE
            NODECP = AINT(ABS(ALOG10(DIPMAX(J) - DIPMIN(J))) + 1)
          END IF
       ELSE
         NODECP = 4
      END IF
      IF (AELG .EQ. 0) THEN
         SCMIN = YLEFT + TZLSZ
         SCMAX = YRIGHT - TZLSZ
       ELSE
         SCMIN = YLEFT - TZLSZ
         SCMAX = YRIGHT + TZLSZ
      END IF
      CALL GMPREA(DIPMIN(J),NODECP,XTOP-0.5*TZLSZ,SCMIN,TZLSZ,90.0,-1)
      CALL GMPREA(DIPMAX(J),NODECP,XTOP-0.5*TZLSZ,SCMAX,TZLSZ,90.0,1)
C
C          TICK MARKS
C
      CALL GMPLCR(5)
      CALL ADIPTM(DIPMIN(J), DIPMAX(J), DELTAD(J), BBOT, YLEFT, YRIGHT)
C
C          DRAW BOX.
C      
      IF ( XTOP .GE. BBOT ) GO TO 900
      CALL PLTBOX(J,NPAIRS,1,XTOP,BBOT,YRIGHT,YLEFT)
      IF (AELG .EQ. 0) YLEFT=YRIGHT
  900 RETURN 
      END
      SUBROUTINE ADIPTM(RMN,RMX,F, BBOT, YLEFT, YRIGHT)
C
C                   DRAW TICK MARKS ON THE DIP SCALE.
C
C***********************************************************************
C
      COMMON /TICKMS/ TIC10, TIC50, TIC100
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      D = RMX - RMN
      N = (D/F) + 1
      DY = (YRIGHT - YLEFT)/(N - 1)
      Y = YLEFT
      DO 400 I =1, N
      IF (I .GT. 1  .AND. I .LT. N) THEN
         CALL GMPMOV(XTOP,Y)
         CALL GMPDRW(XTOP+0.8*TIC50,Y)
      END IF
      Y = Y + DY
  400 CONTINUE
      Y = YLEFT
      DO 500 I =1, N
      IF (I .GT. 1  .AND. I .LT. N) THEN
         CALL GMPMOV(BBOT,Y)
         CALL GMPDRW(BBOT-0.8*TIC50,Y)
      END IF
      Y = Y + DY
  500 CONTINUE
      RETURN
      END
      SUBROUTINE INDEXM(NUWELL)
C
C                   DRAWS INDEX MAP ON CROSS-SECTIONS.
C
C***********************************************************************
C
      CHARACTER*9 TITLE /'INDEX MAP'/
C
      REAL*4 XWL(1000), YWL(1000)
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /SIZES/ XSIZE, YSIZE
      COMMON /WTHLEG/ WTHLEG
      COMMON /XRCOMM/ XR
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /XTOPIM/ XTOPIM
C
      include 'welldb.inc'
      include 'wldwel.inc'
C
      CALL GMPLCR(1)
C
C         SET BOUNDARIES AND SCALE.
C
      YLEFT = 0.5 + YSIZE
      YRIGHT = YLEFT + WTHLEG
      XBOT = XR - 0.2
      XBOTM = XBOT - 1.7*TTLSZ
      DX = GWXMAX - GWXMIN
      DY = GWYMAX - GWYMIN
      IF (DY .GT. 1.5*DX) THEN
          SCALE = 1.2*DY/WTHLEG
          RMARG = (WTHLEG - (DX/SCALE))/2.0
          BMARG = 0.1*DY/SCALE
       ELSE
          SCALE = 1.2*DX/WTHLEG
          RMARG = 0.1*DX/SCALE
          BMARG = AMAX1(0.3,0.1*DY/SCALE)
      END IF
      XTOPIM = XBOTM - (2.0*BMARG + DY/SCALE)   
C
C          DRAW BOX.
C
      CALL PLTBOX(0,0,1,XTOPIM,XBOT,YRIGHT,YLEFT)
C
C          DISPLAY TITLE.
C
      CALL GMPMOV(XBOTM,YLEFT) 
      CALL GMPDRW(XBOTM,YRIGHT)
      CALL GMPTXT(TITLE,XBOT-0.6*TTLSZ, YLEFT+0.5*WTHLEG,0.5*TTLSZ,
     1            90.0,JUSTIF)
C
C          POST WELLS.
C
      DO 500 I = 1, NUWELL
      CALL GETWEL(IWLPTR(I),IWELLR)
      XWL(I) = YLEFT + RMARG + (WXXLOC - GWXMIN)/SCALE
      YWL(I) = XBOTM - BMARG - (WYYLOC - GWYMIN)/SCALE
      CALL GMPOIL(YWL(I),XWL(I),IWPSCD,0.5*SYMSZ,0.01)
      CALL GMPTXT(WELLPI, YWL(I)-0.4*SYMSZ, XWL(I),
     1                                  ZLSZ,90.0,JUSTIF)
  500 CONTINUE
C
C          DRAW NORTH ARROW.
C
      CALL DNORTH(XBOTM,YRIGHT,YLEFT,NUWELL,YWL,XWL)
C
C          DISPLAY CROSS-SECTION LOCATION.
C
      CALL GMPLCR(2)
      IDN = WSNUMB(1)
      XW = YLEFT + RMARG + (WLXLOC(IDN) - GWXMIN)/SCALE
      YW = XBOTM - BMARG - (WLYLOC(IDN) - GWYMIN)/SCALE
      CALL GMPMOV(YW,XW) 
      DO 700 I = 1,NPAIRS
      IDN = WSNUMB(I+1)
      XW = YLEFT + RMARG + (WLXLOC(IDN) - GWXMIN)/SCALE
      YW = XBOTM - BMARG - (WLYLOC(IDN) - GWYMIN)/SCALE 
      CALL GMPDRW(YW,XW)
  700 CONTINUE
C    
      RETURN
      END
      SUBROUTINE WHEREN(XBOT,YRIGHT,YLEFT,NUWELL,XWL,YWL,X,Y)
C
C           LOCATES THE NORTH ARROW
C
      REAL*4 XWL(1000), YWL(1000), DC(4)
      REAL*4 XCORNER(4), YCORNER(4), XARROW(4), YARROW(4)
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /XTOPIM/ XTOPIM
      PARAMETER (XOFF=0.65, YOFF=0.5)
C
      DO 50 I = 1,4
   50 DC (I) = 1.0E30
      XCORNER(1) = XBOT
      XCORNER(2) = XBOT
      XCORNER(3) = XTOPIM
      XCORNER(4) = XTOPIM
      YCORNER(1) = YLEFT
      YCORNER(2) = YRIGHT
      YCORNER(3) = YRIGHT
      YCORNER(4) = YLEFT
C
      XARROW(1) = XBOT-XOFF
      XARROW(2) = XBOT-XOFF
      XARROW(3) = XTOPIM+XOFF
      XARROW(4) = XTOPIM+XOFF
      YARROW(1) = YLEFT+YOFF
      YARROW(2) = YRIGHT-YOFF
      YARROW(3) = YRIGHT-YOFF
      YARROW(4) = YLEFT+YOFF
C           CLOSEST DISTANCE TO EACH CORNER
      DO 200 I = 1,NUWELL
      DO 100 J = 1,4
      DIST = SQRT((XWL(I)-XCORNER(J))*(XWL(I)-XCORNER(J)) +   
     1            (YWL(I)-YCORNER(J))*(YWL(I)-YCORNER(J)))
      IF ( DIST .LT. DC(J) ) DC(J) = DIST
  100 CONTINUE
  200 CONTINUE
      IBEST = 1
      BDIST = DC(1)
      DO 300 I = 2,4
      IF ( DC(I) .GT. BDIST) THEN
         BDIST = DC(I)
         IBEST = I
      END IF
  300 CONTINUE
      X = XARROW(IBEST)
      Y = YARROW(IBEST)
C
      RETURN
      END
      SUBROUTINE DNORTH(XBOT,YRIGHT,YLEFT,NUWELL,XWL,YWL)
C
C           DRAWS A NORTH ARROW.
C
      REAL*4 XWL(1000), YWL(1000)
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /XTOPIM/ XTOPIM
C
      CALL WHEREN(XBOT,YRIGHT,YLEFT,NUWELL,XWL,YWL,X,Y)
      CALL GMPTXT('N', X, Y, ZLSZ,90.0,JUSTIF)
C
C        TAIL
C
      CALL GMPMOV(X+0.02, Y) 
      CALL GMPDRW(X+0.18, Y)
      CALL GMPMOV(X+0.06, Y) 
      CALL GMPDRW(X+0.08, Y - 0.02)
      CALL GMPDRW(X+0.20, Y - 0.02)
      CALL GMPDRW(X+0.18, Y)
      CALL GMPDRW(X+0.20, Y + 0.02)
      CALL GMPDRW(X+0.08, Y + 0.02)
      CALL GMPDRW(X+0.06, Y)
C
C        HEAD
C
      CALL GMPMOV(X-ZLSZ-0.02, Y) 
      CALL GMPDRW(X-ZLSZ-0.08, Y)
      CALL GMPDRW(X-ZLSZ-0.06, Y-0.02)
      CALL GMPDRW(X-ZLSZ-0.20, Y)
      CALL GMPDRW(X-ZLSZ-0.06, Y+0.02)
      CALL GMPDRW(X-ZLSZ-0.08, Y)
C
      RETURN
      END
C***********************************************************************
C
C                  PLOTTING OF TRUE DIPS.
C
C***********************************************************************
C
      SUBROUTINE PLTDIP(TOPZR,BOTZR,YSP1, YSP2, J, DIPMIN, DIPMAX,
     1                  DELTAD)
C
      INCLUDE 'log.inc'
C
      INTEGER HDSYMB
C
      CHARACTER*12  TITLE /'Dip, degrees'/
      COMMON /LOGPOS/ AELG
             INTEGER AELG
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /DIPAZ/  TDIP(LOG_LENGTH), AZIMUTH(LOG_LENGTH)
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /IPERC/ IPER
      COMMON /PERCOR/ PERCO
C            PERSISTENT CORRELATION MATRIX.
             REAL*4 PERCO(LOG_LENGTH,21)
      COMMON /AQCORR/ AVQCOR, PACORR
C            AVERAGE CORRELATION STRENGTH OF A TRUE DIP.
            REAL*4 AVQCOR(LOG_LENGTH)
C            INDICATOR OF PERSISTENCE:  .TRUE. IF DIP BASED ON TWO
C            CORRELATIONS, .FALSE. IF ONLY ON A CORRELATION AND
C            AN INTERPOLATION.
            LOGICAL PACORR(LOG_LENGTH)
C
      TAILLN = 0.5*SYMSZ
      DEGINT = DIPMAX - DIPMIN
C
C          DIAGRAM BOUNDARIES.
C   
      YLEFT=0.05+YSP1+(2.0*TKWD)+DSWH
      YRIGHT=YLEFT+(DEGINT/HSCALE)
      BBOT = AMIN1(XBOT,XTOP + ((BOTZR - TOPZR)/VSCALE))
C
C          POST TADPOLE HEADS.
C
      DO 500 I = 1, IPER
      DEPTH = XTOP + ((PERCO(I,2) - TOPZR)/VSCALE)
      DIP = YLEFT + ((TDIP(I) - DIPMIN)/HSCALE)
      CALL PENSET(AVQCOR(I),NUPEN)
      CALL GMPLCR(NUPEN)
      IF ( PACORR(I) )  THEN
         HDSYMB = 11
       ELSE
         HDSYMB = 15
      END IF
      CALL GMPOIL(DEPTH, DIP, HDSYMB, 0.5*SYMSZ,0.01)
      IF(TDIP(I) .EQ. 0.0)  GO TO 500
C
C          TADPOLE TAILS.
C
      XTAIL = DEPTH - TAILLN*SIN(AZIMUTH(I))
      YTAIL = DIP + TAILLN*COS(AZIMUTH(I))
      CALL GMPMOV(XTAIL, YTAIL)
      IF ( PACORR(I) )  THEN
         XHEAD = DEPTH
         YHEAD = DIP
       ELSE
         XHEAD = DEPTH - 0.25*TAILLN*SIN(AZIMUTH(I))
         YHEAD = DIP + 0.25*TAILLN*COS(AZIMUTH(I))
      END IF
      CALL GMPDRW(XHEAD, YHEAD)
  500 CONTINUE
C
C          DIP SCALE
C
      CALL GMPLCR(1)
      TZLSZ = 1.50*ZLSZ
      CALL GMPTXT(TITLE,XTOP-2.0*TZLSZ,0.5*(YLEFT+YRIGHT),
     1             TZLSZ,90.0,JUSTIF)
      CALL GMPREA(DIPMIN, 2,XTOP-0.5*TZLSZ,YLEFT,TZLSZ,90.0,-1)
      CALL GMPREA(DIPMAX, 2,XTOP-0.5*TZLSZ,YRIGHT,TZLSZ,90.0,1)
C
C          TICK MARKS
C
      CALL GMPLCR(5)
      CALL ADIPTM(DIPMIN, DIPMAX, DELTAD, BBOT, YLEFT, YRIGHT)
C
C          DRAW BOX.
C      
      IF ( XTOP .GE. BBOT ) GO TO 900
      CALL PLTBOX(0,0,1,XTOP,BBOT,YRIGHT,YLEFT)
      IF (AELG .EQ. 0) YLEFT=YRIGHT
  900 RETURN 
      END
      SUBROUTINE TDIPAP(II, DIPMIN, DIPMAX, DELTAD)
C
C            COMPUTES THE DIP AND THE AZIMUTH OF A PLANE
C                        DEFINED BY THREE POINTS.
C
C***********************************************************************
C            The dip is a line of maximum slope that is perpendicular to
C         the strike.  The dip is in the plane, thus is also
C         perpendicular to a vector perpendicular to the plane.  The 
C         vector perpendicular to the plane define by the points A,
C         B, and C is (Munem and Foulis, 1984, p. 783):

C                N = n1*i + n2*j + n3*k = vector(AB)xvector(AC).
C
C            Let (x1, y1, z1), (x2, y2, z2), and (x3, y3, z3) be the
C         the points defining the plane.  Then:
C
C                                       |    i       j       k    |
C               vector(AB)xvector(AC) = | (x2-x1) (y2-y1) (z2-z1) |.
C                                       | (x3-x1) (y3-y1) (z3-z1) |
C
C            The points must not be on line.  This implies that
C         vector(AB)*vector(AC)/(|AB| |AC|) must be different from
C         zero (Munem and Foulis, 1984, p. 794). 
C      
C            If |N| = sign(T)*sqrt(n1*n1 + n2*n2 + n3*n3), then the 
C         direction cosines of N are:
C
C         cos a = n1/|N|     cos b = n2/|N|    cos c = n3/|N|.
C  
C            If the plane ABC does not go through the origin, T is
C         equal to the sign of D, the distance from the plane ABC to
C         the origin, which is given by:
C
C                D = n1*x(l) + n2*y(l) + n3*z(l),  l = 1, 2, or 3.
C
C         If D is zero, take the sign of n3, or the sign of n2 if
C         both D and n3 are zero (Larsen, 1960, p. 214).  This is 
C         the general case.  Here, because of previous conventions,
C         we need to take the opposite sign.         
C
C            The azimuth is angle between a horizontal axis and the
C         projection of a plane perpendicular to the strike.  Because
C         the strike is a horizontal line, such plane is vertical.  And
C         because the strike is in the plane ABC, such plane is    
C         parallel to N.  Thus, the azimuth is 
C
C                       azimuth = arctan (cos b/cos a)
C
C            The dip is the angle that the steepest slope make with the
C         horizontal plane.  Because the steepest slope is perpendicular
C         to N and the vertical cartesian axis is perpendicular to the
C         horizontal plane, the dip is equal to the angle between N and
C         the vertical axis, namely cos c.  The convention is that the
C         k axis points upwards, but because in our case it points
C         downwards, we need a sign change. 
C
C                       dip = arcos(-cos c)
C
C         REFERENCES
C
C         Larsen, H. D., 1960, Rinehart Mathematical Tables, Formuleas,
C              and Curves:  Holt, Rinehart and Winston, New York, 280 p. 
C
C         Munem, M. A. and D. J. Foulis, 1984, Calculus with Analytic 
C              Analytic Geometry:  Worth Publishers, Inc., New York.,
C              1048 p.
C
c***********************************************************************
C
      include 'wldwel.inc'
      INCLUDE 'log.inc'
      include 'wldhdr.inc'
C
      COMMON /DIPAZ/  TDIP(LOG_LENGTH), AZIMUTH(LOG_LENGTH)
      COMMON /PERCOR/ PERCO
C            PERSISTENT CORRELATION MATRIX.
             REAL*4 PERCO(LOG_LENGTH,21)
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /IPERC/ IPER
C
      REAL*4 X(3), Y(3), Z(3)
      REAL*4 N1, N2, N3
      REAL*4 NX, NY, NZ
      REAL*4 M1, M2
C
C         WELL LOCATIONS
C
      ID1=WSNUMB(II-1)
      ID2=WSNUMB(II)
      ID3=WSNUMB(II+1)
      X(1) = XYTODC*WLXLOC(ID2) 
      X(2) = XYTODC*WLXLOC(ID1)
      X(3) = XYTODC*WLXLOC(ID3)
      Y(1) = XYTODC*WLYLOC(ID2) 
      Y(2) = XYTODC*WLYLOC(ID1)
      Y(3) = XYTODC*WLYLOC(ID3)
C
C         ELEVATIONS
C
   50 DO 100 I = 1, IPER
      Z(1) = PERCO(I,2)
      Z(2) = PERCO(I,1)
      Z(3) = PERCO(I,3)
C 
C        PROJECTIONS OF TWO VECTORS THROUGH THE TWO POINTS.
C
      X12 = X(1) - X(2)
      Y12 = Y(1) - Y(2)
      Z12 = Z(1) - Z(2)
      X13 = X(1) - X(3)
      Y13 = Y(1) - Y(3)
      Z13 = Z(1) - Z(3)
C
C        CHECK FOR ALIGNMENT
C
      PROD = X12*X13 + Y12*Y13 + Z12*Z13
      M1 = X12*X12 + Y12*Y12 + Z12*Z12
      M2 = X13*X13 + Y13*Y13 + Z13*Z13
      ANGLE = ACOS((PROD/SQRT(M1*M2)))
      IF (ANGLE .EQ. 0.0) GO TO 300
C
C        THE PERPENDICULAR VECTOR
C
      N1 = Z13*Y12 - Z12*Y13
      N2 = Z12*X13 - Z13*X12
      N3 = X12*Y13 - X13*Y12
C
C           DISTANCE TO ORIGIN
C
      D = N1*X(1) + N2*Y(1) + N3*Z(1)
C
C           SIGN.
C
      IF (D .NE. 0.0) THEN
         SIGNN = -ABS(D)/D
       ELSE
         IF (N3 .NE. 0.0) THEN
            SIGNN = -ABS(N3)/N3
          ELSE
            IF (N2 .NE. 0.0) THEN
               SIGNN = -ABS(N2)/N2
             ELSE
               IF (N1 .NE. 0.0 ) THEN
                  SIGNN = -ABS(N1)/N1
                ELSE
                  AZIMUTH(I) = 0.0
                  TDIP(I) = 0.0
                  GO TO 50 
               END IF
            END IF
         END IF
      END IF
C
C           DIRECTION COSINES
C
      DENOM = SIGNN*SQRT( N1*N1 + N2*N2 + N3*N3 )
      NX = N1/DENOM
      NY = N2/DENOM
      NZ = N3/DENOM
C
C           RESULTS
C
      TDIP(I) = 57.29578*ACOS(-NZ)
      AZIMUTH(I) = ATAN2(NY, NX)
      IF ( NZ .GT. 0.0 ) THEN
         TDIP(I) = 180.0 - TDIP(I)
         IF ( AZIMUTH(I) .GT. 0.0 ) THEN
           AZIMUTH(I) = AZIMUTH(I) - 3.14159
          ELSE
           AZIMUTH(I) = 3.14159 + AZIMUTH(I)
         END IF
      END IF
  100 CONTINUE
C
C          EXTREMES.
C
  300 DIPMIN = 1.0E30
      DIPMAX = -1.0E30
      DO 200 I = 1,IPER
      IF( TDIP(I) .LT. DIPMIN ) DIPMIN = TDIP(I)
      IF( TDIP(I) .GT. DIPMAX ) DIPMAX = TDIP(I)
  200 CONTINUE
      CALL GEXTRE(DIPMIN, DIPMAX, DELTAD)
      DEGINT =  DIPMAX - DIPMIN
      RETURN
      END
      REAL FUNCTION FTDIP(IWELL,IFAULT)
C
C        The orientation in space of the intersection of two planes
C        is given by the vector perpendicular to the normal vectors
C        of these planes.
C        
C        The cross-sectional plane is a vertical plane through the
C        location of a pair of wells.  The fault plane is given by
C        the azimuth and the dip.  The azimuth is measured from the
C        East and is positive counterclockwise. The dip is measure
C        from a horizontal plane and is positive toward the vertical
C        pointing toward the center of the earth.
C        
C        We are interested only on the dip of the line of intersection.
C        The dip for the vector parallel to such is mesured from the
C        vertical.  Thus, a rotation is necessary to have it measured
C        from the conventional horizontal plane. 
C        
C********************************************************************* 
C          
      include 'wldwel.inc'
      INCLUDE 'log.inc'
      include 'wldhdr.inc'
C
      REAL*4 X(2), Y(2)
      REAL*4 NXX, NYX, NZX
      REAL*4 NXF, NYF, NZF
      REAL*4 NZL
      REAL*4 N1L, N2L, N3L
      PARAMETER (RAD=57.29578)
C
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /PFAULT/ NFAULT,NWF,ZFAULT,DIPF
             INTEGER*4 NWF(MAX_NO_FAULTS)
             REAL*4 ZFAULT(MAX_NO_FAULTS)
             REAL*4 DIPF(MAX_NO_FAULTS)
      COMMON /AZIMFA/  AZIMFA(MAX_NO_FAULTS)
C
C        WELL LOCATIONS
C
      ID1=WSNUMB(IWELL)
      ID2=WSNUMB(IWELL+1)
      X(1) = XYTODC*WLXLOC(ID1) 
      X(2) = XYTODC*WLXLOC(ID2)
      Y(1) = XYTODC*WLYLOC(ID1) 
      Y(2) = XYTODC*WLYLOC(ID2)
C
C         PERPENDICULAR VECTOR TO THE CROSS-SECTIONAL PLANE.
C
      DX = X(2) - X(1)
      DY = Y(2) - Y(1)
      AZ =  ATAN2(DY,DX)
      NXX = COS(AZ - 90.0/RAD)
      NYX = SIN(AZ - 90.0/RAD)
      NZX = 0.0
C
C           THE FAULT PLANE.
C
      NZF = -COS(DIPF(IFAULT)/RAD)
      NXF = SQRT((1.0 - NZF*NZF)/
     1    (1.0 + TAN(AZIMFA(IFAULT)/RAD)*TAN(AZIMFA(IFAULT)/RAD)))
      IF ( AZIMFA(IFAULT) .GT. 90.0  .AND.
     1     AZIMFA(IFAULT) .LT. 270.0) NXF = -NXF
      NYF = NXF*TAN(AZIMFA(IFAULT)/RAD)
C
C           VECTOR PERPENDICULAR TO THE NORMAL VECTORS,
C           THUS PARALLEL TO THE INTERSECTION LINE.
C
      N1L = NZF*NYX - NZX*NYF
      N2L = NZX*NXF - NZF*NXX
      N3L = NXX*NYF - NXF*NYX
C
      DENOM = SQRT( N1L*N1L + N2L*N2L + N3L*N3L )
      NZL = -N3L/DENOM
C          ROTATE TO HAVE THE DIP ANGLE MEASURED AN HORIZONTAL PLANE
C          INSTEAD OF FROM THE VERTICAL DIRECTIONAL COSINE.
      ADIP = RAD*ACOS(NZL) - 90.0                           !6/10/93
      FTDIP = TAN(ADIP/RAD)
C
      RETURN
      END
      FUNCTION SIGNM(N1, N2, N3, X, Y, Z)
C
C        CALCULATION OF THE SIGN OF THE MODULUS USED TO DETERMINE
C        THE DIRECTIONAL COSINES OF A THREE-DIMENSIONAL PLANE.
C
C**********************************************************************
C
C     COEFFICIENTS OF THE PLANE.
         REAL*4 N1, N2, N3
C     COORDINATES OF A POINT IN THE PLANE.
         REAL*4 X, Y, Z
C
C           DISTANCE TO ORIGIN
C
      D = N1*X + N2*Y + N3*Z
C
C           SIGN.
C
      IF (D .NE. 0.0) THEN
         SIGNM = -ABS(D)/D
       ELSE
         IF (N3 .NE. 0.0) THEN
            SIGNM = -ABS(N3)/N3
          ELSE
            IF (N2 .NE. 0.0) THEN
               SIGNM = -ABS(N2)/N2
             ELSE
               IF (N1 .NE. 0.0 ) THEN
                  SIGNM = -ABS(N1)/N1
                ELSE
                  AZIMUTH = 0.0
                  TDIP = 0.0
                  GO TO 300 
               END IF
            END IF
         END IF
      END IF
  300 RETURN
 9002 FORMAT(' AZIMUTH DIP:', 2F11.3//)
       END
