C      CORRELATOR MODULE EXPERT
C
C***********************************************************************
C
      SUBROUTINE EXPERT(NZ,DIGS3,IL1,IL2,IL3,IL4,
     1                  RLOG1,RLOG2,RLOG3,RLOG4,KRULE,*,RFLAG)
C
C                    DECIDES WHICH CROSSING CORRELATION TO ELIMINATE.
C                    THE ALGORITHM FOLLOWS AND ARTIFICIAL INTELLIGENCE
C                    APPROACH USING A PRODUCTION SYSTEM TO REPRESENT
C                    KNOWLEDGE AND REASONING BACKWARDS TO SEARCH FOR
C                    SOLUTIONS.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      CHARACTER*1 ANS
      INTEGER*4 DEPSEQ
      REAL*4 RLOG1(LOG_LENGTH),RLOG2(LOG_LENGTH),
     X       RLOG3(LOG_LENGTH),RLOG4(LOG_LENGTH)
      LOGICAL RFLAG
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      COMMON /SHADE/  KSHADR,KSHADM
             INTEGER*2 KSHADR(LOG_LENGTH),KSHADM(LOG_LENGTH)
C
      COMMON /CHARH/FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
C
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /BABB/   ITOPBA,IBOTBA,ITOPBB,IBOTBB
      COMMON /WCORTB/ Z1TOP,Z1BOT
      COMMON /ANTDENTS/ ANTEC
C             ANTECEDENTS
             CHARACTER*50 ANTEC(23)
      COMMON /HYPOTHSS/ HYPOT
C             HYPOTHESES
             CHARACTER*50 HYPOT(11)
      COMMON /RULES/ RIF,IHYPT,IHYPN,NRULE,IRULE
C             RULES' ANTECEDENTS
             INTEGER*2 RIF(3,19)
             INTEGER*2 IHYPT(15),IHYPN(15),NRULE(19),IRULE(23)
      COMMON /ESIZES/ NA,NAR,NH
C             NUMBER OF ANTECEDENTS
             INTEGER*2 NA
C             NUMBER OF ANTECEDENTS PER RULE
             INTEGER*2 NAR(19)
C             NUMBER OF HYPOTHESIS
             INTEGER*2 NH
      COMMON /FINDINGS/ FACTS
C             FINDINGS ABOUT THE ANTECEDENTS
             INTEGER*2 FACTS(23)
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
      COMMON /HANOM/ NHANOM
C          SIZE OF THE HYPOTHESIS SET RELATED TO ANOMALOUS CORRELATIONS.
             INTEGER*2 NHANOM
      COMMON /REJECT/ ITREJ,IBREJ
C
C          RESET TRUTH COUNTERS.
C
      DO 200 I = 1,NA
  200 FACTS(I) = 2
C
C          LOAD THE KNOWLEDGE BASE.
C
C     CALL KNOWBS
C          DEPTH FOR BUNDLE UNDER CONSIDERATION.
      ZTEST = SEQDEP(DEPSEQ(Z1(ITOPLB),DIGS3,DINC),DIGS3,DINC)
C         DEPTH FOR EXTREME CORRELATIONS.
      CALL BUNABO(ITOPUB,DIGS3,ITOPBA,IBOTBA)
      CALL BUNBEL(NZ,IBOTLB,DIGS3,ITOPBB,IBOTBB)
      IF (KRULE .EQ. 0) THEN
         CALL EXTCOR(IL1,IL2,ITOPBA,IBOTBA,ITOPBB,IBOTBB)
        ELSE
         CALL EXTCOR(IL1,IL2,ITOPUB,IBOTUB,ITOPBB,IBOTBB)
        ENDIF
C          DO NOT ANALYZE CASES INVOLVING BUNDLES
C          READY TO BE DISCARDED.
      DO 250 I = ITOPBA,IBOTBB
      IF(ZANOM(I) .EQ. 'R') GO TO 800
  250 CONTINUE
C          TRY EVERY HYPOTHESIS.
      IF ( KRULE .EQ. 0 ) THEN
         M1 = 1
         M2 = NH - NHANOM
         ITOPD = ITOPBA
        ELSE
         M1 = NH - 1
         M2 = NH
         ITOPD = ITOPUB
       END IF
      DO 700 IH = M1,M2
      IHCOPY = IH
      CALL VERYFY(IHCOPY,NZ,DIGS3,JSUCRL)
      IF ( JSUCRL .GT. 0) THEN
         CALL EXTREM(WCC,NZ,WCCMIN,WCCMAX)
         CALL DISCOR(RLOG1,IL1,RLOG2,IL2,RLOG3,IL3,RLOG4,IL4,
     1            NAME1,NAME2,Z1TOP,Z1BOT,KSHADR,KSHADM,DINC,
     2            'ELCO',DATUM,ITOPD,IBOTBB,WCCMIN,CORIN,Z1,Z2,WCC)
         CALL ANMOD2
         IF ( ITREJ .EQ. IBREJ ) THEN
            WRITE(QTEKOT,9004) Z1(ITREJ)
           ELSE
            WRITE(QTEKOT,9002) Z1(ITREJ),Z1(IBREJ)
         END IF
         READ(QTEKIN,'(A1)') ANS
         IF (ANS .EQ. 'y') ANS = 'Y'
         IF (ANS .EQ. 'n') ANS = 'N'
         IF (ANS .EQ. 'w') ANS = 'W'
         IF (ANS .EQ. 's') ANS = 'S'
         IF ( ANS .EQ. 'S' ) RETURN 1
         IF ( ANS .EQ. 'W' ) THEN
            IHH=IHYPN(IH)
         CALL BNSTAT
            WRITE(QTEKOT,9000) HYPOT(IHH),(ANTEC(RIF(K,JSUCRL)),
     1                 K=1,NAR(JSUCRL))
            WRITE (QTEKOT,9003)
            READ(QTEKIN,'(A1)') ANS
            IF (ANS .EQ. 'y') ANS = 'Y'
            IF (ANS .EQ. 'n') ANS = 'N'
         END IF
         IF (ANS .NE. 'Y') GO TO 800
C          ERASE THE INCORRECT BUNDLE
         RFLAG=.TRUE.
         ZANOM(ITOPLB) = ' '
         DO 400 I = ITREJ,IBREJ
         ZANOM(I) = 'R'
  400    CONTINUE
C
         GO TO 800
       END IF
  700 CONTINUE
      IF ( KRULE .EQ. 0 ) WRITE(QTEKOT,9001) ZTEST
  800 RETURN
 9000 FORMAT(///,6X,'THE FOLLOWING RULE WAS SUCCESSFULLY TESTED:',//,
     1           6X,A50,//,
     2           6X,'BECAUSE :',/,
     3           3(11X,A50,/),/)
 9001 FORMAT(///,'***** THERE IS A CROSSING ELEVATION AT ',F7.1,' ,',/,
     1           '      BUT NO RULE APPLIES TO THIS CASE.',//)
 9002 FORMAT(///,'***** CORRELATIONS FROM ',F7.1,' TO ',F7.1,
     1           ' FEET SHOULD BE',/,
     2           '      ELIMINATED. ',
     3        'IS YOUR ANSWER Y (YES), N (NO), W (WHY), OR STOP (S)?: ')
 9003 FORMAT(//'DO YOU WANT TO ELIMINATE THE BUNDLE NOW, ',
     1         'Y(YES) OR N(NO)?: ')
 9004 FORMAT(///,'***** CORRELATION AT ',F7.1,' FEET SHOULD BE ',/,
     1           '      ELIMINATED.',
     2           ' IS YOUR ANSWER Y (YES), N (NO), OR W (WHY)?: ')
      END
C
C***********************************************************************
C
      SUBROUTINE VERYFY(IH,NZ,DIGS3,JSUCRL)
C
C                    TESTS THE TRUTH OF EVERYONE OF THE ANTECEDENTS
C                    LEADING TO A CONSEQUENCE.
C
C***********************************************************************
C
C          FINDINGS ABOUT THE ANTECEDENTS
      INTEGER*2 FACTS(23)
C          BUNDLE TO REJECT OUT OF THE THE PAIR OF CROSSING BUNDLES.
      INTEGER*2 JREJ(19)
C          NUMBER OF ANTECEDENTS
      INTEGER*2 NA
C          NUMBER OF ANTECEDENTS PER RULE
      INTEGER*2 NAR(19)
C          NUMBER OF HYPOTHESIS
      INTEGER*2 NH
C          RULES' ANTECEDENTS
      INTEGER*2 RIF(03,19),IHYPT(15),IHYPN(15),NRULE(19),IRULE(23)
C
      COMMON /RULES/ RIF,IHYPT,IHYPN,NRULE,IRULE
      COMMON /ESIZES/ NA,NAR,NH
      COMMON /FINDINGS/ FACTS
      COMMON /REJSEL/ JREJ
C
C...  STACK VARIABLES
C
      INTEGER NQ,IQQ(2,100)
C
      JSUCRL = 0
      IR=IHYPT(IH)
C
C...  CHECK FOR ANY ANTECEDENT THAT HAS BEEN PROVEN FALSE
C     PUSH ANTECEDENT ONTO STACK
C
      NQ=0
      IS=IR
   15 NNAR=NAR(IS)
      DO 115 I=1,NNAR
      IA=RIF(I,IS)
      IF (FACTS(IA) .EQ. 0) GO TO 25
  115 CONTINUE
      DO 116 J=1,NNAR
      I=NNAR+1-J
      IA=RIF(I,IS)
      NQ=NQ+1
      IQQ(1,NQ)=IRULE(IA)
      IF (IRULE(IA) .GE. 0) IA=-IA
      IQQ(2,NQ)=IA
  116 CONTINUE
C
C...  POP ANTECEDENT OFF STACK
C
   21 IF (NQ .LT. 1) GO TO 111
      IS=IQQ(1,NQ)
      IA=IABS(IQQ(2,NQ))
      NQ=NQ-1
C
C...  CHECK TO SEE IF ANTECEDENT ALREADY PROVEN TRUE
C
      IF (FACTS(IA) .EQ. 1) THEN
         IF (NQ .LT. 1) GO TO 23
         GO TO 21
        ENDIF
      IF (IS .GE. 0) GO TO 31
C
C...  ASK FOR TRUTH ABOUT THIS ANTECEDENT
C
      IFACT=2
      CALL JUMP(IA,NZ,DIGS3,IFACT)
      FACTS(IA)=IFACT
      IF (IFACT .EQ. 0) GO TO 25
C
C...  TRUE
C
      IF (NQ .GT. 0) GO TO 24
   23 JSUCRL=IR
      CALL SETREJ(JREJ(JSUCRL))
      RETURN
   24 IS=IQQ(1,NQ)
      IF (IS .LT. 0) GO TO 21
      IA=IQQ(2,NQ)
      IF (IA .LT. 0) GO TO 21
      NQ=NQ-1
      FACTS(IA)=1
C     WRITE (QTEKOT,2002) IS,ANTEC(IA)
C2002 FORMAT (/,' RULE ',I2,' DEDUCES : ',A50)
      IF (NQ .GT. 0) GO TO 21
      GO TO 23
C**   26 IF (NQ .LT. 1) GO TO 23
C**      IF (IQQ(1,NQ) .LT. 1) GO TO 21
C**      NQ=NQ-1
C**      IF (NQ .LT. 1) GO TO 23
C**      GO TO 21
C
C...  ANTECEDENT FALSE - REMOVE RULE FROM STACK
C
   25 IF (NQ .LT. 1) GO TO 111
      IS=IQQ(1,NQ)
      IA=IQQ(2,NQ)
      NQ=NQ-1
      IF (IS .LT. 0) GO TO 25
      IF (IA .LT. 0) GO TO 25
      IS=NRULE(IS)
C
C...  LOOK FOR NEXT RULE
C
   31 IF (IS .LE.  0) GO TO 35
C
C...  SAVE NEW RULE ON STACK
C
      NQ=NQ+1
      IQQ(1,NQ)=IS
      IQQ(2,NQ)=IA
      GO TO 15
C
C...  FALSE
C
   35 FACTS(IA)=0
      GO TO 25
  111 CONTINUE
      RETURN
      END
C***********************************************************************
C
C                    SETS DELETION BOUNDARIES.
C
C***********************************************************************
C
      SUBROUTINE SETREJ(DB)
C
      INCLUDE 'log.inc'
C
      INTEGER*2 DB
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X            CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),WCC(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /REJECT/ ITREJ,IBREJ
C
      IF ( DB .EQ. 0) THEN
         I = IBOTUB
         J = ITOPLB
  100    IF ( Z2(I) .GT. Z2(J) ) THEN
            IF ( WCC(I) .LT. WCC(J) ) THEN
               I = I - 1
               IF ( I .LT. ITOPUB ) GO TO 200
              ELSE
               J = J + 1
               IF ( J .GT. IBOTLB ) GO TO 200
              END IF
            GO TO 100
          ENDIF
  200       ITREJ = I + 1
            IBREJ = J - 1
      END IF
      IF ( DB .EQ. 1) THEN
         ITREJ = ITOPUB
         IBREJ = IBOTUB
      END IF
      IF ( DB .EQ. 2) THEN
         ITREJ = ITOPLB
         IBREJ = IBOTLB
      END IF
      RETURN
      END
C***********************************************************************
C
C                   SELECTS APPROPRIATE ROUTINE TO ANALYZE ANTECEDENTS.
C
C***********************************************************************
C
      SUBROUTINE JUMP(I,NZ,DIGS3,JFACT)
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /ANTDENTS/ ANTEC
             CHARACTER*50 ANTEC(23)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
C
C          BRANCH TO TEST ANTECEDENT.
      GO TO ( 200,250,300,350,400,450,500,550,600,650,
     1        700,720,740,760,780,800,820,840,860,880,
     2        900,920,940 ) I
  200 CALL BANT01(DIGS3,ITOPUB,IBOTUB,ITOPLB,IBOTLB,JFACT,*8900)
  250 CALL BANT02(NZ,DIGS3,ITOPUB,IBOTUB,ITOPLB,IBOTLB,JFACT,*8900)
  300 CONTINUE
  350 CALL BANT04(ITOPUB,IBOTUB,ITOPLB,IBOTLB,JFACT,*8900)
  400 CALL BANT05(NZ,JFACT,*8900)
  450 CONTINUE
  500 CALL BANT07(JFACT,*8900)
  550 CONTINUE
  600 CALL BANT09(NZ,JFACT,*8900)
  650 CALL BANT10(JFACT,*8900)
  700 CALL BANT11(JFACT,*8900)
  720 CALL BANT01(DIGS3,ITOPLB,IBOTLB,ITOPUB,IBOTUB,JFACT,*8900)
  740 CALL BANT02(NZ,DIGS3,ITOPLB,IBOTLB,ITOPUB,IBOTUB,JFACT,*8900)
  760 CONTINUE
  780 CALL BANT04(ITOPLB,IBOTLB,ITOPUB,IBOTUB,JFACT,*8900)
  800 CALL BANT16(JFACT,*8900)
  820 CONTINUE
  840 CALL BANT18(JFACT,*8900)
  860 CALL BANT19(JFACT,*8900)
  880 CALL BANT20(ITOPUB,IBOTUB,ITOPLB,IBOTLB,JFACT,*8900)
  900 CALL BANT21(NZ,DIGS3,ITOPUB,IBOTUB,ITOPLB,IBOTLB,JFACT,*8900)
  920 CONTINUE
  940 CALL BANT23(NZ,DIGS3,ITOPUB,IBOTUB,ITOPLB,IBOTLB,JFACT,*8900)
      WRITE (QTEKOT,9000) ANTEC(I)
      READ  (QTEKIN,*) JFACT
 8900 RETURN
 9000 FORMAT(/1X,'IS THE FOLLOWING TRUE : ',A50/)
      END
C***********************************************************************
C
C                   ELIMINATES CROSSING CORRELATIONS.
C
C***********************************************************************
C
      SUBROUTINE ELCO(J1STIM)
C
      LOGICAL ERROR
      INTEGER*4 IFLAGE
      CHARACTER*2 OPTION
      CHARACTER*70 MESG
      LOGICAL LOADCI,GOFLAG,SORTFL
      LOGICAL RFLAG
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
C
      COMMON /CHARH/FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
C
      COMMON /PARAL/ THRESD,DZ2MIN
      COMMON /THRES/ THRESC,DZ2CMN
      COMMON /LSTCIX/ LASTCI
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /DEPFINS/ DEPFINS
C
      include 'corrdb.inc'
      include 'wldhdr.inc'
      include 'wldwel.inc'
C
      IFLAGE = 0
      LOADCI = .TRUE.
      GOFLAG = .FALSE.
C
      CALL FINDCP(0,ID1,ID2)
      IF (NCPWEL .LT. 1) LASTCI=0
      IF (LASTCI .GT. NCPWEL) LASTCI=0
      IF ((LASTCI .EQ. 0) .AND. (NCPWEL .GT. 0)) LASTCI=1
      IF (NCPWEL .EQ. 1) LASTCI=1
      ICP=LASTCI
      IF (ICP .GT. 0) CALL RCPHDR(ICPWEL(ICP))
      IF( J1STIM .EQ. 0) THEN
         DEPFINS = ZMINCP
         THRESD = 0.0
         DZ2MIN = 2.0
         THRESC = 0.0
         DZ2CMN = 5.0
      ENDIF
C
   11 CALL MNMODE
      LINE = 2
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'CORRELATION INTERPRETATION EDITING')
C
      CALL TXTCLR(ICOLOR(5))
      WRITE (MESG,2001) ID1,NAME1
      CALL GTEXTS(5,LINE+2,MESG)
      WRITE (MESG,2002) ID2,NAME2
      CALL GTEXTS(5,LINE+3,MESG)
      LINE=LINE+3
 2001 FORMAT ('REFERENCE WELL (',I2,'): ',A20)
 2002 FORMAT ('MATCHING WELL  (',I2,'): ',A20)
      IF (NCPWEL .GT. 0) THEN
         WRITE (MESG,2003) ICP,CPTITL
         CALL GTEXTS(5,LINE+1,MESG)
         LINE=LINE+1
 2003    FORMAT ('INTERPRETATION (',I1,'): ',A40)
         IF (NNNNCP .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+1,
     1           '***** NO CORRELATIONS IN SELECTED INTERPRETATION.')
            LINE=LINE+1
            GOFLAG=.FALSE.
            LOADCI=.FALSE.
           ENDIF
         IF (LOADCI) THEN
            GOFLAG=.FALSE.
C
C           READ IN CORRELATIONS.
            CALL RDELCO(NZ)
C           CHECK FOR REFERENCE DEPTH IN ASCENDING SEQUENCE.
            CALL ASCOR(LINE, NZ,SORTFL)
            IF (SORTFL) THEN
               CALL EMBEDD(NZ,LINE)
               CALL REMCOR(NZ)
               LOADCI=.FALSE.
               GOFLAG=.TRUE.
              ENDIF
           ENDIF
        ELSE
          CALL TXTCLR(ICOLOR(6))
          CALL GTEXTS(5,LINE+1,
     1         '***** NO CORRELATION INTERPRETATIONS FOR WELL PAIR')
          LINE=LINE+1
          GOFLAG=.FALSE.
          LOADCI=.FALSE.
        ENDIF
C
      CALL OPELCO(IFLAGE,LINE,ICP)
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF ((OPTION .EQ. 'GO') .AND. GOFLAG) GO TO 51
      IF ((OPTION .EQ. 'SV') .AND. (IFLAGE .GT. 0)) GO TO 61
C
      IF (OPTION .EQ. 'DM') THEN
         CALL AGETRL(AUX,ERROR)    
         DEPFINS = AUX
      ENDIF
      IF (OPTION .EQ. 'FW') THEN
         CALL AGETRL(THRESD,ERROR)
         THRESD = 0.01*THRESD
        ENDIF
      IF (OPTION .EQ. 'CW') THEN
         CALL AGETRL(DZ2MIN,ERROR)
        ENDIF
      IF (OPTION .EQ. 'FB') THEN
         CALL AGETRL(THRESC,ERROR)
         THRESC = 0.01*THRESC
        ENDIF
      IF (OPTION .EQ. 'CB') THEN
         CALL AGETRL(DZ2CMN,ERROR)
        ENDIF
C
      IF (OPTION .EQ. 'CI' .AND. NCPWEL .GT. 1) THEN
         ICPSAV=ICP
         CALL SELTCP(ICP)
         IF (ICP .NE. ICPSAV) THEN
            LOADCI=.TRUE.
            GOFLAG=.FALSE.
            IFLAGE=0
         ENDIF
         IF( J1STIM .EQ. 0) DEPFINS = ZMINCP
         GO TO 11
      ENDIF 
      GO TO 15
C
C         INSPECT CORRELATION FILE.
C
   51 J1STIM = 1
      CALL CROCO(NZ, *800, RFLAG)
      IF (RFLAG) IFLAGE=1
      GO TO 11
C          SAVE THE EDITED FILE.
   61 CALL EDITCO(NZ,IFLAGE,ICP)
  800 GO TO 11
      END
C***********************************************************************
C
C                   OPTIONS FOR COMMAND 'EC'.
C
C**********************************************************************
C
      SUBROUTINE OPELCO(IFLAGE,LINE,ICP)
C
      INTEGER*4 IFLAGE
      CHARACTER*4 BOMU
C
      COMMON /PARAL/  THRESD,DZ2MIN
      COMMON /THRES/  THRESC,DZ2CMN
      COMMON /USCAL/  BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /DEPFINS/ DEPFINS
C
      include 'corrdb.inc'
C
      CALL TXTCLR(ICOLOR(3))
      IF (NCPWEL .GT. 1) THEN
         CALL GTEXTS( 3,LINE+2,'CI - SELECT CORRELATION INTERPRETATION')
         CALL MARROW(75,LINE+2)
         LINE=LINE+2
        ENDIF
C
      CALL GTEXTS( 3, LINE+2,
     1     'DM - DEPTH TO START THE INSPECTION, '//BOMU(BOM))
      CALL GTXTRL(75, LINE+2,DEPFINS,2)
      CALL GTEXTS( 3, LINE+3,
     1     'FW - DIVERGENCE FACTOR WITHIN A BUNDLE, % OF SEARCH LENGTH')
      CALL GTXTRL(75, LINE+3,100.0*THRESD,1)
      CALL GTEXTS( 3, LINE+4,
     1     'CW - CRITICAL DIVERGENCE WITHIN A BUNDLE, '//BOMU(BOM))
      CALL GTXTRL(75, LINE+4,DZ2MIN,1)
      CALL GTEXTS( 3, LINE+5,
     1     'FB - DIVERGENCE FACTOR BETWEEN BUNDLES, % OF SEARCH LENGTH')
      CALL GTXTRL(75, LINE+5,100.0*THRESC,1)
      CALL GTEXTS( 3, LINE+6,
     1     'CB - CRITICAL DIVERGENCE BETWEEN BUNDLES, '//BOMU(BOM))
      CALL GTXTRL(75, LINE+6,DZ2CMN,1)
      LINE = LINE + 8
      IF (IFLAGE .NE. 0) THEN
         CALL GTEXTS( 3,LINE,'SV - SAVE THE EDITED INTERPRETATION')
         CALL MARROW(75,LINE)
         LINE = LINE + 1
        ENDIF
C
      CALL GTEXTS( 3,LINE,'RE - RETURN TO PREVIOUS MENU')
      LINE = LINE + 1
      IF (ICP .GT. 0) THEN
         CALL GTEXTS( 3,LINE,'GO - EDIT INTERPRETATION')
         LINE = LINE + 1
        ENDIF
C
      RETURN
      END
C***********************************************************************
C
C                   SAVES EDITED CORRELATION INTERPRETATION.
C
C***********************************************************************
C
      SUBROUTINE EDITCO(NZ,IFLAGE,ICP)
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 OPTION,SAVOPT
      CHARACTER*40 CPT
      LOGICAL GOFLAG,ERROR
      CHARACTER*7 SOPTON(2)
      DATA SOPTON/'NEW','REPLACE'/
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
      COMMON /COLOPT/ ICOLOR(6)
C
      include 'corrdb.inc'
C
      INTOPT=2
      NNCP=ICP
      CPT=CPTITL
      GOFLAG=.FALSE.
C
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'SAVE EDITED CORRELATION INTERPRETATION')
      LINE=4
C
      CALL PRNTCP(LINE)
C
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,LINE,
     1    'CD - CORRELATION INTERPRETATION IDENTIFICATION')
      CALL GTXTRJ(75,LINE,CPT)
C
      CALL GTEXTS( 3,LINE+1,'SO - SAVE OPTION - NEW OR REPLACE')
      CALL GTXTRJ(75,LINE+1,SOPTON(INTOPT))
      LINE = LINE + 2
      IF (INTOPT .EQ. 2) THEN
         CALL GTEXTS( 3,LINE,
     1        'CI - CORRELATION INTERPRETATION TO REPLACE')
         CALL GTXTIN(75,LINE,NNCP)
         LINE = LINE + 1
        ENDIF
      CALL GTEXTS( 3,LINE,'RE - RETURN TO PREVIOUS MENU')
      GOFLAG=.FALSE.
      IF (CPT .NE. '*????*') THEN
         IF (INTOPT .EQ. 1) THEN
            GOFLAG=.TRUE.
           ELSE
            IF (NCPWEL .GT. 0) GOFLAG=.TRUE.
           ENDIF
        ENDIF
      IF (GOFLAG) THEN
         CALL GTEXTS( 3,LINE+1,
     1        'GO - SAVE EDITED CORRELATION INTERPRETATION')
         LINE = LINE + 1
        ENDIF
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
      IF ((OPTION .EQ. 'GO') .AND. GOFLAG) GO TO 51
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF (OPTION .EQ. 'CD') THEN
         CALL AGETTX(CPT)
        ENDIF
      IF (OPTION .EQ. 'SO') THEN
         CALL AGETST(SAVOPT,2)
         IF (SAVOPT .EQ. 'NE' .AND. NCPWEL .LT. 9) INTOPT=1
         IF (SAVOPT .EQ. 'RE' .AND. NCPWEL .GT. 0) INTOPT=2
         IF (INTOPT .EQ. 1) CPT='*????*'
        ENDIF
      IF (OPTION .EQ. 'CI' .AND. NCPWEL .GT. 0) THEN
         CALL AGETIN(ITEMP,ERROR)
         IF (.NOT. ERROR) THEN
            IF ((ITEMP .GT. 0) .AND. (ITEMP .LE. NCPWEL)) THEN
               NNCP=ITEMP
               CALL RCPHDR(ICPWEL(NNCP))
               CPT=CPTITL
              ENDIF
           ENDIF
        ENDIF
      GO TO 15
C
C...  SAVE CORRELATION
C
   51 IF (NZ .LT. 1) GO TO 79
      IF (INTOPT .EQ. 1) THEN
         CALL NEWCOR
         NCPWEL=NCPWEL+1
         ICP=NCPWEL
         ICPWEL(ICP)=ICPREC
        ELSE
         ICP=NNCP
        ENDIF
      CALL RCPHDR(ICPWEL(ICP))
      CPTITL=CPT
      CALL WRTCPI(0)
C
C          ELIMINATE PROVEN CROSSING AND EMBEDDED CORRELATIONS.
   71 DO 200 I = 1,NZ
      IF ( ZANOM(I) .EQ. 'R' ) GO TO 200
C          CHECK FOR REMAINING CROSSING CORRELATIONS.
      J = I
  150 J = J - 1
      IF ( J .LE. 0  ) GO TO 180
      IF ( ZANOM(J) .EQ. 'R' ) GO TO 150
      IF( Z2(I) .LT. Z2(J) ) THEN
         ZANOM(I) = 'X'
        ELSE
         IF ( Z2(I) .EQ. Z2(J) ) THEN
            ZANOM(I) = 'E'
           ELSE
            ZANOM(I) = ' '
          ENDIF
       ENDIF
C          SAVE THE CORRELATIONS.
  180 CALL WRTCPR(Z1(I),Z2(I),ZANOM(I),CORIN(I),SELENG(I),
     1          OFFST(I),CUTOFF(I),WCC(I))
  200 CONTINUE
      ISORTF=1
      CALL WRTCPL
      CALL UPDCDH
   79 IFLAGE=0
      RETURN
      END
C***********************************************************************
C
C                 CHECKS FOR REFERENCE ELEVATIONS IN ASCENDING ORDER.
C
C***********************************************************************
C
      SUBROUTINE ASCOR(LINE, NZ, SORTFL)
C
      INCLUDE 'log.inc'
C
      LOGICAL SORTFL
C
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
C
      SORTFL=.TRUE.
      IF (NZ .LT. 2) RETURN
      DO 101 II = 2,NZ
      I = II
      IF ( Z1(I-1) .GE. Z1(I) ) SORTFL=.FALSE.
  101 CONTINUE
      IF (SORTFL) RETURN
      CALL TXTCLR(ICOLOR(6))
      CALL GTEXTS( 5,LINE+2,'***** ELEVATIONS NOT IN ASCENDING ORDER.')
      CALL GTEXTS(11,LINE+3,
     1     'SORT THE CORRELATION INTERPRETATION BEFORE TRYING AGAIN.')
      LINE=LINE+3
      RETURN
      END
C***********************************************************************
C
C                   SEARCHES FOR CROSSING CORRELATIONS.
C
C***********************************************************************
C
      SUBROUTINE CROCO(NZ, *, RFLAG)
C
      INCLUDE 'log.inc'
C
      LOGICAL RFLAG
C
      COMMON /RLOGS/ RLOG1,IL1,RLOG3,IL3,RLOG2,IL2,RLOG4,IL4
             REAL*4 RLOG1(LOG_LENGTH),RLOG2(LOG_LENGTH),
     X              RLOG3(LOG_LENGTH),RLOG4(LOG_LENGTH)
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /DIGS/   DIGS1,DIGS2
      COMMON /CODINC/ DINC
      COMMON /PARAL/  THRESD,DZ2MIN
      COMMON /KRULE/  KRULE
      COMMON /DEPFINS/ DEPFINS
C
      IREAD = 0
      DIGS3=DIGS1
C          DEFINE LITHOLOGICAL UNITS.
      CALL BEDTOP(RLOG3,IL3)
      CALL BEDBOT(RLOG3,IL3)
C
      DO 600 I = 2,NZ
      IF (Z1(I) .LT. DEPFINS ) GO TO 600
      II = I
C          CROSSING CORRELATION.
      IF ( ZANOM(I) .EQ. 'X' ) THEN
         KRULE = 0
         GO TO 500
      ELSE
C          NON-PARALLEL BUNDLES ACCORDING TO THEIR AVERAGE DIP.
         IF ( IREAD .EQ. 0 ) THEN
            CALL BBUNDL(NZ,II,DIGS3)
            IREAD = 1
            DZ2 = ABS((Z2(I) - Z1(I)) - (Z2(I-1) - Z1(I-1)))
            IF( (Z1(I) - Z1(I-1)) .GT. 1.1*DINC  .OR.
     1      DZ2 .GE. AMAX1(DZ2MIN,THRESD*SELENG(I)) ) GO TO 300
         END IF
         IF ( II .LE. IBOTLB ) GO TO 600
  300    CALL BANT20(ITOPUB,IBOTUB,ITOPLB,IBOTLB,JFLAG,*400)
  400    KRULE = 1
      END IF
C          DEFINE THE BUNDLES UNDER INSPECTION.
  500 CALL BBUNDL(NZ,II,DIGS3)
C          DO NOT ANALYZE AN ANOMALOUS BUNDLE FOLLOWED BY CROSSING.
      IF ( ZANOM(IBOTLB+1) .EQ. 'X'  .AND.  KRULE .EQ. 1 ) GO TO 600
C          DECIDE WHICH BUNDLE IS INCORRECT.
      CALL EXPERT(NZ,DIGS3,IL1,IL2,IL3,IL4,
     1            RLOG1,RLOG2,RLOG3,RLOG4,KRULE,*630,RFLAG)
  600 CONTINUE
C          REMOVE CORRELATIONS.
  630 CALL REMCOR(NZ)
      RETURN
      END
C***********************************************************************
C
C                   DEFINES CROSSING BUNDLE BOUNDARIES. THE
C                   LIMITS ARE ESTABLISHED BY:
C                      1.- A CROSSING CORRELATION
C                      2.- A NON-PARALLEL CORRELATION
C                      3.- A GAP IN CORRELATION SEQUENCE
C                      4.- A CHANGE IN LITHOLOGY
C
C***********************************************************************
C
      SUBROUTINE BBUNDL(NZ,J,DIGS3)
C
C          THRESHOLD DIP GRADIENT DEFINING NON-PARALLEL
C          CORRELATIONS, AS A FRACTION OF THE SEARCH LENGTH.
C
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
C
C          DEFINE THE BOUNDARIES FOR THE UPPER BUNDLE.
      CALL BUNABO(J,DIGS3,ITOPUB,IBOTUB)
C          DEFINE THE  BOUNDARIES FOR THE LOWER BUNDLE.
      CALL BUNBEL(NZ,J-1,DIGS3,ITOPLB,IBOTLB)
      RETURN
      END
C***********************************************************************
C
C                   DEFINES BOUNDARIES FOR BUNDLE ABOVE LOCATION J.
C
C***********************************************************************
C
      SUBROUTINE BUNABO(J,DIGS3,ITOPUB,IBOTUB)
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BEDTB/ BEDT,BEDB
             INTEGER*2 BEDT(LOG_LENGTH),BEDB(LOG_LENGTH)
      COMMON /PARAL/ THRESD,DZ2MIN
C
      IF ( J .EQ. 1 ) THEN
         ITOPUB = 1
         IBOTUB = 1
         GO TO 900
      ELSE
         ITOPUB = 1
         IBOTUB = J-1
         DO 200 I = 1,J-2
         K = J - I
         IF ( K .LT. 1 ) GO TO 200
         L = NINT(((Z1(K) - DIGS3)/DINC) + 1.0)
         LM1 = NINT(((Z1(K-1) - DIGS3)/DINC) + 1.0)
         DZ2 = ABS((Z2(K) - Z1(K)) - (Z2(K-1) - Z1(K-1)))
C        IF( (Z1(K) - Z1(K-1)) .GT. DINC  .OR.  LM1 .LE. BEDT(L)  .OR.
C    1       DZ2 .GE. AMAX1(DZ2MIN,THRESD*SELENG(K))  .OR.
C    2       Z2(K) .LT.Z2(K-1) ) THEN
C           ITOPUB = K
C           GO TO 300
C        END IF
         IF( (Z1(K) - Z1(K-1)) .GT. DINC ) THEN
            ITOPUB = K
            GO TO 300
         END IF
         IF( LM1 .LE. BEDT(L)  ) THEN
            ITOPUB = K
            GO TO 300
         END IF
         IF( DZ2 .GE. AMAX1(DZ2MIN,THRESD*SELENG(K)) ) THEN
            ITOPUB = K
            GO TO 300
         END IF
         IF( Z2(K) .LT.Z2(K-1) ) THEN
            ITOPUB = K
            GO TO 300
         END IF
  200 CONTINUE
  300 END IF
  900 RETURN
      END
C***********************************************************************
C
C                   DEFINES BOUNDARIES FOR BUNDLE BELOW LOCATION JB.
C
C***********************************************************************
C
      SUBROUTINE BUNBEL(NZ,JB,DIGS3,ITOPLB,IBOTLB)
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BEDTB/ BEDT,BEDB
             INTEGER*2 BEDT(LOG_LENGTH),BEDB(LOG_LENGTH)
      COMMON /PARAL/ THRESD,DZ2MIN
C
      IF ( JB .EQ. NZ ) THEN
         ITOPLB = NZ
         IBOTLB = NZ
         GO TO 900
      ELSE
         J = JB + 1
         ITOPLB = J
         IBOTLB = NZ
         DO 100 I = J+1,NZ
         L = ((Z1(I) - DIGS3)/DINC) + 1
         LM1 = ((Z1(I-1) - DIGS3)/DINC) + 1
         DZ2 = ABS((Z2(I) - Z1(I)) - (Z2(I-1) - Z1(I-1)))
         IF ( (Z1(I) - Z1(I-1)) .GT. DINC  .OR. L .GE. BEDB(LM1)  .OR.
     1       DZ2 .GE. AMAX1(DZ2MIN,THRESD*SELENG(I))  .OR.
     2       Z2(I) .LT.Z2(I-1) ) THEN
            IBOTLB = I - 1
            GO TO 150
         END IF
  100 CONTINUE
  150 END IF
  900 RETURN
      END
      SUBROUTINE BANT01(DIGS3,T1,B1,T2,B2,JFACT, *)
C
C          BUNDLE T2-B2 DEVIATES THE MOST RELATIVE TO THE
C          BUNDLE ABOVE THE CROSSING PAIR (T1-B1) - (T2-B2).
C
C***********************************************************************
C
      INTEGER*4 T1,B1,T2,B2
C
      JFACT = 0
C          FIND BOUNDARIES OF BUNDLE ABOVE PAIR
      CALL BUNABO(MIN(T1,T2),DIGS3,ITOPBA,IBOTBA)
C          AVERAGE DIP FOR BUNDLE ABOVE
      CALL AVEDIP(AVDBA,ITOPBA,IBOTBA)
C          AVERAGE DIP FOR UPPER BUNDLE
      CALL AVEDIP(AVD1,T1,B1)
C          AVERAGE DIP FOR LOWER BUNDLE
      CALL AVEDIP(AVD2,T2,B2)
C          EVALUATE THE ANTECEDENT.
      IF( ABS(AVD2-AVDBA) .GT. ABS(AVD1-AVDBA) ) JFACT = 1
      RETURN 1
      END
      SUBROUTINE BANT02(NZ,DIGS3,T1,B1,T2,B2,JFACT, *)
C
C          BUNDLE T2-B2 DEVIATES THE MOST RELATIVE TO THE
C          BUNDLE BELOW THE CROSSING PAIR (T1-B1) - (T2-B2).
C
C***********************************************************************
C
      INTEGER*4 T1,B1,T2,B2,B3
C
      JFACT = 0
C          FIND BOUNDARIES OF BUNDLE BELOW THE PAIR.
      B3 = MAX(B1,B2)
      IF ( B3 .EQ. NZ ) GO TO 900
      CALL BUNBEL(NZ,B3,DIGS3,ITOPBB,IBOTBB)
C          AVERAGE DIP FOR BUNDLE BELOW
      CALL AVEDIP(AVDBB,ITOPBB,IBOTBB)
C          AVERAGE DIP FOR LOWER BUNDLE
      CALL AVEDIP(AVD2,T2,B2)
C          AVERAGE DIP FOR UPPER BUNDLE
      CALL AVEDIP(AVD1,T1,B1)
C          EVALUATE THE ANTECEDENT.
      IF( ABS(AVD2-AVDBB) .GT. ABS(AVD1-AVDBB) ) JFACT = 1
  900 RETURN 1
      END
C***********************************************************************
C
C                      AVERAGE DIP FOR A BUNDLE.
C
C***********************************************************************
C
      SUBROUTINE AVEDIP(ADIP,ITOP,IBOT)
C
      INCLUDE 'log.inc'
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
            REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X             CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
            REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X             WCC(LOG_LENGTH)
C
      ADIP = 0.0
      DO 100 I = ITOP,IBOT
      ADIP = ADIP + (Z2(I) - Z1(I))
  100 CONTINUE
      ADIP = ADIP/(1 + (IBOT - ITOP))
      RETURN
      END
      SUBROUTINE BNSTAT
C
C                   CHARACTERISTICS OF BUNDLES INVOLVED IN THE
C                   ELIMINATION OF CORRELATIONS IN THE EDITING
C                   OF A CORRELATION FILE.
C
C***********************************************************************
C
      CHARACTER*4 BOMU
C
      COMMON /BABB/   ITOPBA,IBOTBA,ITOPBB,IBOTBB
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /USCAL/  BOM,SCLSHL,SCLCOL
             CHARACTER*1   BOM,SCLSHL,SCLCOL
      COMMON /KRULE/  KRULE
C
      WRITE(QTEKOT,9000) BOMU(BOM), BOMU(BOM), BOMU(BOM)
      IF (KRULE .EQ. 0) CALL PRBUND(ITOPBA,IBOTBA)
      CALL PRBUND(ITOPUB,IBOTUB)
      CALL PRBUND(ITOPLB,IBOTLB)
      CALL PRBUND(ITOPBB,IBOTBB)
      RETURN
 9000 FORMAT(/10X,'SOME CHARACTERISTICS OF THE BUNDLES INVOLVED ',
     1           'IN THE ANALYSIS'//
     3        6X,'REFERENCE',13X,'MATCHING',6X,'AV. DIFFER.',1X,
     4           'AV. WEIGHTED',2X,'NUMBER OF'/
     5        6X,'  DEPTH  ',14X,' DEPTH  ',4X,'IN ELEVATION',2X,
     6           'CORR. COEF.',1X,'CORRELATIONS'/
     7         8X,A4,18X,A4,11X,A4/    79('-')/)
      END
      SUBROUTINE PRBUND(ITOP,IBOT)
C
C                PRINT BUNDLE CHARACTERISTICS.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      CHARACTER*1 REJF
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /REJECT/ ITREJ,IBREJ
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      IF ( ITREJ .EQ. ITOP ) THEN
         REJF = '*'
       ELSE
         REJF = ' '
       END IF
      IF ( ITOP .EQ. IBOT ) THEN
         WRITE(QTEKOT,9001) Z1(ITOP), Z2(ITOP), Z2(ITOP) -
     1                      Z1(ITOP), WCC(ITOP), REJF
       ELSE
         CALL AVEDIP(ADIP,ITOP,IBOT)
         CALL AVECOR(ACOR,ITOP,IBOT)
         WRITE(QTEKOT,9002) Z1(ITOP),Z1(IBOT),Z2(ITOP),Z2(IBOT),
     1                     ADIP, ACOR, (IBOT-ITOP+1), REJF
      END IF
      RETURN
 9001 FORMAT(6X,F8.2,14X,F8.2, 7X,F9.2,4X,F6.3,11X,'1',2X,A1)
 9002 FORMAT(   F8.2,' TO ',F8.2,2X,F8.2,' TO ',
     1       F8.2,1X,F9.2,4X,F6.3, 8X,I4,2X,A1)
      END
C
      SUBROUTINE BANT04(T1,B1,T2,B2,JFACT, *)
C
C                   TESTS THE STRENGTH OF THE CORRELATION.
C
C***********************************************************************
C
      INTEGER*4 T1,B1,T2,B2
C
      JFACT = 0
C          AVERAGE WEIGTHED CROSS-CORRELATION FOR UPPER BUNDLE
      CALL AVECOR(AVC1,T1,B1)
C          AVERAGE WEIGHTED CROSS-CORRELATION FOR LOWER BUNDLE
      CALL AVECOR(AVC2,T2,B2)
C          EVALUATE THE ANTECEDENT.
      IF( AVC1 .GT. AVC2 ) JFACT = 1
      RETURN 1
      END
C***********************************************************************
C
C                      AVERAGE WEIGHTED CROSS-CORRELATION FOR A BUNDLE.
C
C***********************************************************************
C
      SUBROUTINE AVECOR(ACOR,ITOP,IBOT)
C
      INCLUDE 'log.inc'
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
C
      ACOR = 0.0
      DO 100 I = ITOP,IBOT
      ACOR = ACOR + WCC(I)
  100 CONTINUE
      ACOR = ACOR/(1 + (IBOT - ITOP))
      RETURN
      END
C***********************************************************************
C
C                   CHECK FOR A GAP AROUND THE LOWER BUNDLE.
C                   A BUNDLE IS DEFINED HERE AS A SET OF ONE
C                   OR MORE CONSECUTIVE NON-CROSSING PARALLEL
C                   CORRELATIONS WITHIN THE SAME LITHOLOGICAL UNIT.
C
C***********************************************************************
C
      SUBROUTINE BANT05(NZ,JFACT, *)
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON/BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
C
      JFACT = 0
      IF ( IBOTLB .LT. NZ ) THEN
C          FIND GAP.
         IF ( (Z1(ITOPLB) - Z1(IBOTUB)) .GT. 1.1*DINC
     X        .AND. (Z1(IBOTLB+1) - Z1(IBOTLB)) .GT. 1.1*DINC)
     X        JFACT = 1
      END IF
      RETURN 1
      END
      SUBROUTINE BANT07(JFACT, *)
C
C                   CHECK FOR THE CROSSING BUNDLES BEING
C                   WITHIN THE SAME LITHOLOGICAL UNIT.
C
C***********************************************************************
C
      INTEGER*4 DEPSEQ
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /DIGS/   DIGS1,DIGS2
      COMMON /BEDTB/  BEDT,BEDB
             INTEGER*2 BEDT(LOG_LENGTH),BEDB(LOG_LENGTH)
C
      JFACT = 0
C          COMPARE LITHOLOGICAL BOUNDARIES.
      IF ( BEDT(DEPSEQ(Z1(ITOPUB),DIGS1,DINC)) .EQ.
     1     BEDT(DEPSEQ(Z1(ITOPLB),DIGS1,DINC)) ) JFACT = 1
      RETURN 1
      END
C***********************************************************************
C
C                  FINDS BOUNDARIES FOR WINDOW AROUND
C                  CROSSING CORRELATIONS.
C
C***********************************************************************
C
      SUBROUTINE EXTCOR(IL1,IL2,ITOPBA,IBOTBA,ITOPBB,IBOTBB)
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /WCORTB/ Z1TOP,Z1BOT
      COMMON /DIGS/   DIGS1,DIGS2
C
         Z1BA = Z1(ITOPBA) - (0.5*CORIN(ITOPBA))
         Z1UB = Z1(ITOPUB) - (0.5*CORIN(ITOPUB))
         Z1LB = Z1(ITOPLB) - (0.5*CORIN(ITOPLB))
         Z1BB = Z1(ITOPBB) - (0.5*CORIN(ITOPBB))
         Z1TOP1 = AMIN1(Z1BA,Z1UB,Z1LB,Z1BB)
         Z2BA = Z2(ITOPBA) - (0.5*CORIN(ITOPBA))
         Z2UB = Z2(ITOPUB) - (0.5*CORIN(ITOPUB))
         Z2LB = Z2(ITOPLB) - (0.5*CORIN(ITOPLB))
         Z1BB = Z1(ITOPBB) - (0.5*CORIN(ITOPBB))
         Z2BB = Z2(ITOPBB) - (0.5*CORIN(ITOPBB))
         Z1TOP2 = AMIN1(Z2BA,Z2UB,Z2LB,Z2BB)
         IF ( Z1TOP1 .LT. Z1TOP2 ) THEN
            DELTA = Z1TOP1 - DIGS1
            IF ( DELTA .GE. 5.0*DINC ) THEN
               Z1TOP = Z1TOP1 - 5.0*DINC
            ELSE
               Z1TOP= Z1TOP1
            END IF
         ELSE
            DELTA = Z1TOP2 - DIGS2
            IF ( DELTA .GE. 5.0*DINC ) THEN
               Z1TOP = Z1TOP2 - 5.0*DINC
            ELSE
               Z1TOP= Z1TOP2
            END IF
         END IF
         Z1BA = Z1(IBOTBA) + (0.5*CORIN(IBOTBA))
         Z1UB = Z1(IBOTUB) + (0.5*CORIN(IBOTUB))
         Z1LB = Z1(IBOTLB) + (0.5*CORIN(IBOTLB))
         Z1BB = Z1(IBOTBB) + (0.5*CORIN(IBOTBB))
         Z1BOT1 = AMAX1(Z1BA,Z1UB,Z1LB,Z1BB)
         Z2BA = Z2(IBOTBA) + (0.5*CORIN(IBOTBA))
         Z2UB = Z2(IBOTUB) + (0.5*CORIN(IBOTUB))
         Z2LB = Z2(IBOTLB) + (0.5*CORIN(IBOTLB))
         Z2BB = Z2(IBOTBB) + (0.5*CORIN(IBOTBB))
         Z1BOT2 = AMAX1(Z2BA,Z2UB,Z2LB,Z2BB)
         IF ( Z1BOT1 .GT. Z1BOT2 ) THEN
            DELTA = SEQDEP(IL1,DIGS1,DINC) - Z1BOT1
            IF ( DELTA .GE. 5.0*DINC ) THEN
               Z1BOT = Z1BOT1 + 5.0*DINC
            ELSE
               Z1BOT= Z1BOT1
            END IF
         ELSE
            DELTA = SEQDEP(IL2,DIGS2,DINC) - Z1BOT2
            IF ( DELTA .GE. 5.0*DINC ) THEN
               Z1BOT = Z1BOT2 + 5.0*DINC
            ELSE
               Z1BOT= Z1BOT2
            END IF
         END IF
      RETURN
      END
C
      SUBROUTINE ARROWS(ITERM,SCALE,IDADJ,IDADJ2)
C
C                    DRAWS ARROWS FOR EASIER IDENTIFICATION
C                    OF THE CORRELATIONS TO ELIMINATE.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      INTEGER*4 DEPSEQ
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /REJECT/ ITREJ,IBREJ
      COMMON /DIGS/   DIGS1,DIGS2
C
C          DRAW LEFT ARROW
      CALL SLINDX(6)
      AV = 0.5*(Z1(ITREJ) + Z1(IBREJ))
      Z = ((AV - DIGS1)/DINC) + 1
      Y = 63.0 - (Z - IDADJ)*SCALE
      YS =  63.0 - (FLOAT(DEPSEQ(Z1(ITREJ),DIGS1,DINC)
     1          - IDADJ) - 0.5)*SCALE
      YE =  63.0 - (FLOAT(DEPSEQ(Z1(IBREJ),DIGS1,DINC)
     1          - IDADJ) + 0.5)*SCALE
      CALL XMOVEA(0.2,YS)
      CALL XDRAWA(1.2,Y)
      CALL XDRAWA(0.2,YE)
      CALL XMOVEA(1.2,Y)
      CALL XDRAWA(48.6,Y)
      CALL XDRAWA(47.6,Y-0.2)
      CALL XDRAWA(47.6,Y+0.2)
      CALL XDRAWA(48.6,Y)
C          LEFT MARGIN
      IF ( ITERM .EQ. 0 ) THEN
         CALL XMOVEA(48.7,YS)
         CALL XDRAWA(48.7,YE)
      ELSE
         CALL XMOVEA(48.8,YS)
         CALL XDRAWA(48.8,YE)
      END IF
C          DRAW RIGHT ARROW.
      AV = 0.5*(Z2(ITREJ) + Z2(IBREJ))
      Z = ((AV - DIGS2)/DINC) + 1
      Y = 63.0 - (Z - IDADJ2)*SCALE
      YS =  63.0 - (FLOAT(DEPSEQ(Z2(ITREJ),DIGS2,DINC)
     1          - IDADJ2) - 0.5)*SCALE
      YE =  63.0 - (FLOAT(DEPSEQ(Z2(IBREJ),DIGS2,DINC)
     1          - IDADJ2) + 0.5)*SCALE
      CALL XMOVEA(122.8,YS)
      CALL XDRAWA(121.8,Y)
      CALL XDRAWA(122.8,YE)
      CALL XMOVEA(122.8,YS)
      CALL XMOVEA(121.8,Y)
      CALL XDRAWA(74.3,Y)
      CALL XDRAWA(75.3,Y-0.2)
      CALL XDRAWA(75.3,Y+0.2)
      CALL XDRAWA(74.3,Y)
C          RIGHT MARGIN
      IF ( ITERM .EQ. 0 ) THEN
         CALL XMOVEA(74.2,YS)
         CALL XDRAWA(74.2,YE)
      ELSE
         CALL XMOVEA(74.3,YS)
         CALL XDRAWA(74.3,YE)
      END IF
      CALL SLINDX(2)
      RETURN
      END
      INTEGER FUNCTION DEPSEQ(Z,DIGS,DINC)
C
C                  CONVERTS DEPTH IN FEET TO SEQUENCE NUMBER
C                  IN THE DIGITIZATION STRING.
C
C***********************************************************************
C
      DEPSEQ = ANINT((Z - DIGS)/DINC) + 1.0
      RETURN
      END
      REAL FUNCTION SEQDEP(I,DIGS,DINC)
C
C                  CONVERTS SEQUENCE NUMBER IN THE DIGITIZATION
C                  STRING TO DEPTH.
C
C***********************************************************************
C
      SEQDEP = DIGS + DINC*FLOAT(I - 1)
      RETURN
      END
C***********************************************************************
C
C                   CHECK FOR A GAP BELOW THE LOWER BUNDLE.
C                   A BUNDLE IS DEFINED HERE AS A SET OF ONE
C                   OR MORE CONSECUTIVE NON-CROSSING PARALLEL
C                   CORRELATIONS WITHIN THE SAME LITHOLOGICAL UNIT.
C
C***********************************************************************
C
      SUBROUTINE BANT09(NZ,JFACT, *)
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /PARAL/  THRESD,DZ2MIN
C
      JFACT = 0
C          NO GAP.
      IF ( IBOTLB .LT. NZ ) THEN
         IF ( (Z1(IBOTLB+1) - Z1(IBOTLB)) .LT. 1.1*DINC  .AND.
     1        (Z2(IBOTLB+1) - Z2(IBOTLB))
     2    .LT. AMAX1(DZ2MIN,THRESD*SELENG(ITOPLB)) ) JFACT = 1
      END IF
      RETURN 1
      END
      SUBROUTINE BANT10(JFACT, *)
C
C                   CHECK FOR THE CROSSING BUNDLES BEING
C                   IN DIFFERENT LITHOLOGICAL UNITS.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      INTEGER*4 DEPSEQ
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /DIGS/   DIGS1,DIGS2
      COMMON /BEDTB/  BEDT,BEDB
             INTEGER*2 BEDT(LOG_LENGTH),BEDB(LOG_LENGTH)
C
      JFACT = 0
C          COMPARE LITHOLOGICAL BOUNDARIES.
      IF ( BEDT(DEPSEQ(Z1(ITOPUB),DIGS1,DINC)) .NE.
     1     BEDT(DEPSEQ(Z1(ITOPLB),DIGS1,DINC)) ) JFACT = 1
      RETURN 1
      END
      SUBROUTINE BANT11(JFACT, *)
C
C                   LITHOLOGIC UNITS ARE OF DIFFERENT LENGTH.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      INTEGER*4 DEPSEQ
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /DIGS/   DIGS1,DIGS2
      COMMON /BEDTB/  BEDT,BEDB
             INTEGER*2 BEDT(LOG_LENGTH),BEDB(LOG_LENGTH)
C
      JFACT = 0
C          COMPARE THICKNESS.
      IF ( BEDB(DEPSEQ(Z1(ITOPUB),DIGS1,DINC)) -
     1     BEDT(DEPSEQ(Z1(ITOPUB),DIGS1,DINC)) .NE.
     2     BEDB(DEPSEQ(Z1(ITOPLB),DIGS1,DINC)) -
     3     BEDT(DEPSEQ(Z1(ITOPLB),DIGS1,DINC)) ) JFACT = 1
      RETURN 1
      END
C***********************************************************************
C
C                   CHECK FOR A GAP AROUND THE UPPER BUNDLE.
C                   A BUNDLE IS DEFINED HERE AS A SET OF ONE
C                   OR MORE CONSECUTIVE NON-CROSSING PARALLEL
C                   CORRELATIONS WITHIN THE SAME LITHOLOGICAL UNIT.
C
C***********************************************************************
C
      SUBROUTINE BANT16(JFACT, *)
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
C
      JFACT = 0
      IF ( ITOPUB .GT. 1 ) THEN
C          FIND GAP.
         IF ( (Z1(ITOPLB) - Z1(IBOTUB)) .GT. 1.1*DINC
     X        .AND. (Z1(ITOPUB) - Z1(ITOPUB-1)) .GT. 1.1*DINC)
     X        JFACT = 1
      END IF
      RETURN 1
      END
C***********************************************************************
C
C                   CHECK FOR A GAP ABOVE THE UPPER BUNDLE.
C                   A BUNDLE IS DEFINED HERE AS A SET OF ONE
C                   OR MORE CONSECUTIVE NON-CROSSING PARALLEL
C                   CORRELATIONS WITHIN THE SAME LITHOLOGICAL UNIT.
C
C***********************************************************************
C
      SUBROUTINE BANT18(JFACT, *)
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
      COMMON /PARAL/  THRESD,DZ2MIN
C
      JFACT = 0
      IF ( ITOPUB .GT. 1 ) THEN
C          NO GAP.
         IF ( (Z1(ITOPUB) - Z1(ITOPUB-1)) .LT. 1.1*DINC  .AND.
     1        (Z2(ITOPUB) - Z2(ITOPUB-1))
     2    .LT. AMAX1(DZ2MIN,THRESD*SELENG(ITOPUB)) ) JFACT=1
      END IF
      RETURN 1
      END
C***********************************************************************
C
C                   CHECK FOR CONTIGUOUS CROSSING BUNDLES.
C                   A BUNDLE IS DEFINED HERE AS A SET OF ONE
C                   OR MORE CONSECUTIVE NON-CROSSING PARALLEL
C                   CORRELATIONS WITHIN THE SAME LITHOLOGICAL UNIT.
C
C***********************************************************************
C
      SUBROUTINE BANT19(JFACT, *)
C
      INCLUDE 'log.inc'
C
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /BUNDLE/ ITOPUB,IBOTUB,ITOPLB,IBOTLB
C
      JFACT = 0
C          NO GAP.
      IF ( (Z1(ITOPLB) - Z1(IBOTUB)) .LT. 1.1*DINC ) JFACT = 1
      RETURN 1
      END
      SUBROUTINE BANT20(T1,B1,T2,B2,JFACT, *)
C
C          BUNDLE T2-B2 DEVIATES MORE THE TOLERANCE
C          FROM BUNDLE T1-B1.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      INTEGER*4 T1,B1,T2,B2
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /THRES/ THRESC,DZ2CMN
      COMMON /ADIPUB/ AVD1
C
      JFACT = 0
C          AVERAGE DIP FOR UPPER BUNDLE
      CALL AVEDIP(AVD1,T1,B1)
C          AVERAGE DIP FOR LOWER BUNDLE
      CALL AVEDIP(AVD2,T2,B2)
C          EVALUATE THE ANTECEDENT.
      IF( ABS(AVD2-AVD1) .GT. AMAX1(DZ2CMN,THRESC*SELENG(T2)) )JFACT = 1
      RETURN 1
      END
      SUBROUTINE BANT21(NZ,DIGS3,T1,B1,T2,B2,JFACT, *)
C
C          BUNDLE T2-B2 DEVIATES MORE THE TOLERANCE
C          FROM THE BUNDLE BELOW (T2-B2) AND REVERSES
C          RATE OF INCREASE RELATIVE TO UPPER BUNDLE.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      INTEGER*4 T1,B1,T2,B2,B3
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /THRES/ THRESC,DZ2CMN
      COMMON /ADIPUB/ AVD1
C
      JFACT = 0
C          FIND BOUNDARIES OF BUNDLE BELOW THE PAIR.
      B3 = MAX(B1,B2)
      IF ( B3 .EQ. NZ ) GO TO 900
      CALL BUNBEL(NZ,B3,DIGS3,ITOPBB,IBOTBB)
C          AVERAGE DIP FOR BUNDLE BELOW
      CALL AVEDIP(AVDBB,ITOPBB,IBOTBB)
C          AVERAGE DIP FOR LOWER BUNDLE
      CALL AVEDIP(AVD2,T2,B2)
C          EVALUATE THE ANTECEDENT.
      IF( ABS(AVDBB-AVD2) .GT. AMAX1(DZ2CMN,THRESC*SELENG(T2)) ) THEN
         IF(AVD1 .LT. AVDBB) THEN   !  12/2002
            IF (.NOT. (AVD2 .GT. AVD1  .AND.  AVD2 .LT. AVDBB)) JFACT=1
          ELSE
            IF (.NOT.(AVD2 .LT. AVD1  .AND.  AVD2 .GT. AVDBB)) JFACT=1
         END IF                     !  12/2002
      END IF
  900 RETURN 1
      END
      SUBROUTINE BANT23(NZ,DIGS3,T1,B1,T2,B2,JFACT, *)
C
C                    CORRELATION STRENGTH FOR BUNDLES
C                    SURROUNDING AN ANOMALOUS BUNDLE.
C
C***********************************************************************
C
      INTEGER*4 T1,B1,T2,B2,B3
C
      JFACT = 0
C          FIND BOUNDARIES OF BUNDLE BELOW THE PAIR.
      B3 = MAX(B1,B2)
      IF ( B3 .EQ. NZ ) GO TO 900
      CALL BUNBEL(NZ,B3,DIGS3,ITOPBB,IBOTBB)
C          AVERAGE CORRRELATION FOR BUNDLE ABOVE
      CALL AVECOR(AVC1,T1,B1)
C          AVERAGE CORRELATION FOR THE ANOMALOUS BUNDLE.
      CALL AVECOR(AVC2,T2,B2)
C          AVERAGE DIP FOR BUNDLE BELOW
      CALL AVECOR(AVCB,ITOPBB,IBOTBB)
C          EVALUATE THE ANTECEDENT.
      IF( AVC1 .GT. AVC2  .AND.  AVCB .GT. AVC2 ) JFACT = 1
  900 RETURN 1
      END
C***********************************************************************
C
C          ELIMINATES NARROW CORRELATION INTERVALS FULLY
C          EMBEDDED IN WIDER CORRELATION INTERVALS.
C
C***********************************************************************
C
      SUBROUTINE EMBEDD(NZ,LINE)
C
      INCLUDE 'log.inc'
C
      CHARACTER*70 MESG
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
C
      IF (NZ .LT. 2) RETURN
      IFLAG = 0
      DO 101 I = 1,NZ
      Z1IBOT=Z1(I)-0.5*CORIN(I)
      Z1ITOP=Z1(I)+0.5*CORIN(I)
      J=I
      K=I
   11 J=J+1
      IF (J .GT. NZ) GO TO 21
      IF (Z1(J) .GT. Z1ITOP) GO TO 21
      IF (ZANOM(J) .EQ. 'R') GO TO 11
      IF (Z1(J)-0.5*CORIN(J) .LT. Z1IBOT) GO TO 11
      IF (Z1(J)+0.5*CORIN(J) .GT. Z1ITOP) GO TO 11
      IFLAG=IFLAG+1
      ZANOM(J)='R'
      GO TO 11
   21 K=K-1
      IF (K .LT. 1) GO TO 101
      IF (Z1(K) .LT. Z1IBOT) GO TO 101
      IF (ZANOM(K) .EQ. 'R') GO TO 21
      IF (Z1(K)-0.5*CORIN(K) .LT. Z1IBOT) GO TO 21
      IF (Z1(K)+0.5*CORIN(K) .GT. Z1ITOP) GO TO 21
      IFLAG=IFLAG+1
      ZANOM(K)='R'
      GO TO 21
  101 CONTINUE
      IF ( IFLAG .LE. 0 ) RETURN
      WRITE (MESG,9003) IFLAG
      CALL GTEXTS(5,LINE+1,MESG)
      LINE=LINE+1
      RETURN
 9003 FORMAT(' *****',I5,' EMBEDDED CORRELATIONS WERE',1X,
     1               'AUTOMATICALLY DISCARDED')
      END
C***********************************************************************
C
C             REMOVE CORRELATIONS
C
C***********************************************************************
C
      SUBROUTINE REMCOR(NZ)
C
      INCLUDE 'log.inc'
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
C
      IF (NZ .LT. 1) RETURN
      NZZ=0
      DO 101 I=1,NZ
      IF (ZANOM(I) .EQ. 'R') GO TO 101
      NZZ=NZZ+1
      IF (NZZ .EQ. I) GO TO 101
      Z1    (NZZ)=Z1    (I)
      Z2    (NZZ)=Z2    (I)
      CORIN (NZZ)=CORIN (I)
      SELENG(NZZ)=SELENG(I)
      OFFST (NZZ)=OFFST (I)
      CUTOFF(NZZ)=CUTOFF(I)
      WCC   (NZZ)=WCC   (I)
      ZANOM (NZZ)=ZANOM (I)
  101 CONTINUE
      NZ=NZZ
      RETURN
      END
C***********************************************************************
C
C                    GIVEN THE DEPTH, FINDS SEQUENCIAL INDEX
C                    ON A CORRELATION FILE.
C
C***********************************************************************
C
      SUBROUTINE FDCOIN(NZ,ZT,ITCO,ZB,IBCO, *)
C
      INCLUDE 'log.inc'
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
C
C          TOP
      DO 100 I = 1,NZ
      IF (Z1(I) .GE. ZT  .AND.  Z1(I) .LE. ZB ) THEN
         ITCO = I
         GO TO 200
      END IF
  100 CONTINUE
      RETURN 1
  200 DO 300 I = NZ,ITCO,-1
      IF (Z1(I) .LE. ZB  .AND.  Z1(I) .GE. ZT ) THEN
         IBCO = I
         GO TO 400
      END IF
  300 CONTINUE
      RETURN 1
  400 RETURN
      END
C***********************************************************************
C
C                   DETECTS FAULTS
C
C***********************************************************************
C
      SUBROUTINE FAULT(J1STIM)
C
      LOGICAL ERROR
      CHARACTER*2 OPTION
      CHARACTER*70 MESG
      LOGICAL LOADCI,GOFLAG,SORTFL,PRNTFL
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CHARH/ FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /OPFDRE/ SLOSS
      COMMON /LSTCIX/ LASTCI
      COMMON /COLOPT/ ICOLOR(6)
C
      include 'corrdb.inc'
      include 'wldhdr.inc'
      include 'wldwel.inc'
C
      IF ( J1STIM .EQ. 0 ) THEN
         SLOSS = 100.0
        ENDIF
      LOADCI = .TRUE.
      GOFLAG = .FALSE.
C
      CALL FINDCP(0,ID1,ID2)
      IF (NCPWEL .LT. 1) LASTCI=0
      IF (LASTCI .GT. NCPWEL) LASTCI=0
      IF ((LASTCI .EQ. 0) .AND. (NCPWEL .GT. 0)) LASTCI=1
      IF (NCPWEL .EQ. 1) LASTCI=1
      ICP=LASTCI
      IF (ICP .GT. 0) CALL RCPHDR(ICPWEL(ICP))
C
   11 CALL MNMODE
      LINE = 2
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'FAULT DETECTION')
C
      CALL TXTCLR(ICOLOR(5))
      WRITE (MESG,2001) ID1,NAME1
      CALL GTEXTS(5,LINE+2,MESG)
      WRITE (MESG,2002) ID2,NAME2
      CALL GTEXTS(5,LINE+3,MESG)
      LINE=LINE+3
 2001 FORMAT ('REFERENCE WELL (',I2,'): ',A20)
 2002 FORMAT ('MATCHING WELL  (',I2,'): ',A20)
      IF (NCPWEL .GT. 0) THEN
         WRITE (MESG,2003) ICP,CPTITL
         CALL GTEXTS(5,LINE+1,MESG)
         LINE=LINE+1
 2003    FORMAT ('INTERPRETATION (',I1,'): ',A40)
         IF (NNNNCP .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+1,
     1           '***** NO CORRELATIONS IN SELECTED INTERPRETATION.')
            LINE=LINE+1
            GOFLAG=.FALSE.
            LOADCI=.FALSE.
           ENDIF
         IF (LOADCI) THEN
            GOFLAG=.FALSE.
C
C           READ IN CORRELATIONS.
            CALL RDELCO(NZ)
C           CHECK FOR REFERENCE DEPTH IN ASCENDING SEQUENCE.
            CALL ASCOR(LINE, NZ,SORTFL)
            IF (SORTFL) THEN
               CALL EMBEDD(NZ,LINE)
               CALL REMCOR(NZ)
               LOADCI=.FALSE.
               GOFLAG=.TRUE.
              ENDIF
           ENDIF
        ELSE
          CALL TXTCLR(ICOLOR(6))
          CALL GTEXTS(5,LINE+1,
     1         '***** NO CORRELATION INTERPRETATIONS FOR WELL PAIR')
          LINE=LINE+1
          GOFLAG=.FALSE.
          LOADCI=.FALSE.
        ENDIF
C
      CALL OPFAUL(GOFLAG,LINE)
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') GO TO 900
C
      IF (GOFLAG .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'LS') CALL AGETRL(SLOSS,ERROR)
C
      IF (OPTION .EQ. 'CI' .AND. NCPWEL .GT. 1) THEN
         ICPSAV=ICP
         CALL SELTCP(ICP)
         IF (ICP .NE. ICPSAV) THEN
            LOADCI=.TRUE.
            GOFLAG=.FALSE.
            ENDIF
         GO TO 11
        ENDIF
      GO TO 15
C
C          DETECT FAULTS.
C
   51 CALL CROSCO(1,NZ,LINE+4,*900)
      CALL LOSSS(ID1,NAME1,ID2,NAME2,CPDIST,SLOSS,NZ,PRNTFL)
      IF (.NOT. PRNTFL) THEN
         CALL TXTCLR(ICOLOR(4))
         CALL GTEXTS(10,LINE+4,'***** NO FAULTS DETECTED *****')
         CALL SCHOLD
        ENDIF
      J1STIM = 1
      GO TO 11
  900 RETURN
      END
C***********************************************************************
C
C                   OPTIONS FOR COMMAND 'DF'.
C
C**********************************************************************
C
      SUBROUTINE OPFAUL(GOFLAG,LINE)
C
      LOGICAL GOFLAG
      CHARACTER*4 BOMU
C
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /OPFDRE/ SLOSS
      COMMON /COLOPT/ ICOLOR(6)
C
      include 'corrdb.inc'
C
      CALL TXTCLR(ICOLOR(3))
C
      IF (NCPWEL .GT. 1) THEN
         CALL GTEXTS( 3,LINE+2,'CI - SELECT CORRELATION INTERPRETATION')
         CALL MARROW(75,LINE+2)
         LINE=LINE+2
        ENDIF
C
      IF (.NOT. GOFLAG) THEN
         CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
         LINE = LINE + 2
         RETURN
        ENDIF
      CALL GTEXTS( 3,LINE+2,
     1   'LS - MINIMUM LOSS SECTION TO CONSIDER, ' // BOMU(BOM))
      CALL GTXTRL(75,LINE+2,SLOSS,2)
      LINE = LINE + 2
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
      CALL GTEXTS( 3,LINE+3,'GO - FIND FAULTS')
      LINE = LINE + 3
C
      RETURN
      END
C**********************************************************************
C
C                 SCANS SELECTED FILE SEARCHING FOR
C                 ABNORMAL VARIATION IN APPARENT DIP.
C
C**********************************************************************
C
      SUBROUTINE LOSSS(ID1,NAME1,ID2,NAME2,HWDIST,SLOSS,NZ,PRNTFL)
C
      INCLUDE 'log.inc'
C
      INTEGER*2 WID(100),WMI(100)
      CHARACTER*1 PROBLM(100)
      CHARACTER*4 BOML,BOMU
      CHARACTER*20 NAME1,NAME2
      REAL*4 TOPI(100),BOTI(100),LOSSEC(100),MIZT(100),MIZB(100)
      LOGICAL FPROB,PRNTFL
C
      COMMON/LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
C     LOCAL VARIABLES
      REAL*4 Z1L,Z2L
C
      PRNTFL = .FALSE.
      N = 0
      BOML = BOMU(BOM)
      Z1FOR=Z1(1)
      Z2FOR=Z2(1)
      CORLF=CORIN(1)
      STARC1 = Z1FOR - 0.5*CORLF
      STARC2 = Z2FOR - 0.5*CORLF
      DO 50 I = 1,100
      PROBLM(I) = ' '
      FPROB = .FALSE.
   50 CONTINUE
      DO 100 INZ=2,NZ
      Z1L=Z1(INZ)
      Z2L=Z2(INZ)
      CORL=CORIN(INZ)
      SECLOS = ABS((Z2L - Z1L) - (Z2FOR - Z1FOR))
      IF ( SECLOS .GE. SLOSS ) THEN
C         INCREASE COUNTER.
         N = N + 1
         IF ( N .GT. 100) THEN
            WRITE (QTEKOT,9003)
            GO TO 200
         ENDIF
C         SECTION LOSS
         LOSSEC(N) = SECLOS
C         FIND OUT WHICH OF THE TWO WELLS HAS BEEN INTERSECTED.
         DZ1 = Z1L - Z1FOR
         DZ2 = Z2L - Z2FOR
         IF ( DZ1 .GT. DZ2) THEN
            WID(N) = ID2
            ZFOR = Z2FOR
            Z = Z2L
            WMI(N) = ID1
            ZMFOR = Z1FOR
            ZM = Z1L
         ELSE
            WID(N) = ID1
            ZFOR = Z1FOR
            Z = Z1L
            WMI(N) = ID2
            ZMFOR = Z2FOR
            ZM = Z2L
         ENDIF
C         ESTIMATE THE INTERSECTION ZONE
         TOPI(N) = ZFOR + 0.5*CORLF
         BOTI(N) = Z - 0.5*CORL
         IF ( BOTI(N) .LE. TOPI(N) ) THEN
            TOPI(N) = (CORL*ZFOR + CORLF*Z)/(CORLF + CORL)
            BOTI(N) = TOPI(N)
            PROBLM(N) = '*'
            FPROB = .TRUE.
         END IF
C         ESTIMATE IN THE UNFAULTED WELL THE ZONE THAT IS MISSING
C         IN THE FAULTED WELL.
         MIZT(N) = ZMFOR + 0.5*CORLF
         MIZB(N) = ZM - 0.5*CORL
      END IF
      Z1FOR = Z1L
      Z2FOR = Z2L
      CORLF = CORL
  100 CONTINUE
  200 IF ( N .NE. 0) THEN
         IF (.NOT. PRNTFL) THEN
             CALL ANMODE
             PRNTFL=.TRUE.
            ENDIF
         WRITE (QTEKOT,9000) ID1,NAME1,ID2,NAME2,
     1                 IDSHAR,IDCORR,IDSHAM,IDCORM,SLOSS,BOML,
     2                 ID1,STARC1,Z1L+0.5*CORL,BOML,
     3                 ID2,STARC2,Z2L+0.5*CORL,BOML,
     4                 HWDIST,BOML,BOML,BOML,BOML
      END IF
      DO 300 I = 1,N
         IF ( TOPI(I) .EQ. BOTI(I) ) THEN
            WRITE (QTEKOT,9001)
     1         WMI(I),MIZT(I),MIZB(I),WID(I),TOPI(I),LOSSEC(I),PROBLM(I)
         ELSE
            WRITE (QTEKOT,9002) WMI(I),MIZT(I),MIZB(I),
     1                    WID(I),TOPI(I),BOTI(I),LOSSEC(I),PROBLM(I)
         END IF
  300 CONTINUE
      IF (PRNTFL) THEN
         IF (FPROB) WRITE(QTEKOT,9004)
         WRITE (QTEKOT,'(///)')
         CALL RETKEY
        ENDIF
      RETURN
 9000 FORMAT(////,7X,'DETECTION OF POTENTIAL FAULTS IN THE ',
     X          'CROSS-SECTION COMPRISING WELLS'/
     X       12X,I2,' (',A20,') AND ',I2,' (',A20,')'/
     X       7X,67('*'),///,
     X       23X,'REFERENCE LOGS',4X,A4,'-',A4,//
     X       23X,'MATCHING LOGS',5X,A4,'-',A4,//
     X       23X,'MINIMUM SECTION LOSS ',F6.1,1X,A4,//
     X       23X,'CORRELATED INTERVALS:'/
     X       28X,'WELL ',I2,': ',F7.1,'-',F7.1,' ',A4,/
     X       28X,'WELL ',I2,': ',F7.1,'-',F7.1,' ',A4,//
     X       23X,'DISTANCE BETWEEN WELLS: ',F8.0,' ',A4,///
     X       15X,'WHAT IS MISSING',15X,'WHERE IS MISSING',/
     X       15X,'FUZZY BOUNDARIES',16X,'FAULT LIKELY',//
     X       13X,'WELL',5X,'INTERVAL',
     X        6X,'WELL',6X,'DEPTH',6X,'SECTION LOSS',/
     X       24X,A4,19X,A4,10X,A4/
     X       12X,22('='),' ',35('='),/)
 9001 FORMAT(14X,I2,2X,F7.1,'-',F7.1,4X,I2,6X,F7.1,7X,F7.1,1X,1A1)
 9002 FORMAT(14X,I2,2X,F7.1,'-',F7.1,4X,I2,2X,F7.1,'-',F7.1,3X,
     1       F7.1,1X,1A1)
 9003 FORMAT(///,' *****  ANALYSIS DISCONTINUED.'/
     X          '        DETECTION LIMITED TO 100 FAULTS.'//)
 9004 FORMAT(///,5X,'(*)  OVERLAPPING  CORRELATION  INTERVALS  ACROSS ',
     1              ' THE  FAULT  MAY  RESULT IN'/
     2          10X,'INCONSISTENCIES IN THE PLOTTING OR MODELLING ',
     3              'USING THIS FILE. ELIMINATE'/
     4          10X,'SUCH OVERLAPPING IN CASE THIS ANOMALY IS ',
     4              'INDEED INTERPRETED AS A FAULT.')
      END
C***********************************************************************
C
C          DETECTION OF CROSSING CORRELATIONS.
C
C***********************************************************************
C
      SUBROUTINE CROSCO(M1,M2,LINE1,*)
C
      INCLUDE 'log.inc'
C
      LOGICAL FLAG
      CHARACTER*60 TXTMES
      CHARACTER*4 BOMU
C
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /COLOPT/ ICOLOR(6)
C
      LINE = LINE1
      FLAG = .FALSE.
      IF (M1+1 .GT. M2) RETURN
      Z1P=Z1(M1)
      Z2P=Z2(M1)
      DO 100 I = M1+1,M2
      Z1C=Z1(I)
      Z2C=Z2(I)
      IF (Z2C .LT. Z2P) THEN
         IF (LINE .LT. 20) THEN
            CALL TXTCLR(ICOLOR(6))
            WRITE (TXTMES,9000) Z1P,Z1C,BOMU(BOM)
            CALL GTEXTS(10,LINE,TXTMES)
            LINE = LINE + 1
           ENDIF
         FLAG = .TRUE.
      END IF
   80 Z2P = Z2C
      Z1P = Z1C
  100 CONTINUE
      IF ( FLAG) THEN
         CALL GTEXTS(16,LINE+1,
     1   'PLEASE REFER TO GEOLOGIC INTERPRETATION MENU FOR')
         CALL GTEXTS(16,LINE+2,'REMEDIAL ACTION.')
         CALL SCHOLD
         RETURN 1
        END IF
      RETURN
 9000 FORMAT('***** CROSSING CORRELATION BETWEEN ',
     1       F7.1,' AND ',F7.1,' ',A4,'.')
      END
