C     OPEN FILES
C***********************************************************************
C
C...  OPEN DIRECT ACCESS FILES
C
C***********************************************************************
C
      SUBROUTINE OPEND(IUNIT,NAME,ITYPE,LENGTH)
      CHARACTER*(*) NAME
C
      COMMON /OPENST/ OPENER
      LOGICAL OPENER
C
      LOGICAL FEXIST
C
      OPENER=.FALSE.
      IF (ITYPE .LT. 0) THEN
         OPEN(UNIT=IUNIT,FILE=NAME,ACCESS='DIRECT',
     X        FORM='FORMATTED',
     X        RECL=LENGTH,STATUS='UNKNOWN')
        ENDIF
      IF (ITYPE .EQ. 0) THEN
         OPEN(UNIT=IUNIT,FILE=NAME,ACCESS='DIRECT',
     X        FORM='FORMATTED',
     X        RECL=LENGTH,STATUS='OLD',IOSTAT=IERR)
         OPENER=IERR .GT. 0
        ENDIF
      IF (ITYPE .EQ. 1) THEN
         INQUIRE(FILE=NAME,EXIST=FEXIST)
         IF (FEXIST) THEN
            OPEN(UNIT=IUNIT,FILE=NAME,ACCESS='DIRECT',
     X           FORM='UNFORMATTED',
     X           RECL=LENGTH,STATUS='OLD')
           ELSE
            OPENER=.TRUE.
           ENDIF
        ENDIF
      IF (ITYPE .GT. 1) THEN
         OPEN(UNIT=IUNIT,FILE=NAME,ACCESS='DIRECT',
     X        FORM='UNFORMATTED',
     X        RECL=LENGTH,STATUS='UNKNOWN')
       ENDIF
      RETURN
      END
C***********************************************************************
C
C...  OPEN SEQUENTIAL ASCII FILES
C
C***********************************************************************
C
      SUBROUTINE OPENT(IUNIT,NAME)
      CHARACTER*(*) NAME
C
      COMMON /OPENST/ OPENER
      LOGICAL OPENER
C
              OPEN(UNIT=IUNIT,FILE=NAME,ACCESS='SEQUENTIAL',
     X                  FORM='FORMATTED',STATUS='OLD',
     X                  IOSTAT=IERR)
      OPENER=IERR .GT. 0
      RETURN
      END
C***********************************************************************
C
C...  OPEN PRINTER FILE
C
C***********************************************************************
C
      SUBROUTINE OPENP(IUNIT,FNAME)
      CHARACTER*(*) FNAME
C
      OPEN(UNIT=IUNIT,FILE=FNAME,STATUS='UNKNOWN',FORM='FORMATTED')
      RETURN
      END
C
C...  CREATE SON CLI
C
      SUBROUTINE SYSXXX(STRING)
C
      CHARACTER*(*) STRING
C
      RETURN
      END
      SUBROUTINE CHKOTY(IOUNIT,PAR1,ITYPE,LENGTH,IFTYPE,LINE,ICKERR)
C
C         CHECK FOR VALID FILE TYPE
C
C**********************************************************************
C
      INTEGER*4 TITLEN
      CHARACTER*4 HEFA
      CHARACTER*40 PAR1
      CHARACTER*4 LABEL(10) / 'FAUL' , 'MARK', 'WLDB', 'CLDB',
     1                       'SOUR' , 'DATU', 'SPEC', 'SCOL',
     2                       'LITH' , 'LIT2' /
      CHARACTER*20 TITLE
      CHARACTER*20 FYLTYP(10) /'FAULT FILE',
     2                        'MARKER FILE' ,
     3                        'WELL DATA FILE',
     4                        'CORRELATION FILE',
     5                        'SOURCE FILE',
     6                        'DATUM FILE',
     7                        'SPECIFICATION FILE',
     8                        'STRAT. COLUMN FILE',
     9                        'LITHOLOGY ANNOTATION',
     1                        'LITHOLOGY COLORING'/
C
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /OPENST/ OPENER
             LOGICAL OPENER
C
      ICKERR=0
      CALL OPEND(IOUNIT,PAR1,ITYPE,LENGTH)
      IF (.NOT. OPENER) GO TO 11
      ICKERR=1
         IF (LINE .GT. 0) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(10,LINE, 
     1  '***** THERE IS NO SUCH FILE AS ' // PAR1(1:TITLEN(PAR1))//'.')
            CALL SCHOLD
         ENDIF
      GO TO 900
C
   11 IF ((IFTYPE .EQ. 3) .OR. (IFTYPE .EQ. 4)) THEN
         READ (IOUNIT,REC=1) HEFA
        ELSE
         READ (IOUNIT,9000,REC=1) HEFA
        END IF
      IF (HEFA .EQ. LABEL(IFTYPE)) GO TO 900
      ICKERR=2
      IF (LINE .GT. 0) THEN
         CALL TXTCLR(ICOLOR(6))
         TITLE = FYLTYP(IFTYPE)
         CALL GTEXTS(10,LINE,
     1    '***** FILE ' // PAR1(1:TITLEN(PAR1)) // 
     2    ' IS NOT A ' // TITLE(1:TITLEN(TITLE)) // '.' )
         CALL GTEXTS(16,LINE+1,
     1    'THE LABEL ON FILE ' // PAR1(1:TITLEN(PAR1)) //
     2    ' IS ' // HEFA // '.')
         CALL SCHOLD
      ENDIF
      CLOSE(IOUNIT)
C
  900 RETURN
 9000 FORMAT (A4)
      END
      SUBROUTINE CHKOLF(IOUNIT,PAR1,LENGTH,IFTYPE,LINE,ICKERR,*)
C
C         CHECK FOR EXISTENCE OF FILE WITH SAME NAME
C         AVOID DESTRUCTION.
C
C**********************************************************************
C
      INTEGER*4 TITLEN
      CHARACTER*2 OPTION
      CHARACTER*4 HEFA
      CHARACTER*40 PAR1
      PARAMETER (NJ = 10)
C
      CHARACTER*4 LABEL(10) / '    ', 'FAUL' , 'MARK' , 'WLDB' , 'CLDB',
     1                       'SOUR' , 'DATU', 'SPEC' , 'SCOL' , 'LIT2'/
      CHARACTER*20 TITLE
      CHARACTER*20 FYLTYP(10) /'FILE',
     1                        'FAULT FILE',
     2                        'MARKER FILE' ,
     3                        'WELL DATA FILE',
     4                        'CORRELATION FILE',
     5                        'SOURCE FILE',
     6                        'DATUM FILE',
     7                        'SPECIFICATION FILE',
     8                        'STRAT. COLUMN FILE',
     9                        'LITHOLOGY FILE'/
C
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /OPENST/ OPENER
             LOGICAL OPENER
C
      IF ((IFTYPE .EQ. 3) .OR.  (IFTYPE .EQ. 4)) THEN
         ITYPE = 1
       ELSE
         ITYPE = 0
      END IF
      ICKERR=0
      CALL OPEND(IOUNIT,PAR1,ITYPE,LENGTH)
      IF (OPENER) GO TO 51
C
C        IT WAS POSSIBLE TO OPEN A FILE BY THE NAME 'PAR1'.
C
      IF ((IFTYPE .EQ. 3) .OR. (IFTYPE .EQ. 4)) THEN
         READ (IOUNIT,REC=1) HEFA
        ELSE
         READ (IOUNIT,9000,REC=1) HEFA
        END IF
   11 CALL TXTCLR(ICOLOR(6))
      I = 1
      DO 12 J = 1,NJ
      IF ( HEFA .EQ. LABEL(J+1) ) I = J+1
   12 CONTINUE
      TITLE = FYLTYP(IFTYPE)
      CALL GTEXTS(10,LINE,
     1       '***** THERE IS ALREADY A ' // FYLTYP(I) )
      CALL GTEXTS(16,LINE+1,
     1      'WITH THE SAME NAME OF ' // PAR1(1:TITLEN(PAR1)) // '.')
      CALL GTEXTS(16,LINE+3,
     1'RE -- RETURN TO PREVIOUS MENU NOT TO DESTROY AN EXISTING FILE')
      CALL GTEXTS(16,LINE+4,
     1   'GO -- RECYCLE THE EXISTING FILE.  EXISTING FILE WILL BE LOST')
      CALL GTEXTS(18,LINE+6,'PLEASE ENTER YOUR SELECTION:')
      CALL AINPUT(48,LINE+6)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN 1
      IF (OPTION .NE. 'GO') GO TO 15
   51 CLOSE(IOUNIT)
C
      RETURN
 9000 FORMAT (A4)
      END
C***********************************************************************
C
C         CHECK FOR VALID CORRELATION FILE
C
C**********************************************************************
C
      SUBROUTINE CHKCFL(IOPT,LINE,ICKERR,NZ)
C
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /OPENST/ OPENER
             LOGICAL OPENER
      COMMON /CHARH/ FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
C
      include 'corrdb.inc'
C
      CHARACTER*4 CORRN
C
      ICKERR=0
      NZ=0
      CALL OPEND(25,CORRFN,1,196)
      IF (.NOT. OPENER) GO TO 11
         ICKERR=1
         IF (LINE .GT. 0) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(10,LINE+12,
     X          '***** FILE DOES NOT EXIST.  PRESS RETURN TO CONTINUE')
            CALL SCHOLD
           ENDIF
         RETURN
C
   11 READ (25,REC=1) CORRN,CTITLE,CWELDB,NCCORR,IFCORR,LSTCOR,
     X                      ICLREC,ICFREC,LCPSEQ
      IF (CORRN .EQ. 'CLDB') GO TO 21
         ICKERR=2
         IF (LINE .GT. 0) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(10,LINE+12,
     X          '***** FILE NOT A CORRELATION DATABASE FILE.')
            CALL SCHOLD
            NCCORR=-1
          ENDIF
         CLOSE(25)
         RETURN
C
   21 IF (IOPT .LT. 1) GO TO 31
      IF (CWELDB .EQ. FYLES) GO TO 31
         ICKERR=3
         IF (LINE .GT. 0) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(10,LINE+12,
     X'***** CORRELATION DATABASE FILE REQUIRES ANOTHER WELL DATA FILE')
            CALL SCHOLD
            NCCORR=-1
           ENDIF
         CLOSE(25)
         RETURN
C
   31 RETURN
      END
