C     CORRELATOR MODULE OTHER
C
C***********************************************************************
C
C                     HEADING FOR WEIGHTED CROSS-CORRELATIONS.
C
C***********************************************************************
C
      SUBROUTINE HEADNG(NAME1,NAME2,ID1,ID2,CUTOFF)
C
      CHARACTER*20 NAME1
      CHARACTER*20 NAME2
      CHARACTER*10 LABEL
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /COLOPT/ ICOLOR(6)
C
      IF (ITERMQ .EQ. 0) THEN
         CALL XMOVEA(16.,66.0)
         CALL GTEXTX(NAME1)
         CALL XMOVEA(90.,66.0)
         CALL GTEXTX(NAME2)
         WRITE(LABEL,'(I2)') ID1
         CALL XMOVEA(23.0,63.8)
         CALL GTEXTX(LABEL)
         WRITE(LABEL,'(I2)') ID2
         CALL XMOVEA(98.,63.8)
         CALL GTEXTX(LABEL)
        ELSE
         CALL TXTCLR(ICOLOR(2))
C         CALL SLINDX(0)  ! Publication
         CALL XMOVEA(16.,65.0)
         CALL GTEXTX(NAME1)
         CALL XMOVEA(90.,65.0)
         CALL GTEXTX(NAME2)
         WRITE(LABEL,'(I2)') ID1
         CALL XMOVEA(23.7,63.8)
         CALL GTEXTX(LABEL)
         WRITE(LABEL,'(I2)') ID2
         CALL XMOVEA(98.,63.8)
         CALL GTEXTX(LABEL)
         DELCUT = (1.0 - CUTOFF)/5.0
         Y = 63.3
         CORR = CUTOFF - 0.5*DELCUT
         DO 100 I = 1,5
         Y = Y + 0.3
         CORR = CORR + DELCUT
         CALL COLSET(CORR,CUTOFF)
         CALL XMOVEA(58.0,Y)
         CALL XDRAWA(63.0,Y)
  100    CONTINUE
         CALL SLINDX(2)
C         CALL SLINDX(0)  ! Publication
         CALL XMOVEA(54.1,65.0)                             !jlc 7/25/90
         CALL GTEXTX('MATCHING SCALE')
         WRITE(LABEL,'(F8.3)') CUTOFF
         CALL XMOVEA(61.0,63.3)                             !jlc 7/25/90
         CALL GTEXTX(LABEL)
         CALL XMOVEA(53.0,63.8)                             !jlc 7/25/90
         CALL GTEXTX('1.00')                                !jlc 7/25/90
      ENDIF
      RETURN
      END
      SUBROUTINE GEXTRE(RMN,RMX,F)
C
C                  GRAPH EXTREMES.
C
C***********************************************************************
C
      CALL WIDTH(RMN,RMX,F)
      IF (RMN .LT. 0.0) THEN
       RMN = F*(INT(RMN/F) - 1)
      ELSE
       RMN = F*(INT(RMN/F))
      ENDIF
      IF (RMX .LT. 0.0) THEN
       RMX = F*(INT(RMX/F))
      ELSE
       RMX = F*(INT(RMX/F) + 1)
      ENDIF
      RETURN
      END
      SUBROUTINE WIDTH(RMN,RMX,F)
C
C                  FREQUENCY OF ANNOTATIONS.
C
C***********************************************************************
C
      REAL*8 D
C
      D = RMX - RMN
      IF ( D .GT. 1.0) THEN
         F = (10.0D0)**(INT((DLOG10(D))))
      ELSE
         F = (10.0D0)**(INT((DLOG10(D)- 1.0D0)))
      END IF
      N = ANINT(D/F)
      IF ( N .EQ. 1 ) F = 0.2*F
      IF ( N .GE. 2  .AND. N .LE. 4) F = 0.5*F
      RETURN
      END
      SUBROUTINE LABELX(RMN,RMX,F,NAME1,ID1)
C
C                   LABEL THE ABSCISSAS
C
C***********************************************************************
C
      INTEGER*4 XLAB
      CHARACTER*4 BOML
      CHARACTER*3 CHID1
      CHARACTER*5 NUM
      CHARACTER*20 NAME1
      CHARACTER*46 TITX
C
      COMMON/BOML/ BOML
      COMMON /BOX/ XLL,YLL,XUR,YUR
C
      D = RMX - RMN
      N = NINT(D/F) + 1
      X = XLL
      DX = (XUR - XLL)/(N - 1)
      XLAB = ANINT(RMN)
      DO 400 I=1,N
      IF (I .GT. 1  .AND. I .LT. N) THEN
       CALL XMOVEA(X,YLL)
       CALL XDRAWA(X,YLL+0.4)
       CALL XMOVEA(X,YUR-0.4)
       CALL XDRAWA(X,YUR)
       END IF
      CALL XMOVEA(X-2.9,YLL-1.5)
C     IF ( ITERMQ .EQ. 0) THEN
C      CALL ANMOD2
C      WRITE (QTEKOT,'(I5)') XLAB
C      CALL GRMOD2
C     ELSE
       WRITE(NUM,'(I5)') XLAB
       CALL GTEXTX(NUM)
C     END IF
      X = X + DX
      XLAB = ANINT(XLAB + F)
  400 CONTINUE
      WRITE(CHID1,'(I3)') ID1
      TITX = 'DEPTH ON WELL '//CHID1//' ('//NAME1//'), '//BOML
      CALL XMOVEA(XLL+29.2,YLL-4.8)
C     IF ( ITERMQ .EQ. 0) THEN
C      CALL ANMOD2
C      WRITE (QTEKOT,'(A46)') TITX
C      CALL GRMOD2
C     ELSE
       CALL GTEXTX(TITX)
C     END IF
      RETURN
      END
      SUBROUTINE LABELY(RMN,RMX,F)
C
C                   LABEL THE ORDINATES.
C
C***********************************************************************
C
      LOGICAL SMALL
      INTEGER*4 YLAB
      CHARACTER*4 BOML
      CHARACTER*5 NUM
      CHARACTER*7 RNUM
      CHARACTER*30 TITY
      CHARACTER*25 TTY /'DIFFERENCE IN ELEVATION, '/
C
      COMMON/BOML/ BOML
      COMMON /BOX/ XLL,YLL,XUR,YUR
C
      SMALL = ABS(F) .LT. 1.0
      D = RMX - RMN
      N = (D/F) + 1
      Y = YLL
      DY = (YUR - YLL)/(N - 1)
      IF (SMALL) THEN
         YLAB=ANINT(RMN*10.0)
         FF=F*10.0
        ELSE
         YLAB = ANINT(RMN)
         FF=F
        ENDIF
      DO 400 I=1,N
      IF (I .GT. 1  .AND. I .LT. N) THEN
       CALL XMOVEA(XLL,Y)
       CALL XDRAWA(XLL+0.4,Y)
       END IF
      IF (SMALL) THEN
         CALL XMOVEA(XLL-8.0,Y-0.4)
         YYLAB=FLOAT(YLAB)/10.0
         WRITE (RNUM,'(F7.1)') YYLAB
         CALL GTEXTX(RNUM)
        ELSE
         CALL XMOVEA(XLL-6.0,Y-0.4)
         WRITE(NUM,'(I5)') YLAB
         CALL GTEXTX(NUM)
        ENDIF
      Y = Y + DY
      YLAB = ANINT(YLAB + FF)
  400 CONTINUE
      Y = YUR - 11.0
      TITY = TTY//BOML
      DO 500 I=1,30
       CALL XMOVEA(XLL-10.0,Y)
       CALL GTEXTX(TITY(I:I))
       Y = Y - 1.0
  500 CONTINUE
      RETURN
      END
      SUBROUTINE LABEYD(RMN,RMX,HWDIST)
C
C                   LABEL THE ORDINATES IN DEGREES.
C
C***********************************************************************
C
      CHARACTER*7 NUM
      CHARACTER*21 TTY /'APPARENT DIP, DEGREES'/
C
      COMMON /BOX/ XLL,YLL,XUR,YUR
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      DEGRMN = 57.29578*ATAN2(RMN,HWDIST)
      DEGRMX = 57.29578*ATAN2(RMX,HWDIST)
      CALL GEXTRD(DEGRMN,DEGRMX,DEGF)
      DEGD = DEGRMX - DEGRMN
      N = (DEGD/DEGF) + 1
      DY = (YUR - YLL)/(RMX - RMN)
      YLAB = DEGRMN
      Y = YLL + (DY*HWDIST*(TAN(0.017453*YLAB)-TAN(ATAN2(RMN,HWDIST))))
      DO 400 I=1,N
      CALL XMOVEA(XUR-0.4,Y)
      CALL XDRAWA(XUR,Y)
      CALL XMOVEA(XUR+0.5,Y-0.4)
      WRITE (NUM,'(F7.3)') YLAB
      CALL GTEXTX(NUM)
      YLAB = YLAB + DEGF
      Y = YLL + (DY*HWDIST*(TAN(0.017453*YLAB)-TAN(ATAN2(RMN,HWDIST))))
  400 CONTINUE
      Y = YUR - 13.0
      DO 500 I=1,21
      IF ( ITERMQ .EQ. 0) THEN
       CALL XMOVEA(XUR+10.0,Y)
       CALL GTEXTX(TTY(I:I))
      ELSE
       CALL XMOVEA(XUR+13.0,Y)
       CALL GTEXTX(TTY(I:I))
      END IF
      Y = Y - 1.0
  500 CONTINUE
      RETURN
      END
      SUBROUTINE GEXTRD(RMN,RMX,F)
C
C                  GRAPH EXTREMES.
C
C***********************************************************************
C
      CALL WIDTH(RMN,RMX,F)
      IF (RMN .LT. 0.0) THEN
       RMN = F*(INT(RMN/F))
      ELSE
       RMN = F*(INT(RMN/F) + 1)
      ENDIF
      IF (RMX .LT. 0.0) THEN
       RMX = F*(INT(RMX/F) - 1)
      ELSE
       RMX = F*(INT(RMX/F))
      ENDIF
      RETURN
      END
C
      SUBROUTINE CORCOE(RLOG1,IL1,RLOG2,IL2,IFLAGR,ICINT,IS,IE,ICS,ICE,
     1                  RMIN,RMAX,SX1P,SX1X1P,CORR)
C
C                     CROSS-CORRELATION COEFFICIENTS.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      REAL*4 RLOG1(LOG_LENGTH)
      REAL*4 RLOG2(LOG_LENGTH)
      REAL*4 CORR(LOG_LENGTH)
      REAL*8 AN,R1,R2,SX1,SX2,SX1X1,SX1X2,SX2X2,RT,DIV
      REAL*8 SX2P,SX2X2P,SX1P,SX1X1P,RKM1,RKP2I
C
      RMIN=+1.0E 30
      RMAX=-RMIN
      AN=ICINT+ICINT+1
      SX2=0.0
      SX2X2=0.0
      IFLAG=0
C
C          REFERENCE WELL COEFFICIENTS
C
       IF( IFLAGR .EQ. 0) THEN
C          TOP LEVEL.
       SX1=0.0
       SX1X1=0.0
       DO 100 J=ICS,ICE
       R1=RLOG1(J)
       SX1=SX1+R1
       SX1X1=SX1X1+R1*R1
  100  CONTINUE
       END IF
C          REMAINDER INTERVALS.
       IF( IFLAGR .GT. 0) THEN
       RKM1=RLOG1(ICS-1)
       RKP2I=RLOG1(ICE)
       SX1=(SX1P - RKM1) + RKP2I
       SX1X1=(SX1X1P - RKM1*RKM1) + (RKP2I*RKP2I)
       END IF
      SX1P=SX1
      SX1X1P=SX1X1
C
C          CROSSED REFERENCE-MATCHING COEFFICIENT.
C
      DO 161 I=IS,IE
      CORR(I)=-1.0E 30
      IF (I-ICINT .LT. 1) GO TO 161
      IF (I+ICINT .GT. IL2) GO TO 161
      K=I-ICINT
      SX1X2=0.0
      DO 162 J=ICS,ICE
      R1=RLOG1(J)
      R2=RLOG2(K)
      SX1X2=SX1X2+R1*R2
C
C          MATCHING WELL COEFFICIENTS.
C
       IF(IFLAG .EQ. 0) THEN
C          TOP INTERVAL.
       SX2=SX2+R2
       SX2X2=SX2X2+R2*R2
       END IF
      K=K+1
  162 CONTINUE
C          REMAINDER INTERVALS.
       IF( IFLAG .GT. 0) THEN
       RKM1=RLOG2(I-ICINT-1)
       RKP2I=RLOG2(I+ICINT)
       SX2=(SX2P - RKM1) + RKP2I
       SX2X2=(SX2X2P - RKM1*RKM1) + (RKP2I*RKP2I)
       END IF
      SX2P=SX2
      SX2X2P=SX2X2
C
C          CROSS-CORRELATION COEFFICIENT.
C
      RT=SX1X2-SX1*SX2/AN
      DIV=DSQRT((SX1X1-SX1*SX1/AN)*(SX2X2-SX2*SX2/AN))
      IF (DABS(DIV) .LT. 1.0D-20) THEN
         R=-1.0
        ELSE
         R=RT/DIV
        ENDIF
      CORR(I)=R
      RMIN=AMIN1(R,RMIN)
      RMAX=AMAX1(R,RMAX)
      IFLAG=1
  161 CONTINUE
      RETURN
      END
      SUBROUTINE HEADIN(NAME1,ID1,NAME2,ID2,
     1                  TIT1,TIT2,TIT3,X1,X2)
C
C                   PLOTS PLOT HEADINGS.
C
C***********************************************************************
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CHARACTER*5 CHAR5
      CHARACTER*7 CHAR7
      CHARACTER*20 NAME1
      CHARACTER*20 NAME2
      CHARACTER*29 TIT1
      CHARACTER*7 TIT2
      CHARACTER*7 TIT3
      CHARACTER*2 CCNQ
C
C      CALL SLINDX(0)    ! Publication
      CALL SLINDX(2)
        IF (ITERMQ .LE. 2) THEN
          CALL XMOVEA(15.0,65.0)
          CALL GTEXTX(NAME1)
          CALL XMOVEA(99.0,65.0)
          CALL GTEXTX(NAME2)
          IF(X1 .LT. 0) GO TO 50
          CALL XMOVEA(55.7,65.0)
          CALL GTEXTX(TIT1)
   50     CALL XMOVEA(23.0,63.8)
          WRITE (CCNQ,'(I2)') ID1
          CALL GTEXTX(CCNQ)
          CALL XMOVEA(107.0,63.8)
          WRITE (CCNQ,'(I2)') ID2
          CALL GTEXTX(CCNQ)
          IF(X1 .LT. 0) GO TO 100
          CALL XMOVEA(53.5,63.8)
          CALL GTEXTX(TIT2)
          CALL XMOVEA(59.0,63.8)
          WRITE (CHAR7,'(F7.1)') X1
          CALL GTEXTX(CHAR7)
          CALL XMOVEA(68.0,63.8)
          CALL GTEXTX(TIT3)
          CALL XMOVEA(74.0,63.8)
          WRITE (CHAR7,'(F7.1)') X2
          CALL GTEXTX(CHAR7)
  100     CONTINUE
        ELSE
          CALL XMOVEA(14.0,65.0)
          CALL GTEXTX(NAME1)
          CALL XMOVEA(99.0,65.0)
          CALL GTEXTX(NAME2)
          WRITE(CHAR5,'(I2)') ID1
          CALL XMOVEA(23.7,63.8)
          CALL GTEXTX(CHAR5)
          WRITE(CHAR5,'(I2)') ID2
          CALL XMOVEA(108.0,63.8)
          CALL GTEXTX(CHAR5)
          IF(X1 .LT. 0) GO TO 200
          CALL XMOVEA(55.7,65.0)
          CALL GTEXTX(TIT1)
          CALL XMOVEA(51.5,63.8)
          CALL GTEXTX(TIT2)
          WRITE(CHAR7,'(F7.1)') X1
          CALL XMOVEA( 57.5,63.8)
          CALL GTEXTX(CHAR7)
          CALL XMOVEA(66.0,63.8)
          CALL GTEXTX(TIT3)
          WRITE(CHAR7,'(F7.1)') X2
          CALL XMOVEA(74.0,63.8)
          CALL GTEXTX(CHAR7)
  200     CONTINUE
        ENDIF
      RETURN
      END
      SUBROUTINE LOGSLA(FRMX)
C
C                   PLOTS LOG TYPE ON HEADING.
C
C***********************************************************************
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
C     CHARACTER*2 IFRMX
      CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
C
      COMMON/LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
C
C      CALL SLINDX(0)    ! Publication
        IF (ITERMQ .LE. 2) THEN
           CALL XMOVEA( 7.0,63.8)
           CALL GTEXTX(IDSHAR)
           CALL XMOVEA(37.0,63.8)
           CALL GTEXTX(IDCORR)
           CALL XMOVEA(FRMX-3.0,63.8)
           CALL GTEXTX(IDSHAM)
           CALL XMOVEA(FRMX+27.0,63.8)
           CALL GTEXTX(IDCORM)
        ELSE
          CALL XMOVEA(09.0,63.8)
          CALL GTEXTX(IDSHAR)
          CALL XMOVEA(36.0,63.8)
          CALL GTEXTX(IDCORR)
          CALL XMOVEA(FRMX,63.8)
          CALL GTEXTX(IDSHAM)
          CALL XMOVEA(FRMX+27.0,63.8)
          CALL GTEXTX(IDCORM)
        ENDIF
      RETURN
      END
      SUBROUTINE DATLAB(ITERM,DATUM)
C
C                   LOG DATUM.
C
C***********************************************************************
C
      CHARACTER*7 TDATUM /'DATUM: '/
      CHARACTER*15 DATUM
C
C
      IF (ITERM .LE. 2) THEN
         CALL XMOVEA(56.0,63.8)
         CALL GTEXTX(TDATUM)
         CALL XMOVEA(63.5,63.8)
         CALL GTEXTX(DATUM)
      ELSE
         CALL XMOVEA(54.0,63.8)
         CALL GTEXTX(TDATUM)
         CALL XMOVEA(62.0,63.8)
         CALL GTEXTX(DATUM)
      ENDIF
      RETURN
      END
      SUBROUTINE SHWCUT(TITCUT,CUTOFF)
C
C                   DISPLAYS CORRELATION CUTOFF.
C
C***********************************************************************
C
      CHARACTER*7 TITCUT
      CHARACTER*6 CHAR6
C
C       IF (ITERMQ .EQ. 0) THEN
C       ELSE
          CALL XMOVEA(61.0,0.02)
          CALL GTEXTX(TITCUT)
          WRITE (CHAR6,'(F6.3)') CUTOFF
          CALL XMOVEA(68.5,0.02)
          CALL GTEXTX(CHAR6)
C       ENDIF
      RETURN
      END
      SUBROUTINE PLRES(RMIN,RMAX,ZICP,RMIN1,RMAX1,RMIN2,RMAX2,
     1                 RMIN3,RMAX3,RMIN4,RMAX4,ICP,IDADJ,SCALE,DINC)
C
C                     LABELING OF CROSS-CORRELATION PLOTS.
C
C***********************************************************************
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CHARACTER*1 BOM,SCLSHL,SCLCOL
      CHARACTER*5 CHAR5
      CHARACTER*6 CHAR6
      CHARACTER*7 CHAR7
      CHARACTER*26 CHAR20
C
      COMMON/USCAL/ BOM,SCLSHL,SCLCOL
C
C      CALL TXTCLR(4)
      CALL TXTCLR(2)
C      CALL SLINDX(0)    ! Publication
      IF ( SCLSHL .EQ. 'L' ) THEN
         SHARL = RMAX3
         SHARR = RMIN3
         SHAML = RMAX4
         SHAMR = RMIN4
      ELSE
         SHARL = RMIN3
         SHARR = RMAX3
         SHAML = RMIN4
         SHAMR = RMAX4
      END IF
      IF ( SCLCOL .EQ. 'L' ) THEN
         CORRL = RMAX1
         CORRR = RMIN1
         CORML = RMAX2
         CORMR = RMIN2
      ELSE
         CORRL = RMIN1
         CORRR = RMAX1
         CORML = RMIN2
         CORMR = RMAX2
      END IF
      Y=63.0-FLOAT(ICP-IDADJ)*SCALE
        IF (ITERMQ .LE. 2) THEN
          IF(RMIN .EQ. RMAX) GO TO 100
          IF ( (DINC - ANINT(DINC)) .NE. 0.0 ) THEN
             WRITE (CHAR7,'(F7.1)') ZICP
             CALL XMOVEA(80.0,Y-0.35)
             CALL GTEXTX(CHAR7)
          ELSE
             WRITE (CHAR5,'(I5)') NINT(ZICP)
             CALL XMOVEA(80.0,Y-0.35)
             CALL GTEXTX(CHAR5)
          END IF
  100     IF ( RMAX3 .GT. -1.0E30 ) THEN
             CALL XMOVEA(1.0,0.02)
             WRITE (CHAR20,9101) SHARL,SHARR
 9101        FORMAT (F7.2,12X,F7.2)
             CALL GTEXTX(CHAR20)
           ENDIF
          IF ( RMAX1 .GT. -1.0E30 ) THEN
             CALL XMOVEA(27.0,0.02)
             WRITE (CHAR20,9101) CORRL,CORRR
             CALL GTEXTX(CHAR20)
            ENDIF
          IF ( RMAX4 .GT. -1.0E30 ) THEN
             CALL XMOVEA(85.0,0.02)
             WRITE (CHAR20,9101) SHAML,SHAMR
             CALL GTEXTX(CHAR20)
            ENDIF
          IF ( RMAX2 .GT. -1.0E30 ) THEN
             CALL XMOVEA(112.0,0.02)
             WRITE (CHAR20,9101) CORML,CORMR
             CALL GTEXTX(CHAR20)
            ENDIF
          IF (RMIN .NE. RMAX) THEN
             CALL XMOVEA(54.0,0.02)
             WRITE (CHAR6,'(F6.3)') RMIN
             CALL GTEXTX(CHAR6)
             CALL XMOVEA(74.5,0.02)
             WRITE (CHAR6,'(F6.3)') RMAX
             CALL GTEXTX(CHAR6)
            ENDIF
        ELSE
          IF ( RMAX1 .GT. -1.0E30 ) THEN
             WRITE (CHAR7,9107) SHARL
             CALL XMOVEA( 1.0,0.01)
             CALL GTEXTX(CHAR7)
             WRITE (CHAR7,9107) SHARR
             CALL XMOVEA( 14.0,0.01)
             CALL GTEXTX(CHAR7)
             WRITE (CHAR7,9107) CORRL
             CALL XMOVEA(28.0,0.01)
             CALL GTEXTX(CHAR7)
             WRITE (CHAR7,9107) CORRR
             CALL XMOVEA(41.0,0.01)
             CALL GTEXTX(CHAR7)
          END IF
          IF ( RMAX2 .GT. -1.0E30 ) THEN
             WRITE (CHAR7,9107) SHAML
             CALL XMOVEA(85.0,0.01)
             CALL GTEXTX(CHAR7)
             WRITE (CHAR7,9107) SHAMR
             CALL XMOVEA( 98.0,0.01)
             CALL GTEXTX(CHAR7)
             WRITE (CHAR7,9107) CORML
             CALL XMOVEA(112.0,0.01)
             CALL GTEXTX(CHAR7)
             WRITE (CHAR7,9107) CORMR
             CALL XMOVEA(123.8,0.01)
             CALL GTEXTX(CHAR7)
          END IF
          IF (RMIN .EQ. RMAX) GO TO 300
          WRITE (CHAR7,'(F7.3)') RMIN
          CALL XMOVEA(52.0,0.01)
          CALL GTEXTX(CHAR7)
          WRITE (CHAR5,'(F5.3)') RMAX
          CALL XMOVEA( 75.6,0.01)
          CALL GTEXTX(CHAR5)
          IF ((DINC - INT(DINC)) .NE. 0.0 ) THEN
             WRITE (CHAR7,'(F7.1)') ZICP
             CALL XMOVEA(79.4,Y-0.35)
             CALL GTEXTX(CHAR7)
          ELSE
             WRITE (CHAR5,'(I5)') NINT(ZICP)
             CALL XMOVEA(79.4,Y-0.35)
             CALL GTEXTX(CHAR5)
          END IF
  300     CONTINUE
        ENDIF
      CALL WKDONE
      RETURN
 9107 FORMAT (F7.2)
      END
C
      SUBROUTINE PLTSPE(RLOG1,IL1,RLOG2,IL2,DSTART,DINC,CDEPTH,DWIND,
     1                  XL1,RMIN1,RMAX1,RMIN2,RMAX2)
C
C                  DISPLAYS TWO LOGS FROM THE SAME WELL.
C
C***********************************************************************
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CHARACTER*5 DEPTH
      REAL RLOG1(IL1),RLOG2(IL2)
C
      COMMON/USCAL/ BOM,SCLSHL,SCLCOL
      CHARACTER*1 BOM,SCLSHL,SCLCOL
C
      IDADK=ANINT(1.0 + (CDEPTH+DWIND-DSTART)/DINC)
      IDE=MIN0(IL1,IL2,IDADK)
      IDADJ=ANINT(1.0 + (CDEPTH-DWIND-DSTART)/DINC)
      IF ( IDADJ .GE. MAX0(IL1,IL2) ) GO TO 900
      IDS=MAX0(1,IDADJ)
      X20=XL1+20.0
      X20P5=XL1+20.5
      X20P8=XL1+20.8
      X21=XL1+21.0
      X26=XL1+26.0
      X26P2=XL1+26.2
      X26P5=XL1+26.5
      X27=XL1+27.0
      X47 = X27 + 20.0
C
C          DISPLAY DEPTH SCALE
C
      SCALE=62.0/((2.0*DWIND)/DINC)
      YEND=63.0-(SCALE*FLOAT(IDE-IDADJ))
C          FREQUENCY OF ANNOTATIONS.
      INCZ = 1
      IF ( DWIND  .GT.  100.0  .AND.  DWIND .LT. 1500.0 ) INCZ = 10
      IF ( DWIND  .GE.  1500.0 ) INCZ = 100
      DS = FLOAT((NINT(SEQDEP(IDADJ,DSTART,DINC))/INCZ)*INCZ)
      ILS = NINT((DS-DSTART)/DINC+1.0)
      ILB=ILS
      ILI=NINT(INCZ/DINC)
C          DEPTH TRACK.
      CALL SLINDX(5)
C      CALL SLINDX(0)    ! Publication
      CALL XMOVEA(X20,63.0)
      CALL XDRAWA(X20,YEND)
      CALL XMOVEA(X27,YEND)
      CALL XDRAWA(X27,63.0)
C          TICK MARKS.
   11 IF (ILS .GT. IDE  ) GO TO 15
      IF (ILS .LT. IDADJ) GO TO 13
      Y=63.0-FLOAT(ILS-IDADJ)*SCALE
      ILL=NINT(DS+FLOAT(ILS-ILB)*DINC)
      IF (MOD(ILL,10*INCZ) .EQ. 0) GO TO 12
      IF (MOD(ILL,5*INCZ)  .EQ. 0) GO TO 14
      CALL XMOVEA(X20,Y)
      CALL XDRAWA(X20P5,Y)
      CALL XMOVEA(X26P5,Y)
      CALL XDRAWA(X27,Y)
      GO TO 13
   14 CALL XMOVEA(X20P8,Y)
      CALL XDRAWA(X20,Y)
      CALL XMOVEA(X26P2,Y)
      CALL XDRAWA(X27,Y)
      GO TO 13
   12 CALL XMOVEA(X21,Y)
      CALL XDRAWA(X20,Y)
      CALL XMOVEA(X26,Y)
      CALL XDRAWA(X27,Y)
        IF (ITERMQ .LE. 2) THEN
          CALL XMOVEA(XL1+21.0,Y-0.3)
          WRITE(DEPTH,'(I5)') ILL
          CALL GTEXTX(DEPTH)
        ELSE
          WRITE(DEPTH,'(I5)') ILL
          CALL XMOVEA(X21,Y-0.3)
          CALL GTEXTX(DEPTH)
        ENDIF
C***
   13 ILS=ILS+ILI
      GO TO 11
C
C          DISPLAY FIRST LOG
C
   15 RMIN1=+1.0E 30
      RMAX1=-RMIN1
      DO 111 I=IDS,IDE
      R=RLOG1(I)
      RMIN1=AMIN1(R,RMIN1)
      RMAX1=AMAX1(R,RMAX1)
  111 CONTINUE
      XSCALE=20.0/(RMAX1-RMIN1)
      CALL SLINDX(3)
C      CALL SLINDX(0)   ! Publication
      DO 112 I=IDS,IDE
      CALL MOVPEN(RLOG1(I),RMIN1,XSCALE,XL1,X20,SCLSHL,X)
      Y=63.0-FLOAT(I-IDADJ)*SCALE
      IF (I .EQ. IDS) CALL XMOVEA(X,Y)
      IF (I .GT. IDS) CALL XDRAWA(X,Y)
  112 CONTINUE
C
C          DISPLAY SECOND LOG
C
      IDE=MIN0(IL2,IDADK)
      RMIN2=+1.0E 30
      RMAX2=-RMIN2
      DO 121 I=IDS,IDE
      R=RLOG2(I)
      RMIN2=AMIN1(R,RMIN2)
      RMAX2=AMAX1(R,RMAX2)
  121 CONTINUE
      XSCALE=20.0/(RMAX2-RMIN2)
      CALL SLINDX(3)
C      CALL SLINDX(0)   ! Publication
      DO 122 I=IDS,IDE
      CALL MOVPEN(RLOG2(I),RMIN2,XSCALE,X27,X47,SCLCOL,X)
      Y=63.0-FLOAT(I-IDADJ)*SCALE
      IF (I .EQ. IDS) CALL XMOVEA(X,Y)
      IF (I .GT. IDS) CALL XDRAWA(X,Y)
  122 CONTINUE
  900 RETURN
      END
      SUBROUTINE MOVPEN(RLOG1,RMIN1,XSCALE,XL1,X20,FSCL,X)
C
C                  FIND ABSCISSA FOR NEXT PEN MOVEMENT.
C
C***********************************************************************
C
      CHARACTER*1 FSCL
C
      X=(RLOG1-RMIN1)*XSCALE
      IF ( FSCL .NE. 'L' ) THEN
         X = XL1 + X
      ELSE
         X = X20 - X
      END IF
      RETURN
      END
C***********************************************************************
C
      SUBROUTINE COSHAL(RLOG3,IL3,RLOG4,IL4)
C
C          CORRECT SHALE LOG FOR DRIFTING BASE LINES OR
C          HIGHLY RADIOACTIVE BLACK SHALES.
C
C***********************************************************************
C
      REAL*4 RLOG3(IL3)
      REAL*4 RLOG4(IL4)
C
      COMMON/DIGS/ DIGS1,DIGS2
      COMMON/DRIFTSP/ SPPR,SPPM
      INTEGER*4 SPPM,SPPR
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
C
      IF ( SPPR .GT. 0 ) THEN
         IF ( SPPR .LT. 20 ) THEN
            CALL SSPBL(SPPR,ID1,RLOG3,IL3,DIGS1,1,2)
         ELSE
            XSPPR=SPPR
            CALL CLIP(RLOG3,IL3,XSPPR)
         END IF
      END IF
      IF ( SPPM .GT. 0 ) THEN
         IF ( SPPM .LT. 20 ) THEN
            CALL SSPBL(SPPM,ID2,RLOG4,IL4,DIGS2,2,2)
         ELSE
            XSPPM=SPPM
            CALL CLIP(RLOG4,IL4,XSPPM)
         END IF
      END IF
      RETURN
      END
C***********************************************************************
C
C                   SHADES AREA BETWEEN EACH OF TWO LOG AND DEPTH SCALE.
C
C***********************************************************************
C
      SUBROUTINE SHADOW(ICS,ICE,RLOG1,IL1,RLOG2,IL2,DSTART,DINC,
     X                  CDEPTH,DWIND,XL1,ISHADE,MENU)
C
      INCLUDE 'log.inc'
C
      INTEGER*2 ISHADE(LOG_LENGTH)
      INTEGER*2 ONE/1/
      CHARACTER*4 MENU
      REAL RLOG1(IL1),RLOG2(IL2)
C
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
C
C      CALL SLINDX(0)    ! Publication
      X20=XL1+20.0
      X27=XL1+27.0
      X47 = X27 + 20.0
      IDADJ=NINT(1.0 + (CDEPTH-DWIND-DSTART)/DINC)
      IDADK=NINT(1.0 + (CDEPTH+DWIND-DSTART)/DINC)
      IDS=MAX0(1,IDADJ)
      IDE=MIN0(IL1,IDADK)
      SCALE=62.0/((2.0*DWIND)/DINC)
      IF(MENU .EQ. 'COLE'  .OR.  MENU .EQ. 'COIN') GO TO 1125
C
C          SHADE SHALE LOG
C
      RMIN1=+1.0E 30
      RMAX1=-RMIN1
      DO 111 I=IDS,IDE
      R=RLOG1(I)
      RMIN1=AMIN1(R,RMIN1)
      RMAX1=AMAX1(R,RMAX1)
  111 CONTINUE
      XSCALE=20.0/(RMAX1-RMIN1)
      DO 112 I=ICS,ICE
      IF(ISHADE(I) .EQ. ONE) GO TO 112
      CALL MOVPEN(RLOG1(I),RMIN1,XSCALE,XL1,X20,SCLSHL,X)
      Y=63.0-FLOAT(I-IDADJ)*SCALE
      IF ((Y .GT. 63.0) .OR. (Y .LT. 1.0)) GO TO 112
      CALL XMOVEA(X,Y)
      CALL XDRAWA(X20,Y)
  112 CONTINUE
 1125 IF(MENU .EQ. 'SHAL') GO TO 1235
C
C          SHADE CORRELATION LOG.
C
      IDE=MIN0(IL2,IDADK)
      RMIN2=+1.0E 30
      RMAX2=-RMIN2
      DO 121 I=IDS,IDE
      R=RLOG2(I)
      RMIN2=AMIN1(R,RMIN2)
      RMAX2=AMAX1(R,RMAX2)
  121 CONTINUE
      XSCALE=20.0/(RMAX2-RMIN2)
      DO 123 I=ICS,ICE
      IF(ISHADE(I) .EQ. ONE) GO TO 123
      CALL MOVPEN(RLOG2(I),RMIN2,XSCALE,X27,X47,SCLCOL,X)
      Y=63.0-FLOAT(I-IDADJ)*SCALE
      IF ((Y .GT. 63.0) .OR. (Y .LT. 1.0)) GO TO 122
      CALL XMOVEA(X27,Y)
      CALL XDRAWA(X,Y)
  122 ISHADE(I)=ONE
  123 CONTINUE
 1235 RETURN
      END
C***********************************************************************
C
C                   SHADES AREA BETWEEN EACH OF TWO LOG AND DEPTH SCALE.
C
C***********************************************************************
C
      SUBROUTINE SHADLG(RLOG1,IL1,RLOG2,IL2,DSTART,DINC,
     X                  CDEPTH,DWIND,XL1,ISHADE,MENU)
C
      INCLUDE 'log.inc'
C
      INTEGER*2 ISHADE(LOG_LENGTH)
      INTEGER*2 ONE/1/
      CHARACTER*4 MENU
      REAL RLOG1(IL1),RLOG2(IL2)
C
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
C
      X20=XL1+20.0
      X27=XL1+27.0
      X47 = X27 + 20.0
      IDADJ=NINT(1.0 + (CDEPTH-DWIND-DSTART)/DINC)
      IDADK=NINT(1.0 + (CDEPTH+DWIND-DSTART)/DINC)
      IDS=MAX0(1,IDADJ)
      IDE=MIN0(IL1,IDADK)
      SCALE=62.0/((2.0*DWIND)/DINC)
      IF(MENU .EQ. 'COLE'  .OR.  MENU .EQ. 'COIN') GO TO 1125
C
C          SHADE SHALE LOG
C
      RMIN1=+1.0E 30
      RMAX1=-RMIN1
      DO 111 I=IDS,IDE
      R=RLOG1(I)
      RMIN1=AMIN1(R,RMIN1)
      RMAX1=AMAX1(R,RMAX1)
  111 CONTINUE
      XSCALE=20.0/(RMAX1-RMIN1)
      DO 112 I=IDS,IDE
      IF (ISHADE(I) .NE. ONE) GO TO 112
      CALL MOVPEN(RLOG1(I),RMIN1,XSCALE,XL1,X20,SCLSHL,X)
      Y=63.0-FLOAT(I-IDADJ)*SCALE
      IF ((Y .GT. 63.0) .OR. (Y .LT. 1.0)) GO TO 112
      CALL XMOVEA(X,Y)
      CALL XDRAWA(X20,Y)
  112 CONTINUE
 1125 IF(MENU .EQ. 'SHAL') GO TO 1235
C
C          SHADE CORRELATION LOG.
C
      RMIN2=+1.0E 30
      RMAX2=-RMIN2
      DO 121 I=IDS,IDE
      R=RLOG2(I)
      RMIN2=AMIN1(R,RMIN2)
      RMAX2=AMAX1(R,RMAX2)
  121 CONTINUE
      XSCALE=20.0/(RMAX2-RMIN2)
      DO 123 I=IDS,IDE
      IF (ISHADE(I) .NE. ONE) GO TO 123
      CALL MOVPEN(RLOG2(I),RMIN2,XSCALE,X27,X47,SCLCOL,X)
      Y=63.0-FLOAT(I-IDADJ)*SCALE
      IF ((Y .GT. 63.0) .OR. (Y .LT. 1.0)) GO TO 123
      CALL XMOVEA(X27,Y)
      CALL XDRAWA(X,Y)
  123 CONTINUE
 1235 RETURN
      END
      SUBROUTINE SPBALI(I1STIM)
C
C                   CORRECT BASE LINE FOR SPONTANEOUS POTENTIAL LOGS.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      LOGICAL FLAG
      LOGICAL ERROR
      CHARACTER*1 ANSWER
      CHARACTER*2 PODEG(2) /'P1','P2'/
      CHARACTER*2 ANSW(2) /'CR','CM'/
      CHARACTER*2 OPTION,ANS
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /DIGS/ DIGS1,DIGS2
      COMMON /CODICO/ IOPT(2),IREGN(2), ISAV
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      IF ( I1STIM .EQ. 0 ) THEN
         DO 10 I = 1,2
         IOPT(I) = 1
   10    IREGN(I) =1
      ISAV = 2
      END IF
C
   11 FLAG = .TRUE.
      CALL OPCOBS
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS(3,15,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,15)
   15 CALL AGETST(OPTION,2)
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') GO TO 900
      IF ( OPTION .EQ. 'GO' ) GO TO 51
C
      IF (OPTION .EQ. 'SA') THEN
         CALL AGETTX(ANSWER)
         IF (ANSWER .EQ. 'Y'  .OR.  ANSWER .EQ. 'y') ISAV = 1
         IF (ANSWER .EQ. 'N'  .OR.  ANSWER .EQ. 'n') ISAV = 2
      END IF
      DO 30 I = 1,2
      IF (OPTION .EQ. PODEG(I) ) THEN
         CALL AGETIN(IVAL,ERROR)
         IF (.NOT. ERROR) THEN
            IF ((IVAL .GE. 0) .AND. (IVAL .LT. 20)) IREGN(I)=IVAL
         ENDIF
      ENDIF
      IF (OPTION .EQ. ANSW(I) ) THEN
         CALL AGETST(ANS,2)
         IF (ANS .EQ. 'YE') IOPT(I)=1
         IF (ANS .EQ. 'NO') IOPT(I)=2
      ENDIF
   30 CONTINUE
      GO TO 15
   51 IF( IOPT(1) .EQ. 2  .AND.  IOPT(2) .EQ. 2 ) GO TO 900
      CALL SPTEST(15,ID1,1,FLAG)
      CALL SPTEST(18,ID2,2,FLAG)
      IF (.NOT. FLAG) THEN
         CALL SCHOLD
         GO TO 11
      END IF
      I1STIM = 1
      CALL ANMODE
      WRITE(QTEKOT,9000)
      IF ( IOPT(1) .EQ. 1 ) 
     1   CALL SSPBL(IREGN(1),ID1,RLOG3,IL3,DIGS1,3,ISAV)
      IF ( IOPT(2) .EQ. 1 ) 
     1   CALL SSPBL(IREGN(2),ID2,RLOG4,IL4,DIGS2,4,ISAV)
 9000 FORMAT(///12X,'CORRECTION OF BASE LINE FOR ',
     1             'SPONTANEOUS POTENTIAL LOG'/
     2          12X,'****************************',
     3             '*************************'//)
      CALL RETKEY
  900 RETURN
      END
      SUBROUTINE SPTEST(LINE,ID,K,FLAG)
C
C                  TEST CONDITION THAT THE SHALE LOG IS AN SP LOG.
C
C***********************************************************************
C
      LOGICAL FLAG
      CHARACTER*4 IDSHAM
C
      include 'welldb.inc'
      include 'wldwel.inc'
C
      COMMON /COLOPT/ ICOLOR(6)
C
      CALL TXTCLR(ICOLOR(6))
      CALL GETWEL(IWLPTR(ID),IWELLR)
      ISL=ISHLLG(ID)
      IDSHAM=LOGNMM(ISL)
      IF ( .NOT.(IDSHAM .EQ. 'SP  '  .OR.  IDSHAM .EQ. ' SP '  .OR.
     1        IDSHAM .EQ. ' SPC'  .OR.  IDSHAM .EQ. 'spc '  .OR.
     1        IDSHAM .EQ. '  SP'  .OR.  IDSHAM .EQ. 'sp  '  .OR.
     5        IDSHAM .EQ. ' sp '  .OR.  IDSHAM .EQ. '  sp' )) THEN
         IF ( K .EQ. 1 ) THEN
            CALL GTEXTS(13,LINE,
     1     '***** THE REFERENCE SHALE LOG IS AN '//IDSHAM//' LOG.  THE')
            CALL GTEXTS(19,LINE+1,
     1           ' BASE LINE CORRECTION IS INTENTED FOR SP LOGS ONLY.')
            FLAG = .FALSE.
          ELSE
            CALL GTEXTS(13,LINE,
     1     '***** THE MATCHING SHALE LOG IS AN '//IDSHAM//' LOG.  THE')
            CALL GTEXTS(19,LINE+1,
     1           ' BASE LINE CORRECTION IS INTENTED FOR SP LOGS ONLY.')
            FLAG = .FALSE.
         END IF
      END IF
      RETURN
      END
      SUBROUTINE OPCOBS
C
C                 OPTION FOR COMMAND 'CB'.
C
C***********************************************************************
C
      CHARACTER*3 STATUS(2) /'YES','NO'/
C
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /CODICO/ IOPT(2),IREGN(2), ISAV
C
      CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'CORRECT THE SPONTANEOUS POTENTIAL BASE LINE')
C
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS(3,4,
     1  'CR - CORRECT THE REFERENCE SPONTANEOUS POTENTIAL LOG')
      CALL GTXTRJ(75,4,STATUS(IOPT(1)))
      LINE = 5
      IF (STATUS(IOPT(1)) .EQ. 'YES') THEN
         CALL GTEXTS(3,LINE,'P1 - POLYNOMIAL DEGREE')
         CALL GTXTIN(75,LINE,IREGN(1))
         LINE = LINE + 1
      END IF
      LINE = LINE + 1
      CALL GTEXTS(3,LINE,
     1  'CM - CORRECT THE MATCHING SPONTANEOUS POTENTIAL LOG')
      CALL GTXTRJ(75,LINE,STATUS(IOPT(2)))
      LINE = LINE + 1
      IF (STATUS(IOPT(2)) .EQ. 'YES') THEN
         CALL GTEXTS(3,LINE,'P2 - POLYNOMIAL DEGREE')
         CALL GTXTIN(75,LINE,IREGN(2))
         LINE = LINE + 1
      END IF
      LINE = LINE + 1
C
      CALL GTEXTS( 3,LINE,'SA - SAVE CORRECTIONS IN DATABASE')
      CALL GTXTRJ(75,LINE,STATUS(ISAV))
      LINE = LINE + 2
C
      CALL GTEXTS(3,LINE,'RE - RETURN TO PREVIOUS MENU')
      CALL GTEXTS(3,LINE+1,'GO - CORRECT BASE LINES')
C
      RETURN
      END
      SUBROUTINE DWBOX(XLL,YLL,XUR,YUR)
C
C                    DRAWS A BOX.
C
C***********************************************************************
C
      CALL XMOVEA(XLL,YLL)
      CALL XDRAWA(XUR,YLL)
      CALL XDRAWA(XUR,YUR)
      CALL XDRAWA(XLL,YUR)
      CALL XDRAWA(XLL,YLL)
      RETURN
      END
      SUBROUTINE DRAWCV(CORRL,IS,IE,XSTCV,CVWD,XSCALE,SCALE,IDADJ,
     1                  RMIN,ICP)
C
C                   DRAWS A CURVE AT THE CENTER OF THE SCREEN.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      REAL*4 CORRL(LOG_LENGTH)
C
      CALL SLINDX(3)
      CALL DWBOX(XSTCV,1.0,XSTCV+CVWD,63.0)
      ICP=IS
      DO 183 I=IS,IE
      IF (CORRL(I) .GT. CORRL(ICP)) ICP=I
      Y=63.0-FLOAT(I-IDADJ)*SCALE
      X=(CORRL(I)-RMIN)*XSCALE+XSTCV
      IF(CORRL(I) .GT. -1.0E30) THEN
        IF(I .NE. IS) THEN
          IF(CORRL(I-1) .GT. -1.0E30) THEN
            CALL XDRAWA(X,Y)
            ELSE
            CALL XMOVEA(X,Y)
          ENDIF
          ELSE
          CALL XMOVEA(X,Y)
        ENDIF
        ELSE
        CALL XMOVEA(XSTCV,Y)
      ENDIF
  183 CONTINUE
C     CALL XSTOPX
C     CALL XSTRTX
      RETURN
      END
      SUBROUTINE SHOWCT(DINC,XSTCV,Y,SHALZ)
C
C                     SHOW CENTER OF CORRELATION.
C
C***********************************************************************
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CHARACTER*7 CHAR7
      CHARACTER*5 CHAR5
C
      CALL SLINDX(2)      
      IF (ITERMQ .EQ. 0) THEN
C        CALL XMOVEA(XSTCV,Y-0.35)
C        CALL XSTOPX
         IF ( (DINC - INT(DINC)) .NE. 0.0 ) THEN
            WRITE(CHAR7,'(F7.1)') SHALZ
            CALL XMOVEA(47.0,Y-0.35)
            CALL GTEXTX(CHAR7)
         ELSE
            WRITE (CHAR5,'(I5)') NINT(SHALZ)
            CALL XMOVEA(48.0,Y-0.35)
            CALL GTEXTX(CHAR5)
         END IF
C        CALL XSTRTX
      ELSE
         IF ( (DINC - INT(DINC)) .NE. 0.0 ) THEN
            WRITE(CHAR7,'(F7.1)') SHALZ
            CALL XMOVEA(XSTCV-7.40,Y-0.35)
            CALL GTEXTX(CHAR7)
         ELSE
            WRITE(CHAR5,'(I5)') NINT(SHALZ)
            CALL XMOVEA(XSTCV-5.50,Y-0.35)
            CALL GTEXTX(CHAR5)
         END IF
      ENDIF
      CALL SLINDX(3)      
      RETURN
      END
C---------------------------------------------------------------------
C--  PROGRAM 4.2   PRINTM                          DAVIS 1973:131   --
C--                                                                 --
C--  GOLDEN DATAFILE LISTFILE YOURPROG                              --
C--                                                                 --
C--  SUBROUTINE TO OUTPUT A MATRIX HAVING N ROWS AND M COLUMNS TO   --
C--  LISTFILE.                                                      --
C--                                                                 --
C--  FORTRAN 77 VERSION: 11 JUN 84                                  --
C---------------------------------------------------------------------
C
        SUBROUTINE PRINTD (A, N, M, N1, M1)
C
        IMPLICIT NONE
        COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
               INTEGER QTEKIN,QTEKOT,ITERMQ
C
        INTEGER I
        INTEGER IB
        INTEGER IE
        INTEGER J
        INTEGER K
        INTEGER N
        INTEGER N1
        INTEGER M
        INTEGER M1
        REAL*8 A
        DIMENSION A(N1,M1)
C       PRINT MATRIX OUT IN STRIPS OF 10 COLUMNS.
        DO 101 IB = 1,M,10
          IE = IB + 9
          IF (IE .GT. M) IE = M
C         PRINT HEADING.
          WRITE ( QTEKOT, 2000) (I, I = IB,IE)
C         PRINT ROW OF MATRIX.
          DO 102 J = 1,N
            WRITE ( QTEKOT, 2001) J, (A(J,K), K = IB,IE)
  102      CONTINUE
  101    CONTINUE
        RETURN
2000    FORMAT(1X,10I12)
2001    FORMAT (1X,I5, 10G12.5)
        END
C***********************************************************************
C
C                  PREPARE A SOURCE FILE.
C
C***********************************************************************
C
      SUBROUTINE PRSOFI(J1STIM)
C
      CHARACTER*4 PSLA /'SOUR'/
C
      COMMON /SOFIAL/ PAR1
             CHARACTER*40 PAR1
      COMMON /SOFINU/ PAR2,PAR3,PAR4,NPAR,PAR3W(21),PAR4W(21)
             INTEGER*4 PAR2,PAR3,PAR4,NPAR,PAR3W,PAR4W
C
C         READ PARAMETERS
C
   11 CALL OPSOFI(J1STIM,*900)
C
C         START A NEW FILE
C
      IF ( PAR2 .EQ. 1) THEN
         CALL OPEND(68,PAR1,-1,12)
         NPAR = 0
         WRITE (68,9000,REC=1) PSLA,NPAR
         PAR2 = 2
        ELSE
         NPAR=NPAR+1
         PAR3W(NPAR)=PAR3
         PAR4W(NPAR)=0
         IF (NPAR .GT. 1) PAR4W(NPAR-1)=PAR4
         WRITE (68,9000,REC=1) PSLA,NPAR
         DO 101 I=1,NPAR
         WRITE (68,9001,REC=I+1) PAR3W(I),PAR4W(I)
  101    CONTINUE
        ENDIF
      CALL RPSOFI
      CLOSE (68,STATUS='KEEP')
      GO TO 11
  900 RETURN
 9000 FORMAT (A4,I5)
 9001 FORMAT (2I5)
      END
C**********************************************************************
C
C                   OPTIONS FOR COMMAND 'PS'.
C
C**********************************************************************
C
      SUBROUTINE OPSOFI(J1STIM,*)
C
      LOGICAL FLAG,ERROR
      CHARACTER*1 ANS
      CHARACTER*2 OPTION
      CHARACTER*4 LABEL
      CHARACTER*5 SOA(2) /'START','  ADD'/
C
      COMMON /COLOPT/  ICOLOR(6)
      COMMON /SOFIAL/ PAR1
             CHARACTER*40 PAR1
      COMMON /SOFINU/ PAR2,PAR3,PAR4,NPAR,PAR3W(21),PAR4W(21)
             INTEGER*4 PAR2,PAR3,PAR4,NPAR,PAR3W,PAR4W
C
      include 'wldhdr.inc'
      include 'corrdb.inc'
C
      IF (J1STIM .EQ. 0) THEN
         PAR1 = '*????*'
         PAR2 = 1
         PAR3 = 0
         PAR4 = 0
         NPAR = 0
       END IF
C
C        MENU
C
   11 FLAG = .FALSE.
      CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'PREPARATION OF A SOURCE FILE')
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3, 4,'FN - NAME OF THE SOURCE FILE')
      CALL GTXTRJ(75, 4,PAR1)
      LINE = 4
      IF ( PAR1 .NE. '*????*' ) THEN
         CALL GTEXTS( 3, 5,
     1    'SA - START A NEW FILE (S) OR ADD TO AN EXISTING FILE (A)')
         CALL GTXTRJ(75, 5,SOA(PAR2))
         LINE = 5
         IF ( PAR2 .EQ. 2 ) THEN
            CALL GTEXTS( 3,6,'WS - WELL SEQUENTIAL NUMBER')
            CALL GTXTIN(75,6,PAR3)
            LINE = LINE + 1
           ENDIF
        ENDIF
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
      IF ( PAR1 .NE. '*????*' )
     1   CALL GTEXTS( 3,LINE+3,'GO - UPDATE THE SOURCE FILE')
C
      LINE = LINE + 5
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN 1
C
      IF ((PAR1 .NE. '*????*')  .AND. (OPTION .EQ. 'GO')) THEN
         IF (PAR2 .EQ. 1) GO TO 51
         IF (PAR2 .EQ. 2  .AND.  PAR3 .GT. 0) GO TO 51
        ENDIF
C
      IF (OPTION .EQ. 'FN') CALL AGETST(PAR1,40)
      IF (OPTION .EQ. 'SA') THEN
         CALL AGETST(ANS,1)
         IF (ANS .EQ. 'S') PAR2 = 1
         IF (ANS .EQ. 'A') PAR2 = 2
        ENDIF
      IF (OPTION .EQ. 'WS') THEN
         PAR3=0
         PAR4=0
         CALL AGETIN(IVAL,ERROR)
         IF (.NOT. ERROR) THEN
            IF ((IVAL .GE. 1) .AND. (IVAL .LE. NUMWEL)) THEN
               IF (NPAR .LT. 1) THEN
                  PAR3=IVAL
                  PAR4=0
                 ELSE
                  IV=PAR3W(NPAR)
                  CALL FINDCP(0,IV,IVAL)
                  IF (NCPWEL .LT. 1) THEN
                     CALL TXTCLR(ICOLOR(6))
                     CALL GTEXTS(10,LINE+2,
     1           '***** NO CORRELATIONS FOR REQUEST WELL PAIR.')
                     CALL SCHOLD
                     GO TO 11
                    ELSE
                     IF (NCPWEL .EQ. 1) THEN
                        PAR3=IVAL
                        PAR4=ICPWEL(1)
                       ELSE
                        CALL SELTCP(ICP)
                        IF (ICP .LT. 1) GO TO 11
                        PAR3=IVAL
                        PAR4=ICPWEL(ICP)
                       ENDIF
                     ENDIF
                  ENDIF
              ENDIF
           ENDIF
        ENDIF
      GO TO 15
C
C          PARAMETER CHECKING.
C
   51 CALL TXTCLR(ICOLOR(6))
      IF ( PAR2 .EQ. 2 ) THEN
         CALL CHKOTY(68,PAR1,0,12,5,LINE+2,ICKERR)
         IF ( ICKERR .NE. 0 ) GO TO 11
         READ (68,9000,REC=1) LABEL,NPAR
         IF ( NPAR .GE. 21) THEN
            CALL GTEXTS(15,LINE+2,
     1       '***** THE MAXIMUM NUMBER OF WELLS IS 21.')
            LINE = LINE + 1
            FLAG = .TRUE.
           ENDIF
          IF (NPAR .GT. 0) THEN
             DO 151 I=1,NPAR
             READ (68,9001,REC=I+1) PAR3W(I),PAR4W(I)
  151        CONTINUE
            ENDIF
        ELSE
         CALL CHKOLF(68,PAR1,12,5,LINE+2,ICKERR,*11)
         NPAR=0
        ENDIF
      IF ( FLAG ) THEN
         CALL SCHOLD
         GO TO 11
        ENDIF
C
      J1STIM = 1
      RETURN
 9000 FORMAT (A4,I5)
 9001 FORMAT (2I5)
      END
C***********************************************************************
C
C                 DISPLAY CONTENT OF SOURCE FILE.
C
C***********************************************************************
C
      SUBROUTINE RPSOFI
C
      CHARACTER*4 LABEL
      INTEGER WSNUMB,CPNUMB
C
      COMMON /SOFIAL/ PAR1
             CHARACTER*40 PAR1
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CALL ANMODE
      READ (68,9000,REC=1) LABEL,NUSF
      WRITE (QTEKOT,9001) PAR1,NUSF
      IF ( NUSF .EQ. 0 ) GO TO 999
      WRITE (QTEKOT,9002)
      DO 100 I = 1,NUSF
      K = I
      READ (68,9003,REC=K+1) WSNUMB,CPNUMB
      WRITE (QTEKOT,9004) K,WSNUMB,CPNUMB
  100 CONTINUE
  999 CALL RETKEY
      RETURN
 9000 FORMAT (A4,I5)
 9001 FORMAT (///34X,'SOURCE FILE',/,
     1           34X,'***********',///,
     2        1X,'SOURCE FILE NAME',22X,A40/
     3        1X,'NUMBER OF WELLS', 8X,I4,////)
 9002 FORMAT (/,15X,'WELL SEQUENTIAL NUMBER',2X,'CORRELATION ID',/,
     2          15X,'----------------------',2X,'--------------',/)
 9003 FORMAT (2I5)
 9004 FORMAT (20X,I4,3X,I5,10X,I5)
      END
        SUBROUTINE PRDAFI(J1STIM)
C
C                  PREPARE A DATUM FILE.
C
C***********************************************************************
C
C
      CHARACTER*4 LABEL
      CHARACTER*4 DFLA /'DATU'/
C
      COMMON /DAFIAL/ PAR1
         CHARACTER*40 PAR1
      COMMON /DAFINU/ PAR2,PAR3
         INTEGER*4 PAR2
         REAL*4 PAR3
C
C         READ PARAMETERS
C
   11 CALL OPDAFI(J1STIM,*900)
C
C         START A NEW FILE
C
      IF ( PAR2 .EQ. 1) THEN
         CALL OPEND(68,PAR1,-1,11)
         K = 0
         WRITE (68,9000,REC=1) DFLA,K
       ELSE
         READ (68,9000,REC=1) LABEL,K
         WRITE (68,9000,REC=1) LABEL,K+1
         WRITE (68,9001,REC=K+2) PAR3
      END IF
      CALL RPDAFI
      CLOSE (68,STATUS='KEEP')
      GO TO 11
  900 RETURN
 9000 FORMAT (A4, 1X,I5)
 9001 FORMAT (F10.2)
      END
      SUBROUTINE OPDAFI(J1STIM,*)
C
C                   OPTIONS FOR COMMAND 'PD'.
C
C**********************************************************************
C
      LOGICAL FLAG
      CHARACTER*1 ANS
      CHARACTER*2 OPTION
      CHARACTER*4 LABEL
      CHARACTER*5 SOA(2) /'START','  ADD'/
      COMMON /COLOPT/  ICOLOR(6)
      LOGICAL ERROR
      CHARACTER*4 BOMU
C
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*15 DATUM
C            LOG DATA FILE NAME AND WELL DATA FILE
             CHARACTER*40 FYLES
C            REFERENCE WELL NAME.
             CHARACTER*20 NAME1
C            MATCHING WELL NAME.
             CHARACTER*20 NAME2
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /DAFIAL/ PAR1
         CHARACTER*40 PAR1
      COMMON /DAFINU/ PAR2,PAR3
         INTEGER*4 PAR2
         REAL*4 PAR3
C
      IF (J1STIM .EQ. 0) THEN
         PAR1 = '*????*'
         PAR2 = 1
         PAR3 = 0.0
      END IF
C
C        MENU
C
   11 FLAG = .FALSE.
      CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'PREPARATION OF A DATUM FILE')
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3, 4,'FN - NAME OF THE DATUM FILE')
      CALL GTXTRJ(75, 4,PAR1)
      LINE = 4
      IF ( PAR1 .NE. '*????*' ) THEN
         CALL GTEXTS( 3, 5,
     1    'SA - START A NEW FILE (S) OR ADD TO AN EXISTING FILE (A)')
         CALL GTXTRJ(75, 5,SOA(PAR2))
         LINE = 5
         IF ( PAR2 .EQ. 2 ) THEN
            CALL GTEXTS( 3,6,
     1  'DF - DEPTH TO DATUM, ' // BOMU(BOM) // ' BELOW ' // DATUM)
            CALL GTXTRL(75,6,PAR3,2)
            LINE = LINE + 1
         END IF
      END IF
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
      IF ( PAR1 .NE. '*????*' )
     1   CALL GTEXTS( 3,LINE+3,'GO - UPDATE THE DATUM FILE')
C
      LINE = LINE + 5
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN 1
C
      IF ((PAR1 .NE. '*????*')  .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'FN') CALL AGETST(PAR1,40)
      IF (OPTION .EQ. 'SA') THEN
         CALL AGETST(ANS,1)
         IF (ANS .EQ. 'S') PAR2 = 1
         IF (ANS .EQ. 'A') PAR2 = 2
      ENDIF
      IF (OPTION .EQ. 'DF') CALL AGETRL(PAR3,ERROR)
      GO TO 15
C
C          PARAMETER CHECKING.
C
   51 CALL TXTCLR(ICOLOR(6))
      IF ( PAR2 .EQ. 2 ) THEN
         CALL CHKOTY(68,PAR1,0,11,6,LINE+2,ICKERR)
         IF ( ICKERR .NE. 0 ) GO TO 11
         READ (68,9000,REC=1) LABEL,NUDA
         IF ( NUDA .GE. 21) THEN
            CALL GTEXTS(15,LINE+2,
     1       '***** THE MAXIMUM NUMBER OF DATUM VALUES IS 21.')
            LINE = LINE + 1
            FLAG = .TRUE.
         END IF
      ELSE
         CALL CHKOLF(68,PAR1,11,6,LINE+2,ICKERR,*11)
      END IF
      IF ( FLAG ) THEN
         CALL SCHOLD
         GO TO 11
      END IF
C
      J1STIM = 1
      RETURN
 9000 FORMAT (A4, 1X,I5)
      END
      SUBROUTINE RPDAFI
C
C                 DISPLAY CONTENT OF DATUM FILE.
C
C***********************************************************************
C
C
      CHARACTER*4 LABEL
      CHARACTER*4 BOMU
C
      COMMON /DAFIAL/ PAR1
         CHARACTER*40 PAR1
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CALL ANMODE
      READ (68,9000,REC=1) LABEL,NUDA
      WRITE (QTEKOT,9001) PAR1,NUDA
      IF ( NUDA .EQ. 0 ) GO TO 999
      WRITE(QTEKOT,9002) BOMU(BOM)
      DO 100 I = 1,NUDA
      K = I
      READ(68,9003,REC=K+1) DEPDAT
      WRITE(QTEKOT,9004) K,DEPDAT
  100 CONTINUE
  999 CALL RETKEY
      RETURN
 9000 FORMAT (A4, 1X,I5)
 9001 FORMAT (///27X,'DATUM FILE',/,
     1           27X,'**********',///,
     2        1X,'DATUM FILE NAME',14X,A40/
     3        1X,'NUMBER OF DATUM VALUES', 4X,I4////)
 9002 FORMAT(/30X,'DEPTH'/
     1       30X,A4/
     2       26X,13('-')/)
 9003 FORMAT (F10.0)
 9004 FORMAT (19X,I4,3X,F10.2)
      END
      SUBROUTINE COFIL(J1STIM)
C
C        PREPARATION OF FILE FOR DISPLAY OF LITHOLOGY IN CROSS SECTION
C
C***********************************************************************
C
      CHARACTER*4 HEMA /'LIT2'/
C
      COMMON /COFILHEAD/ PAR9,PAR10,PAR11
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 PAR9
C            NUMBER OF LITHOLOGY ZONES.
             INTEGER*4 PAR10
C            NUMBER OF ZONES TO MODIFY
             INTEGER*4 PAR11
      COMMON /COFILCH/ PAR1,PAR4,PAR5
         CHARACTER*40 PAR1
         CHARACTER*2  PAR4
         CHARACTER*10 PAR5
      COMMON /COFILNUM/ PAR2,PAR3,PAR6,PAR7,PAR8
         INTEGER*4 PAR2,PAR6,PAR8
         REAL*4 PAR3,PAR7
C
C         READ PARAMETERS
C
   11 CALL OPCOFIL(J1STIM,*900)
C
C         START A NEW FILE
C
      IF ( PAR2 .EQ. 1) THEN
         CALL OPEND(68,PAR1,-1,31)
         K = 0
         PAR11 = 0
         WRITE (68,9000,REC=1) HEMA,PAR9,K,PAR11
       ELSE IF ( PAR2 .EQ. 2) THEN
         READ (68,9000,REC=1) HEMA,PAR9,K,PAR11
         WRITE (68,9000,REC=1) HEMA,PAR9,K+1,PAR11
         WRITE (68,9001,REC=K+2) PAR3,PAR4,PAR5
       ELSE
         READ (68,9000,REC=1) HEMA,PAR9,K,PAR11
         WRITE (68,9000,REC=1) HEMA,PAR9,K,PAR11+1
         WRITE (68,9002,REC=K+2) PAR11+1
         WRITE (68,9003,REC=3+K+PAR11) PAR7,PAR8,PAR6
      END IF
      CALL RPCOFIL
      CLOSE (68,STATUS='KEEP')
      IF (PAR2 .EQ. 1 ) PAR2 = 2  !BGR
      GO TO 11
  900 RETURN
 9000 FORMAT (A4,11X,3I5)
 9001 FORMAT (F10.2,3X,A2,5X,A10)
 9002 FORMAT ('MODIFICATIONS',12X,I5)
 9003 FORMAT (F10.2,2(5X,I5))
      END
      SUBROUTINE OPCOFIL(J1STIM,*)
C
C                   OPTIONS FOR COMMAND 'LC'.
C
C**********************************************************************
C
      LOGICAL FLAG
      CHARACTER*1 ANS
      CHARACTER*2 OPTION
      CHARACTER*4 BOMU
      CHARACTER*4 HEMA 
      CHARACTER*7 SOA(3) /'START','PRIMARY','MODIFY'/
      LOGICAL ERROR
C
      include 'lithcolor.inc'
C
      COMMON /COLOPT/  ICOLOR(6)
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*15 DATUM
C            LOG DATA FILE NAME AND WELL DATA FILE
             CHARACTER*40 FYLES
C            REFERENCE WELL NAME.
             CHARACTER*20 NAME1
C            MATCHING WELL NAME.
             CHARACTER*20 NAME2
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
         CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COFILHEAD/ PAR9,PAR10,PAR11
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 PAR9
C            NUMBER OF LITHOLOGY ZONES.
             INTEGER*4 PAR10
C            NUMBER OF ZONES TO MODIFY
             INTEGER*4 PAR11
      COMMON /COFILCH/ PAR1,PAR4,PAR5
         CHARACTER*40 PAR1
         CHARACTER*2  PAR4
         CHARACTER*10 PAR5
      COMMON /COFILNUM/ PAR2,PAR3,PAR6,PAR7,PAR8
         INTEGER*4 PAR2,PAR6,PAR8
         REAL*4 PAR3,PAR7
      COMMON /MICKERR/ ICKERR  ! BGR
C
      IF (J1STIM .EQ. 0) THEN
         PAR11 = 0
         PAR1 = '*????*'
         PAR2 = 1
         PAR3 = 0.0
         PAR4 = LITOPTION(6)
         PAR5 = '*????*'
         PAR6 = 1
         PAR7 = 0.0
         PAR8 = 1
         PAR9 = 1
         ICKERR = 3
      END IF
C
C        MENU
C
   11 FLAG = .FALSE.
      CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'PREPARATION OF FILE FOR DISPLAY OF LITHOLOGY '//
     1   'IN CROSS SECTION')
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3, 4,'FN - NAME OF THE FILE')
      CALL GTXTRJ(75, 4,PAR1)
      LINE = 4
      IF ( PAR1 .NE. '*????*' ) THEN
         IF (PAR11 .EQ. 0) THEN
            IF (ICKERR .EQ. 0) THEN
               CALL GTEXTS( 3, 5,
     1      'SA - START A NEW FILE (S), ENTER PRIMARY INFORMATION (P),')
               CALL GTEXTS( 9, 6,
     1          'OR ENTER INFORMATION TO MODIFY PRIMARY ZONES (M)')
             ELSE
               CALL GTEXTS( 3, 5,'SA - START A NEW FILE (S)')
            END IF
          ELSE
            CALL GTEXTS( 3, 5,
     1         'SA - START A NEW FILE (S) OR ENTER INFORMATION')
            CALL GTEXTS( 9, 6, ' TO MODIFY PRIMARY ZONES (M)')
         END IF
         CALL GTXTRJ(75, 5,SOA(PAR2))
         LINE = 7
         IF ( PAR2 .EQ. 1 ) THEN
            CALL GTEXTS( 3,7,
     1       'SN - SEQUENTIAL NUMBER FOR THE WELL TO START THE COLORING')
            CALL GTXTIN(75,7,PAR9)
            LINE = LINE + 1
          ELSE IF ( PAR2 .EQ. 2) THEN
            CALL GTEXTS( 3, 7,
     1  'DZ - DEPTH TO TOP OF ZONE, ' // BOMU(BOM) // ' BELOW ' // DATUM)
            CALL GTXTRL(75, 7,PAR3,2)
           CALL GTEXTS( 3, 8,'CL - CLEAN LITHOLOGY.  OPTIONS: '
     1     //LITOPTION(1)//', '//LITOPTION(2)//', '//LITOPTION(3)//', '
     2       //LITOPTION(4)//', '//LITOPTION(5)//', '
     3        //LITOPTION(6)//', '//LITOPTION(8)//', '
     4        //LITOPTION(7))
            CALL GTXTRJ(75, 8,PAR4)
            CALL GTEXTS( 3,10,'RM - UP TO A 10-CHARACTER REMARK')
            CALL GTXTRJ(75,10,PAR5)
            LINE = LINE + 5
          ELSE
            CALL GTEXTS( 3,LINE,
     1       'PO - SEQUENTIAL NUMBER FOR THE WELL PAIR TO OVERRIDE')
            CALL GTXTIN(75,LINE,PAR8)
            CALL GTEXTS( 3,LINE+1,
     1       'ZO - SEQUENTIAL NUMBER FOR THE ZONE TO OVERRIDE')
            CALL GTXTIN(75,LINE+1,PAR6)
            CALL GTEXTS( 3, LINE+2,
     1  'DO - OVERRULING DEPTH ,' // BOMU(BOM) // ' BELOW ' // DATUM)
            CALL GTXTRL(75, LINE+2,PAR7,2)
            LINE = LINE + 3
         END IF
      END IF
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
      IF ( PAR1 .NE. '*????*'  .AND.  (ICKERR .EQ. 0  .OR.
     1    (ICKERR .NE. 0   .AND.  PAR2 .EQ. 1)))
     2   CALL GTEXTS( 3,LINE+3,'GO - UPDATE THE LITHOLOGY FILE')
C
      LINE = LINE + 5
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN 1
C
      IF (PAR1 .NE. '*????*'  .AND.  (ICKERR .EQ. 0  .OR. 
     1    (ICKERR .NE. 0   .AND.  PAR2 .EQ. 1))  .AND.
     2     OPTION .EQ. 'GO') GO TO 51
C
      IF (OPTION .EQ. 'SN') CALL AGETIN(PAR9,ERROR)
      IF (OPTION .EQ. 'FN') THEN
         CALL AGETST(PAR1,40)
         CALL CHKOTY(68,PAR1,0,31,10,LINE+2,ICKERR)      ! 11/2002
         IF ( ICKERR .NE. 0 ) THEN
            GO TO 11
          ELSE
            READ (68,9000,REC=1) HEMA,I1,I2,PAR11  ! 11/2002
            IF (PAR11 .NE. 0) THEN
               CALL TXTCLR(ICOLOR(6))
                CALL GTEXTS(10,LINE+4,'***** WARNING: '//
     1             'FILE ALREADY HAS INFORMATION TO MODIFY ZONES.')
               CALL SCHOLD
            END IF
         END IF
      END IF
      IF (OPTION .EQ. 'SA') THEN
         CALL AGETST(ANS,1)
         IF (ANS .EQ. 'S') PAR2 = 1
         IF (ANS .EQ. 'P') PAR2 = 2
         IF (ANS .EQ. 'M') PAR2 = 3
         IF (PAR2 .EQ. 1) PAR11 = 0
      END IF
      IF (OPTION .EQ. 'DZ') CALL AGETRL(PAR3,ERROR)
      IF (OPTION .EQ. 'CL') CALL AGETTX(PAR4)
      IF (OPTION .EQ. 'RM') CALL AGETTX(PAR5)
      IF (OPTION .EQ. 'ZO') CALL AGETIN(PAR6,ERROR)
      IF (OPTION .EQ. 'DO') CALL AGETRL(PAR7,ERROR)
      IF (OPTION .EQ. 'PO') CALL AGETIN(PAR8,ERROR)
      GO TO 15
C
C          PARAMETER CHECKING.
C
   51 CALL TXTCLR(ICOLOR(6))
      IF (PAR9 .LE. 0)  THEN
         CALL GTEXTS(15,LINE+2,
     1   '***** SEQUENTIAL WELL NUMBER TO START COLORING LESS THAN ONE.')
         FLAG = .TRUE.
         GO TO 800
      END IF
      IF (PAR2 .EQ. 2  .AND.  PAR11 .GT. 0)  THEN
         CALL GTEXTS(10,LINE+2,
     1         '***** IT IS NOT ALLOWED TO ADD PRIMARY INFORMATION ')
         CALL GTEXTS(16,LINE+3,
     1         'TO A FILE WITH MODIFICATIONS.')
         FLAG = .TRUE.
         GO TO 800
      END IF
      IF ( PAR2 .EQ. 1 ) THEN
         CALL CHKOLF(68,PAR1,31,10,LINE+2,ICKERR,*11)
       ELSE
         CALL OPEND(68,PAR1,0,31)
         READ (68,9000,REC=1) HEMA,I1,I2,PAR11
         IF ( PAR2 .EQ. 2 ) THEN
      IF (.NOT.(PAR4 .EQ. 'SS'    .OR.  PAR4 .EQ. 'Ss'  .OR.  
     1    PAR4 .EQ. LITOPTION(8)  .OR.  PAR4 .EQ. 'SH'  .OR.  
     2    PAR4 .EQ. 'Sh'  .OR.  PAR4 .EQ. LITOPTION(9)  .OR.
     3    PAR4 .EQ. 'CL'  .OR.  PAR4 .EQ. 'Cl'  .OR.  
     4    PAR4 .EQ. LITOPTION(3)  .OR.  PAR4 .EQ. 'BL'  .OR.  
     5    PAR4 .EQ. 'Bl'  .OR.  PAR4 .EQ. 'bl'  .OR.
     6    PAR4 .EQ. '  '  .OR.  PAR4 .EQ. 'LM'  .OR.  
     7    PAR4 .EQ. 'Ls'  .OR.  PAR4 .EQ. LITOPTION(6)  .OR.
     8    PAR4 .EQ. 'DL'  .OR.  PAR4 .EQ. 'Dl'  .OR.  
     9    PAR4 .EQ. LITOPTION(4)  .OR.  PAR4 .EQ. 'ST'  .OR.
     &    PAR4 .EQ. 'St'  .OR.  PAR4 .EQ. LITOPTION(7)  .OR.
     1    PAR4 .EQ. 'CK'  .OR.  PAR4 .EQ. 'Ck'  .OR.
     2    PAR4 .EQ. LITOPTION(2)  .OR.  PAR4 .EQ. 'AH'  .OR.
     3    PAR4 .EQ. 'Ah'  .OR.  PAR4 .EQ. LITOPTION(1)  .OR.
     2    PAR4 .EQ. 'GN'  .OR.  PAR4 .EQ. 'Gn'  .OR.
     3    PAR4 .EQ. LITOPTION(5))) THEN
         CALL GTEXTS(3,LINE+2,
     1       "*** '"//PAR4//"' IS AN ILEGAL LITHOLOGY CODE. "//
     2       "VALID CODES ARE:")
         CALL GTEXTS(7,LINE+3, "ANHYDRATE: "//LITOPTION(1)//
     1       "  BLANK: bl       CHALK: "//LITOPTION(2)//
     2  "   COAL: "//LITOPTION(3)//"      DOLOMITE: "//LITOPTION(4))
         CALL GTEXTS(7,LINE+4, "GRANITE: "//LITOPTION(5)//
     1  "    LIMESTONE: "//LITOPTION(6)//"   SALT: "//LITOPTION(7)//
     2  "    SANDSTONE: "//LITOPTION(8))
            FLAG = .TRUE.
            LINE = LINE + 3  
      END IF
          ELSE
            IF ( PAR2 .EQ. 3  .AND. I2 .LE. 0 ) THEN
               CALL GTEXTS(15,LINE+2,
     1   '***** NO ZONES TO MODIFY')
            FLAG = .TRUE.
            GO TO 800
         END IF
            IF ( PAR2 .EQ. 3  .AND. PAR8 .LE. 0 ) THEN
               CALL GTEXTS(15,LINE+2,
     1   '***** SEQUENTIAL PAIR NUMBER TO MODIFY LESS THAN ONE.')
            FLAG = .TRUE.
            LINE = LINE + 1
         END IF
          IF ( PAR2 .EQ. 3   .AND.  PAR8 .GT. 20 ) THEN
            CALL GTEXTS(15,LINE+2,
     1   '***** SEQUENTIAL PAIR NUMBER TO MODIFY LARGER THAN 20.')
            FLAG = .TRUE.
            LINE = LINE + 1
         END IF
          IF ( PAR2 .EQ. 3   .AND.  PAR6 .GT. I2 ) THEN
            CALL GTEXTS(15,LINE+2,
     1   '***** ZONE TO OVERRIDE LARGER THAN'//
     1          ' NUMBER ZONES.')
            FLAG = .TRUE.
          END IF
          IF ( PAR2 .EQ. 3   .AND.  PAR6 .LE. 0 ) THEN
            CALL GTEXTS(15,LINE+2,
     1   '***** ZONE TO OVERRIDE LESS THAN ZERO.')
            FLAG = .TRUE.
          END IF
         END IF
      END IF
  800 IF ( FLAG ) THEN
         CALL SCHOLD
         GO TO 11
      END IF
C
      J1STIM = 1
      RETURN
 9000 FORMAT (A4,11X,3I5)
      END
      SUBROUTINE RPCOFIL
C
C                 DISPLAY CONTENT OF 'LIT2' FILE.
C
C***********************************************************************
C
      CHARACTER*2 LITHOL
      CHARACTER*4 BOMU
      CHARACTER*4 HEMA
      CHARACTER*10 REMARK
      INTEGER*4 SNSW
C
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /COFILCH/ PAR1,PAR4,PAR5
         CHARACTER*40 PAR1
         CHARACTER*2  PAR4
         CHARACTER*10 PAR5
C
      CALL ANMODE
      READ (68,9000,REC=1) HEMA,SNSW,NMARK,NSTT
      WRITE (QTEKOT,9001) PAR1,SNSW,NMARK
      IF ( NMARK .EQ. 0 ) GO TO 999
      WRITE(QTEKOT,9002) BOMU(BOM)
      DO 100 I = 1,NMARK
      K = I
      READ(68,9003,REC=K+1) DEPTH, LITHOL,REMARK
      WRITE(QTEKOT,9004) K,DEPTH,LITHOL,REMARK
  100 CONTINUE
      IF (NSTT .EQ. 0) GO TO 999
      WRITE(QTEKOT,9005) NSTT, BOMU(BOM)
      DO 200 I = 1, NSTT
      K = 2 + I + NMARK
      READ(68,9007,REC=K) DEPTHM, MPAIR,MMARK
      WRITE(QTEKOT,9006) I,DEPTHM, MPAIR,MMARK
  200 CONTINUE
  999 CALL RETKEY
      RETURN
 9000 FORMAT (A4,11X,3I5)
 9001 FORMAT (///,34X,'CLEAN LITHOLOGY FILE',/,
     1            34X,'********************',///,
     2        1X,'LITHOLOGY FILE NAME',19X,A40/
     3        1X,'SEQUENTIAL NUMBER FOR STARTING WELL',I4/
     4        1X,'NUMBER OF ZONES IN THE FILE', 7X,I5//)
 9002 FORMAT(//30X,'DEPTH', 3X,'LITHOLOGY',4X,'REMARKS'/
     1       31X,A4/
     2       26X,35('-'),/)
 9003 FORMAT (F10.2,3X,A2,5X,A10)
 9004 FORMAT (20X,I4,2X,F10.2,6X,A2,6X,A10)
 9005 FORMAT (//'ZONES TO BE OVERRIDDEN',12X,I5//
     1          30X,'DEPTH', 4X,'PAIR',4X,'ZONE'/
     2          31X,A4/
     3          26X,29('-'),/)
 9006 FORMAT (20X,I4,2X,F10.2,1X,I5,3X,I5)
 9007 FORMAT (F10.2,2(5X,I5))
      END
      SUBROUTINE CREATETOOLS(NFYLES)
C
C                 CREATES MISSING 'FAMILY.NAM' FILE.
C
C***********************************************************************
C
C
      include 'tools.inc'
C
      CHARACTER*40 NFYLES
      CHARACTER*6 LABEL /'FAMILY'/
C
      OPEN(31,FILE=NFYLES,FORM='FORMATTED',STATUS='UNKNOWN')
      WRITE(31,9000) LABEL
      DO 100 I = 1, TOTALLN
      WRITE(31,9001) TTOOLS(I)
  100 CONTINUE
C
      CLOSE (31)
      RETURN
 9000 FORMAT(A6)
 9001 FORMAT(A21)
      END
C***********************************************************************
C
C          CORRECTS SPONTANEOUS POTENTIAL BASE LINE.
C
C***********************************************************************
C
      SUBROUTINE SSPBL(REGN,ID,RLOG,IL,DIGS,K,ISAV)
C
      INCLUDE 'log.inc'
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      INTEGER*4 REGN,REGN1
      REAL*4 RLOG(LOG_LENGTH)
      REAL*8 A(LOG_LENGTH,2)
      REAL*8 B(20,20)
      REAL*8 C(20)
      REAL*8 XP(20)
      REAL*8 XXP,YYP,SY,SSR,SST,R
C
      COMMON /DRIFTSP/ SPPR,SPPM
             INTEGER*4 SPPR,SPPM
      COMMON /CODINC/ DINC
      COMMON /FLAGWS/ FLAGWS
      LOGICAL FLAGWS
C
      include 'welldb.inc'
      include 'wldwel.inc'
C
C          DATA.
      IF (K .EQ. 3  .OR.  K .EQ. 4) THEN
         IF ( K .EQ. 3) WRITE (QTEKOT,9002)
         IF ( K .EQ. 4) WRITE (QTEKOT,9003)
      ELSE
         IF ( K .EQ. 1 ) REGN = SPPR
         IF ( K .EQ. 2 ) REGN = SPPM
      END IF
      REGN1 = REGN + 1
C          FIND MAXIMA
      NEN = 0
      DO 100 I = 1,IL
         II = I
         M1 = II - 20
         IF ( M1 .LT. 1 ) M1 = 1
         M2 = II + 20
         IF ( M2 .GT. IL ) M2 = IL
         DO 50 J = M1,M2
            IF ( RLOG(II) .LT. RLOG(J) ) GO TO 100
   50       CONTINUE
C          COEFFICIENT MATRIX.
         NEN = NEN + 1
         A(NEN,1) = SEQDEP(II,DIGS,DINC)
         A(NEN,2) = RLOG(I)
  100 CONTINUE
      IF ( NEN .GT. REGN1 ) GO TO 200
      WRITE (QTEKOT,9005)
      CALL SCHOLD
      GO TO 900
  200 CALL SUMREG(A,B,C,XP,NEN,REGN1)
C          SOLVE THE SYSTEM OF EQUATIONS.
      CALL SLED(B,C,REGN1,20,1.0D-35,IERR)
      IF (IERR .GT. 0) GO TO 91
C          AVERAGE
      SY = 0.0D0
      DO 222 I = 1,NEN
         SY = SY + A(I,2)
  222 CONTINUE
      SY = SY/NEN
C          STATISTICAL ANALYSIS.
      SST = 0.0D0
      SSR= 0.0D0
      DO 243 I=1,NEN
      XXP = 1.0D0
      YYP = 0.0D0
         DO 244 J = 1,REGN1
            YYP = YYP + XXP*C(J)
            XXP = XXP*A(I,1)
  244     CONTINUE
      SST = SST + (A(I,2) - SY)*(A(I,2) - SY)
      SSR = SSR + (YYP - SY)*(YYP - SY)
  243 CONTINUE
      R=DSQRT(SSR/SST)
      WRITE (QTEKOT,9004)
      CALL PRINTD(C,1,REGN1,1,20)
      WRITE (QTEKOT,9001) NEN,SSR,SST,R
C          REMOVE TREND.
      DO 220 I=1,IL
      XXP = 1.0D0
      YYP = 0.0D0
      II = I
      DEPTH = SEQDEP(II,DIGS,DINC)
         DO 226 J = 1,REGN1
            YYP = YYP + XXP*C(J)
            XXP = XXP*DEPTH
  226     CONTINUE
      RLOG(I)=100.0 + RLOG(I) - YYP
  220 CONTINUE
  900 IF ( (K .EQ. 3  .OR.  K .EQ. 4) ) THEN
         IF ( ISAV .EQ. 1 ) THEN
            CALL GETWEL(IWLPTR(ID),IWELLR)
            ISL=ISHLLG(ID)
            ISRFNS(ISL)=REGN
            CALL UPDWEL(IWLPTR(ID),IWELLR)
            ISAV = 2
            WRITE (QTEKOT,9006)
          ELSE
            FLAGWS = .FALSE.
         END IF
      END IF
   91 RETURN
 9001 FORMAT(///10X,'NUMBER OF SAMPLES                     : ',I9/
     3        10X,'SUMS OF SQUARES DUE TO REGRESSION     : ',G15.5/
     4        10X,'TOTAL SUMS OF SQUARES                 : ',G15.5/
     5        10X,'CORRELATION COEFFICIENT               : ',G15.5//)
9002  FORMAT(/10X,'INFORMATION ABOUT THE REFERENCE LOG'/)
9003  FORMAT(/10X,'INFORMATION ABOUT THE MATCHING LOG'/)
9004  FORMAT(/10X,'COEFFICIENTS OF THE REGRESSION EQUATION')
9005  FORMAT(//5X,'***** NOT ENOUGH POINT ALONG THE BASE LINE.',
     1         5X,'      NO CORRECTION PERFORMED.'//)
9006  FORMAT(/15X,'CORRECTION PERMANENTLY MADE IN DATABASE.'/)
      END

