C     CORRELATOR MODULE PRNT
C
C***********************************************************************
C
C              INITIALIZE A PRINTER FILE
C
C***********************************************************************
C
C
      SUBROUTINE PRNTIN(J1STIM)
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 OPTION
C
      COMMON /PRINTU/ IPRNTU
      COMMON /PRINTC/ FYLEPR
             CHARACTER*40 FYLEPR
      COMMON /COLOPT/ ICOLOR(6)
C
      IF (J1STIM .EQ. 0) FYLEPR = '*????*'
C
C        MENU.
C
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'INITIALIZE A PRINTER FILE')
      LINE=2
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3, LINE+2,'FN - NAME OF THE PRINTER OUTPUT FILE')
      CALL GTXTRJ(75, LINE+2,FYLEPR)
C
      LINE=LINE+2
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO FILE MANAGEMENT MENU')
      IF (FYLEPR .NE. '*????*') THEN
         CALL GTEXTS( 3,LINE+3,'GO - OPEN PRINTER FILE')
         LINE = LINE + 1
        ENDIF
      LINE = LINE + 2
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF (OPTION .EQ. 'GO') GO TO 51
C
      IF (OPTION .EQ. 'FN') THEN
         CALL AGETST(FYLEPR,40)
         IF ( FYLEPR .EQ. ' ' ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(10,LINE+6,'***** FILE NAME UNDEFINED.')
            CALL SCHOLD
          END IF
       END IF
      GO TO 15
C
C          OPEN PRINTER FILE
C
   51 IF (IPRNTU .GT. 0) CLOSE(71,STATUS='KEEP')
      CALL OPENP(71,FYLEPR)
      IPRNTU=71
      J1STIM = 1
      CALL RPPTIN
      RETURN
      END
C***********************************************************************
C
C                   REPORT ON OPTION 'PR'.
C
C***********************************************************************
C
      SUBROUTINE RPPTIN
C
      COMMON /PRINTC/ FYLEPR
             CHARACTER*40 FYLEPR
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CALL ANMODE
      WRITE (QTEKOT,2000) FYLEPR
 2000 FORMAT (///,25X,'INITIALIZATION OF PRINTING FILE',/,
     1            25X,'*******************************',///,
     2             8X,'FILE NAME                     ',A40,//)
      CALL RETKEY
      RETURN
      END
C**********************************************************************
C
C                     PRINT PERSISTENT CORRELATIONS
C                     *****************************
C
C**********************************************************************
C
      SUBROUTINE PRNPXX(J1STIM)
C
      COMMON /IPERC/ IPER
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      MENU = 'PERS'
C
C
C          READ IN PARAMETERS.
C
      CALL OPPRNP(J1STIM , *900)
C
C          SEARCH FOR PERSISTENT CORRELATIONS.
C
      CALL PERSIS
C
C          PRINT REPORT
C
      CALL RPPRNP
C
C          PRINT CORRELATION FILE
C
      IF ( IPER .GT. 0 ) THEN
         CALL PRITRA
        END IF
  900 RETURN
      END
C***********************************************************************
C
C                    PARAMETERS FOR OPTION 'TP'.
C
C***********************************************************************
C
      SUBROUTINE OPPRNP(J1STIM, *)
C
      LOGICAL XSFLAG
C
      CHARACTER*4 BOMU
      CHARACTER*2 OPTION
      LOGICAL ERROR
      CHARACTER*4 LABEL
C
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /COFIPR/ COFIPR
             CHARACTER*40 COFIPR
C
      COMMON /TRACNG/ TSTART,TEND
      COMMON /USCAL/  BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /DSLDEE/ DSHAL(21),DDEEP(21)
      COMMON /MAXNZ/  MAXNZ
C
      include 'wldwel.inc'
      include 'corrdb.inc'
C
      IF ( J1STIM .EQ. 0 ) THEN
         COFIPR = '*????*'
        END IF
      XSFLAG = (GWXMIN .NE. GWXMAX) .OR. (GWYMIN .NE. GWYMAX)
      NPAIRS=0
C
C        MENU.
C
   11 CALL MNMODE
      IFLAG = 0
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'PRINTING OF PERSISTENT CORRELATIONS')
      LINE=2
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,LINE+2,
     1     'SF - SOURCE FILE WITH WELL CORRELATION INTERPRETATIONS')
      CALL GTXTRJ(79,LINE+2,COFIPR)
      IF (XSFLAG) THEN
         LINE = LINE + 1
         CALL GTEXTS( 3,LINE+2,
     1        'XS - SELECT INTERPRETATION(S) FROM WINDOW POSTING')
         CALL MARROW(79,LINE+2)
        ENDIF 
      IF ( NPAIRS .GT. 0 ) THEN
         CALL GTEXTS( 3,LINE+3,
     1        'ND - STARTING DEPTH ON THE FIRST WELL, ' // BOMU(BOM))
         CALL GTXTRL(79,LINE+3,TSTART,2)
         CALL GTEXTS( 3,LINE+4,
     1        'XD - ENDING DEPTH ON THE FIRST WELL, ' // BOMU(BOM))
         CALL GTXTRL(79,LINE+4,TEND,2)
         LINE=LINE+2
      END IF
C
      CALL GTEXTS( 3,LINE+4,'RE - RETURN TO PREVIOUS MENU')
      IF (NPAIRS .GT. 0) THEN
         CALL GTEXTS( 3,LINE+5,'GO - PRINT')
         LINE = LINE + 1
        ENDIF
      LINE = LINE + 6
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
      IF (OPTION .EQ. 'RE') RETURN 1
      IF ((NPAIRS .GT. 0)  .AND.  (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'SF') THEN
         CALL AGETST(COFIPR,40)
         IF (COFIPR .EQ. ' ') THEN
            COFIPR = '*????*'
            GO TO 11
           ENDIF
         CALL CHKOTY(24,COFIPR,0,12,5,LINE+2,ICKERR)
         IF ( ICKERR .NE. 0 ) GO TO 11
         READ (24,9411,REC=1) LABEL,NUSF
 9411    FORMAT (A4,I5)
         DO 101 I=1,NUSF
         IF (I .LT. NUSF) THEN
            READ (24,FMT='(2I5)',REC=I+1) WSNUMB(I),CPNUMB(I)
           ELSE
            READ (24,FMT='(I5)',REC=I+1) WSNUMB(I)
           ENDIF
  101    CONTINUE
         CLOSE(24,STATUS='KEEP')
         NPAIRS=NUSF-1
         IF (NPAIRS .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS( 6,LINE+3,
     1                  '**** LESS THAN TWO WELLS IN SOURCE FILE')
            CALL SCHOLD
            GO TO 11
           ENDIF
         CALL DEFILE(LINE,*11)
         IF (MAXNZ .EQ. 0) RETURN 1
         TSTART= DSHAL(1)
         TEND  = DDEEP(1)
        ENDIF
C
      IF (OPTION .EQ. 'XS' .AND. XSFLAG) THEN
         CALL XSMENU
         IF (NPAIRS .LT. 1) GO TO 11
         CALL DEFILE(LINE,*11)
         IF (MAXNZ .EQ. 0) RETURN 1
         TSTART= DSHAL(1)
         TEND  = DDEEP(1)
         GO TO 11
        ENDIF
C
      IF (OPTION .EQ. 'ND') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) TSTART = TEMP
        ENDIF
      IF (OPTION .EQ. 'XD') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) TEND = TEMP
        ENDIF
      GO TO 15
   51 IF ( TSTART .GE. TEND ) THEN
         CALL GTEXTS(15,LINE+2,
     1   '***** ENDING PLOTTING DEPTH NOT DEEPER THAN STARTING DEPTH.')
         LINE = LINE + 1
         IFLAG = 1
      END IF
      IF ( IFLAG .EQ. 1 ) THEN
         CALL SCHOLD
         GO TO 11
      END IF
      J1STIM = 1
  900 RETURN
      END
C***********************************************************************
C
C                   REPORT ON OPTION 'TP'.
C
C***********************************************************************
C
      SUBROUTINE RPPRNP
C
      COMMON /PRINTC/ FYLEPR
             CHARACTER*40 FYLEPR
      COMMON /COFIPR/ COFIPR
             CHARACTER*40 COFIPR
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CALL ANMODE
      WRITE(QTEKOT,2000) COFIPR,FYLEPR
 2000 FORMAT(///25X,'LISTING OF PERSISTENT CORRELATIONS'/
     1          25X,'**********************************'///
     2           8X,'SOURCE FILE                   ',A40/
     3           8X,'PRINTING FILE                 ',A40//)
      CALL RETKEY
      RETURN
      END
C**********************************************************************
C
C                     PRINT TRACED CORRELATIONS
C                     *************************
C
C**********************************************************************
C
      SUBROUTINE PRNTXX(J1STIM)
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
C
      MENU = 'TRAC'
C
C          READ IN PARAMETERS.
C
   11 CALL OPPRNT(J1STIM,LINE,*8999)
C
C          READ IN ELEVATIONS FOR TRACING.
C
      CALL REETRA(LINE,*11)
C
C          SEARCH FOR PERSISTENT CORRELATIONS.
C
      CALL TRACIN
C
C          PRINT REPORT
C
      CALL RPPRNT
C
C          PRINT CORRELATION FILE
C
      CALL PRITRA
C
 8999 RETURN
      END
C***********************************************************************
C
C                    PARAMETERS FOR OPTION 'TM'.
C
C***********************************************************************
C
      SUBROUTINE OPPRNT(J1STIM,LINE,*)
C
      CHARACTER*2 OPTION
      CHARACTER*4 LABEL
      LOGICAL XSFLAG
C
C            NAME OF FILE WITH ELEVATIONS TO TRACE ACROSS.
      COMMON /FYLTRA/ FILTRA
             CHARACTER*40 FILTRA
C
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /COFIPR/ COFIPR
             CHARACTER*40 COFIPR
      COMMON /MAXNZ/  MAXNZ
C
      include 'wldwel.inc'
      include 'corrdb.inc'
C
      IF ( J1STIM .EQ. 0 ) THEN
         COFIPR = '*????*'
         FILTRA = '*????*'
         NPAIRS = 0
        END IF
      NPAIRS = 0
      XSFLAG = (GWXMIN .NE. GWXMAX) .OR. (GWYMIN .NE. GWYMAX)
C
C        MENU.
C
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'PRINTING OF SELECTED MARKERS TRACED ACROSS')
      LINE=2
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,LINE+2,
     1     'SF - SOURCE FILE WITH WELL CORRELATION INTERPRETATIONS')
      CALL GTXTRJ(79,LINE+2,COFIPR)
      IF (XSFLAG) THEN
         LINE = LINE + 1
         CALL GTEXTS( 3,LINE+2,
     1        'XS - SELECT WELLS IN CROSS-SECTION FROM GRAPHICAL MENU')
         CALL MARROW(79,LINE+2)
        ENDIF
      CALL GTEXTS( 3,LINE+3,
     1  'MF - NAME OF MARKER FILE WITH THE ELEVATIONS TO TRACE ACROSS')
      CALL GTXTRJ(79,LINE+3,FILTRA)
C
      LINE=LINE+3
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
      IF (NPAIRS .GT. 0  .AND.  FILTRA .NE. '*????*') THEN
         CALL GTEXTS( 3,LINE+3,'GO - PRINT MARKERS')
         LINE = LINE + 1
        ENDIF
      LINE = LINE + 4
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
      IF (OPTION .EQ. 'RE') RETURN 1
      IF ((NPAIRS .GT. 0)  .AND.  (FILTRA .NE. '*????*')
     1                     .AND.  (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'SF') THEN
         CALL AGETST(COFIPR,40)
         IF (COFIPR .EQ. ' ') THEN
            COFIPR = '*????*'
            GO TO 11
           ENDIF
         CALL CHKOTY(24,COFIPR,0,12,5,LINE+2,ICKERR)
         IF ( ICKERR .NE. 0 ) GO TO 11
         READ (24,9411,REC=1) LABEL,NUSF
 9411    FORMAT (A4,I5)
         DO 101 I=1,NUSF
         IF (I .LT. NUSF) THEN
            READ (24,FMT='(2I5)',REC=I+1) WSNUMB(I),CPNUMB(I)
           ELSE
            READ (24,FMT='(I5)',REC=I+1) WSNUMB(I)
           ENDIF
  101    CONTINUE
         CLOSE(24,STATUS='KEEP')
         NPAIRS=NUSF-1
         IF (NPAIRS .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS( 6,LINE+3,
     1                  '**** LESS THAN TWO WELLS IN SOURCE FILE')
            CALL SCHOLD
            GO TO 11
           ENDIF
         CALL DEFILE(LINE,*11)
         IF (MAXNZ .EQ. 0) RETURN 1
      ENDIF
C
      IF (OPTION .EQ. 'XS' .AND. XSFLAG) THEN
         CALL XSMENU
         IF (NPAIRS .LT. 1) GO TO 11
         CALL DEFILE(LINE,*11)
         IF (MAXNZ .EQ. 0) RETURN 1
         GO TO 11
        ENDIF
C
      IF (OPTION .EQ. 'MF') THEN
         CALL AGETST(FILTRA,40)
         IF (FILTRA .EQ. ' ') FILTRA= '*????*'
        ENDIF
      GO TO 15
   51 J1STIM = 1
      RETURN
      END
C***********************************************************************
C
C                   REPORT ON OPTION 'TM'.
C
C***********************************************************************
C
      SUBROUTINE RPPRNT
C
      COMMON /PRINTC/ FYLEPR
             CHARACTER*40 FYLEPR
      COMMON /COFIPR/ COFIPR
             CHARACTER*40 COFIPR
      COMMON /FYLTRA/ FILTRA
             CHARACTER*40 FILTRA
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CALL ANMODE
      WRITE (QTEKOT,2000) COFIPR,FILTRA,FYLEPR
 2000 FORMAT (///,25X,'LISTING OF MARKERS TRACED ACROSS',/
     1            25X,'********************************',///,
     2             8X,'SOURCE FILE                   ',A40,/,
     3             8X,'MARKER FILE                   ',A40,/,
     4             8X,'PRINTING FILE                 ',A40,//)
      CALL RETKEY
      RETURN
      END
C***********************************************************************
C
C                  SCHEDULES THE SEARCH OF PERSISTENT CORRELATIONS.
C
C***********************************************************************
C
      SUBROUTINE PERSIS
C
      INCLUDE 'log.inc'
C
      COMMON /NCO/    NCORRL
             INTEGER*4 NCORRL(20)
      COMMON /CORRMA/ COMAT
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /NINSZ/ NINSEL
      COMMON /IPERC/ IPER
      COMMON /START/ STARTP
             INTEGER*4 STARTP(20)
      COMMON /TRACNG/ TSTART,TEND
      COMMON /CLENGT/ COLENG(LOG_LENGTH,20)
C
      DO 200 I = 1,NPAIRS
      STARTP(I) = 1
  200 CONTINUE
      IPER = 0
      NINSEL = 0
C
C          FOCUS SEARCH WITHIN GIVEN BOUNDARIES.
C
      DO 500 I = 1,NCORRL(1)
      II = I
      IF ( COMAT(I,1) .LT. TSTART ) GO TO 500
      IF ( (COMAT(I,1)-0.5*COLENG(II,1)) .GT. TEND ) GO TO 800
C          CHECK PERSISTENCE FOR EVERY CORRELATED INTERVAL
C          IN THE LEFT MOST REFERENCE WELL.
C
       CALL OVERLP(II)
  500 CONTINUE
  800 RETURN
      END
C***********************************************************************
C
C                  LATERAL CORRELATION TRACING
C
C***********************************************************************
C
      SUBROUTINE OVERLP(I)
C
      INCLUDE 'log.inc'
C
C          SCRATCH POINTER TO CURRENT CORRELATION BEING TRACED.
      INTEGER*4 CSTARP(20)
C          FLAG TO DENOTE THE PERSISTENCE OF A CORRELATION ACROSS.
      INTEGER*4 FPERS
C          INSPECTED ELEVATIONS, FEET.
C          ELEVATION OF A PERSISTANT CORRELATION AT EACH WELL.
      REAL*4 MATCH(21)
C          COUNTER TO KEEP TRACK OF WHAT ELEVATIONS HAVE
C          BEEN ALREADY TESTED WITHIN A PARTICULAR CORRELATION LENGTH.
      REAL*4 SCOLEN
C          TEMPORARY STORAGE FOR WEIGHTED CORRELATION COEFFICIENTS.
      REAL*4 TWCCOE(20)
C
      COMMON /CODINC/ DINC
C
      COMMON /NCO/    NCORRL(20)
      COMMON /CORRMA/ COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG(LOG_LENGTH,20)
      COMMON /SLENTH/ SEALEN(LOG_LENGTH,20)
      COMMON /PERCOR/ PERCO (LOG_LENGTH,21)
      COMMON /IPERC/ IPER
      COMMON /INSZ/ INSELE
             REAL*4 INSELE(1)
      COMMON /NINSZ/ NINSEL
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /START/ STARTP
             INTEGER*4 STARTP(20)
      COMMON /WCCOEF/ WCCOE
             REAL*4 WCCOE(LOG_LENGTH,20)
      COMMON /WCCOEP/ WCCOEP
             REAL*4 WCCOEP(LOG_LENGTH,20)
      COMMON /TRACNG/ TSTART,TEND
C
C          FIND START OF EVENTUAL PERSISTENT CORRELATION.
C
      SCOLEN = 0.0
      MATCH(1) = COMAT(I,1) - 0.5*COLENG(I,1)
      IF ( MATCH(1) .LT. TSTART ) MATCH(1) = TSTART
      STARTP(1) = I
  120 LOLD = I
C
C          AVOID SEARCH ABOVE THE LAST PERSISTENT CORRELATION.
C
      IF ( NINSEL .GT. 0 ) THEN
         IF ( MATCH(1) .LE. INSELE(NINSEL) ) GO TO 450
        END IF
C
C          FIND THE MATCHING ELEVATION FOR THE CURRENT PAIR OF WELLS
C          AS A REFERENCE ELEVATION IN THE NEXT PAIR OF WELLS.
C
      DO 300 K = 1,NPAIRS
      FPERS = 0
      K20 = K + 20
C
C          MAKE THE SEARCH FROM TOP TO BOTTOM
C          STARTING FROM THE LAST PERSISTENT CORRELATION.
C
      DO 200 L = STARTP(K),NCORRL(K)
      DELTA = COMAT(L,K) - MATCH(K)
C
C          DECIDE WHETHER THE POINTER LAYS INSIDE
C          THE CURRENT CORRELATION INTERVAL OR BEYOND.
C
      IF ( ABS(DELTA) .LE. 0.5*COLENG(L,K) ) THEN
         IF ( L .NE. NCORRL(K) ) THEN
            DTNEXT = COMAT(L+1,K) - MATCH(K)
            IF ( ABS(DTNEXT) .LE. 0.5*COLENG(L+1,K) ) THEN
               ZHALFR = (COMAT(L,  K)*COLENG(L+1,K) +
     1                   COMAT(L+1,K)*COLENG(L,K))/
     2                  (COLENG(L,K) + COLENG(L+1,K))
               IF ( MATCH(K) .GE. ZHALFR ) THEN
                  IF ( K .EQ. 1 ) THEN
                     GO TO 900
                  ELSE
                     GO TO 200
                  END IF
               END IF
            END IF
C
C          FIND THE CORRELATION WINDOW FOR THE CENTER OF THE
C          CORRELATION INTERVAL IN THE MATCHING WELL.
C
            IF ( L .GT. 1 ) THEN
               IF ( (COLENG(L,K) + COLENG(L-1,K)) .GT. 0.0 ) THEN
                  ZHALFA = (COMAT(L,  K20)*COLENG(L-1,K) +
     1                      COMAT(L-1,K20)*COLENG(L,K))/
     2                     (COLENG(L,K) + COLENG(L-1,K))
                ELSE
                  ZHALFA = 0.5*(COMAT(L,K20) + COMAT(L-1,K20))
               END IF
            ELSE
               ZHALFA = COMAT(1,K20) - 0.5*COLENG(1,K)
            END IF
            IF ( (COLENG(L,K) + COLENG(L+1,K)) .GT. 0.0 ) THEN
               ZHALFB = (COMAT(L,  K20)*COLENG(L+1,K) +
     1                   COMAT(L+1,K20)*COLENG(L,K))/
     2                  (COLENG(L,K) + COLENG(L+1,K))
             ELSE
               ZHALFB = 0.5*(COMAT(L,K20) + COMAT(L+1,K20))
            END IF
            IF ( (COMAT(L,K20) - DELTA) .LT. ZHALFA ) THEN
               MATCH(K+1) = DINC*ANINT(ZHALFA/DINC)
               GO TO 190
            END IF
            IF ( (COMAT(L,K+20) - DELTA) .GT. ZHALFB ) THEN
               MATCH(K+1) = DINC*ANINT(ZHALFB/DINC)
               GO TO 190
            END IF
         END IF
C
C          SUCCESSFUL SEARCH OF AN ADDITIONAL
C          LINK FOR THE CORRELATION CHAIN.
C
         MATCH(K+1) = COMAT(L,K20) - DELTA
  190    TWCCOE(K) = WCCOE(L,K)
         CSTARP(K) = L
         LOLD = L
         FPERS = 1
         GO TO 300
      ELSE
         IF ( K .GT. 1 ) THEN
C
C          EXCEPT FOR THE LEFT MOST CORRELATIONS, STOP SEARCHING
C          WHEN CORRELATIONS ARE BEYOND THE SEARCH INTERVAL.
C
            IF (DELTA .GT. SEALEN(LOLD,K-1) )
     1          GO TO 400
         END IF
      END IF
  200 CONTINUE
      IF ( FPERS .EQ. 0 ) GO TO 400
  300 CONTINUE
C
C          STORE THE PERSISTENT CORRELATION IN MATRIX.
C
      IF (FPERS .EQ. 1 ) THEN
         IPER = IPER + 1
         DO 350 K = 1,NPAIRS+1
         PERCO(IPER,K) = MATCH(K)
  350    CONTINUE
         DO 380 K = 1,NPAIRS
         STARTP(K) = CSTARP(K)
         WCCOEP(IPER,K) = TWCCOE(K)
  380    CONTINUE
      END IF
C
C          ENTER THE LEFT MOST CORRELATION AS
C          THE LAST ELEVATIONS ALREADY INSPECTED.
C
  400 NINSEL =  1
      INSELE(NINSEL) = MATCH(1)
C
C          TRY THE NEXT LEVEL FOR THE SAME CORRELATION INTERVAL
C
  450 SCOLEN = SCOLEN + DINC
      IF ( SCOLEN .LE. COLENG(I,1) ) THEN
         MATCH(1) = MATCH(1) + DINC
         IF ( MATCH(1) .LE. TEND ) GO TO 120
      END IF
  900 RETURN
      END
C***********************************************************************
C
C                  READS IN ELEVATIONS TO TRACE ACROSS.
C
C***********************************************************************
C
      SUBROUTINE REETRA(LINE, *)
C
      CHARACTER*4 BOMU
      CHARACTER*68 TXTMES
C
      INCLUDE 'log.inc'
      include 'pen.inc'
C
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
C            NAME OF FILE WITH ELEVATIONS TO TRACE ACROSS.
      COMMON /FYLTRA/ FILTRA
             CHARACTER*40 FILTRA
C
      COMMON /RELETA/ ETRA
C            ELEVATIONS TO TRACE ACROSS.
             REAL*4 ETRA(LOG_LENGTH)
      COMMON /MARPEN/ MARPEN
C            PEN NUMBER.
             INTEGER*4 MARPEN(LOG_LENGTH)
      COMMON /MARTXT/ MARTXT
C            REMARKS ABOUT THE MARKER.
             CHARACTER*10 MARTXT(LOG_LENGTH)
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
C            NUMBER OF ELEVATION TO TRACE ACROSS.
             INTEGER*4 NETRA
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            CORRELATION MATRIX COLUMN FOR TRACE STARTING.
             INTEGER*4 CTT
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
      COMMON /POLIN/ POLIN
C            OPTION TO EITHER DRAW LINE OR PAINT
             CHARACTER*1 POLIN(LOG_LENGTH)
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /STEPOUT/ SODEPTH,SOPAIR,SOMARKER
             REAL*4 SODEPTH(LOG_LENGTH)
             INTEGER*4 SOPAIR(LOG_LENGTH)
             INTEGER*4 SOMARKER(LOG_LENGTH)
C
      IFLAG = 0
      CALL CHKOTY(68,FILTRA,0,31,2,LINE+2,IERMAR)
      IF ( IERMAR .NE. 0 ) RETURN 1
      READ (68,9000,REC=1) HEMA,SNSW,NETRA,NSTT
      CALL FINDTR(LINE,SNSW,CTT,*850)
      DO 100 I = 1,NETRA
      K = I
      READ(68,9002,REC=K+1) ETRA(K),MARPEN(K),POLIN(K),MARTXT(K)
  100 CONTINUE
      IF (NSTT .EQ. 0) GO TO 300
      DO 200 I = 1,NSTT
      K = 2 + NETRA + I
      READ(68,9003,REC=K) SODEPTH(I),SOPAIR(I),SOMARKER(I)
  200 CONTINUE
  300 CLOSE(68,STATUS='KEEP')
      IF ( NETRA .LE. 1 ) GO TO 900
      DO 800 I = 1,NETRA
      IF ( MARPEN(I) .LT. 1 ) THEN
         CALL GTEXTS(15,LINE+2,
     1       '***** THE PEN NUMBER MUST BE LARGER THAN ZERO.')
         LINE = LINE + 1
         IFLAG = 1
      END IF
      IF ( MARPEN(I) .GT. NRGB ) THEN
         CALL GTEXTS(15,LINE+2,
     1       '***** THE PEN NUMBER CANNOT BE GREATER THAN   .')
         CALL GTXTIN(60,LINE+2,NRGB)
         LINE = LINE + 1
         IFLAG = 1
      END IF
      IF(I .EQ. 1) GO TO 800
      IF( ETRA(I) .GE. ETRA(I-1) ) GO TO 800
         CALL TXTCLR(ICOLOR(6))
         WRITE (TXTMES,9001) ETRA(I),ETRA(I-1),BOMU(BOM)
         CALL GTEXTS(15,LINE+2,
     1       '***** MARKERS TO TRACE ACROSS NOT IN ASCENDING')
         CALL GTEXTS(21,LINE+3,TXTMES)
         IFLAG = 1
  800 CONTINUE
      IF ( IFLAG .EQ. 1 ) THEN
         CALL SCHOLD
         RETURN 1
      END IF
      GO TO 900
  850 RETURN 1
  900 RETURN
 9000 FORMAT (A4,11X,3I5)
 9001 FORMAT ('ORDER BY DEPTH. ',F8.2,' AFTER ',F8.2,' ',A4,'.')
 9002 FORMAT (F10.2,1X,I4,3X,A1,1X,A10)
 9003 FORMAT (F10.2,2I10)
      END
C***********************************************************************
C
C          TRACE ACROSS EACH ONE OF THE STARTING ELEVATIONS.
C
C***********************************************************************
C
      SUBROUTINE TRACIN

C
      INCLUDE 'log.inc'
C
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
C            STARTING COLUMN FOR TRACING.
             INTEGER*4 CTT
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /START/ STARTP
C            POINTER TO THE LAST PERSISTENT CORRELATION.
             INTEGER*4 STARTP(20)
      COMMON /IPERC/ IPER
      COMMON /MSFLAG/MSFLAG
             LOGICAL MSFLAG(LOG_LENGTH,21)
C
      DO 100 I = 1,NPAIRS
      STARTP(I) = 1
  100 CONTINUE
      IPER = 0
      DO 200 I = 1,NETRA
      DO 150 J = 1,NPAIRS+1
      MSFLAG(I,J) = .FALSE.
  150 CONTINUE
C
C          TRACE TO THE RIGHT.
C
      II = I
      CALL RTRACN(II)
C
C          TRACE TO THE LEFT.
C
      IF (CTT .NE. 1) THEN
         CALL LTRACN(II)
      END IF
  200 CONTINUE
      RETURN
      END
C***********************************************************************
C
C                  CORRELATION TRACING TO THE RIGHT
C                  OF THE STARTING REFERENCE WELL.
C
C***********************************************************************
C
      SUBROUTINE RTRACN(I)
C
      INCLUDE 'log.inc'
C
C          FLAG TO DENOTE THE PERSISTENCE OF A CORRELATION ACROSS.
      INTEGER*2 FPERS
C
      COMMON /RELETA/ ETRA
C            ELEVATIONS TO TRACE.
             REAL*4 ETRA(LOG_LENGTH)
      COMMON /INTRA/  SNSW,NETRA,CTT,NSTT
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            STARTING COLUMN FOR TRACING.
             INTEGER*4 CTT
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
      COMMON /NCO/    NCORRL
C            NUMBER OF CORRELATIONS ON EACH FILE.
             INTEGER*4 NCORRL(20)
      COMMON /CORRMA/ COMAT
C            MATRIX CONTAINING ALL THE CORRELATIONS.  REFERENCE 
C            ELEVATIONS ARE IN THE FIRST 20 COLUMNS, MATCHING
C            CORRELATIONS IN THE SECOND TWENTY COLUMNS.
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /CLENGT/ COLENG
C            MATRIX CONTAINING CORRELATION LENGTH.
             REAL*4 COLENG(LOG_LENGTH,20)
      COMMON /SLENTH/ SEALEN
C            SEARCH LENGHT MATRIX.
             REAL*4 SEALEN(LOG_LENGTH,20)
      COMMON /PERCOR/ PERCO
C            PERSISTENT CORRELATION MATRIX.
             REAL*4 PERCO(LOG_LENGTH,21)
      COMMON /IPERC/ IPER
C            NUMBER OF PERSISTENT CORRELATIONS ACROSS.
             INTEGER*4 IPER
      COMMON /CODINC/ DINC
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /START/  STARTP
C            POINTER TO THE LAST PERSISTENT CORRELATION.
             INTEGER*4 STARTP(20)
      COMMON /WCCOEF/ WCCOE
C            WEIGHTED CORRELATION COEFFICIENTS.
             REAL*4 WCCOE(LOG_LENGTH,20)
      COMMON /WCCOEP/ WCCOEP
C         WEIGHTED CORRELATION COEFFICIENTS FOR PERSISTENT CORRELATIONS
             REAL*4 WCCOEP(LOG_LENGTH,20)
      COMMON /MATCH/  MATCH
C            ELEVATION OF A PERSISTANT CORRELATION AT EACH WELL.
             REAL*4 MATCH(21)
      COMMON /CSTARP/ CSTARP
C            SCRATCH POINTER TO CURRENT CORRELATION BEING TRACED.
             INTEGER*4 CSTARP(20)
      COMMON /TWCCOE/ TWCCOE
C            TEMPORARY STORAGE FOR WEIGHTED CORRELATION COEFFICIENTS.
             REAL*4 TWCCOE(20)
C
C          DEFINE STARTING ELEVATION.
C
      MATCH(CTT) = ETRA(I)
      CSTARP(CTT) = I
      LOLD = I
C
C          FIND THE MATCHING ELEVATION FOR THE CURRENT PAIR OF WELLS
C          AS A REFERENCE ELEVATION IN THE NEXT PAIR OF WELLS.
C
      DO 300 K = CTT,NPAIRS
      CALL NEWTRACR(I,K,*300)
      KK = K
      K20 = K + 20
      FPERS = 0
C
C          MAKE THE SEARCH FROM TOP TO BOTTOM
C          STARTING FROM THE LAST PERSISTENT CORRELATION.
C
      DO 200 L = STARTP(K),NCORRL(K)
      DELTA = COMAT(L,K) - MATCH(K)
      IF ( ABS(DELTA) .LE. 0.5*COLENG(L,K) ) THEN
C
C          SEE WHETHER THE CLOSEST CORRELATION TO THE POINTER
C          LAYS WITHIN THE CURRENT CORRELATION INTERVAL OR BEYOND.
C
         IF ( L .NE. NCORRL(K) ) THEN
            DTNEXT = COMAT(L+1,K) - MATCH(K)
            IF ( ABS(DTNEXT) .LE. 0.5*COLENG(L+1,K) ) THEN
               ZHALFR = (COMAT(L,  K)*COLENG(L+1,K) +
     1                   COMAT(L+1,K)*COLENG(L,  K))/
     2                  (COLENG(L,K) + COLENG(L+1,K))
               IF ( MATCH(K) .GT. ZHALFR ) GO TO 200
            END IF
C
C          FIND THE CORRELATION WINDOW FOR THE
C          CENTER OF THE CORRELATION INTERVAL.
C
            IF ( L .GT. 1) THEN
               ZHALFA = (COMAT(L,  K20)*COLENG(L-1,K) +
     1                   COMAT(L-1,K20)*COLENG(L,K))/
     2                  (COLENG(L,K) + COLENG(L-1,K))
            ELSE
               ZHALFA = COMAT(1,K20) - COLENG(1,K)
            END IF
            ZHALFB = (COMAT(L,  K20)*COLENG(L+1,K) +
     1                COMAT(L+1,K20)*COLENG(L,K))/
     2               (COLENG(L,K) + COLENG(L+1,K))
            IF ( (COMAT(L,K20) - DELTA) .LT. ZHALFA ) THEN
               MATCH(K+1) = DINC*ANINT(ZHALFA/DINC)
               GO TO 190
            END IF
            IF ( (COMAT(L,K20) - DELTA) .GT. ZHALFB ) THEN
               MATCH(K+1) = DINC*ANINT(ZHALFB/DINC)
               GO TO 190
            END IF
         END IF
C
C          THE CORRELATION KEEPS PERSISTING.
C
         MATCH(K+1) = COMAT(L,K20) - DELTA
  190    TWCCOE(K) = WCCOE(L,K)
         CSTARP(K) = L
         LOLD = L
         FPERS = 1
         GO TO 300
      ELSE
C
C          EXCEPT FOR THE LEFT MOST CORRELATIONS, STOP SEARCHING
C          WHEN CORRELATIONS ARE BEYOND THE SEARCH INTERVAL.
C
         IF ( K .GT. CTT ) THEN
            IF (DELTA .GT. SEALEN(LOLD,K-1) ) THEN
                CALL MISSER(I,KK)
                GO TO 300
            END IF
         END IF
      END IF
  200 CONTINUE
      IF ( FPERS .EQ. 0 ) CALL MISSER(I,KK)
  300 CONTINUE
C
C          STORE THE PERSISTENT CORRELATION IN MATRIX.
C
         IPER = IPER + 1
         DO 350 K = CTT,NPAIRS+1
         PERCO(IPER,K) = MATCH(K)
  350    CONTINUE
         DO 380 K = CTT,NPAIRS
         STARTP(K) = CSTARP(K)
         WCCOEP(IPER,K) = TWCCOE(K)
  380    CONTINUE
      RETURN
      END
C***********************************************************************
C
C                    PRINTS MATRIX WITH CORRELATIONS TRACED ACROSS.
C
C***********************************************************************
C
      SUBROUTINE PRITRA
C
      INCLUDE 'log.inc'
C
C          VARIABLE DEFINITION.
C
C          WIDTH OF PRINTING FIELD PER WELL.
      INTEGER*4 COLWID /10/
C          MAXIMUM NUMBER OF COLUMNS PER PAGE
      INTEGER*4 MAXCOL / 8/
C          PRINTING FORMATS
      CHARACTER*100 FORMT2
      CHARACTER*122 FORMT3
      CHARACTER*122 FORMT4
      CHARACTER*122 FORMT5
      CHARACTER*150 FORMT6
C          NUMBER OF COLUMNS TO PRINT IN ONE PAGE.
      INTEGER*4 NC
C          LINE COUNTER
      INTEGER*4 NL
C          PAGE COUNTER
      INTEGER*4 NP
C          RELIABILITY OF THE CORRELATION.
      CHARACTER*1 RECO(LOG_LENGTH,20)
C          LENGTH OF ROWS IN THE PERSISTENT CORRELATION MATRIX.
      INTEGER*4 ROWL
C          RIGHT SHIFT ON TOP OF HEADING FOR OPTIONS 'TM' AND 'LM'.
      INTEGER*4 SFTMLM
C          STARTING COLUMN
      INTEGER*4 STACOL
C
      COMMON /MARTXT/ MARTXT
C            REMARKS ABOUT THE MARKER.
             CHARACTER*10 MARTXT(LOG_LENGTH)
      COMMON /CODINC/ DINC
      COMMON /PRINTU/ IPRNTU
C
      COMMON /IPERC/  IPER
C            NUMBER OF PERSISTENT CORRELATIONS
             INTEGER*4 IPER
      COMMON /PERCOR/ PERCO
C            MATRIX OF PERSISTENT CORRELATIONS.
             REAL*4 PERCO(LOG_LENGTH,21)
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /WIDENT/ IDENT1,IDENT2
C            WELL SEQUENTIAL NUMBER
             INTEGER*4 IDENT1(20)
             INTEGER*4 IDENT2(20)
      COMMON /IDENTW/ IDENT
             INTEGER*4 IDENT(21)
      COMMON /WCCOEP/ WCCOEP(LOG_LENGTH,20)
      COMMON /BOML/   BOML
C            UNIT USED TO MEASURE ELEVATIONS.
             CHARACTER*4 BOML
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /TX/     TX1,TX2,TX3,TX4,TX5,TX6,TX7,TX8,TX9,
     1                TX10,TX11,TX12,TX13,TX14,TX15,TX16
C            TEXT TO FORM FORMATS
             CHARACTER*35 TX1
             CHARACTER*9  TX2
             CHARACTER*2  TX3
             CHARACTER*2  TX4
             CHARACTER*2  TX5
             CHARACTER*4  TX6
             CHARACTER*1  TX7
             CHARACTER*2  TX8
             CHARACTER*2  TX9
             CHARACTER*2  TX10
             CHARACTER*2  TX11
             CHARACTER*2  TX12
             CHARACTER*2  TX13
             CHARACTER*16 TX14
             CHARACTER*2  TX15
             CHARACTER*2  TX16
             CHARACTER*25 TX17
      COMMON /CHARH/ FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
C
C          PARAMETERS SET UP.
C
      IF ( MENU .EQ. 'TRAC'  .OR.  MENU .EQ. 'PRNT'   .OR.
     1      MENU .EQ. 'LIT2') THEN
         DO 50 I = 1,IPER
         DO 50 J = 1,NPAIRS
         IF ( WCCOEP(I,J) .LT. -1.0 ) THEN
             RECO(I,J) = 'I '
          ELSE IF ( WCCOEP(I,J) .LE. 1.0 ) THEN
             RECO(I,J) = ' '
          ELSE  IF ( WCCOEP(I,J) .LE. 2.0 ) THEN
             RECO(I,J) = 'L'
          ELSE
             RECO(I,J) = 'R'
        END IF
   50    CONTINUE
         SFTMLM = 6
       ELSE
         SFTMLM = 0
      END IF
      NL = 1000
      NP = 0
      ROWL = NPAIRS + 1
C
C          WELL SEQUENTIAL NUMBERS.
C
      DO 100 I = 1,NPAIRS
      IDENT(I) = IDENT1(I)
  100 CONTINUE
      IDENT(ROWL) = IDENT2(NPAIRS)
C
C          TITLE PRINTING FORMAT.
C
      NDATUM = 0
      DO 300 I = 15,1,-1
      IF ( DATUM(I:I) .NE. ' ') GO TO 350
      NDATUM = NDATUM + 1
  300 CONTINUE
  350 IF ( IDENT(1) .EQ. IDENT(ROWL) ) THEN
         STACOL = 5
         CLEMAX = -1.0E30
         AVECLE = 0.0
      ELSE
         STACOL = 1
      END IF
      IF ( MENU .EQ. 'TRAC'  .OR.  MENU .EQ. 'PRNT'   .OR.
     1      MENU .EQ. 'LIT2') THEN
C         TX1 = '''1'','//'96X,''PAGE '',I2,//'
         TX1 = '96X,''PAGE '',I2,//'  ! BGR
       ELSE
         TX1 = '80X,''PAGE '',I2,//'  ! BGR
      END IF
      TX2 = '(8X,I2)'
      TX6 = '////'
      TX7 = '/'
      TX8 = '//'
      TX14 = '(1X,A4,''-'',A4)'
      DO 500 I = 1,ROWL,MAXCOL
      II = I
      N1 = MAXCOL - 1
      IF ( (I+N1) .LE. ROWL ) THEN
         IENDP = I + N1
         NC = MAXCOL
      ELSE
         IENDP = ROWL
         NC = IENDP - II + 1
         IF ( IDENT(1) .EQ. IDENT(ROWL) ) THEN
            STACOL = STACOL + 0.5*(MAXCOL - NC - 1)*COLWID
          ELSE
            STACOL = STACOL + 0.5*(MAXCOL - NC)*COLWID
         END IF
      END IF
      IENDPI = IENDP - II
      WRITE(TX13,'(I2)') IENDPI
      IENDP1 = IENDPI + 1
      WRITE(TX5,'(I2)') IENDP1
      WRITE(TX10,'(I2)') IENDP1*COLWID
      WRITE(TX4,'(I2)') 3 + STACOL
      WRITE(TX11,'(I2)') 1 + STACOL
      IFW = COLWID*NC
      NXT = 0.5*( 6 + IFW - 23)
      IF ( NXT .GE. 0) THEN
         IF ( IDENT(1) .EQ. IDENT(ROWL) ) THEN
            WRITE(TX3,'(I2)') 5 + STACOL + NXT + SFTMLM
            WRITE(TX12,'(I2)') 2 + STACOL + NXT + SFTMLM
            ITX15 = 5 + STACOL + NXT
            WRITE(TX16,'(I2)') 7 + STACOL + NXT + SFTMLM
         ELSE
            WRITE(TX3,'(I2)') 1 + STACOL + NXT + SFTMLM
            WRITE(TX12,'(I2)') STACOL + NXT + SFTMLM - 2
            ITX15 = 1 + STACOL + NXT
            WRITE(TX16,'(I2)') 3 + STACOL + NXT + SFTMLM
         END IF
      ELSE
         IF ( IDENT(1) .EQ. IDENT(ROWL) ) THEN
            WRITE(TX3,'(I2)') 1 + STACOL + SFTMLM
            WRITE(TX12,'(I2)') STACOL + SFTMLM - 2
            ITX15 = 1 + STACOL
            WRITE(TX16,'(I2)') 3 + STACOL + SFTMLM
         ELSE
            WRITE(TX3,'(I2)') 5 + STACOL + SFTMLM
            WRITE(TX12,'(I2)') 2 + STACOL + SFTMLM
            ITX15 = 5 + STACOL
            WRITE(TX16,'(I2)') 7 + STACOL + SFTMLM
         END IF
         WRITE(TX4,'(I2)') 3 + STACOL - NXT
         WRITE(TX11,'(I2)') 1 + STACOL - NXT
      END IF
      NXT = 5 + STACOL + 0.5*IFW
      WRITE(TX9,'(I2)') (NXT - 5)
      WRITE(TX15,'(I2)') ITX15 + SFTMLM + (NDATUM/2)
C
C          MATRIX PRINTING FORMATS.
C
      IF ( MENU .EQ. 'TRAC'  .OR.  MENU .EQ. 'PRNT'   .OR.
     1      MENU .EQ. 'LIT2') THEN
         IF ( IENDPI .EQ. 0) THEN
            TX17 = '3X,'
          ELSE
            TX17 = '2X,'//TX13//'(1X,F7.1,1X,A1),1X,'
         END IF
         FORMT2 = '('//TX11//'X,I4,3X,'//TX5//'(1X,F7.1,1X,A1),3X,A10)'
         FORMT4 = '('//TX11//'X,I4,1X'//TX17//'F7.1,3X,1A10)'
         IF ( IDENT(1) .EQ. IDENT(ROWL) )  THEN
           FORMT3 = '('//TX11//'X,I4,1X'//TX17//'F7.1,2X,F7.1,3X,1A10)'
           FORMT5 = '('//TX11//'X,I4,1X'//TX17//'F7.1,12X,1A10)'
         END IF
        ELSE
         FORMT2 = '('//TX11//'X,I4,3X,'//TX5//'(1X,F7.1,2X))'
         IF ( IDENT(1) .EQ. IDENT(ROWL) ) THEN
            IF (IENDPI .EQ. 0) THEN
               FORMT3 = '('//TX11//'X,I4,4X,F7.1,2X,F7.1)'
             ELSE
               FORMT3 = '('//TX11//'X,I4,3X,'//TX13//
     1                  '(1X,F7.1,2X),1X,F7.1,2X,F7.1)'
            END IF
         END IF
      END IF
C
C          PRINT HEADING.
C
      DO 400 L = 1,IPER
C      IF(NL .GE. 40) THEN
      IF(NL .GE. 53) THEN   !BGR Length for an A4 page

         NL = 0
         NP = NP + 1
         CALL PRTRHD(NP,ROWL,II,IENDP)
      END IF
C
C          CORRELATION PRINTING.
C
      IF ( MENU .EQ. 'TRAC'  .OR.  MENU .EQ. 'PRNT'   .OR.
     1      MENU .EQ. 'LIT2') THEN
         IF ( IENDP .LT. ROWL ) THEN
            WRITE (IPRNTU,FORMT2) L,(PERCO(L,J),RECO(L,J),J = I,IENDP),
     1                            MARTXT(L)
         ELSE
            IF ( IDENT(1) .EQ. IDENT(ROWL) ) THEN
               CLERR = PERCO(L,1) - PERCO(L,ROWL)
               IF ( ABS(CLERR) .GT. CLEMAX ) CLEMAX = ABS(CLERR)
               IF ( CLERR .NE. 0.0 ) THEN
                  WRITE (IPRNTU,FORMT3) L,
     1                            (PERCO(L,J),RECO(L,J),J = I,NPAIRS),
     2                            PERCO(L,IENDP),CLERR,MARTXT(L)
                  AVECLE = AVECLE + ABS(CLERR)
               ELSE
                  WRITE (IPRNTU,FORMT5) L,
     1                            (PERCO(L,J),RECO(L,J),J = I,NPAIRS),
     2                            PERCO(L,IENDP),MARTXT(L)
               END IF
            ELSE
               WRITE (IPRNTU,FORMT4) L,
     1                          (PERCO(L,J),RECO(L,J),J = I,NPAIRS),
     2                          PERCO(L,IENDP),MARTXT(L)
            END IF
         END IF
      ELSE
         IF ( L .GT. 1 ) THEN
            IF((PERCO(L,1)-PERCO(L-1,1)) .GT. (1.1*DINC) ) THEN
               WRITE (IPRNTU,'(1X)')
               NL = NL + 1
            END IF
         END IF
         IF ( IENDP .LT. ROWL ) THEN
            WRITE (IPRNTU,FORMT2) L,(PERCO(L,J),J = I,IENDP)
         ELSE
            IF ( IDENT(1) .EQ. IDENT(ROWL) ) THEN
               CLERR = PERCO(L,1) - PERCO(L,ROWL)
               IF ( ABS(CLERR) .GT. CLEMAX ) CLEMAX = ABS(CLERR)
               IF ( CLERR .NE. 0.0 ) THEN
                  WRITE (IPRNTU,FORMT3)L,(PERCO(L,J),J = I,IENDP),CLERR
                  AVECLE = AVECLE + ABS(CLERR)
               ELSE
                  WRITE (IPRNTU,FORMT3)L,(PERCO(L,J),J = I,IENDP)
               END IF
            ELSE
               WRITE (IPRNTU,FORMT2) L,(PERCO(L,J),J = I,IENDP)
            END IF
         END IF
      END IF
      NL = NL + 1
  400 CONTINUE
      NL = 1000
  500 CONTINUE
C
C          PRINT STATISTICS ON CLOSURE ERRORS
C
      IF ( IDENT(1) .EQ. IDENT(ROWL) ) THEN
      FORMT6 = '(///'//TX11//
     1        'X,10X,''MAXIMUM ABSOLUTE CLOSURE ERROR: '',F7.1,3X,A4//'
     2         //TX11//
     3        'X,10X,''AVERAGE ABSOLUTE CLOSURE ERROR: '',F9.3,1X,A4)'
         WRITE (IPRNTU,FORMT6) CLEMAX,BOML,(AVECLE/IPER),BOML
      END IF
      RETURN
      END
C***********************************************************************
C
C                 HEADING IN TRACING LISTING.
C
C***********************************************************************
C
      SUBROUTINE PRTRHD(NP,ROWL,I,IENDP)
C
C
      include 'welldb.inc'                                     ! 8/00
      include 'wldwel.inc'                                     ! 8/00
C
      CHARACTER*8 WELLPIH(21)                                  ! 8/00
C          PRINTING FORMAT
      CHARACTER*495 FORMT1
C          LENGTH OF ROWS IN THE PERSISTENT CORRELATION MATRIX.
      INTEGER*4 ROWL
C
      COMMON /CHARH/ FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
             INTEGER*4 SNSW,CTT,NSTT
      COMMON /WIDENT/ IDENT1,IDENT2
             INTEGER*4 IDENT1(20),IDENT2(20)
      COMMON /IDENTW/ IDENT
             INTEGER*4 IDENT(21)
      COMMON /BOML/   BOML
             CHARACTER*4 BOML
      COMMON /LABELL/ LDSHAR,LDCORR,LDSHAM,LDCORM
             CHARACTER*4 LDCORM(20),LDCORR(20)
             CHARACTER*4 LDSHAM(20),LDSHAR(20)
      COMMON /TX/ TX1,TX2,TX3,TX4,TX5,TX6,TX7,TX8,TX9,
     1            TX10,TX11,TX12,TX13,TX14,TX15,TX16
      CHARACTER*35 TX1
      CHARACTER*9  TX2
      CHARACTER*2  TX3
      CHARACTER*2  TX4
      CHARACTER*2  TX5
      CHARACTER*4  TX6
      CHARACTER*1  TX7
      CHARACTER*2  TX8
      CHARACTER*2  TX9
      CHARACTER*2  TX10
      CHARACTER*2  TX11
      CHARACTER*2  TX12
      CHARACTER*2  TX13
      CHARACTER*16 TX14
      CHARACTER*2  TX15
      CHARACTER*2  TX16
      CHARACTER*153 TX17
      CHARACTER*2  TX18
      CHARACTER*9  TX19                                        ! 8/00
      CHARACTER*8  TX20
C
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /PRINTU/ IPRNTU
C
      TX19 =  '(2X,A8)'
      IF ( MENU .EQ. 'TRAC'  .OR.  MENU .EQ. 'PRNT'   .OR.
     1      MENU .EQ. 'LIT2') THEN
         CALL GETWEL(IWLPTR(IDENT1(CTT)),IWELLR)               ! 8/00
         WRITE(TX20,'(A8)') WELLPI                             ! 8/00
         IF ( WELLPI .EQ. '        ') THEN
            WRITE(TX18,'(I2)') IDENT1(CTT)                     ! 8/00
         TX17 = '('//TX1//TX3//'X,''LITHOSTRATIGRAPHIC MARKERS'''//TX7//
     1              TX3//'X,''**************************'''//TX6//TX12//
     2          'X,3X,''TRACING STARTED FROM WELL '//TX18//''''//TX7
          ELSE
         TX17 = '('//TX1//TX3//'X,''LITHOSTRATIGRAPHIC MARKERS'''//TX7//
     1              TX3//'X,''**************************'''//TX6//TX12//
     2          'X,''TRACING STARTED FROM WELL '//TX20//''''//TX7
         END IF
      ELSE
         TX17 = '('//TX1//TX3//'X,''  PERSISTENT CORRELATIONS'''//TX7//
     1           TX3//'X,''  ***********************'''//TX6
      END IF
      IF ( MENU .EQ. 'TRAC'  .OR.  MENU .EQ. 'PRNT'   .OR.
     1      MENU .EQ. 'LIT2') THEN
         IF ( IDENT(1) .EQ. IDENT(ROWL)
     1  .AND.  ROWL .EQ. IENDP ) THEN
            FORMT1 = TX17//TX15//'X,''THE DATUM IS '',A15'//TX7//
     1          TX16//'X,''ALL RESULTS ARE IN '',A4'//TX6//
     2          TX9//'X,''WELLS AND LOGS'''//TX8//
     4          TX4//'X,'//TX13//TX2//',8X,I2'//TX7//
     6          TX11//'X,6X,'//TX13//TX19//
     7          ',2X,A8,1X,''CLOSURE'''//TX7//
     6          TX11//'X,6X,'//TX5//TX14//
     7          ',2X,''ERROR'',4X,''REMARKS'''//TX8//
     7          TX11//'X,'//'6X,'//TX10//'(''-''),1X,7(''-''),
     8          1X,12(''-'')'//TX8//')'
         ELSE
            FORMT1 = TX17//TX15//'X,''THE DATUM IS '',A15'//TX7//
     1          TX16//'X,''ALL RESULTS ARE IN '',A4'//TX6//
     2          TX9//'X,''WELLS AND LOGS'''//TX8//
     3          TX4//'X,'//TX5//TX2//TX7//
     6          TX11//'X,6X,'//TX5//TX19//TX7//
     4          TX11//'X,6X,'//TX5//TX14//',3X,''REMARKS'''//TX8//
     5          TX11//'X,6X,'//TX10//'(''-''),1X,11(''-'')'//TX8//')'
         END IF
       ELSE
         IF ( IDENT(1) .EQ. IDENT(ROWL)
     1  .AND.  ROWL .EQ. IENDP ) THEN
            FORMT1 = TX17//TX15//'X,''THE DATUM IS '',A15'//TX7//
     1          TX16//'X,''ALL RESULTS ARE IN '',A4'//TX6//
     2          TX9//'X,''WELLS AND LOGS'''//TX8//
     4          TX4//'X,'//TX13//TX2//',8X,I2'//TX7//
     6    TX11//'X,6X,'//TX13//TX19//',2X,A8,1X,''CLOSURE'''//TX7//
     6          TX11//'X,6X,'//TX5//TX14//'2X,''ERROR'''//TX8//
     7          TX11//'X,'//'6X,'//TX10//'(''-''),1X,7(''-'')'//
     8          TX8//')'
         ELSE
            FORMT1 = TX17//TX15//'X,''THE DATUM IS '',A15'//TX7//
     1          TX16//'X,''ALL RESULTS ARE IN '',A4'//TX6//
     2          TX9//'X,''WELLS AND LOGS'''//TX8//
     3          TX4//'X,'//TX5//TX2//TX7//
     6          TX11//'X,6X,'//TX5//TX19//TX7//
     4          TX11//'X,6X,'//TX5//TX14//TX8//
     5          TX11//'X,6X,'//TX10//'(''-'')'//TX8//')'
         END IF
      END IF
C
      DO 100 J = I,IENDP                                       ! 8/00
      CALL GETWEL(IWLPTR(IDENT(J)),IWELLR)                     ! 8/00
      WELLPIH(J) = WELLPI                                      ! 8/00
  100 CONTINUE                                                 ! 8/00
C
      IF ( ROWL .EQ. IENDP ) THEN
         WRITE (IPRNTU,FORMT1) NP,DATUM,BOML,
     1                       (IDENT(J),J = I,IENDP),
     4                       (WELLPIH(J),J = I,IENDP),
     2                       (LDSHAR(J),LDCORR(J),J = I,IENDP-1),
     3                       LDSHAM(NPAIRS),LDCORM(NPAIRS)
       ELSE
         WRITE (IPRNTU,FORMT1) NP,DATUM,BOML,
     1                       (IDENT(J),J = I,IENDP),
     3                       (WELLPIH(J),J = I,IENDP),
     2                       (LDSHAR(J),LDCORR(J),J = I,IENDP)
      END IF
      RETURN
      END
C***********************************************************************
C
C          TRACE ACROSS ELEVATIONS ONE WELL TO EACH SIDE.
C
C          TRACING STARTS FROM THE COMMON WELL AT TWO CONSECUTIVE
C          PAIRS OF WELLS.  TRACING IS DONE FROM TOP TO BOTTTOM
C          CONSIDERING ALL MATCHING ELEVATIONS ON THE FIRST PAIR
C          AND ALL REFERENCE ELEVATIONS IN THE SECOND ONE.
C
C***********************************************************************
C
      SUBROUTINE TRACE2(I)
C
      INCLUDE 'log.inc'
C
      LOGICAL LASTJ, LASTK
      COMMON /CORRMA/ COMAT
C            MATRIX CONTAINING ALL THE CORRELATIONS.  REFERENCE 
C            ELEVATIONS ARE IN THE FIRST 20 COLUMNS, MATCHING
C            CORRELATIONS IN THE SECOND TWENTY COLUMNS.
             REAL*4 COMAT(LOG_LENGTH,40)
      COMMON /RELETA/ ETRA
C            ELEVATIONS TO TRACE ACROSS.
             REAL*4 ETRA(LOG_LENGTH)
      COMMON /PERCOR/ PERCO
C            PERSISTENT CORRELATION MATRIX.
             REAL*4 PERCO(LOG_LENGTH,21)
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
C            NUMBER OF ELEVATION TO TRACE ACROSS.
             INTEGER*4 NETRA
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            CORRELATION MATRIX COLUMN FOR TRACE STARTING.
             INTEGER*4 CTT
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
      COMMON /NCO/    NCORRL
C            NUMBER OF CORRELATIONS ON EACH FILE.
             INTEGER*4 NCORRL(20)
      COMMON /TRACNG/ TSTART,TEND
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /START/ STARTP
C            POINTER TO THE LAST PERSISTENT CORRELATION.
             INTEGER*4 STARTP(20)
      COMMON /IPERC/ L
      COMMON /WCCOEF/ WCCOE
C            WEIGHTED CORRELATION COEFFICIENTS.
             REAL*4 WCCOE(LOG_LENGTH,20)
      COMMON /WCCOEP/ WCCOEP
C         WEIGHTED CORRELATION COEFFICIENTS FOR PERSISTENT CORRELATIONS
             REAL*4 WCCOEP(LOG_LENGTH,20)
C
      L = 0
      DO 50 II = 1,NPAIRS
      STARTP(II) = 1
  50  CONTINUE
      I19 = I + 19
      I20 = I + 20
      CTT = I
C
C               FINDING THE STARTING POINT
C
      LASTJ = .FALSE.
      LASTK = .FALSE.
      DO 60 II = 1, NCORRL(I-1)
      J = II
      IF ( COMAT(J,I19) .GE. TSTART ) GO TO 65
   60 CONTINUE
      LASTJ = .TRUE.
   65 DO 70 II = 1, NCORRL(I)
      K = II
      IF (  COMAT(K,I) .GE. TSTART ) GO TO 100
   70 CONTINUE
      LASTK = .TRUE.
      IF (LASTJ .OR. LASTK) GO TO 170
C
C               NEITHER FILE IS EXHAUSTED.
C               **************************
C
C         BOTH ELEVATIONS FOR THE CENTRAL WELL ARE THE SAME.
C
  100 IF ( COMAT(J,I19) .EQ. COMAT(K,I) ) THEN
         IF ( COMAT(J,I19) .GT. TEND ) GO TO 900
         L = L + 1
         PERCO(L,1) = COMAT(J,I-1)
         PERCO(L,2) = COMAT(J,I19)
         PERCO(L,3) = COMAT(K,I20)
         WCCOEP(L,1) = WCCOE(J,I-1)
         WCCOEP(L,2) = WCCOE(K,I)
         J = J + 1
         K = K + 1
         GO TO 150
      END IF
C
C     THE ELEVATION FOR THE LEFT WELL IS SHALLOWER.
C
      IF ( COMAT(J,I19) .LT. COMAT(K,I) ) THEN
         IF ( COMAT(J,I19) .GT. TEND ) GO TO 900
         ETRA(L+1) = COMAT(J,I19)
         CALL RTRACN(L+1)
         PERCO(L,1) = COMAT(J,I-1)
         PERCO(L,2) = COMAT(J,I19)
         WCCOEP(L,1) = WCCOE(J,I-1)
         J = J + 1
         GO TO 150
      END IF
C
C     THE ELEVATION FOR THE LEFT WELL IS DEEPER.
C
      IF ( COMAT(J,I19) .GT. COMAT(K,I) ) THEN
         IF ( COMAT(K,I) .GT. TEND ) GO TO 900
         L = L + 1         
         ETRA(L) = COMAT(K,I)
         CALL LTRACN(L)
         PERCO(L,2) = COMAT(K,I)
         PERCO(L,3) = COMAT(K,I20)
         WCCOEP(L,2) = WCCOE(K,I)
         K = K + 1
         IPER = IPER + 1
      END IF
  150 CALL CAQCOR(L)
      IF ( J .LE. NCORRL(I-1)  .AND.  K .LE. NCORRL(I) ) GO TO 100
C
C               CORRELATIONS ON THE FIRST FILE ONLY.
C               ************************************
C
  170 IF ( J .LE. NCORRL(I-1) ) THEN
         DO 200 JJ = J, NCORRL(I-1)
         IF ( COMAT(J,I19) .LT. TSTART  .OR.  
     1        COMAT(J,I19) .GT. TEND ) GO TO 900
         ETRA(L+1) = COMAT(J,I19)
         CALL RTRACN(L+1)
         PERCO(L,1) = COMAT(J,I-1)
         PERCO(L,2) = COMAT(J,I19)
         WCCOEP(L,1) = WCCOE(J,I-1)
         CALL CAQCOR(L)
  200    CONTINUE
      END IF
C
C               CORRELATIONS ON THE SECOND FILE ONLY.
C               *************************************
C
      IF ( K .LE. NCORRL(I) ) THEN
      DO 300 KK = K, NCORRL(I)
         IF ( COMAT(K,I) .LT. TSTART  .OR.
     1        COMAT(K,I) .GT. TEND ) GO TO 900
         L = L + 1         
         ETRA(L) = COMAT(K,I)
         CALL LTRACN(L)
         PERCO(L,2) = COMAT(K,I)
         PERCO(L,3) = COMAT(K,I20)
         WCCOEP(L,2) = WCCOE(K,I)
         IPER = IPER + 1
         CALL CAQCOR(L)
  300    CONTINUE
      END IF
  900 CONTINUE
 9999 RETURN
      END
      SUBROUTINE CAQCOR(L)
C
C             CALCULATION OF THE AVERAGE CORRELATION COEFFICIENT 
C             FOR A TRUE DIP AND INDICATION OF PERSISTENCE.
C
C*******************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /WCCOEP/ WCCOEP
C         WEIGHTED CORRELATION COEFFICIENTS FOR PERSISTENT CORRELATIONS
             REAL*4 WCCOEP(LOG_LENGTH,20)
      COMMON /AQCORR/ AVQCOR, PACORR
C            AVERAGE CORRELATION STRENGTH OF A TRUE DIP.
            REAL*4 AVQCOR(LOG_LENGTH)
C            INDICATOR OF PERSISTENCE:  .TRUE. IF DIP BASED ON TWO
C            CORRELATIONS, .FALSE. IF ONLY ON A CORRELATION AND
C            AN INTERPOLATION.
            LOGICAL PACORR(LOG_LENGTH)
C
      IF ( WCCOEP(L,1) .GE. -1.0  .AND.  WCCOEP(L,2) .GE. -1.0 ) THEN
         AVQCOR(L) = 0.5*(WCCOEP(L,1) + WCCOEP(L,2))
         PACORR(L) = .TRUE.
       ELSE
         PACORR(L) = .FALSE.
         IF ( WCCOEP(L,2) .LT. -1.0 ) THEN
            AVQCOR(L) = WCCOEP(L,1)
          ELSE
            AVQCOR(L) = WCCOEP(L,2)
         END IF
      END IF
      RETURN
      END
C***********************************************************************
C
C                  STRATIGRAPHIC COLUMN.
C
C***********************************************************************
C
      SUBROUTINE STRACO(STRACOF,IREFL,YSP2)
C
      CHARACTER *40 STRACOF
C
      INCLUDE 'log.inc'
      LOGICAL NOUNC
      INTEGER*4 TITLEN
C            ELEVATION FOR THE TOP OF AN ANNOTATION INTERVAL.
      REAL*4 ELEV(ANNOT_LENGTH)
C            DEPTH TRANSFORM, INCHES IN THE CROSS-SECTION.
      REAL*4 XANNOT(ANNOT_LENGTH)
C            HORIZONTAL OR VERTICAL DISPLAY
      CHARACTER*1 HOV
C            CONFORMABLE OR UNCONFORMABLE CONTACT
      CHARACTER*1 COU
C            COLUMN TITLE
      CHARACTER*40 TITLE
C            ANNOTATION
      CHARACTER*40 ANNOT(ANNOT_LENGTH)
      COMMON /ZSLDEE/ ZSHAL,ZDEEP
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /YSTART/ YSTART
      COMMON /INT2PP/ IHFC,IHPFC,JUSTIF,FONT,FONTTL
             INTEGER IHFC,IHPFC,JUSTIF,FONT,FONTTL
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CODINC/ DINC
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
             INTEGER*4 LOG1,LOG2,LOG3,LOG4
      COMMON /DIGS/ DIGS1,DIGS2
             REAL*4 DIGS1,DIGS2
      COMMON /WFACTOR/ WFACTOR
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /FASEN/ FASEN
C
      CALL RWELLH
      DIGZS1=DEPRMN
      DIGZS2=DEPMMN
      DIGS1 = DIGZS1 - DATUM1
      DIGS2 = DIGZS2 - DATUM2
      IL1=(DEPRMX-DEPRMN)/DINC+1.05
      IL2=(DEPMMX-DEPMMN)/DINC+1.05
      IL3=IL1
      IL4=IL2
      ATTLSZ = 0.5*TTLSZ
      CALL GMPLCR(1)
      IF (IREFL .EQ. 1) THEN
         CALL TOPBOT(IREFL,TOPZR,BOTZR)
         ZEND = DEPRMX-DATUM1
         ZBEG =  DIGS1
      END IF
      IF (IREFL .NE. 1) THEN
         CALL TOPBOT(IREFL,TOPZR,BOTZR)
         ZEND = DEPMMX-DATUM2
         ZBEG =  DIGS2
      END IF
C
C          END OF LOG.
C
      XBEG = XTOP + (AMAX1(TOPZR,ZBEG) - TOPZR)/VSCALE
      XEND = XTOP + (AMIN1(BOTZR,ZEND) - TOPZR)/VSCALE
      IF ((XEND - XBEG) .LT. 1.2*ATTLSZ) GO TO 900
C
C          READ IN THE FILE HEADING.
C
      K = 1
      CALL CHKOTY(68,STRACOF,0,51,8,0,IERSC)
      READ (68,9000,REC=K) HEMA,NSEQW,NCATEG
      K = K + 1
C
C          WIDTH OF THE COLUMN.
C
      FASEN = 0.0
      DO 200 I = 1,NCATEG
      READ(68,9001,REC=K) TITLE, NANNOT, NLETER, HOV
      K = K + 1
      IF (HOV .EQ. 'H' )THEN
         YRIGHT = YSTART + WFACTOR*ATTLSZ*(2 + NLETER)
       ELSE
         YRIGHT = YSTART + ATTLSZ*MAX0(3,2 + NLETER)
      END IF
C
C          TITLE 
C
      YA = 0.5*(YSTART + YRIGHT)
      CALL GMPTXT(TITLE,XBEG-ATTLSZ, YA, ATTLSZ,90.0,JUSTIF)
      CALL PLTBOX(I,NCATEG,0,XBEG-3.0*ATTLSZ,XBEG,YRIGHT,YSTART)
      IF ( NANNOT .LE.0 ) GO TO 200
C
C          READ IN THE ANNOTATIONS.
C
      FASEC = FASEN
      NOUNC = .TRUE.
      DO 100 J = 1,NANNOT
      READ(68,9002,REC=K) ANNOT(J), ELEV(J), COU
      K = K + 1
C
C          DRAW A HORIZONTAL LINE OR WEAVELY LINE.
C
      XANNOT(J) = XTOP + ((ELEV(J) - TOPZR)/VSCALE)
      IF ( ELEV(J) .GT. AMAX1(TOPZR,ZBEG)  .AND.
     1     ELEV(J) .LT. AMIN1(BOTZR,ZEND) ) THEN
         IF ( COU .EQ. 'S' ) THEN
            CALL GMPMOV(XANNOT(J), YRIGHT)
            CALL GMPDRW(XANNOT(J), YSTART)
          ELSE
            CALL UNCONF('R',YSTART, XANNOT(J), YRIGHT, 0.02,FASEC,FASEN)
            NOUNC = .FALSE.
         END IF
      END IF
  100 CONTINUE
      IF (NOUNC) FASEN = 0.0
C
C          CHECK THERE IS ENOUGH ROOM TO MAKE THE ANNOTATION.
C
      DO 150 J = NANNOT,1,-1
      IF (  HOV .EQ. 'H')  THEN
         HEIGMN =  1.2*ATTLSZ
       ELSE
         HEIGMN =  WFACTOR*ATTLSZ*TITLEN(ANNOT(J))
      END IF
      IF ( J .LT. NANNOT ) THEN
         ZBOTTOM = AMIN1(ELEV(J+1),BOTZR,ZEND)
       ELSE
         ZBOTTOM = AMIN1(BOTZR,ZEND)
      END IF
      IF( (( ZBOTTOM - AMAX1(ELEV(J),TOPZR,ZBEG))/VSCALE)
     1                                  .LE. 1.1*HEIGMN ) GO TO 150
C
C          HORIZONTAL ANNOTATION.
C
         IF ( HOV .EQ. 'H')  THEN
            IF ( XANNOT(J) .GT. XBEG ) THEN
                XABOVE = XANNOT(J)
             ELSE
                XABOVE = XBEG
            END IF
            IF ( J .LT. NANNOT ) THEN
               IF ( XANNOT(J+1) .LT. XEND ) THEN
                  XA = 0.5*(XABOVE + XANNOT(J+1) + ATTLSZ)
                ELSE
                  XA = 0.5*(XABOVE + XEND + ATTLSZ)
               END IF
             ELSE
               XA = 0.5*(XABOVE + XEND + ATTLSZ)
             END IF
            CALL GMPTXT(ANNOT(J),XA, YA, ATTLSZ,90.0,JUSTIF)
C
C         VERTICAL ANNOTATION.
C
          ELSE
            YA = 0.5*(YSTART + YRIGHT + ATTLSZ)
            IF ( XANNOT(J) .GT. XBEG ) THEN
               IF ( J .LT. NANNOT ) THEN
                  IF ( XANNOT(J+1) .LT. XEND ) THEN
                     XA = 0.5*(XANNOT(J) + XANNOT(J+1))
                   ELSE
                     XA = 0.5*(XANNOT(J) + XEND)
                  END IF
                ELSE
                  XA = 0.5*(XANNOT(J) + XEND)
               END IF
             ELSE
               IF ( J .LT. NANNOT  ) THEN
                  IF (((ELEV(J+1) - ZBEG)/VSCALE) 
     1                 .GE. WFACTOR*ATTLSZ*TITLEN(ANNOT(J)))THEN
                     XA = 0.5*(XBEG + AMIN1(XANNOT(J+1),XEND))
                   ELSE
                     GO TO 150
                  END IF
                ELSE
                  XA = 0.5*(XBEG + XEND)
               END IF
            END IF
            CALL GMPTXT(ANNOT(J),XA, YA, ATTLSZ,180.0,JUSTIF)
         END IF
  150 CONTINUE
C
C          DRAW BOX.
C
      CALL PLTBOX(I,NCATEG,0,XBEG,XEND,YRIGHT,YSTART)
      YSTART = YRIGHT
  200 CONTINUE
      YSTART = YSTART + 0.2
      CLOSE(68,STATUS='KEEP')
  900 YSP2=YSTART
      CALL BXBOUN(YSTART)
      RETURN
 9000 FORMAT (A4,31X,3I5)
 9001 FORMAT (A40,2I4,1X,1A1)
 9002 FORMAT (A40,F9.0,A1)
      END
      SUBROUTINE UNCONF(LOR,XI, YI, XF, H, FASEC,FASEN)
C
C             DRAWING OF A WEAVLY LINE.
C
C*********************************************************************
C
      CHARACTER*1 LOR
C
      SINT = YI + H*SIN((3.14159*FASEC)/(4.0*H))
      IF (LOR .EQ. 'R') THEN
      CALL GMPMOV(SINT, XI)
       ELSE
      CALL GMPMOV(SINT, XF)
      END IF
C
C           
C
      T = (H/10.0)
  100 IF (LOR .EQ. 'R') THEN
      SINT = YI + H*SIN((3.14159*(FASEC + T))/(4.0*H))
         CALL GMPDRW(SINT, XI+T)
       ELSE
      SINT = YI - H*SIN((3.14159*(FASEC + T))/(4.0*H))
         CALL GMPDRW(SINT, XF-T)
      END IF
      T = T + H/10.0
      IF ( T .LE. (XF-XI) ) GO TO 100
      FASEN = MOD(FASEC+T,8.0*H)
      RETURN
      END
C
      SUBROUTINE UNCONFWT(LOR,XI, YI, H, FASEC,FASEN,
     1                    TOPZR,ZBEG,RLOG1,IL1,RMIN1,YSCALE,
     2                    YLLOG,YRLOG,INCREASE)
C
C             DRAWING OF A WEAVLY LINE WITH TESTING
C             NOT TO GO BEYOND THE LOG TRACE
C
C*********************************************************************
C
      CHARACTER*1 LOR, INCREASE
      REAL*4 RLOG1(IL1)
C
      SINT = YI + H*SIN((3.14159*FASEC)/(4.0*H))
      CALL GMPMOV(SINT, XI)
C
C           
C
      T = (H/10.0)
  100 IF (LOR .EQ. 'R') THEN
         SINT = YI + H*SIN((3.14159*(FASEC + T))/(4.0*H))
         CALL LOGVALUE(SINT,TOPZR,ZBEG,RLOG1,IL1,RMIN1,YSCALE,
     1                 YLLOG,YRLOG,INCREASE,YANLOG)
         IF (XI+T .GT. YANLOG)  GO TO 900
         CALL GMPDRW(SINT, XI+T)
       ELSE
         SINT = YI - H*SIN((3.14159*(FASEC + T))/(4.0*H))
         CALL LOGVALUE(SINT,TOPZR,ZBEG,RLOG1,IL1,RMIN1,YSCALE,
     1                 YLLOG,YRLOG,INCREASE,YANLOG)
         IF (XI-T .LT. YANLOG)  GO TO 900
         CALL GMPDRW(SINT, XI-T)
      END IF
C
      T = T + H/10.0
      GO TO 100
  900 FASEN = MOD(FASEC+T,8.0*H)
      RETURN
      END
      SUBROUTINE CHKSC(LINE,IFSC,IERSC,*)
C
C         CHECK STRATIGRAPHIC COLUMN FILE
C         AND ITS CALCULATES WIDTH IF CHECKING IS SUCCESSFUL.
C
C***********************************************************************
C
      include 'welldb.inc'
      include 'wldwel.inc'
      INCLUDE 'log.inc'
C
      INTEGER*4 TITLEN
      CHARACTER*1 HOV
      CHARACTER*4 BOMU
      CHARACTER*10 D1, D2
      CHARACTER*3 I1, I2
      CHARACTER*20 TITLE, WNAMEI
      CHARACTER*40 STRACOF
      CHARACTER*40 TEXT
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /WNAMES/ WNAME1,WNAME2
             CHARACTER*20 WNAME1(20),WNAME2(20)
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /USCAL/  BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /STRACOF/ STRACOFL, STRACOFR
             CHARACTER*40 STRACOFL, STRACOFR
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /WIDTHSC/ WIDTHSCL, WIDTHSCR
      COMMON /WFACTOR/ WFACTOR
C
      WFACTOR = 0.65
      WIDTHSC = 0.0
C
C           CHECK FILE TYPE.
C
      IERSC = 0 
      IF (IFSC .EQ. 1 ) THEN
         STRACOF = STRACOFL
         I = 1
       ELSE
         STRACOF = STRACOFR
         I = NPAIRS+1
      END IF
      CALL CHKOTY(68,STRACOF,0,51,8,LINE+2,IERSC)
      IF ( IERSC .NE. 0 ) THEN 
        LINE = LINE + 1
        RETURN 1
      END IF
C
C           CHECK THAT THE WELL TO DISPLAY AND THE WELL IN
C           THE STRATIGRAPHIC COLUMN FILE MATCH.
C
      READ (68,9000,REC=1) NWIF, NCOL, NRECORDS
      IF ( MENU .EQ. 'TDIP') I = 2
      CALL GETWEL(IWLPTR(NWIF),IWELLR)
      TITLE = WELLDS(1:20)
      IF (IFSC .EQ. 1 ) THEN
         WNAMEI = WNAME1(I)
       ELSE
         WNAMEI = WNAME2(I-1)
      END IF
      IF ( WNAMEI .NE. TITLE ) THEN
            WRITE(I1,'(I3)') WSNUMB(I)
            WRITE(I2,'(I3)') NWIF
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+2,'***** WRONG FILE.  '//
     1       'WELL (' //I1// ') '//WNAMEI(1:TITLEN(WNAMEI))// 
     2       ' REQUIRES THE ANNOTATION ' )
            CALL GTEXTS(10,LINE+3,
     1    ' OF THE STRATIGRAPHIC COLUMN AND FILE ' 
     2    // STRACOF(1:TITLEN(STRACOF)) )
            CALL GTEXTS(5,LINE+4, '      IS FOR'//
     1   ' WELL ('//I2//') '//TITLE(1:TITLEN(TITLE))//'.')
            LINE = LINE + 3
            CALL SCHOLD
            IERSC = 1
            RETURN 1  
       END IF
C
C           MAKE SURE THERE IS AT LEAST ONE COLUMN HEADING.
C
      IF ( NCOL .LE. 0 ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** FILE ' // STRACOF(1:TITLEN(STRACOF)) // ' IS EMPTY.')
            CALL SCHOLD
            IERSC = 1
            RETURN 1  
       END IF
C
C           MAKE SURE THERE ARE NOT TOO MANY RECORDS PER COLUMN.
C
      K = 2
      MAXNANNOT = -1
      DO 50 J = 1, NCOL
      READ(68,9003,REC=K) TEXT, NANNOT
      IF (NANNOT .GT. MAXNANNOT) MAXNANNOT = NANNOT
      K = K + 1 + NANNOT
   50 CONTINUE
      IF ( MAXNANNOT .GT. ANNOT_LENGTH) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+2,
     1   '***** MAXIMUM NUMBER OF RECORDS PER COLUMN')
            CALL GTEXTS(11,LINE+3,
     1   'FOR A STRATIGRAPHIC COLUMN FILE IS')
            CALL GTXTIN(49,LINE+3,ANNOT_LENGTH)
            CALL GTEXTS(50,LINE+3,'.')
            CALL GTEXTS(11,LINE+4,'FILE ' //
     1    STRACOF(1:TITLEN(STRACOF)) // ' HAS A COLUMN WITH')
            CALL GTXTIN(49,LINE+4,MAXNANNOT)
            CALL GTEXTS(51,LINE+4,'RECORDS.')
            CALL SCHOLD
            IERSC = 1
            RETURN 1  
      END IF
C
C            CHECK THAT THE DEPTHS GO FROM SWALLOWEST
C            TO DEPEEST FOR EVERY COLUMN.
C
      K = 2
      DO 150 I = 1,NCOL
      READ(68,9001,REC=K) NROW
      K = K + 1
      IF ( NROW .GT. 1 ) THEN
         READ(68,9002,REC=K) PDEPTH
         K = K + 1
         DO 100 II = 2,NROW
         READ(68,9002,REC=K) DEPTH
         K = K + 1
         IF ( DEPTH .LE. PDEPTH ) THEN
            WRITE(D1,'(F10.2)') DEPTH
            WRITE(D2,'(F10.2)') PDEPTH
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+2,
     1       '***** DEPTHS NOT IN ASCENDING ORDER-' / /D1 //' AFTER '
     2      // D2 // ' ' // BOMU(BOM) // '.')  
            IERSC = 1
            LINE = LINE + 1  
         END IF
         PDEPTH = DEPTH
  100    CONTINUE
      END IF
  150 CONTINUE
      IF ( IERSC .NE. 0 ) THEN
         CALL SCHOLD
         RETURN 1
      END IF
C
C           WIDTH
C
      ATTLSZ = 0.5*TTLSZ
      K = 2
      DO 300 I = 1,NCOL
      READ(68,9001,REC=K) NROW, NLETER, HOV
      IF ( HOV .EQ. 'H' ) THEN
         WIDTHSC = WIDTHSC + WFACTOR*ATTLSZ*(2 + NLETER)
       ELSE
         WIDTHSC = WIDTHSC + ATTLSZ*MAX0(3,2 + NLETER)
      END IF
      K = 1 + K + NROW
  300 CONTINUE     
      IF (IFSC .EQ. 1 ) THEN
         WIDTHSCL = WIDTHSC
       ELSE
         WIDTHSCR = WIDTHSC
      END IF
      RETURN
 9000 FORMAT(35X,3I5)
 9001 FORMAT (40X,2I4,1X,1A1)
 9002 FORMAT (40X,F9.2)
 9003 FORMAT (A40,I4)
      END
      SUBROUTINE CHKLITHO(LINE,IFSC,IERSC,*)
C
C         CHECK LITHOLOGY COLUMN FILE
C
C***********************************************************************
C
      include 'welldb.inc'
      include 'wldwel.inc'
      INCLUDE 'log.inc'
      include 'lithcolor.inc'
C
      CHARACTER*1 LITHOLINE
      CHARACTER*2 LITHOTYPE
      CHARACTER*3 I1, I2
      INTEGER*4 TITLEN
      CHARACTER*4 BOMU
      CHARACTER*10 D1, D2
      CHARACTER*20 TITLE, WNAMEI
      CHARACTER*40 LICOLF
C
      COMMON /USCAL/  BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /WNAMES/ WNAME1,WNAME2
             CHARACTER*20 WNAME1(20),WNAME2(20)
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /LITHOFILES/ LFILEL, LFILER
             CHARACTER*40 LFILEL, LFILER
C
C           CHECK FILE TYPE.
C
      IERSC = 0 
      IF (IFSC .EQ. 1 ) THEN
         LICOLF = LFILEL
         I = 1
       ELSE
         LICOLF = LFILER
         I = NPAIRS+1
      END IF
      CALL CHKOTY(69,LICOLF,0,21,9,LINE+2,IERSC)
      IF ( IERSC .NE. 0 ) THEN
         LINE = LINE + 1 
         RETURN 1
      END IF
C
C           CHECK THAT THE WELL TO DISPLAY AND THE WELL IN
C           THE STRATIGRAPHIC COLUMN FILE MATCH.
C
      READ (69,9000,REC=1) NWIF, NRECORDS
      IF ( MENU .EQ. 'TDIP') I = 2
      CALL GETWEL(IWLPTR(NWIF),IWELLR)
      TITLE = WELLDS(1:20)
      IF (IFSC .EQ. 1 ) THEN
         WNAMEI = WNAME1(I)
       ELSE
         WNAMEI = WNAME2(I-1)
      END IF
      IF ( WNAMEI .NE. TITLE ) THEN
            WRITE(I1,'(I3)') WSNUMB(I)
            WRITE(I2,'(I3)') NWIF
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+2,'***** WRONG FILE.  '//
     1       'WELL (' //I1// ') '//WNAMEI(1:TITLEN(WNAMEI))// 
     2       ' REQUIRES ANNOTATION OF ' )
            CALL GTEXTS(10,LINE+3,
     1    ' LITHOLOGY AND FILE ' 
     2    // LICOLF(1:TITLEN(LICOLF)) )
            CALL GTEXTS(5,LINE+4, '      IS FOR'//
     1   ' WELL ('//I2//') '//TITLE(1:TITLEN(TITLE))//'.')
            CALL SCHOLD
            IERSC = 1
            RETURN 1  
       END IF
C
C           MAKE SURE THERE IS AT LEAST ONE RECORD IN THE FILE.
C
      IF ( NRECORDS .LE. 0 ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** FILE ' // LICOLF(1:TITLEN(LICOLF)) // ' IS EMPTY.')
            CALL SCHOLD
            IERSC = 1
            RETURN 1  
      END IF
C
C           MAKE SURE THERE ARE NOT TOO MANY RECORDS.
C
      IF ( NRECORDS .GT. ANNOT_LENGTH) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** MAXIMUM NUMBER OF BEDS FOR A LITHOLOGY FILE IS')
            CALL GTXTIN(71,LINE+2,ANNOT_LENGTH)
            CALL GTEXTS(21,LINE+3,
     1   'FILE ' // LICOLF(1:TITLEN(LICOLF)) // ' HAS')
            CALL GTXTIN(42,LINE+3,NRECORDS)
            CALL SCHOLD
            IERSC = 1
            RETURN 1  
      END IF
C
C            CHECK THAT THE DEPTHS GO FROM SWALLOWEST
C            TO DEPEEST FOR EVERY COLUMN.
C
      K = 2
      IF ( NRECORDS .GT. 1 ) THEN
         READ(69,9001,REC=K) PDEPTH
         K = K + 1
         DO 100 II = 3,NRECORDS+1
         READ(69,9001,REC=K) DEPTH
         K = K + 1
         IF ( DEPTH .LE. PDEPTH ) THEN
            WRITE(D1,'(F10.2)') DEPTH
            WRITE(D2,'(F10.2)') PDEPTH
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+2,
     1       '***** DEPTHS NOT IN ASCENDING ORDER-' / /D1 //' AFTER '
     2      // D2 // ' ' // BOMU(BOM) // '.')  
            IERSC = 1
            LINE = LINE + 1  
         END IF
         PDEPTH = DEPTH
  100    CONTINUE
      END IF
C
C            CHECK THAT THE LITHOLOGY CODE IS VALID
C
      DO 200 II = 2,NRECORDS
      READ(69,9001,REC=II) DEPTH, LITHOTYPE, LITHOLINE
      IF (.NOT.(LITHOTYPE .EQ. 'SS'    .OR.  LITHOTYPE .EQ. 'Ss'  .OR.  
     1    LITHOTYPE .EQ. LITOPTION(8)  .OR.  LITHOTYPE .EQ. 'SH'  .OR.  
     2    LITHOTYPE .EQ. 'Sh'  .OR.  LITHOTYPE .EQ. LITOPTION(9)  .OR.
     3    LITHOTYPE .EQ. 'CL'  .OR.  LITHOTYPE .EQ. 'Cl'  .OR.  
     4    LITHOTYPE .EQ. LITOPTION(3)  .OR.  LITHOTYPE .EQ. 'BL'  .OR.  
     5    LITHOTYPE .EQ. 'Bl'  .OR.  LITHOTYPE .EQ. 'bl'  .OR.
     6    LITHOTYPE .EQ. '  '  .OR.  LITHOTYPE .EQ. 'LM'  .OR.  
     7    LITHOTYPE .EQ. 'Ls'  .OR.  LITHOTYPE .EQ. LITOPTION(6)  .OR.
     8    LITHOTYPE .EQ. 'DL'  .OR.  LITHOTYPE .EQ. 'Dl'  .OR.  
     9    LITHOTYPE .EQ. LITOPTION(4)  .OR.  LITHOTYPE .EQ. 'ST'  .OR.
     &    LITHOTYPE .EQ. 'St'  .OR.  LITHOTYPE .EQ. LITOPTION(7)  .OR.
     1    LITHOTYPE .EQ. 'CK'  .OR.  LITHOTYPE .EQ. 'Ck'  .OR.
     2    LITHOTYPE .EQ. LITOPTION(2)  .OR.  LITHOTYPE .EQ. 'AH'  .OR.
     3    LITHOTYPE .EQ. 'Ah'  .OR.  LITHOTYPE .EQ. LITOPTION(1)  .OR.
     2    LITHOTYPE .EQ. 'GN'  .OR.  LITHOTYPE .EQ. 'Gn'  .OR.
     3    LITHOTYPE .EQ. LITOPTION(5))) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(3,LINE+2,
     1       "*** '"//LITHOTYPE//"' IS AN ILEGAL LITHOLOGY CODE. "//
     2       "VALID CODES ARE:")
         CALL GTEXTS(7,LINE+3, "ANHYDRATE: "//LITOPTION(1)//
     1       "  BLANK: bl       CHALK: "//LITOPTION(2)//
     2  "   COAL: "//LITOPTION(3)//"      DOLOMITE: "//LITOPTION(4))
         CALL GTEXTS(7,LINE+4, "GRANITE: "//LITOPTION(5)//
     1  "    LIMESTONE: "//LITOPTION(6)//"   SALT: "//LITOPTION(7)//
     2  "    SANDSTONE: "//LITOPTION(8)//"  SHALE:   "//LITOPTION(9))
            IERSC = 1
            LINE = LINE + 3  
      END IF
C
C            CHECK THAT THE LINE TYPE CODE IS VALID
C
      IF (.NOT.(LITHOLINE .EQ. 'S'  .OR.  LITHOLINE .EQ. 's'  .OR.  
     1          LITHOLINE .EQ. 'W'  .OR.  LITHOLINE .EQ. 'w'  .OR.  
     2          LITHOLINE .EQ. 'G'  .OR.  LITHOLINE .EQ. 'g')) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(3,LINE+2,
     1       "*** '"//LITHOLINE//"' IS AN ILEGAL LINE CODE. "//
     2       "VALID CODES ARE:")
         CALL GTEXTS(7,LINE+3, "STRAIGHT LINE: 'S'; "//
     1       "UNCONFORMITY: 'W'; OR NO LINE: 'G.'")
            IERSC = 1
            LINE = LINE + 2  
      END IF
  200 CONTINUE
      IF ( IERSC .NE. 0 ) THEN
         CALL SCHOLD
         RETURN 1
      END IF
      RETURN
 9000 FORMAT(10X,2I5)
 9001 FORMAT(F10.0,3X,A2,4X,A1)
      END
C***********************************************************************
C
C              LITHOLOGICAL ANNOTATION IN STRATIGRAPHIC COLUMN.
C
C***********************************************************************
C
      SUBROUTINE LITHANNOT(LFILE,IREFL,YL1,RLOG1,IL1,DSTART,
     1                     TOPZ,BOTZ,YSP2)
C
      INCLUDE 'log.inc'
      include 'lithcolor.inc'
C
      LOGICAL NOUNC
      CHARACTER*1 INCREASE
      CHARACTER*40 LFILE
      REAL*4 RLOG1(IL1)
      INTEGER*4 DEPSEQ
      REAL*4 XANNOT(ANNOT_LENGTH)
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
      COMMON /IFSC/ IFSC
      COMMON /CODINC/ DINC
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /REAL41/ XBOT,YLEFT,YRIGHT
      COMMON /YSTART/ YSTART
      COMMON /DIGS/ DIGS1,DIGS2
             REAL*4 DIGS1,DIGS2
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /LITHOPAR/ HINC
      COMMON /FASEN/ FASEN
      COMMON /LIANNOT/ ELEV, LITHCODE, LINECODE
             REAL*4 ELEV(ANNOT_LENGTH)
             CHARACTER*1 LINECODE(ANNOT_LENGTH)
             CHARACTER*2 LITHCODE(ANNOT_LENGTH)
C
C     PARAMETERS
C
      HINC = 0.1
      CALL CENWID(TOPZ,BOTZ,CDEPTH,DWIND)
      ICPTH1=ANINT((CDEPTH-DSTART)/DINC+1.0)
      IDINT=DWIND/DINC+0.05
      IDS=MAX0(1,ICPTH1-IDINT)
      IDE=MIN0(IL1,ICPTH1+IDINT)
      IDADJ=ICPTH1-IDINT
C
C        ADJUSTMENTS
C
      IF (IREFL .EQ. 1) THEN
         DIGLOG = DIGS1
         IF (SCLSHL .EQ. 'L') THEN
            INCREASE = 'R'
          ELSE
            INCREASE = 'L'
         END IF
         IF (IFSC .EQ. 1  .OR.  IFSC .EQ. 3) THEN
            YLLOG = YL1 + 0.44
            YL = YL1 -0.2
          ELSE
            YLLOG = YL1 + 0.64
            YL = YL1
         END IF
         YMAX = YL
         YRLOG = YLLOG + 0.3*TKWD
       ELSE
         DIGLOG = DIGS2
         INCREASE = SCLSHL
         YL = YL1
         YMAX = YL + 1.0
         YLLOG = YL1
         YRLOG = YLLOG + 0.3*TKWD
      END IF
C
C        DRAW LOG
C
      CALL GMPLCR(1)
      RMIN1=+1.0E 30
      RMAX1=-RMIN1
      DO 111 I=IDS,IDE
      R=RLOG1(I)
      RMIN1=AMIN1(R,RMIN1)
      RMAX1=AMAX1(R,RMAX1)
  111 CONTINUE
      YSCALE=(YRLOG-YLLOG)/(RMAX1-RMIN1)
      CALL DRWLOG(RLOG1,IL1,IDS,IDE,IDADJ,DINC,RMAX1,YLLOG,
     1            YRLOG,INCREASE)
C
C        EXTREMES
C
      IF (IREFL .EQ. 1) THEN
         CALL TOPBOT(IREFL,TOPZR,BOTZR)
         ZEND = DEPRMX-DATUM1
         ZBEG =  DIGS1
      END IF
      IF (IREFL .NE. 1) THEN
         CALL TOPBOT(IREFL,TOPZR,BOTZR)
         ZEND = DEPMMX-DATUM2
         ZBEG =  DIGS2
      END IF
      DEPTHTOP = AMAX1(TOPZR,ZBEG)
      DEPTHBOT = AMIN1(BOTZR,ZEND)
      XBEG = XTOP + (DEPTHTOP - TOPZR)/VSCALE
      XEND = XTOP + (DEPTHBOT - TOPZR)/VSCALE
      IF ((XEND - XBEG) .LT. 0.6*TTLSZ) GO TO 900
C
C        BOX
C
      I = DEPSEQ(PP2DEPTH(XBEG,TOPZR),DIGLOG,DINC)
      CALL MOVEPN(RLOG1(I),RMIN1,YSCALE,YLLOG,YRLOG,INCREASE,YLOG)
      CALL GMPMOV(XBEG,YMAX)
      CALL GMPDRW(XBEG,YLOG)
      I = DEPSEQ(PP2DEPTH(XEND,TOPZR),DIGLOG,DINC)
      CALL MOVEPN(RLOG1(I),RMIN1,YSCALE,YLLOG,YRLOG,INCREASE,YLOG)
      CALL GMPMOV(XEND,YMAX)
      CALL GMPDRW(XEND,YLOG)
      IF ( IFSC .EQ. 0   
     1                      .OR.
     2       (IFSC .EQ. 2  .AND. IREFL .EQ. 1)  
     3                      .OR.  
     4       (IFSC .EQ. 1  .AND. IREFL .NE. 1) )
     5 THEN
         CALL GMPMOV(XEND,YMAX)
         CALL GMPDRW(XBEG,YMAX)
      END IF
C
C          READ IN THE FILE HEADING.
C
      K = 1
      CALL CHKOTY(69,LFILE,0,21,9,0,IERSC)
      READ (69,9000,REC=K) NANNOT
      K = K + 1
C
C          DRAW A HORIZONTAL LINE OR WEAVELY LINE.
C
      FASEC = FASEN
      DO 200 I = 1, NANNOT
      READ (69,9001,REC=K) ELEV(I),LITHCODE(I), LINECODE(I)
      K = K + 1
      XANNOT(I) = XTOP + ((ELEV(I) - TOPZR)/VSCALE)
      IF ( ELEV(I) .GT. DEPTHTOP  .AND.  ELEV(I) .LT. DEPTHBOT ) THEN
         IF (LINECODE(I) .EQ. 'S'  .OR.  LINECODE(I) .EQ. 'W') THEN
            J = DEPSEQ(ELEV(I),DIGLOG,DINC)
            CALL MOVEPN(RLOG1(J),RMIN1,YSCALE,YLLOG,YRLOG,
     1                  INCREASE,YLOG)
         END IF
         IF ( LINECODE(I) .EQ. 'S' ) THEN
            CALL GMPMOV(XANNOT(I), YLOG)
            CALL GMPDRW(XANNOT(I), YMAX)
          ELSE IF ( LINECODE(I) .EQ. 'W' ) THEN
            IF (IREFL .EQ. 1) THEN
             CALL UNCONFWT('R',YMAX, XANNOT(I), 0.02,
     1                    FASEC,FASEN,TOPZR,ZBEG,RLOG1,IL1,RMIN1,
     2                    YSCALE,YLLOG,YRLOG,INCREASE)
             ELSE
             CALL UNCONFWT('L',YMAX, XANNOT(I), 0.02,
     1                    0.0,FASEN,TOPZR,ZBEG,RLOG1,IL1,RMIN1,
     2                    YSCALE,YLLOG,YRLOG,INCREASE)
            END IF
            NOUNC = .FALSE.
         END IF
      END IF
  200 CONTINUE
      IF (NOUNC) FASEN = 0.0
C
C        ANNOTATE THE LITHOLOGY
C
         DO 300 I = 1, NANNOT
         IF (LITHCODE(I) .EQ. 'SS'  .OR. LITHCODE(I) .EQ. 'Ss'  .OR.
     1      LITHCODE(I) .EQ. LITOPTION(8)) THEN
            CALL LITHSAND(I,NANNOT, IREFL, DEPTHTOP,DEPTHBOT,TOPZR,YL,
     1                 RLOG1,IL1,ZBEG,RMIN1,RMAX1,YLLOG,YRLOG,INCREASE,
     2                 FASEC)
          ELSE IF(LITHCODE(I) .EQ. 'SH' .OR. LITHCODE(I) .EQ. 'Sh'  .OR.
     1      LITHCODE(I) .EQ. LITOPTION(9)) THEN
            CALL LITHSHALE(I,NANNOT, IREFL, DEPTHTOP,DEPTHBOT,TOPZR,YL,
     1                 RLOG1,IL1,ZBEG,RMIN1,RMAX1,YLLOG,YRLOG,INCREASE,
     2                 FASEC)
          ELSE IF(LITHCODE(I) .EQ. 'CL' .OR. LITHCODE(I) .EQ. 'Cl'  .OR.
     1      LITHCODE(I) .EQ. LITOPTION(3)) THEN
            CALL LITHCOAL(I,NANNOT, IREFL, DEPTHTOP,DEPTHBOT,TOPZR,YL,
     1                 RLOG1,IL1,ZBEG,RMIN1,RMAX1,YLLOG,YRLOG,INCREASE,
     2                 FASEC)
          ELSE IF(LITHCODE(I) .EQ. 'LM' .OR. LITHCODE(I) .EQ. 'Ls'  .OR.
     1      LITHCODE(I) .EQ. LITOPTION(6)) THEN
            CALL LITHLIMEST(I,NANNOT, IREFL, DEPTHTOP,DEPTHBOT,TOPZR,YL,
     1                 RLOG1,IL1,ZBEG,RMIN1,RMAX1,YLLOG,YRLOG,INCREASE,
     2                 FASEC)
          ELSE IF(LITHCODE(I) .EQ. 'DL' .OR. LITHCODE(I) .EQ. 'Dl'  .OR.
     1      LITHCODE(I) .EQ. LITOPTION(4)) THEN
            CALL LITHDOL(I,NANNOT, IREFL, DEPTHTOP,DEPTHBOT,TOPZR,YL,
     1                 RLOG1,IL1,ZBEG,RMIN1,RMAX1,YLLOG,YRLOG,INCREASE,
     2                 FASEC)
          ELSE IF(LITHCODE(I) .EQ. 'ST' .OR. LITHCODE(I) .EQ. 'St'  .OR.
     1      LITHCODE(I) .EQ. LITOPTION(7)) THEN
            CALL LITHSALT(I,NANNOT, IREFL, DEPTHTOP,DEPTHBOT,TOPZR,YL,
     1                 RLOG1,IL1,ZBEG,RMIN1,RMAX1,YLLOG,YRLOG,INCREASE,
     2                 FASEC)
          ELSE IF(LITHCODE(I) .EQ. 'CK' .OR. LITHCODE(I) .EQ. 'Ck'  .OR.
     1      LITHCODE(I) .EQ. LITOPTION(2)) THEN
            CALL LITHCHALK(I,NANNOT, IREFL, DEPTHTOP,DEPTHBOT,TOPZR,YL,
     1                 RLOG1,IL1,ZBEG,RMIN1,RMAX1,YLLOG,YRLOG,INCREASE,
     2                 FASEC)
          ELSE IF(LITHCODE(I) .EQ. 'AH' .OR. LITHCODE(I) .EQ. 'Ah'  .OR.
     1      LITHCODE(I) .EQ. LITOPTION(1)) THEN
            CALL LITHANH(I,NANNOT, IREFL, DEPTHTOP,DEPTHBOT,TOPZR,YL,
     1                 RLOG1,IL1,ZBEG,RMIN1,RMAX1,YLLOG,YRLOG,INCREASE,
     2                 FASEC)
          ELSE IF(LITHCODE(I) .EQ. 'GN' .OR. LITHCODE(I) .EQ. 'Gn'  .OR.
     1      LITHCODE(I) .EQ. LITOPTION(5)) THEN
            CALL LITHGRAN(I,NANNOT, IREFL, DEPTHTOP,DEPTHBOT,TOPZR,YL,
     1                 RLOG1,IL1,ZBEG,RMIN1,RMAX1,YLLOG,YRLOG,INCREASE,
     2                 FASEC)
          ELSE IF(LITHCODE(I) .EQ. 'BL' .OR. LITHCODE(I) .EQ. 'Bl'  .OR.
     1      LITHCODE(I) .EQ. 'bl') THEN
            CALL LITHBLANK(I,NANNOT,ZTOPCOL,ZBOTCOL)
         END IF
  300    CONTINUE
C
C        LEFT MARGIN FOR FOLLOWING GRAPHIC ROUTINE
C
      YSTART = YSTART + 1.0
  900 YSP2=YSTART
      IF (IREFL .EQ. 1) THEN
         IF (IFSC .EQ. 1  .OR.  IFSC .EQ. 3) YLEFT = YLEFT + 1.0
         IF (IFSC .EQ. 0  .OR.  IFSC .EQ. 2) YSP2= YSP2 + 0.2
      END IF
      RETURN
 9000 FORMAT(15X,I5)
 9001 FORMAT(F10.0,3X,A2,4X,A1)
      END
C***********************************************************************
C
C**            CONVERTION OF PAPER UNITS IN THE CROSS SECTION
C              DEPTH IN THE LOG
C
C***********************************************************************
C
      REAL*4 FUNCTION PP2DEPTH(PAPER, TOPZ)
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
C
      PP2DEPTH = TOPZ + VSCALE*(PAPER - XTOP)
      RETURN
      END
      SUBROUTINE NEWTRACR(I,K,*)
C
C           MARKER VALUES PROVIDED BY THE USER.  THE NEW VALUES
C           ARE EQUIVALENT TO PROVIDE A NEW STARTING ELEVATION FOR
C           THE TRACING IN WELLS TO THE RIGHT OF THE STARTING
C           TRACING WELL.
C
C              I:  MARKER SEQUENTIAL NUMBER
C              K:  SEQUENTIAL NUMBER FOR PAIR OF CORRELATED WELLS
C
C********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /MATCH/  MATCH
C            ELEVATION OF A PERSISTANT CORRELATION AT EACH WELL.
             REAL*4 MATCH(21)
      COMMON /TWCCOE/ TWCCOE
C            TEMPORARY STORAGE FOR WEIGHTED CORRELATION COEFFICIENTS.
             REAL*4 TWCCOE(20)
      COMMON /MENUPP/ MENU
             CHARACTER*4 MENU
      COMMON /STEPOUT/ SODEPTH,SOPAIR,SOMARKER
             REAL*4 SODEPTH(LOG_LENGTH)
             INTEGER*4 SOPAIR(LOG_LENGTH)
             INTEGER*4 SOMARKER(LOG_LENGTH)
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
C            NUMBER OF ELEVATION TO TRACE ACROSS.
             INTEGER*4 NETRA
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            CORRELATION MATRIX COLUMN FOR TRACE STARTING.
             INTEGER*4 CTT
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
C
      IF ( .NOT.(MENU .EQ. 'TRAC'  .OR.  MENU .EQ. 'LIT2')) GO TO 900
C
      IF (NSTT .EQ. 0) GO TO 900
      DO 100 J = 1, NSTT
      IF ( K  .EQ. SOPAIR(J)  .AND. I  .EQ. SOMARKER(J) ) THEN
          MATCH(K+1) = SODEPTH(J)
          TWCCOE(K) = 3.0
          RETURN 1
      END IF
  100 CONTINUE
  900 RETURN
      END
C***********************************************************************
C
C              READS IN ELEVATIONS TO TRACE ACROSS FOR THE PURPOSE
C              TO PREPARE A FALSE COLOR LITHOLOGY CROSS SECTION.
C
C***********************************************************************
C
      SUBROUTINE REACOLITH(LINE, *)
C
      INCLUDE 'log.inc'
      INCLUDE 'lithcolor.inc'
C
      CHARACTER*2 LITYPE(LOG_LENGTH)
      CHARACTER*4 BOMU
      CHARACTER*68 TXTMES
C
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /FILCOLITH/ FILCOLITH
      CHARACTER*40 FILCOLITH
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
C            NUMBER OF ELEVATION TO TRACE ACROSS.
             INTEGER*4 NETRA
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            CORRELATION MATRIX COLUMN FOR TRACE STARTING.
             INTEGER*4 CTT
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
      COMMON /RELETA/ ETRA
C            ELEVATIONS TO TRACE ACROSS.
             REAL*4 ETRA(LOG_LENGTH)
      COMMON /MARPEN/ MARPEN
C            PEN NUMBER.
             INTEGER*4 MARPEN(LOG_LENGTH)
      COMMON /MARTXT/ MARTXT
C            REMARKS ABOUT THE MARKER.
             CHARACTER*10 MARTXT(LOG_LENGTH)
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /STEPOUT/ SODEPTH,SOPAIR,SOMARKER
             REAL*4 SODEPTH(LOG_LENGTH)
             INTEGER*4 SOPAIR(LOG_LENGTH)
             INTEGER*4 SOMARKER(LOG_LENGTH)
      COMMON /PENSH/ PENSH
              INTEGER*4 PENSH
      COMMON /DATMFF/ DATUMF
             INTEGER*2 DATUMF
      COMMON /ZSLDEE/ ZSHAL,ZDEEP
      COMMON /INT4PP/ NPAIRS,WSNUMB(21),CPNUMB(20)
             INTEGER WSNUMB,CPNUMB
C
      IFLAG = 0
      CALL CHKOTY(68,FILCOLITH,0,31,10,LINE+2,IERMAR)
      IF ( IERMAR .NE. 0 ) RETURN 1
      READ (68,9000,REC=1) HEMA,SNSW,NETRA,NSTT
      PENSH = LITHFCOL(9)
      CALL FINDTR(LINE,SNSW,CTT,*850)
      DO 100 I = 1,NETRA
      K = I
      READ(68,9002,REC=K+1) ETRA(K),LITYPE(K),MARTXT(K)
  100 CONTINUE
      IF (DATUMF .EQ. 1) THEN
         IF (ZSHAL .LT. ETRA(1) ) CALL WRONGTOP(ETRA(1),LINE,IFLAG)
       ELSE
         DO 150 I = 1,NPAIRS+1
         IF (SNSW .EQ. WSNUMB(I) ) THEN
            IWELL = I
            GO TO 160         
         END IF
  150    CONTINUE
  160    CALL TOPBOT(IWELL,TOPXS,BOTXS)
         IF (TOPXS .LT. ETRA(1) ) CALL WRONGTOP(ETRA(1),LINE,IFLAG)
      END IF
      IF (NSTT .EQ. 0) GO TO 300
      DO 200 I = 1,NSTT
      K = 2 + NETRA + I
      READ(68,9003,REC=K) SODEPTH(I),SOPAIR(I),SOMARKER(I)
  200 CONTINUE
  300 CLOSE(68,STATUS='KEEP')
      IF ( NETRA .LE. 1 ) GO TO 500
      DO 400 I = 2,NETRA
      IF( ETRA(I) .GE. ETRA(I-1) ) GO TO 400
         CALL TXTCLR(ICOLOR(6))
         WRITE (TXTMES,9001) ETRA(I),ETRA(I-1),BOMU(BOM)
         CALL GTEXTS(15,LINE+2,
     1       '***** MARKERS TO TRACE ACROSS NOT IN ASCENDING')
         CALL GTEXTS(21,LINE+3,TXTMES)
         IFLAG = 1
  400 CONTINUE
  500 DO 700 K = 1,NETRA
      DO 600 I = 1,NLITOP
      IF (LITYPE(K) .EQ.  LITOPTION(I)) THEN
         MARPEN(K) = LITHFCOL(I)
         GO TO 700
      END IF
  600 CONTINUE
      CALL GTEXTS(15,LINE+2,
     1       '***** UNKNOWN LITHOLOGY: '//LITYPE(K))
      IFLAG = 1
      LINE = LINE + 1
  700 CONTINUE
      IF ( IFLAG .EQ. 1 ) THEN
         CALL SCHOLD
         RETURN 1
      END IF
      GO TO 900
  850 RETURN 1
  900 RETURN
 9000 FORMAT (A4,11X,3I5)
 9001 FORMAT ('ORDER BY DEPTH. ',F8.2,' AFTER ',F8.2,' ',A4,'.')
 9002 FORMAT (F10.2,3X,A2,5X,A10)
 9003 FORMAT (F10.2,2I10)
 9004 FORMAT ('START OF LITHOLOGY TABLE (',F8.1,' ',A4,').')
      END
      SUBROUTINE WRONGTOP(ETRA,LINE,IFLAG)
C***********************************************************************
C
C              PRINTING OF MESSAGE TO DENOTE THAT BEGINNING
C              OF LITHOLOGY TABLE IS NOT ENOUGH SHALLOW.
C
C***********************************************************************
C
      CHARACTER*4 BOMU
      CHARACTER*42 TXTMES
C
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
C
      IFLAG = 1
      CALL TXTCLR(ICOLOR(6))
      CALL GTEXTS(15,LINE+2,
     1          '***** TOP OF CROSS SECTION SHALLOWER THAN')
      WRITE (TXTMES,9000) ETRA,BOMU(BOM)
      CALL GTEXTS(21,LINE+3,TXTMES)
      RETURN
 9000 FORMAT ('START OF LITHOLOGY TABLE (',F8.1,' ',A4,').')
      END
