C     CORRELATOR MODULE PRYNT
C
C***********************************************************************
C
C                    PRINTING OF CORRELATION TABLE
C                       AND EFFICIENCY INDICES.
C
C***********************************************************************
C
      SUBROUTINE PRYNT(JJ,NP,NZ)
C
      INCLUDE 'log.inc'
C
C          VARIABLE DEFINITION.
C
C          BAR DIAGRAM
      CHARACTER*1 BARD(20)
C          CORRELATION LENGTH, FEET.
      REAL*4 CORLEN
C          WEIGHTED CORRELATION COEFFICIENT CUTOFF.
      REAL*4 ZCUTOF
C          TOTAL CORRELATION, FT.
      REAL*4 FCORR
C          TOTAL WEIGHTED CORRELATION, FT.
      REAL*4 FWCORR
C          CUMULATIVE CORRELATION FLAG.
      INTEGER*4 INITC
C          LINE COUNTER
      INTEGER*4 NL
C          PAGE COUNTER
      INTEGER*4 NP
C          NUMBER OF SHADED LEVELS.
      INTEGER*4 NWCCOE
C          SEARCH LENGTH, FEET.
      REAL*4 SEARLE
C          SKIPPING LENGTH, FEET.
      REAL*4 SKIP
C          STEP LENGTH, FEET.
      REAL*4 STEP
C          CROSSING CORRELATION FLAG.
      CHARACTER*1 XCFLAG
C          WEIGHTED CORRELATION COEFFICIENT
      REAL*4 WCCOE
C          REFERENCE DEPTH, FEET.
      REAL*4 Z1L
C          MATCHING DEPTH, FEET.
      REAL*4 Z2L
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
C
      COMMON /CODINC/ DINC
      COMMON /DIGS  / DIGS1,DIGS2
      COMMON /PRINTU/ IPRNTU
C
      COMMON /REAL4P/ XTOP,TTLSZ,ZLSZ,SYMSZ,WIDSZ,TKWD,HSCALE,VSCALE,
     1                DSWH,HWDIST,CSTART,CEND,PSSIZE,SHDIST
      COMMON /SHADE/ KSHADR,KSHADM
             INTEGER*2 KSHADR(LOG_LENGTH),KSHADM(LOG_LENGTH)
C
C          PARAMETERS SET UP.
C
      CALL TOPBOT(JJ,TOPZR,BOTZR)
      CORLEN=1.0E30
      ZCUTOF=1.0E30
      SEARLE=1.0E30
      SKIP=1.0E30
      STEP=1.0E30
      Z1L=-1.0E30
      INITC=0
      NL=1000
      NP=0
      CCORRF=0.0
      FCORR=0.0
      FWCORR=0.0
      NWCCOE=0
      ICSTAR=((TOPZR-DIGS1)/DINC)+1.01
      ICEND=((BOTZR-DIGS1)/DINC)+1.01
C
C          PREVIOUS READING.
C
      CALL REDCPI
      DO 200 IZ=1,NZ
      Z1P=Z1L
      STEPP=STEP
      CORLEP=CORLEN
      SEARLP=SEARLE
      CUTOFP=ZCUTOF
C
C          RETRIEVE.
C
C     READ(26,END=300) Z1L,Z2L,XCFLAG,CORLEN,SEARLE,SKIP,ZCUTOF,
C    1              WCCOE
C      Z1L=Z1(IZ)
C      Z2L=Z2(IZ)
C      XCFLAG=ZANOM(IZ)
C      CORLEN=CORIN(IZ)
C      SEARLE=SELENG(IZ)
C      SKIP  =OFFST(IZ)
C      ZCUTOF=CUTOFF(IZ)
C      WCCOE =WCC(IZ)
      CALL REDCPR(Z1L,Z2L,XCFLAG,CORLEN,SEARLE,SKIP,ZCUTOF,WCCOE)
C
C          SKIP LEVELS OUTSIDE THE INTERVAL.
C
      IF((Z1L+0.5*CORLEN).LT.TOPZR .AND. (Z2L+0.5*CORLEN).LT.TOPZR)
     1GO TO 200
      IF((Z1L-0.5*CORLEN).GT.BOTZR .AND. (Z2L-0.5*CORLEN).GT.CEND)
     1GO TO 200
C
C          PRINT HEADING.
C
      IF(NL .LT. 40) GO TO 240
      NL=0
      NP=NP+1
      CALL LTHEAD(NP)
  240 IF(INITC.NE.0) GO TO 245
C
C          START COUNTERS.
C
      IF((Z1L+0.5*CORLEN).LT.TOPZR .OR. (Z1L-0.5*CORLEN).GT.BOTZR)
     1 GO TO 260
      AXCORR=WCCOE
      NWCCOE=NWCCOE+1
      ICZ2=ANINT((Z1L-(0.5*CORLEN)-DIGS1)/DINC)
      INITC=1
      IF(ICZ2.LT.ICSTAR) ICZ2=ICSTAR-1
      IF(ICZ2.GT.ICEND) ICZ2=ICEND-1
      GO TO 260
C
C          NEW LITHOSTRATIGRAPHIC UNIT.
C
  245 IF((Z1L+0.5*CORLEN).LT.TOPZR .OR. (Z1L-0.5*CORLEN).GT.BOTZR )
     1     GO TO 250
      IF(CORLEN.EQ.CORLEP) GO TO 247
      ICZ1 = ICZ2 + 1
      AUXZ = (Z1P*CORLEN + Z1L*CORLEP)/(CORLEN + CORLEP)
      ICZ2=ANINT(((AUXZ - DIGS1)/DINC) + 1)
      IF ( ICZ2 .LT. ICSTAR) GO TO 250
      IF(ICZ2.GT.ICEND) ICZ2=ICEND
      GO TO 2485
  247 IFACT=0.5*CORLEP
      IF((Z1L-Z1P).LE.(IFACT+(0.5*CORLEN))) GO TO 249
C
C          CUMULATIVE CORRELATION.
C
      ICZ1=ICZ2+1
      ICZ2=0.5*CORLEP
      ICZ2=ANINT((Z1P-DIGS1+ICZ2)/DINC+1.0)
      IF(ICZ2.GT.ICEND) ICZ2=ICEND
 2485 DO 246 I=ICZ1,ICZ2
      if(KSHADR(I) .ne. 0) CCORRF=CCORRF+KSHADR(I)/KSHADR(I)   !!!!!
  246 CONTINUE
      IF ((Z1L - Z1P) .GT. 0.5*(CORLEN+CORLEP)) THEN
         CCORRF=DINC*(CCORRF-1.0)
      ELSE
         CCORRF=DINC*CCORRF
      END IF
      FCORR=FCORR+CCORRF
C
C          WEIGHTED CORRELATION.
C
      FWCORR=FWCORR+((CCORRF*AXCORR)/NWCCOE)
C
C          PREPARE COUNTERS FOR FOLLOWING LITHOLOGICAL UNITS.
C
      CCORRF=0.0
      AXCORR=0.0
      NWCCOE=0
C
C          ADD CORRELATION COEFFICIENTS.
C
  249 AXCORR=AXCORR+WCCOE
      NWCCOE=NWCCOE+1
C
C          SKIP A LINE FOR CHANGE OF PROCESSING PARAMETERS.
C
  250 IF(STEPP.EQ.STEP .AND. CORLEP.EQ.CORLEN .AND. SEARLP.EQ.SEARLE
     1   .AND. CUTOFP.EQ.ZCUTOF) GO TO 255
      WRITE (IPRNTU,9311)
 9311 FORMAT (' ',9X,'...')
      NL=NL+1
C
C          SKIP A LINE FOR GAP IN THE CORRELATION.
C
  255 IF((Z1L-Z1P) .LT. (1.1*DINC)) GO TO 260
      WRITE (IPRNTU,'(1X)')
      NL=NL+1
C
C          CORRELATION PRINTING.
C
  260 CALL BARPLT(WCCOE,BARD)
      WRITE (IPRNTU,9002) CORLEN,SEARLE,SKIP,ZCUTOF,
     1                    Z1L,Z2L,XCFLAG,(Z2L-Z1L),WCCOE,BARD
      NL=NL+1
  200 CONTINUE
C
C          INDICES PRINTING.
C
      IF(NWCCOE.EQ.0) GO TO 999
      IF (FCORR .EQ. 0.0) THEN
         ICZ1 = ICZ2
      ELSE
         ICZ1=ICZ2+1
      END IF
      ICZ2=ANINT((Z1L+(0.5*CORLEN)-DIGS1)/DINC+1.01)
      IF(ICZ2.GT.ICEND) ICZ2=ICEND
      DO 320 I=ICZ1,ICZ2
      if(KSHADR(I) .ne. 0) CCORRF=CCORRF+KSHADR(I)/KSHADR(I)      !!!!!
C      CCORRF=CCORRF+KSHADR(I)
  320 CONTINUE
      IF (CORLEN .GT. 0.0 )  THEN
         CCORRF=DINC*(CCORRF-1.0)
       ELSE
         CCORRF=DINC*CCORRF
      END IF
      FCORR=FCORR+CCORRF
      FWCORR=FWCORR+((CCORRF*AXCORR)/NWCCOE)
      FACTOR=DIGS1+((IL1-1)*DINC)
      IF(CEND.LT.FACTOR) FACTOR=BOTZR
      IF(FACTOR.EQ.TOPZR) FACTOR=100.0/DINC
      IF(FACTOR.NE.TOPZR) FACTOR=100.0/(FACTOR-AMAX1(DIGS1,TOPZR))
      PFCOR=FACTOR*FCORR
      PFWCOR=FACTOR*FWCORR
      WRITE (IPRNTU,9003) FCORR,PFCOR,FWCORR,PFWCOR,(FWCORR/FCORR)
  999 RETURN
 9002 FORMAT(08X,F6.1,1X,F7.1,1X,F7.1,F6.3,2X,2(F7.1,1X),
     1        A1,F7.1,1X,F5.3,1X,20A1)
 9003 FORMAT(///,15X,'CORRELATION ON REFERENCE WELL            : ',F7.1,
     1       ' FEET OR ',F7.1,' % ',/,
     2           15X,'WEIGHTED CORRELATION ON REFERENCE WELL   : ',F7.1,
     3       ' FEET OR ',F7.1,' % ',/,
     2           15X,'AVERAGE WEIGHTED CORRELATION COEFFICIENT : ',F9.3)
      END
C***********************************************************************
C
C                   PRINTS LISTING HEADING.
C
C***********************************************************************
C
      SUBROUTINE LTHEAD(NP)
C
      COMMON /PRINTU/ IPRNTU
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      COMMON /BOML/BOML
             CHARACTER*4 BOML
C
      WRITE (IPRNTU,9000) NP,ID1,NAME1,ID2,NAME2,FYLES,
     1                   DATUM,DATUM1,DATUM2,
     2                   IDSHAR,IDCORR,IDSHAM,IDCORM,
     3                   BOML,BOML,BOML,BOML,BOML,BOML
      RETURN
 9000 FORMAT('1',/,75X,'PAGE ',I2,//,
     X       24X,'PROCESSING PARAMETERS AND CORRELATION RESULTS FOR',/,
     1       24X,'*************************************************',/,
     2       18X,'WELLS ',I2,' (',1A20,') AND ',I2,' (',1A20,')',/,
     3       18X,61('*'),//,
     4       38X,'WELL DATA FILE: ',A40/
     3       29X,'DATUM: ',A15,'(',F7.1,';',F7.1,')',/,
     4       33X,'REFERENCE LOGS',8X,A4,' - ',A4,/,
     5       33X,'MATCHING LOGS',9X,A4,' - ',A4,///,
     6       16X,' BASIC INFORMATION',
     7       22X,' FINAL RESULTS',//,
     8       09X,'CORREL ','SEARCH ','SEARCH ',
     9           'DISPLAY',2X,'REFER.',1X,' MATCH',4X,
     1           ' DIF.',5X,'WEIGHTED CORREL.',/,
     1       09X,'LENGTH ','LENGTH ','OFFSET ',
     2           ' CUTOFF',2X,'DEPTH ',1X,' DEPTH',4X,
     3           'DEPTH',5X,'  COEFFICIENT     ',/,
     4       10X,A4,3X,A4,3X,A4,11X,A4,5X,A4,5X,A4,/,
     5       09X,28('='),1X,51('='),/)
      END
