C     CORRELATOR MODULE SORTIN
C
C***********************************************************************
C
C                     SORTS A CORRELATION SET INTO INCREASING
C                     ORDER OF THE REFERENCE DEPTH.
C
C***********************************************************************
C
      SUBROUTINE SORTIN
C
      INCLUDE 'log.inc'
C
      INTEGER*4 SUBS(LOG_LENGTH)
      CHARACTER*2 OPTION
      LOGICAL DUPFLG
      LOGICAL GOFLAG,LOADCI
      CHARACTER*70 MESG
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
      COMMON /COLOPT/ ICOLOR(6)
C
      COMMON /CHARH/FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
C
      COMMON /LSTCIX/ LASTCI
C
      include 'corrdb.inc'
      include 'wldhdr.inc'
      include 'wldwel.inc'
C
      LOADCI = .TRUE.
      GOFLAG = .FALSE.
C
      CALL FINDCP(0,ID1,ID2)
      IF (NCPWEL .LT. 1) LASTCI=0
      IF (LASTCI .GT. NCPWEL) LASTCI=0
      IF ((LASTCI .EQ. 0) .AND. (NCPWEL .GT. 0)) LASTCI=1
      IF (NCPWEL .EQ. 1) LASTCI=1
      ICP=LASTCI
      IF (ICP .GT. 0) CALL RCPHDR(ICPWEL(ICP))
C
C        MENU.
C
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'SORT CORRELATION INTERPRETATION')
      LINE=2
C
      CALL TXTCLR(ICOLOR(5))
      WRITE (MESG,3001) ID1,NAME1
      CALL GTEXTS(5,LINE+2,MESG)
      WRITE (MESG,3002) ID2,NAME2
      CALL GTEXTS(5,LINE+3,MESG)
      LINE=LINE+3
 3001 FORMAT ('REFERENCE WELL (',I5,'): ',A20)
 3002 FORMAT ('MATCHING WELL  (',I5,'): ',A20)
      IF (NCPWEL .GT. 0) THEN
         WRITE (MESG,3003) ICP,CPTITL
         CALL GTEXTS(5,LINE+1,MESG)
         LINE=LINE+1
 3003    FORMAT ('INTERPRETATION (',I1,'): ',A40)
         IF (NNNNCP .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+1,
     1           '***** NO CORRELATIONS IN SELECTED INTERPRETAION.')
            LINE=LINE+1
            GOFLAG=.FALSE.
            LOADCI=.FALSE.
           ENDIF
         IF (LOADCI) THEN
            GOFLAG=.FALSE.
C
C           READ IN CORRELATIONS.
            CALL RDELCO(NZ)
            LOADCI=.FALSE.
            GOFLAG=.TRUE.
            ZMINC=ZMINCP
            ZMAXC=ZMAXCP
            CSTART=ZMINC
            CEND  =ZMAXC
           ENDIF
        ELSE
          CALL TXTCLR(ICOLOR(6))
          CALL GTEXTS(5,LINE+1,
     1         '***** NO CORRELATION INTERPRETATIONS FOR WELL PAIR')
          LINE=LINE+1
          GOFLAG=.FALSE.
          LOADCI=.FALSE.
        ENDIF
C
      CALL TXTCLR(ICOLOR(3))
      IF (NCPWEL .GT. 1) THEN
         CALL GTEXTS( 3,LINE+2,'CI - SELECT CORRELATION SET')
         CALL MARROW(75,LINE+2)
         LINE=LINE+2
        ENDIF
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
      LINE=LINE+2
      IF (GOFLAG) THEN
         CALL GTEXTS( 3,LINE+1,
     1               'GO - SORT THE CORRELATION INTERPRETATION')
         LINE = LINE + 1
        ENDIF
C
      LINE=LINE+2
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF (GOFLAG .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'CI' .AND. NCPWEL .GT. 1) THEN
         ICPSAV=ICP
         CALL SELTCP(ICP)
         IF (ICP .NE. ICPSAV) THEN
            LOADCI=.TRUE.
            GOFLAG=.FALSE.
           ENDIF
         GO TO 11
        ENDIF
      GO TO 15
C
C          READ IN CORRELATION.
C
   51 DUPFLG=.FALSE.
      IF (NNNNCP .LT. 1) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1     '***** NO CORRELATIONS FOR SELECTED WELL PAIR.')
         CALL SCHOLD
         GO TO 11
        ENDIF
      IF (ISORTF .GT. 0) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,'***** CORRELATIONS ALREADY SORTED.')
         CALL SCHOLD
         GO TO 11
        ENDIF
      IF (NZ .LT. 2) GO TO 11
      DO 101 I=1,NZ
      SUBS(I)=I
  101 CONTINUE
C          SORT
      CALL SNGLX(Z1,SUBS,1,NZ)
C          WRITE IN HEADING.
      CALL WRTCPI(0)
      DO 111 J=1,NZ
      I = SUBS(J)
C          CHECK ALL DEPTH FLAGS STARTING AT THE SECOND CORRELATION
      IF ( J .GE. 2 ) THEN
         IF ( Z1(I) .EQ. Z1ABOV ) THEN
            IF ( .NOT. DUPFLG ) THEN
               CALL TXTCLR(ICOLOR(6))
               CALL GTEXTS(10,LINE+6,
     1  '***** WARNING.  DUPLICATED REFERENCE ELEVATIONS.  TAKE')
               CALL GTEXTS(20,LINE+7,
     1  ' CORRECTIVE ACTION TO AVOID FURTHER FATAL ERRORS.')
               CALL GTEXTS(20,LINE+8,
     1  'THE DUPLICATIONS OCCUR AT THE FOLLOWING ELEVATIONS:')
               DUPFLG = .TRUE.
               LEFTJU = 16
            END IF
            CALL GTXTRL(LEFTJU,LINE+10,Z1(I),2)
            IF ( LEFTJU .LE. 56 ) THEN
               LEFTJU = LEFTJU + 10
             ELSE
               LEFTJU = 16
               LINE = LINE + 1
            END IF
         END IF
         IF ( Z2(I) .LT. Z2ABOV ) ZANOM(I) = 'X'
         IF ( Z2(I) .EQ. Z2ABOV ) ZANOM(I) = 'E'
         IF ( Z2(I) .GT. Z2ABOV ) ZANOM(I) = ' '
      END IF
C          WRITE CORRELATIONS.
      CALL WRTCPR(Z1(I),Z2(I),ZANOM(I),CORIN(I),
     1          SELENG(I),OFFST(I),CUTOFF(I),WCC(I))
      Z1ABOV = Z1(I)
      Z2ABOV = Z2(I)
  111 CONTINUE
      IF ( DUPFLG ) CALL SCHOLD
      ISORTF=1
      CALL WRTCPL
      CALL RPSORT(ID1,ID2,NZ)
      GO TO 11
      END
C***********************************************************************
C
C                   REPORT ON OPTION 'SO'.
C
C***********************************************************************
C
      SUBROUTINE RPSORT(ID1,ID2,NZ)
C
       COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
              INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CALL ANMODE
      WRITE (QTEKOT,2001) ID1,ID2
 2001 FORMAT (///,25X,'CORRELATION INTERPRETATION SORTING',/,
     1            25X,'**********************************',///,
     2             8X,'REFERENCE WELL     ',I5,/,
     3             8X,'MATCHING WELL      ',I5,/)
      WRITE (QTEKOT,2002) NZ
 2002 FORMAT (8X,'NUMBER OF CORRELATIONS ',I5,//)
      CALL RETKEY
      RETURN
      END
C***********************************************************************
C
C               THIS ROUTINE IS REPUTED TO BE AN IMPROVEMENT ON BOTH
C               THE QUICKSORT AND THE QUICKERSORT ROUTINES DESIGNED
C               TO SORT AN ARRAY OF ELEMENTS INTO INCEASING ORDER.
C               MODIFIED FROM :
C                  SINGLETON, R. C., AN EFFICIENT ALGORITHM FOR SORTING
C                         WITH MINIMAL STORAGE: COMMUNICATIONS OF THE
C                         ACM, VOL. 12, NO. 3, PP. 185-187.
C
C***********************************************************************
C
        SUBROUTINE SNGLX(AA,SUBS,TOPTOP,BOTBOT)
C
      INCLUDE 'log.inc'
C
        DIMENSION AA(LOG_LENGTH)
        INTEGER SUBS(LOG_LENGTH)
C
        INTEGER*4 UPPER(18),LOWER(18),TOPTOP,BOTBOT,MIDDLE,LEVEL
        INTEGER*4 TOP,BOT,SWAPA,MIDA
C
        LEVEL=1
        TOP=TOPTOP
        BOT=BOTBOT
5       IF(TOP.GE.BOT)GOTO 70
C
C               OK, THERE ARE SOME VALUES TO BE SORTED...
C               FIND THE MIDDLE VALUE, AND IF THE TOP VALUE IS LARGER
C               THEN SWITCH THE TOP AND MIDDLE VALUES.
C
10      K=TOP
        MIDDLE=(TOP+BOT)/2
        MIDA=SUBS(MIDDLE)
        IF(AA(SUBS(TOP)).LE.AA(MIDA))GOTO 20
        SUBS(MIDDLE)=SUBS(TOP)
        SUBS(TOP)=MIDA
        MIDA=SUBS(MIDDLE)
C       WRITE(*,*)'..SWITCH TOP AND MIDVAL..'
C
C               COMPARE THE BOTTOM WITH THE MIDDLE, SWAPPING
C               THE TWO WHEN THE BOTTOM IS LESS THAN THE MIDDLE..
C
20      L=BOT
        IF(AA(SUBS(BOT)).GE.AA(MIDA))GOTO 40
        SUBS(MIDDLE)=SUBS(BOT)
        SUBS(BOT)=MIDA
        MIDA=SUBS(MIDDLE)
C       WRITE(*,*)'..SWITCHED BOT AND MIDDLE..'
C
C               AND THEN THE TOP WITH THE MIDDLE..
C
        IF(AA(SUBS(TOP)).LE.AA(MIDA))GOTO 40
        SUBS(MIDDLE)=SUBS(TOP)
        SUBS(TOP)=MIDA
        MIDA=SUBS(MIDDLE)
C       WRITE(*,*)'..SECOND SWITCH OF TOP AND MIDDLE..'
        GOTO 40
C
C               SWAP THE 2 VALUES FOUND BELOW: I.E. THE FIRST VALUE FROM
C               THE BOTTOM WHICH IS NOT GREATER THAN THE MIDDLE, AND THE
C               FIRST FROM THE TOP NOT LESS THAN THE MIDDLE.
C
30      SUBS(L)=SUBS(K)
        SUBS(K)=SWAPA
C       WRITE(*,*)'..SWAPPED 1ST FROM BOTTOM WITH 1ST FROM TOP..'
C
C               FIND THE FIRST VALUE FROM THE BOTTOM WHICH IS
C               NOT GREATER THAN THE CURRENT MIDDLE VALUE.
C
40      L=L-1
           IF(AA(SUBS(L)).GT.AA(MIDA))GOTO 40
C
C               AND SAVE THIS VALUE IN SWAP
C
        SWAPA=SUBS(L)
C
C               THEN FIND THE FIRST VALUE FROM THE TOP WHICH IS
C               NOT LESS THAN THE CURRENT MIDDLE VALUE.
C
50      K=K+1
           IF(AA(SUBS(K)).LT.AA(MIDA))GOTO 50
C       WRITE(*,*)'..1ST FROM TOP AND BOTTOM NOW FOUND..'
C
C               IF BOTH FOUND WITHOUT CROSSING, GO SWAP.
C
        IF(K.LE.L)GOTO 30
C
C               NOW, ONE OF THE SEGMENTS MUST BE SAVED WHILE THE
C               OTHER ONE IS BEING SORTED.  SAVE THE POINTERS TO
C               THE LARGER SEGMENT FOR LATER SORTING.
C
        IF(L-TOP.LE.BOT-K)GOTO 60
C
C               SAVE THE TOP FOR LATER.
C
C       WRITE(*,*) 'LEVEL=',LEVEL
        LOWER(LEVEL)=TOP
        UPPER(LEVEL)=L
        TOP=K
        LEVEL=LEVEL+1
C       WRITE(*,*)'..TOP SEGMENT SAVED, LEVEL = ',LEVEL
        GOTO 80
C
C               SAVE THE BOTTOM FOR LATER.
C
60      LOWER(LEVEL)=K
        UPPER(LEVEL)=BOT
        BOT=L
        LEVEL=LEVEL+1
C       WRITE(*,*)'..BOTTOM SEGMENT SAVED, LEVEL = ',LEVEL
        GOTO 80
C
C               HERE FOR POPPING A LEVEL TO A SAVED SEGMENT.
C
70      LEVEL=LEVEL-1
        IF(LEVEL.EQ.0)RETURN
        TOP=LOWER(LEVEL)
        BOT=UPPER(LEVEL)
C       WRITE(*,*)'..POPPED TO LEVEL = ',LEVEL
C
C               IF AT LEAST 12 ELEMENTS GO TO PARTITION THEM.
C
80      IF(BOT-TOP.GT.10)GOTO 10
        IF(TOP.EQ.TOPTOP)GOTO 5
        TOP=TOP-1
C
C               FIND THE FIRST OUT-OF-ORDER ELEMENT.
C
90      TOP=TOP+1
        IF(TOP.GE.BOT)GOTO 70
        MIDA=SUBS(TOP+1)
        IF(AA(SUBS(TOP)).LE.AA(MIDA))GOTO 90
C
C               NOW RE-ORDER THE (HERETOFORE) DISORDERLY PAIR.
C
        K=TOP
100     SUBS(K+1)=SUBS(K)
        K=K-1
C       WRITE(*,*)'..DISORDERLY VALUE REMOVED..'
C
C               CONTINUE SHIFTING IF NEXT ONE IS OUT-OF-ORDER AS WELL.
C
        IF(AA(MIDA).LT.AA(SUBS(K)))GOTO 100
C
C               NOW INSERT THE VALUE TAKEN OUT.
C
        SUBS(K+1)=MIDA
C       WRITE(*,*)'..DISORDERLY VALUE RE-INSERTED..'
        GOTO 90
        END
C***********************************************************************
C
C                     DELETES RECORDS FROM CORRELATION FILES.
C
C***********************************************************************
C
      SUBROUTINE DELETC
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 OPTION
      CHARACTER*4 BOMU
      CHARACTER*50 TITL
      LOGICAL ERROR, ZOUT
      LOGICAL GOFLAG,LOADCI
      CHARACTER*70 MESG
C
      COMMON /CHARH/FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
C
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
C
      COMMON /LSTCIX/ LASTCI
C
      include 'corrdb.inc'
      include 'wldhdr.inc'
      include 'wldwel.inc'
C
      CSTART= -1.0
      CEND  = -1.0
C
   10 NC = 0
      LOADCI = .TRUE.
      GOFLAG = .FALSE.
C
      CALL FINDCP(0,ID1,ID2)
      IF (NCPWEL .LT. 1) LASTCI=0
      IF (LASTCI .GT. NCPWEL) LASTCI=0
      IF ((LASTCI .EQ. 0) .AND. (NCPWEL .GT. 0)) LASTCI=1
      IF (NCPWEL .EQ. 1) LASTCI=1
      ICP=LASTCI
      IF (ICP .GT. 0) CALL RCPHDR(ICPWEL(ICP))
C
C        MENU.
C
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'DELETE CORRELATIONS FROM INTERVAL')
      LINE=2
C
      CALL TXTCLR(ICOLOR(5))
      WRITE (MESG,3001) ID1,NAME1
      CALL GTEXTS(5,LINE+2,MESG)
      WRITE (MESG,3002) ID2,NAME2
      CALL GTEXTS(5,LINE+3,MESG)
      LINE=LINE+3
 3001 FORMAT ('REFERENCE WELL (',I5,'): ',A20)
 3002 FORMAT ('MATCHING WELL  (',I5,'): ',A20)
      IF (NCPWEL .GT. 0) THEN
         WRITE (MESG,3003) ICP,CPTITL
         CALL GTEXTS(5,LINE+1,MESG)
         LINE=LINE+1
 3003    FORMAT ('INTERPRETATION (',I1,'): ',A40)
         IF (NNNNCP .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+1,
     1           '***** NO CORRELATIONS IN SELECTED INTERPRETAION.')
            LINE=LINE+1
            GOFLAG=.FALSE.
            LOADCI=.FALSE.
           ENDIF
         IF (LOADCI) THEN
            GOFLAG=.FALSE.
C
C           READ IN CORRELATIONS.
            CALL RDELCO(NZ)
            LOADCI=.FALSE.
            GOFLAG=.TRUE.
            ZMINC=ZMINCP
            ZMAXC=ZMAXCP
           ENDIF
        ELSE
          CALL TXTCLR(ICOLOR(6))
          CALL GTEXTS(5,LINE+1,
     1         '***** NO CORRELATION INTERPRETATIONS FOR WELL PAIR')
          LINE=LINE+1
          GOFLAG=.FALSE.
          LOADCI=.FALSE.
        ENDIF
C
      IF (GOFLAG) THEN
         CALL TXTCLR(ICOLOR(5))
         CALL GTEXTS( 7,LINE+2,'MINIMUM CORRELATION DEPTH,')
         CALL GTEXTS( 34,LINE+2,BOMU(BOM))
         CALL GTXTRL(75,LINE+2,ZMINCP,2)
         CALL GTEXTS( 7,LINE+3,'MAXIMUM CORRELATION DEPTH,')
         CALL GTEXTS( 34,LINE+3,BOMU(BOM))
         CALL GTXTRL(75,LINE+3,ZMAXCP,2)
         LINE = LINE + 3
        ENDIF
C
      CALL TXTCLR(ICOLOR(3))
      IF (NCPWEL .GT. 1) THEN
         CALL GTEXTS( 3,LINE+2,'CI - SELECT CORRELATION INTERPRETATION')
         CALL MARROW(75,LINE+2)
         LINE=LINE+2
        ENDIF
C
      CALL GTEXTS( 3,LINE+2,'ND - TOP OF INTERVAL TO BE DELETED,')
      CALL GTEXTS(39,LINE+2,BOMU(BOM))
      CALL GTXTRL(75,LINE+2,CSTART,2)
      CALL GTEXTS( 3,LINE+3,'XD - BOTTOM OF INTERVAL TO BE DELETED,')
      CALL GTEXTS(42,LINE+3,BOMU(BOM))
      CALL GTXTRL(75,LINE+3,CEND,2)
      LINE = LINE + 3
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO FILE MANAGEMENT MENU')
      LINE=LINE+2
      IF (GOFLAG) THEN
         CALL GTEXTS( 3,LINE+1,'GO - DELETE CORRELATIONS FROM INTERVAL')
         LINE = LINE + 1
        ENDIF
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF (GOFLAG .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'CI' .AND. NCPWEL .GT. 1) THEN
         ICPSAV=ICP
         CALL SELTCP(ICP)
         IF (ICP .NE. ICPSAV) THEN
            LOADCI=.TRUE.
            GOFLAG=.FALSE.
           ENDIF
         GO TO 11
        ENDIF
C
      IF (OPTION .EQ. 'ND') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) CSTART = TEMP
        END IF
      IF (OPTION .EQ. 'XD') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) CEND = TEMP
        END IF
      GO TO 15
C
   51 IF ( CSTART .GT. CEND ) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1       '***** STARTING DEPTH DEEPER THEN ENDING.')
         CALL SCHOLD
         GO TO 11
        END IF
      IF ( CSTART .GT. ZMAXCP  .OR.  CEND .LT. ZMINCP ) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1     '***** CORRELATION INTERVAL OUTSIDE INTERVAL TO DELETE.')
         CALL SCHOLD
         GO TO 11
        END IF
C
C          READ IN CORRELATION.
C
      IF (NNNNCP .LT. 1) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1     '***** NO CORRELATIONS FOR SELECTED WELL PAIR.')
         CALL SCHOLD
         GO TO 11
        ENDIF
      NC=0
      DO 200 I=1,NZ
        IF ((Z1(I) .GE. CSTART) .AND. (Z1(I) .LE. CEND)) NC=NC+1
  200 CONTINUE
C
  111 CALL TXTCLR(ICOLOR(6))
      IF (NC .GT. 1) THEN
         WRITE(TITL,9000) NC
 9000    FORMAT('*****',I5,' CORRELATIONS WILL BE DISCARDED' )
       ELSE IF (NC .EQ. 1) THEN
         WRITE(TITL,9001) NC
 9001    FORMAT('*****',I5,' CORRELATION WILL BE DISCARDED' )
       ELSE
         CALL SCHOLD
         GO TO 11
      ENDIF
      CALL GTEXTS(10,LINE+4,TITL)
      IF (NC .GT. 1) THEN
         CALL GTEXTS(16,LINE+6,'RE -- STOP DELETION OF SUCH '//
     1     'CORRELATIONS')
         CALL GTEXTS(16,LINE+7,
     1                   'GO -- PROCEED WITH THE DELETIONS AS PLANNED')
       ELSE
         CALL GTEXTS(16,LINE+6,'RE -- STOP DELETION OF SUCH '//
     1      'CORRELATION')
         CALL GTEXTS(16,LINE+7,
     1                    'GO -- PROCEED WITH THE DELETION AS PLANNED')
      END IF
      CALL GTEXTS(18,LINE+9,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(48,LINE+9)
  151 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 111
C
      IF (OPTION .EQ. 'RE') GO TO 11
      IF (OPTION .EQ. 'GO') GO TO 61
      GO TO 151
   61 NC = 0
      CALL WRTCPI(0)
      DO 300 I=1,NZ
C        MODIFY DEPTH FLAG FOR FIRST CORRELATION AFTER LAST DELETION
      IF (Z1(I) .LT. CSTART  .OR.  Z1(I) .GT. CEND) THEN
         IF( ZOUT ) THEN
            IF ( Z1(I) .GE. Z1ABOV ) THEN
               IF ( Z2(I) .LT. Z2ABOV ) ZANOM(I) = 'X'
               IF ( Z2(I) .EQ. Z2ABOV ) ZANOM(I) = 'E'
               IF ( Z2(I) .GT. Z2ABOV ) ZANOM(I) = ' '
            END IF
         END IF
C           KEEP CORRELATIONS OUTSIDE DELETION INTERVAL
         CALL WRTCPR(Z1(I),Z2(I),ZANOM(I),CORIN(I),
     1               SELENG(I),OFFST(I),CUTOFF(I),WCC(I))
         Z1ABOV=Z1(I)
         Z2ABOV=Z2(I)
         ZOUT = .FALSE.
        ELSE
         NC = NC + 1
         ZOUT = .TRUE.
      END IF
  300 CONTINUE
      CALL WRTCPL
      CALL OPDELE(ID1,ID2,CSTART,CEND,NC)
      GO TO 10
      END
C***********************************************************************
C
C                   REPORT ON CORRELATION DELETION.
C
C***********************************************************************
C
      SUBROUTINE OPDELE(ID1,ID2,CSTART,CEND,NC)
C
      CHARACTER*4 BOMU
C
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CALL ANMODE
      WRITE(QTEKOT,2000) ID1,ID2,BOMU(BOM),CSTART,BOMU(BOM),CEND,NC
 2000 FORMAT(///25X,'CORRELATION DELETION',/,
     1          25X,'********************',///,
     2           8X,'REFERENCE WELL     ',I5,/,
     3           8X,'MATCHING WELL      ',I5,/,
     4           8X,'TOP FOR DELETION, ',A4,8X,F8.2,/,
     5           8X,'BOTTOM FOR DELETION, ',A4,5X,F8.2,/,
     6           8X,'CORRELATTIONS DISCARDED',11X,I4,//)
      CALL RETKEY
      RETURN
      END
C***********************************************************************
C
C              LISTS CORRELATION TO SCREEN.
C
C***********************************************************************
C
      SUBROUTINE PRYNTC
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 OPTION
      CHARACTER*1 BAR(20)
      CHARACTER*4 BOMU
      LOGICAL ERROR
      COMMON /DRIFTSP/ SPPR, SPPM
      INTEGER*4 SPPR,SPPM
      REAL*8 WCCC,C(20)
      LOGICAL GOFLAG,LOADCI
      CHARACTER*70 MESG
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /CHARH/ FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
C
      COMMON /LSTCIX/ LASTCI
C
      include 'welldb.inc'
      include 'wldhdr.inc'
      include 'wldwel.inc'
      include 'corrdb.inc'
C
      CSTART = -1.0
      CEND   = -1.0
      LOADCI = .TRUE.
      GOFLAG = .FALSE.
C
      CALL FINDCP(0,ID1,ID2)
      IF (NCPWEL .LT. 1) LASTCI=0
      IF (LASTCI .GT. NCPWEL) LASTCI=0
      IF ((LASTCI .EQ. 0) .AND. (NCPWEL .GT. 0)) LASTCI=1
      IF (NCPWEL .EQ. 1) LASTCI=1
      ICP=LASTCI
      IF (ICP .GT. 0) CALL RCPHDR(ICPWEL(ICP))
C
C        MENU.
C
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'WINDOW LIST A CORRELATION INTERPRETATION')
      LINE=2
C
      CALL TXTCLR(ICOLOR(5))
      WRITE (MESG,3001) ID1,NAME1
      CALL GTEXTS(5,LINE+2,MESG)
      WRITE (MESG,3002) ID2,NAME2
      CALL GTEXTS(5,LINE+3,MESG)
      LINE=LINE+3
 3001 FORMAT ('REFERENCE WELL (',I2,'): ',A20)
 3002 FORMAT ('MATCHING WELL  (',I2,'): ',A20)
      IF (NCPWEL .GT. 0) THEN
         WRITE (MESG,3003) ICP,CPTITL
         CALL GTEXTS(5,LINE+1,MESG)
         LINE=LINE+1
 3003    FORMAT ('INTERPRETATION (',I1,'): ',A40)
         IF (NNNNCP .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+1,
     1           '***** NO CORRELATIONS IN SELECTED INTERPRETAION.')
            LINE=LINE+1
            GOFLAG=.FALSE.
            LOADCI=.FALSE.
           ENDIF
         IF (LOADCI) THEN
            GOFLAG=.FALSE.
C
C           READ IN CORRELATIONS.
            CALL RDELCO(NZ)
            LOADCI=.FALSE.
            GOFLAG=.TRUE.
            CSTART=ZMINCP
            CEND  =ZMAXCP
           ENDIF
        ELSE
          CALL TXTCLR(ICOLOR(6))
          CALL GTEXTS(5,LINE+1,
     1         '***** NO CORRELATION INTERPRETATIONS FOR WELL PAIR')
          LINE=LINE+1
          GOFLAG=.FALSE.
          LOADCI=.FALSE.
        ENDIF
C
      IF (GOFLAG) THEN
         CALL TXTCLR(ICOLOR(5))
         CALL GTEXTS( 7,LINE+2,'MINIMUM CORRELATION DEPTH,')
         CALL GTEXTS( 34,LINE+2,BOMU(BOM))
         CALL GTXTRL(75,LINE+2,ZMINCP,2)
         CALL GTEXTS( 7,LINE+3,'MAXIMUM CORRELATION DEPTH,')
         CALL GTEXTS( 34,LINE+3,BOMU(BOM))
         CALL GTXTRL(75,LINE+3,ZMAXCP,2)
         LINE = LINE + 3
        END IF
C
      CALL TXTCLR(ICOLOR(3))
      IF (NCPWEL .GT. 1) THEN
         CALL GTEXTS( 3,LINE+2,'CI - SELECT CORRELATION INTERPRETATION')
         CALL MARROW(75,LINE+2)
         LINE=LINE+2
        ENDIF
C
      IF (GOFLAG) THEN
         CALL GTEXTS( 3,LINE+2,'ND - MINIMUM DEPTH TO DISPLAY,')
         CALL GTEXTS(34,LINE+2,BOMU(BOM))
         CALL GTXTRL(75,LINE+2,CSTART,2)
         CALL GTEXTS( 3,LINE+3,'XD - MAXIMUM DEPTH TO DISPLAY,')
         CALL GTEXTS(34,LINE+3,BOMU(BOM))
         CALL GTXTRL(75,LINE+3,CEND,2)
         LINE = LINE + 3
        END IF

      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO CORRELATION DISPLAY MENU')
      LINE=LINE+2
      IF (GOFLAG) THEN
         CALL GTEXTS( 3,LINE+1,'GO - LIST THE INTERPRETATION')
         LINE = LINE + 1
        ENDIF
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF (GOFLAG .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'CI' .AND. NCPWEL .GT. 1) THEN
         ICPSAV=ICP
         CALL SELTCP(ICP)
         IF (ICP .NE. ICPSAV) THEN
            LOADCI=.TRUE.
            GOFLAG=.FALSE.
           ENDIF
         GO TO 11
        ENDIF
C
      IF (OPTION .EQ. 'ND') THEN
            CALL AGETRL(TEMP,ERROR)
            IF (.NOT. ERROR) CSTART = TEMP
        END IF
      IF (OPTION .EQ. 'XD') THEN
            CALL AGETRL(TEMP,ERROR)
            IF (.NOT. ERROR) CEND = TEMP
        END IF
      GO TO 15
C
   51 IF ( CSTART .GT. CEND ) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1       '***** STARTING DEPTH DEEPER THEN ENDING.')
         CALL SCHOLD
         GO TO 11
        END IF
      IF ( CSTART .GT. ZMAXCP  .OR.  CEND .LT. ZMINCP ) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1     '***** CORRELATION INTERVAL OUTSIDE INTERVAL TO DISPLAY.')
         CALL SCHOLD
         GO TO 11
        END IF
C
      IF (NZ .LT. 1) GO TO 11
C
C          LIST HEADING.
C
      CALL ANMODE
      WRITE (QTEKOT,9000) FYLES
      WRITE (QTEKOT,9001) DATUM,BOM,SCLSHL,SCLCOL
      WRITE (QTEKOT,9002)
     1      NAME1,ID1,PSYMB1,DATUM1,IDSHAR,LOG3,SPPR,IDCORR,LOG1
      WRITE (QTEKOT,9002)
     1      NAME2,ID2,PSYMB2,DATUM2,IDSHAM,LOG4,SPPM,IDCORM,LOG2
      WRITE (QTEKOT,9003) DINC
      WRITE (QTEKOT,9004) ID1,ID2,CPDIST,NREGCP,ISORTF,
     1                  ZMINCP,ZMAXCP
      IF ( NREGCP .GE. 1 ) THEN
         IRN=NRGPTR
         DO 533 J = 1,NREGCP
         READ (25,REC=IRN  ) NEXT,IREGN,CSTARR,CENDR,RCUTOF,
     1                       RMIN,RMAX,WCCC,C
         IRN=NEXT
         WRITE (QTEKOT,9005) IREGN,CSTARR,CENDR,RCUTOF,RMIN,RMAX,WCCC
         NT=IREGN+1
         DO 532 ICS=1,NT,5
         ICE=ICS+4
         IF (ICE .GT. NT) ICE=NT
         WRITE (QTEKOT,9006) (C(IC),IC=ICS,ICE)
  532    CONTINUE
  533    CONTINUE
       END IF
C          LIST CORRELATIONS.
      DO 200 I=1,NZ
      IF (Z1(I) .GE. CSTART  .AND.  Z1(I) .LE. CEND) THEN
         CALL BARPLT(WCC(I),BAR)
         WRITE (QTEKOT,9007) Z1(I),Z2(I),ZANOM(I),CORIN(I),
     1                      SELENG(I),OFFST(I),CUTOFF(I),WCC(I),BAR
        END IF
  200 CONTINUE
  220 CALL RETKEY
      GO TO 11
 9000 FORMAT (' ',A40)
 9001 FORMAT (' ',A15,32X,3(1X,A1))
 9002 FORMAT (' ',A20,2I3,F7.1,1X,A4,I3,I4,1X,A4,I3)
 9003 FORMAT (' ',F10.2,/)
 9004 FORMAT (' ',2(1X,I4),1X,F10.2,2(1X,I4),2(1X,F10.2))
 9005 FORMAT (' ',I4,2(1X,F10.2),1X,F6.3,2(1X,F10.2),1X,F6.3)
 9006 FORMAT (' ',4(G14.7,1X),G14.7)
 9007 FORMAT (' ',2(F8.2,1X),A1,3(1X,F7.1),2(1X,F6.3),1X,20A1)
      END
C***********************************************************************
C
C                    PREPARES BAR OF A BAR DIAGRAM
C                    FOR WEIGHTED CROSS-CORRELATION VALUES.
C
C***********************************************************************
C
      SUBROUTINE BARPLT(WCC,BAR)
C
      CHARACTER*1 BAR(20)
      REAL*4 CUTOFF /0.8/
C
      DO 100 I = 1,20
  100 BAR(I) = ' '
      IEND = ANINT(20.0*((WCC - CUTOFF)/(1.0 - CUTOFF)))
      IF ( IEND .GT. 0 ) THEN
         DO 200 I = 1,IEND
  200    BAR(I) = '*'
       END IF
      RETURN
      END
C***********************************************************************
C
C              COPIES A CORRELATION INTO A PRINTING FILE
C
C***********************************************************************
C
      SUBROUTINE PRYNTP
C
      INCLUDE 'log.inc'
C
      CHARACTER*2 OPTION
      CHARACTER*1 BAR(20)
      CHARACTER*4 BOMU,BOML
      LOGICAL ERROR
      LOGICAL GOFLAG,LOADCI
      CHARACTER*70 MESG
C
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /LABELS/ IDSHAR,IDCORR,IDSHAM,IDCORM
             CHARACTER*4 IDSHAR,IDCORR,IDSHAM,IDCORM
      COMMON /CHARH/ FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /CODINC/ DINC
      COMMON /FILE/ Z1,Z2,CORIN,SELENG,OFFST,CUTOFF,WCC
             REAL*4 Z1(LOG_LENGTH),Z2(LOG_LENGTH),
     X              CORIN(LOG_LENGTH),SELENG(LOG_LENGTH)
             REAL*4 OFFST(LOG_LENGTH),CUTOFF(LOG_LENGTH),
     X              WCC(LOG_LENGTH)
      COMMON /CHARF/ ZANOM
             CHARACTER*1 ZANOM(LOG_LENGTH)
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /PRINTU/ IPRNTU
C
      COMMON /LSTCIX/ LASTCI
C
      include 'welldb.inc'
      include 'wldhdr.inc'
      include 'wldwel.inc'
      include 'corrdb.inc'
C
      CSTART = -1.0
      CEND   = -1.0
      LOADCI = .TRUE.
      GOFLAG = .FALSE.
C
      CALL FINDCP(0,ID1,ID2)
      IF (NCPWEL .LT. 1) LASTCI=0
      IF (LASTCI .GT. NCPWEL) LASTCI=0
      IF ((LASTCI .EQ. 0) .AND. (NCPWEL .GT. 0)) LASTCI=1
      IF (NCPWEL .EQ. 1) LASTCI=1
      ICP=LASTCI
      IF (ICP .GT. 0) CALL RCPHDR(ICPWEL(ICP))
C
C        MENU.
C
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,
     1     'COPY CORRELATION INTERPRETATION INTO A PRINTING FILE')
      LINE=2
C
      CALL TXTCLR(ICOLOR(5))
      WRITE (MESG,3001) ID1,NAME1
      CALL GTEXTS(5,LINE+2,MESG)
      WRITE (MESG,3002) ID2,NAME2
      CALL GTEXTS(5,LINE+3,MESG)
      LINE=LINE+3
 3001 FORMAT ('REFERENCE WELL (',I2,'): ',A20)
 3002 FORMAT ('MATCHING WELL  (',I2,'): ',A20)
      IF (NCPWEL .GT. 0) THEN
         WRITE (MESG,3003) ICP,CPTITL
         CALL GTEXTS(5,LINE+1,MESG)
         LINE=LINE+1
 3003    FORMAT ('INTERPRETATION (',I1,'): ',A40)
         IF (NNNNCP .LT. 1) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+1,
     1           '***** NO CORRELATIONS IN SELECTED INTERPRETAION.')
            LINE=LINE+1
            GOFLAG=.FALSE.
            LOADCI=.FALSE.
           ENDIF
         IF (LOADCI) THEN
            GOFLAG=.FALSE.
C
C           READ IN CORRELATIONS.
            CALL RDELCO(NZ)
            LOADCI=.FALSE.
            GOFLAG=.TRUE.
            CSTART=ZMINCP
            CEND  =ZMAXCP
           ENDIF
        ELSE
          CALL TXTCLR(ICOLOR(6))
          CALL GTEXTS(5,LINE+1,
     1         '***** NO CORRELATION INTERPRETATIONS FOR WELL PAIR')
          LINE=LINE+1
          GOFLAG=.FALSE.
          LOADCI=.FALSE.
        ENDIF
C
      IF (GOFLAG) THEN
         CALL GTEXTS( 7,LINE+2,'MINIMUM CORRELATION DEPTH,')
         CALL GTEXTS(34,LINE+2,BOMU(BOM))
         CALL GTXTRL(75,LINE+2,ZMINCP,2)
         CALL GTEXTS( 7,LINE+3,'MAXIMUM CORRELATION DEPTH,')
         CALL GTEXTS(34,LINE+3,BOMU(BOM))
         CALL GTXTRL(75,LINE+3,ZMAXCP,2)
         LINE = LINE + 3
        ENDIF
C
      CALL TXTCLR(ICOLOR(3))
      IF (NCPWEL .GT. 1) THEN
         CALL GTEXTS( 3,LINE+2,'CI - SELECT CORRELATION INTERPRETATION')
         CALL MARROW(75,LINE+2)
         LINE=LINE+2
        ENDIF
C
      IF (GOFLAG) THEN
         CALL GTEXTS( 3,LINE+2,'ND - MINIMUM DEPTH TO DISPLAY,')
         CALL GTEXTS(34,LINE+2,BOMU(BOM))
         CALL GTXTRL(75,LINE+2,CSTART,2)
         CALL GTEXTS( 3,LINE+3,'XD - MAXIMUM DEPTH TO DISPLAY,')
         CALL GTEXTS(34,LINE+3,BOMU(BOM))
         CALL GTXTRL(75,LINE+3,CEND,2)
         LINE = LINE + 3
        ENDIF
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO CORRELATION DISPLAY MENU')
      LINE=LINE+2
      IF (GOFLAG) THEN
         CALL GTEXTS( 3,LINE+1,'GO - LIST THE INTERPRETATION')
         LINE = LINE + 1
        ENDIF
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE+2,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE+2)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      IF (GOFLAG .AND. (OPTION .EQ. 'GO')) GO TO 51

C
      IF (OPTION .EQ. 'CI' .AND. NCPWEL .GT. 1) THEN
         ICPSAV=ICP
         CALL SELTCP(ICP)
         IF (ICP .NE. ICPSAV) THEN
            LOADCI=.TRUE.
            GOFLAG=.FALSE.
           ENDIF
         GO TO 11
        ENDIF
C
      IF (OPTION .EQ. 'ND') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) CSTART = TEMP
        END IF
      IF (OPTION .EQ. 'XD') THEN
         CALL AGETRL(TEMP,ERROR)
         IF (.NOT. ERROR) CEND = TEMP
        END IF
      GO TO 15
C
   51 IF ( CSTART .GT. CEND ) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1       '***** STARTING DEPTH DEEPER THEN ENDING.')
         CALL SCHOLD
         GO TO 11
        END IF
      IF ( CSTART .GT. ZMAXCP  .OR.  CEND .LT. ZMINCP ) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,LINE+6,
     1     '***** CORRELATION INTERVAL OUTSIDE INTERVAL TO DISPLAY.')
         CALL SCHOLD
         GO TO 11
        END IF
C
      IF (NZ .LT. 1) GO TO 11
C
      NL=1000
      NP=0
      Z1P=Z1(1)
      CORLEP=CORIN(1)
      SEARLP=SELENG(1)
      CUTOFP=CUTOFF(1)
      BOML=BOMU(BOM)
      DO 200 I=1,NZ
      IF (Z1(I) .LT. CSTART  .OR.  Z1(I) .GT. CEND) GO TO 200
C
C          PRINT HEADING.
C
      IF (NL .GT. 40) THEN
         NL=0
         NP=NP+1
      WRITE (IPRNTU,9000) NP,ID1,NAME1,ID2,NAME2,DATUM,DATUM1,DATUM2,
     2                   IDSHAR,IDCORR,IDSHAM,IDCORM,
     3                   BOML,BOML,BOML,BOML,BOML,BOML
 9000 FORMAT('1',/,75X,'PAGE ',I2,//,
     X    23X,' PROCESSING PARAMETERS AND CORRELATION RESULTS FOR',/,
     1    23X,' *************************************************',/,
     2    17X,' WELLS ',I2,' (',A20,') AND ',I2,' (',A20,')',/,
     3    18X,61('*'),//,
     3    29X,'DATUM: ',A15,'(',F7.1,';',F7.1,')',/,
     4    33X,'REFERENCE LOGS',8X,A4,' - ',A4,/,
     5    33X,'MATCHING LOGS',9X,A4,' - ',A4,///,
     6    16X,' BASIC INFORMATION',
     7    22X,' FINAL RESULTS',//,
     8     9X,'CORREL ','SEARCH ','SEARCH ',
     9        'DISPLAY',2X,'REFER.',1X,' MATCH',4X,
     1        ' DIF.',5X,'WEIGHTED CORREL.',/,
     1     9X,'LENGTH LENGTH OFFSET ',
     2        ' CUTOFF',2X,'DEPTH ',1X,' DEPTH',4X,
     3        'DEPTH',5X,'  COEFFICIENT     ',/,
     4    10X,A4,3X,A4,3X,A4,11X,A4,5X,A4,5X,A4,/,
     5     9X,28(1H=),1X,51(1H=),/)
        ENDIF
C
C          SKIP A LINE FOR GAP IN THE CORRELATION.
C
      IF ((Z1(I)-Z1P) .GE. (1.1*DINC)) THEN
         WRITE (IPRNTU,'(1X)')
         NL=NL+1
        ENDIF
C
C          SKIP A LINE FOR CHANGE OF PROCESSING PARAMETERS.
C
      IF (CORLEP.EQ.CORIN(I) .AND. SEARLP.EQ.SELENG(I)
     1   .AND. CUTOFP.EQ.CUTOFF(I)) GO TO 260
      WRITE (IPRNTU, 9300)
 9300 FORMAT(' ',9X,'...',/,1X)
      NL=NL+1
C
C          CORRELATION PRINTING.
C
  260 CALL BARPLT(WCC(I),BAR)
      WRITE (IPRNTU,9002) CORIN(I),SELENG(I),OFFST(I),CUTOFF(I),
     1            Z1(I),Z2(I),ZANOM(I),(Z2(I)-Z1(I)),WCC(I),BAR
      NL=NL+1
      Z1P=Z1(I)
      CORLEP=CORIN(I)
      SEARLP=SELENG(I)
      CUTOFP=CUTOFF(I)
  200 CONTINUE
      CALL RPPRTP(ID1,ID2)
      GO TO 11
 9002 FORMAT (8X,F6.1,1X,F7.1,1X,F6.1,1X,F6.3,2X,2(F7.1,1X),
     1        1A1,F7.1,1X,F5.3,1X,20A1)
      END
C***********************************************************************
C
C                   REPORT ON OPTION 'LC'.
C
C***********************************************************************
C
      SUBROUTINE RPPRTP(ID1,ID2)
C
      COMMON /PRINTC/ FYLEPR
             CHARACTER*40 FYLEPR
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CALL ANMODE
      WRITE(QTEKOT,2000) ID1,ID2,FYLEPR
 2000 FORMAT(///,
     1  25X,'COPY CORRELATION INTERPRETATION INTO A PRINTING FILE',/,
     1  25X,'****************************************************',///,
     2           8X,'REFERENCE WELL ID             ',I5,/,
     3           8X,'MATCHING WELL ID              ',I5,//,
     4           8X,'FILE CONTAINING THE LISTING   ',A40//)
      CALL RETKEY
      RETURN
      END
