C     CORRELATOR MODULE T4510
C
C**********************************************************************
C**
C**         ROUTINES TO SUPPORT 4510A RASTERIZER
C**         INITIALIZE 4510A
C**
C**********************************************************************
C
      SUBROUTINE X4510A
C
      COMMON /T4510A/ MXBUFR,IRPTR,MXLINE,NCOPYR,ICOPYR,ICOPYE
C
        INTEGER CCMAP(32)
        DATA CCMAP/7,0,65,100,
     ~             8,0,100,0,
     ~             6,60,40,100,
     ~             5,140,60,100,
     ~             4,180,50,80,
     ~             3,240,50,100,
     ~             2,340,50,100,
     ~             1,300,50,100/
C
      MXBUFR=140                                        ! klp 7/27/90
      IRPTR=0
      MXLINE=0
      ICOPYE=0
         CALL T45CHR(CHAR(27))
         CALL T45CHR(CHAR(12))
         CALL T45CHR(CHAR(29))
C        CALL SET_VIEWPORT(0,0,4095,3071)
         CALL T45CMD('RV')
         CALL T45XY (0,0)
         CALL T45XY (4095,3071)
         CALL T45PLT
C        CALL SET_WINDOW(0,0,4095,3071)
         CALL T45CMD('RW')
         CALL T45XY (0,0)
         CALL T45XY(4095,3071)
C        CALL SET_SURFACE_DEFINITIONS(ISURFS,2)
         CALL T45CMD('RD')
         CALL T45INT (2)
         CALL T45INT (3)
         CALL T45INT (1)
C        CALL SET_SURFACE_PRIORITIES(ISURFP,4)
         CALL T45CMD('RN')
         CALL T45INT (4)
         CALL T45INT (1)
         CALL T45INT (2)
         CALL T45INT (2)
         CALL T45INT (1)
         CALL T45PLT
C
C************************************************************
C**
C**             SET SURFACE 1 COLORMAP FOR
C**             CODING OF CORRELATION QUALITY
C**             USING THE HLS COORDINATE SYSTEM.
C**
C************************************************************
C
C       SET COLOR MODE
         CALL T45CMD('TM')
         CALL T45INT (3)
         CALL T45INT (1)
         CALL T45INT (1)
C       CALL SET_SURFACE_COLOR_MAP(1,CCMAP,32)
         CALL T45CMD('TG')
         CALL T45INT (1)
         CALL T45INT (32)
         DO 111 I=1,32
         CALL T45INT (CCMAP(I))
  111    CONTINUE
         CALL T45PLT
C
C        CALL SET_LINE_INDEX(1)
         CALL T45CMD('ML')
         CALL T45INT (1)
         IF (IRPTR  .GT. MXBUFR) CALL T45PLT
C        CALL SET_GRAPHTEXT_PRECISION(2)
         CALL T45CMD('MQ')
         CALL T45INT (2)
C        CALL SET_GRAPHTEXT_SIZE(25,30,8)
         CALL T45CMD('MC')
         CALL T45INT (25)
         CALL T45INT (30)
         CALL T45INT ( 8)
C        CALL SET_TEXT_INDEX(1)
         CALL T45CMD('MT')
         CALL T45INT (1)
      RETURN
      END
C**********************************************************************
C**
C**         DUMP RASTERIZER BUFFER
C**
C**********************************************************************
C
      SUBROUTINE T45PLT
C
      INCLUDE 'log.inc'
C
      COMMON /T4510A/ MXBUFR,IRPTR,MXLINE,NCOPYR,ICOPYR,ICOPYE
      COMMON /T4510B/ BUFF
      CHARACTER*225  BUFF
      COMMON /T4510C/ RBUFF
      CHARACTER*225 RBUFF(LOG_LENGTH)
      COMMON /T4510D/ LBUFF(LOG_LENGTH)
C
      IF (IRPTR .LE. MXBUFR) RETURN
      IF (IRPTR .LE. 0) RETURN
      MXLINE=MXLINE+1
      LBUFF(MXLINE)=IRPTR
      RBUFF(MXLINE)=BUFF
      IRPTR=0
      RETURN
      END
C**********************************************************************
C**
C**         PUT 4510 COMMANDS INTO OUTPUT BUFFER
C**
C**********************************************************************
C
      SUBROUTINE T45CMD(COM)
C
      CHARACTER*(*) COM
C
      COMMON /T4510A/ MXBUFR,IRPTR,MXLINE,NCOPYR,ICOPYR,ICOPYE
      COMMON /T4510B/ BUFF
      CHARACTER*225  BUFF
C
      IRPTR =IRPTR +1
      BUFF(IRPTR :IRPTR )=CHAR(27)
      IRPTR =IRPTR +1
      BUFF(IRPTR :IRPTR )=COM(1:1)
      IRPTR =IRPTR +1
      BUFF(IRPTR :IRPTR )=COM(2:2)
      RETURN
      END
C**********************************************************************
C**
C**         PUT SINGLE ASCII CHARACTER INTO OUTPUT BUFFER
C**
C**********************************************************************
C
      SUBROUTINE T45CHR(CCC)
C
      CHARACTER*(1) CCC
C
      COMMON /T4510A/ MXBUFR,IRPTR,MXLINE,NCOPYR,ICOPYR,ICOPYE
      COMMON /T4510B/ BUFF
      CHARACTER*225  BUFF
C
      IRPTR =IRPTR +1
      BUFF(IRPTR :IRPTR )=CCC
      RETURN
      END
C**********************************************************************
C**
C**         PUT INT PARAMETER INTO OUTPUT BUFFER
C**
C**********************************************************************
C
      SUBROUTINE T45INT(INTQ)
C
      COMMON /T4510A/ MXBUFR,IRPTR,MXLINE,NCOPYR,ICOPYR,ICOPYE
      COMMON /T4510B/ BUFF
      CHARACTER*225  BUFF
C
      INTX=IABS(INTQ)
      IF (INTQ .GE. 0) THEN
         LADJ=48
        ELSE
         LADJ=32
        ENDIF
C
      IH1=INTX/1024
      IH2=MOD(INTX/16,64)
      LOW=MOD(INTX,16)
      IF (IH1 .GT. 0) THEN
         IRPTR =IRPTR +1
         BUFF(IRPTR :IRPTR )=CHAR(IH1+64)
        ENDIF
      IF ((IH1 .GT. 0) .OR. (IH2 .GT. 0)) THEN
         IRPTR =IRPTR +1
         BUFF(IRPTR :IRPTR )=CHAR(IH2+64)
        ENDIF
      IRPTR =IRPTR +1
      BUFF(IRPTR :IRPTR )=CHAR(LOW+LADJ)
      RETURN
      END
C**********************************************************************
C**
C**         PUT X,Y PARAMETER INTO OUTPUT BUFFER
C**
C**********************************************************************
C
      SUBROUTINE T45XY (IX,IY)
C
      COMMON /T4510A/ MXBUFR,IRPTR,MXLINE,NCOPYR,ICOPYR,ICOPYE
      COMMON /T4510B/ BUFF
      CHARACTER*225  BUFF
C
         IHY=IY/128
         ILY=MOD(IY/4,32)
         IEX=MOD(IY,4)*4+MOD(IX,4)
         IHX=IX/128
         ILX=MOD(IX/4,32)
         IRPTR =IRPTR +1
         BUFF(IRPTR :IRPTR )=CHAR(IHY+32)
         IRPTR =IRPTR +1
         BUFF(IRPTR :IRPTR )=CHAR(IEX+96)
         IRPTR =IRPTR +1
         BUFF(IRPTR :IRPTR )=CHAR(ILY+96)
         IRPTR =IRPTR +1
         BUFF(IRPTR :IRPTR )=CHAR(IHX+32)
         IRPTR =IRPTR +1
         BUFF(IRPTR :IRPTR )=CHAR(ILX+64)
      RETURN
      END
C
C**********************************************************************
C**
C**         ROUTINES TO SUPPORT 4510A RASTERIZER
C**         MAKE HARDCOPY
C**
C**********************************************************************
C
      SUBROUTINE HARDCP
C
      INCLUDE 'log.inc'
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT
      COMMON /T4510A/ MXBUFR,IRPTR,MXLINE,NCOPYR,ICOPYR,ICOPYE
      COMMON /T4510B/ BUFF
      CHARACTER*225  BUFF
      COMMON /T4510C/ RBUFF
      CHARACTER*225 RBUFF(LOG_LENGTH)
      COMMON /T4510D/ LBUFF(LOG_LENGTH)
C
      CHARACTER HNAME*12
      CHARACTER*12 TNAMES(4)
      DATA TNAMES/
     1  'TEK_200JJ2',
     2  'TEK_328',
     3  'TEK_200JJ1',
     4  'TEK_200NN'/
C
      IF (ICOPYR .LE. 0) RETURN
      IF (ICOPYE .LE. 0) THEN
         CALL T45CMD('KH')
         CALL T45INT(0)
         MXLINE=MXLINE+1
         RBUFF(MXLINE)=BUFF
         LBUFF(MXLINE)=IRPTR
         IRPTR=0
        ENDIF
       ICOPYE=0
       NCOPYR=NCOPYR+1
       HNAME='CORXXXX.T45'
       HNAME(4:4)=CHAR(NCOPYR/1000+48)
       HNAME(5:5)=CHAR(MOD(NCOPYR/100,10)+48)
       HNAME(6:6)=CHAR(MOD(NCOPYR/10 ,10)+48)
       HNAME(7:7)=CHAR(MOD(NCOPYR,    10)+48)
       CALL ANMOD2
       WRITE (QTEKOT,*)
       WRITE (QTEKOT,*) '***** MAKING HARDCOPY *****'
       WRITE (QTEKOT,*) 'HNAME = ',HNAME
       WRITE (QTEKOT,*) 'NCOPYR,ICOPYR = ',NCOPYR,ICOPYR
       WRITE (QTEKOT,*) 'MXLINE = ',MXLINE
       OPEN(61,FILE=HNAME     ,STATUS='UNKNOWN',RECL=250)
         DO 111 I=1,MXLINE
         LEN=LBUFF(I)
         WRITE (61,2202) RBUFF(I)(1:LEN)
  111    CONTINUE
 2202 FORMAT ('+',A,$)
      CLOSE(61,STATUS='KEEP')
      CALL SYSXXX('PRINT/DELETE/QUE='//TNAMES(ICOPYR)//' '//HNAME)
      CALL GRMOD2
      RETURN
      END
C**********************************************************************
C**
C**         ROUTINES TO SUPPORT 4510A RASTERIZER
C**         SELETE 4510 TO SEND HARDCOPIES TO
C**
C**********************************************************************
C
      SUBROUTINE SLHARD
C
      LOGICAL ERROR
C
      COMMON /T4510A/ MXBUFR,IRPTR,MXLINE,NCOPYR,ICOPYR,ICOPYE
C
      COMMON /COLOPT/ ICOLOR(6)
C
      CHARACTER*65 MNT(4)
      DATA MNT/
     1 '1 -- TEK_200JJ2   - ROOM 200JJ (INKJET)',
     2 '2 -- TEK_328   - ROOM 328   (INKJET)',
     3 '3 -- TEK_200JJ1 - ROOM 200JJ (THERMAL WAX)',
     4 '4 -- TEK_200NN - ROOM 200NN (THERMAL WAX)'/
      CHARACTER MENUS*2
C
      ICOPYR = 0
    1 CALL MNMODE
      CALL TXTCLR(ICOLOR(5))
      CALL GTEXTC(35,2,'SELECT 4510 HARDCOPY LOCATION')
      CALL GTEXTC(35,3,
     1     'USE CTRL/H TO MAKE A COPY OF THE SCREEN GRAPHICS')
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3, 5,'RC - ROOM CODE')
      CALL GTXTIN(75, 5,ICOPYR)
      LINE=6
      DO 111 I=1,4
      CALL GTEXTS(8,LINE,MNT(I))
      LINE=LINE+1
  111 CONTINUE
      CALL GTEXTS( 3,11,'RE - RETURN TO PREVIOUS MENU')
      CALL GTEXTS( 3,12,'GO   COMMIT THE CHANGE')
      LINE = 12
C
      CALL TXTCLR(ICOLOR(4))
      CALL TXTCUR(5,LINE+2)
      CALL GTEXTX('PLEASE ENTER YOUR SELECTIONS: ')
      CALL AINPUT(35,LINE+2)
   15 CALL AGETST(MENUS,2)
C
C         EXECUTION
C
      IF (MENUS .EQ. '  ') GO TO 1
      IF (MENUS .EQ. 'RE') RETURN
      IF (MENUS .EQ. 'GO') GO TO 51
C
      IF ( MENUS .EQ. 'RC' ) THEN
         CALL AGETIN(IVAL,ERROR)
         IF (.NOT. ERROR) ICOPYR = IVAL
      END IF
      GO TO 15
C
   51 IF ((ICOPYR .LT. 0) .OR. (ICOPYR .GT. 4)) THEN
         CALL TXTCLR(ICOLOR(6))
         CALL GTEXTS(10,16,'***** INVALID ROOM CODE')
         CALL SCHOLD
         GO TO 1
      END IF
      CALL RP4510
      GO TO 1
      END
C***********************************************************************
C
C               REPORT FOR OPTION 4510.
C
C***********************************************************************
C
      SUBROUTINE RP4510
C
      CHARACTER*40 DNAMES(4)
      DATA DNAMES/
     1 'TEK_200JJ2   - ROOM 200JJ (INKJET)',
     2 'TEK_328   - ROOM 328   (INKJET)',
     3 'TEK_200JJ1 - ROOM 200JJ (THERMAL WAX)',
     4 'TEK_200NN - ROOM 200NN (THERMAL WAX)'/
C
      COMMON /T4510A/ MXBUFR,IRPTR,MXLINE,NCOPYR,ICOPYR,ICOPYE
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CALL ANMODE
      WRITE (QTEKOT,9000)
      IF (ICOPYR .LE. 0) THEN
         WRITE (QTEKOT,9001)
       ELSE
         WRITE (QTEKOT,9002) DNAMES(ICOPYR)
      ENDIF
      CALL RETKEY
      RETURN
 9000 FORMAT (26X,'SELECT 4510 HARDCOPY LOCATION'/
     1        26X,'*****************************'//)
 9001 FORMAT( 28X,'NO 4510 LOCATION SELECTED')
 9002 FORMAT( 25X,A40)
      END
