C     CORRELATOR MODULE ULOGS
C
C***********************************************************************
C
C**   'PL', DISPLAY LOGS
C
C***********************************************************************
C
      SUBROUTINE PLLOGS(I1STIM)
C
      INCLUDE 'log.inc'
C
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /CODINC/ DINC
      COMMON /HEAD/   ID1,PSYMB1,LOG3,LOG1,DATUM1,NNCOR,
     X                ID2,PSYMB2,LOG4,LOG2,DATUM2,HDIST,
     X                DEPRMN,DEPRMX,DEPMMN,DEPMMX,
     X                SLG3MN,SLG3MX,CLG1MN,CLG1MX,
     X                SLG4MN,SLG4MX,CLG2MN,CLG2MX
             INTEGER*4 PSYMB1,PSYMB2
             REAL*4 DATUM1,DATUM2
      COMMON /CHARH/ FYLES,DATUM,NAME1,NAME2
             CHARACTER*40 FYLES
             CHARACTER*15 DATUM
             CHARACTER*20 NAME1,NAME2
      COMMON /DIGS/ DIGS1,DIGS2
      COMMON /DIGZ12/ DIGZS1,DIGZS2
      COMMON /DFOPPL/ CSTART, CEND, IDOOPT
      COMMON /DFPLA/ DOTITL
             CHARACTER*15 DOTITL(2)
      COMMON /COLOPT/ ICOLOR(6)
C
      CHARACTER*29 TITCOR/'      CORRELATION COEFFICIENT'/
      CHARACTER*7 TITCOL/'LENGTH '/
      CHARACTER*7 TITSEL/'SEARCH '/
      CHARACTER*2  OPTION,DEPOPT
      REAL ZDIGR(2),ZDIGM(2)
      LOGICAL ERROR,EFLAG
C
C        ASSORTED PARAMETERS.
C
      ZDIGR(1)=DIGZS1
      ZDIGR(2)=DIGS1
      ZDIGM(1)=DIGZS2
      ZDIGM(2)=DIGS2
      IF ( I1STIM .EQ. 0) THEN
         IDOOPT=1
         DOTITL(1)='SURFACE'
         DOTITL(2)=DATUM
         CSTART=AMIN1(ZDIGR(IDOOPT),ZDIGM(IDOOPT))
         CEND = AMAX1(SEQDEP(MAX0(IL1,IL3),ZDIGR(IDOOPT),DINC),
     1                SEQDEP(MAX0(IL2,IL4),ZDIGM(IDOOPT),DINC))
      END IF
C
      CALL GETALX(DATUM,DEPOPT)
C
C        MENU.
C
   11 CALL MNMODE
      EFLAG=.FALSE.
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'LOG PLOT MENU')
      LINE=2
      CALL STENDE(ZDIGR,ZDIGM,IDOOPT,LINE)
      CALL OPPLOT(DATUM,DEPOPT)
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,14,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,14)
   15 CALL AGETST(OPTION,2)
C
C        EXECUTION.
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
C
      I1STIM = 1
      IF ((.NOT. EFLAG) .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'DT') THEN
         CALL AGETST(OPTION,2)
         IF (OPTION .EQ. 'SU'  ) IDOOPT=1
         IF (OPTION .EQ. DEPOPT) IDOOPT=2
         CSTART=AMIN1(ZDIGR(IDOOPT),ZDIGM(IDOOPT))
         CEND = AMAX1(SEQDEP(MAX0(IL1,IL3),ZDIGR(IDOOPT),DINC),
     1                SEQDEP(MAX0(IL2,IL4),ZDIGM(IDOOPT),DINC))
         OPTION=' '
        ENDIF
      IF (OPTION .EQ. 'MN') THEN
         CALL AGETRL(CSTART,ERROR)
        ENDIF
      IF (OPTION .EQ. 'MX') THEN
         CALL AGETRL(CEND,ERROR)
        ENDIF
      GO TO 15
C
   51 CALL TXTCLR(ICOLOR(6))
      IF (ID1 .LE. 0  .OR.  ID2 .LE. 0)  THEN
         CALL GTEXTS(15,LINE+12,
     1   '***** SEQUENTIAL WELL NUMBER MUST BE LARGER THEN ZERO.')
         CALL SCHOLD
         GO TO 11
      END IF
      CMID=(CEND+CSTART)/2.0
      CLEN=(CEND-CSTART)/2.0
      CALL GRMODE
      CALL HEADIN(NAME1,ID1,NAME2,ID2,TITCOR,TITCOL,TITSEL,-1.0,-1.0)
      CALL LOGSLA(93.0)
      CALL DATLAB(ITERMQ,DOTITL(IDOOPT))
      CALL PLTSPE(RLOG3,IL3,RLOG1,IL1,ZDIGR(IDOOPT),DINC,
     1  CMID,CLEN, 1.0,PMIN3,PMAX3,PMIN1,PMAX1)
      CALL PLTSPE(RLOG4,IL4,RLOG2,IL2,ZDIGM(IDOOPT),DINC,
     1  CMID,CLEN,85.0,PMIN4,PMAX4,PMIN2,PMAX2)
      CALL PLRES(0.0,0.0,0.0,PMIN1,PMAX1,PMIN2,PMAX2,
     1           PMIN3,PMAX3,PMIN4,PMAX4,0,0,0.0,DINC)
      CALL XENPLT
      GO TO 11
      END
C***********************************************************************
C
C                  PRINTS STARTING AND ENDING DEPTHS.
C
C***********************************************************************
C
      SUBROUTINE STENDE(ZDIGR,ZDIGM,K,LINEC)
C
      INCLUDE 'log.inc'
C
      CHARACTER*4 BOMU
      CHARACTER*80 LINE
      REAL ZDIGR(2),ZDIGM(2)
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /CODINC/ DINC
      COMMON /USCAL/  BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /EXTZVA/ ZMINR,ZMAXR,ZMINM,ZMAXM
C
      ZMINR = ZDIGR(K)
      ZMAXR = SEQDEP(MAX0(IL1,IL3),ZDIGR(K),DINC)
      ZMINM = ZDIGM(K)
      ZMAXM = SEQDEP(MAX0(IL2,IL4),ZDIGM(K),DINC)
      CALL TXTCLR(ICOLOR(5))
      WRITE(LINE,2211) ZMINR,ZMAXR,BOMU(BOM)
      CALL GTEXTS( 3,LINEC+2,LINE)
      WRITE(LINE,2212) ZMINM,ZMAXM,BOMU(BOM)
      CALL GTEXTS( 3,LINEC+3,LINE)
      LINEC=LINEC+3
      RETURN
 2211 FORMAT ('DEPTH INTERVAL ON REFERENCE WELL IS ',
     1        F9.2,' TO ',F9.2, 2X,A4)
 2212 FORMAT ('DEPTH INTERVAL ON MATCHING WELL IS  ',
     1        F9.2,' TO ',F9.2,2X,A4)
      END
      SUBROUTINE OPPLOT(DATUM,DEPOPT)
C
C                   OPTIONS FOR COMMAND 'PL'.
C
C**********************************************************************
C
      CHARACTER*1   BOM,SCLSHL,SCLCOL
      CHARACTER*4 MORF
      CHARACTER*2  DEPOPT
      CHARACTER*15 DATUM
      CHARACTER*80 LINE
C
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /DFOPPL/ CSTART, CEND, IDOOPT
      COMMON /DFPLA/ DOTITL
             CHARACTER*15 DOTITL(2)
      COMMON /USCAL/   BOM,SCLSHL,SCLCOL
C
      CALL TXTCLR(ICOLOR(3))
      CALL TXTCUR(3,10)
      WRITE (LINE,2111) DEPOPT,DATUM
 2111 FORMAT ('DT - DATUM - (SU) SURFACE OR (',A2,') ',A15)
      CALL GTEXTS( 3, 7,LINE)
      CALL GTXTRJ(75, 7,DOTITL(IDOOPT))
      CALL GTEXTS( 3, 8,'MN - MINIMUM DEPTH TO DISPLAY,' // MORF(BOM))
      CALL GTXTRL(75, 8,CSTART,2)
      CALL GTEXTS( 3, 9,'MX - MAXIMUM DEPTH TO DISPLAY,' // MORF(BOM))
      CALL GTXTRL(75, 9,CEND,2)
C
      CALL GTEXTS( 3,11,'RE - RETURN TO PREVIOUS MENU')
      CALL GTEXTS( 3,12,'GO - PLOT LOGS')
C
      IF (CSTART .GT. CEND) THEN
         CALL TXTCLR(ICOLOR(2))
         CALL GTEXTS( 3,24,
     1              'DISPLAY STARTING DEPTH GREATER THAN ENDING DEPTH')
        ENDIF
      RETURN
      END
      CHARACTER*4 FUNCTION MORF(BOM)
C
C                 SETS UNIT OF LENGTH.
C
      CHARACTER*1   BOM
C
      IF ( BOM .EQ. 'M') THEN
         MORF = '  M '
         ELSE
         MORF = 'FEET'
      END IF
      RETURN
      END
C***********************************************************************
C
C**   STANDARDIZE LOGS
C
C***********************************************************************
C
      SUBROUTINE STLOGS(I1STIM)
C      
      INCLUDE 'log.inc'
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /CODINC/ DINC
      COMMON /DIGS/ DIGS1,DIGS2
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /LN1LN2/ LINE1,LINE2
C
      CHARACTER*3 STATUS(2)
      CHARACTER*2 OPTION,ANS
      REAL WSTART(4),WEND(4),DSTART(4),DEND(4)
      CHARACTER*80 LINE1
      CHARACTER*80 LINE2
      CHARACTER*18 TITLE1 /'MEAN              '/
      CHARACTER*18 TITLE2 /'STANDARD DEVIATION'/
      LOGICAL ERROR
      DATA STATUS/'YES',' NO'/
C
      IRSOPT=1
      IRCOPT=1
      IMSOPT=1
      IMCOPT=1
C
      WSTART(1)=DIGS1
      WSTART(2)=DIGS2
      WSTART(3)=DIGS1
      WSTART(4)=DIGS2
      WEND  (1)=DIGS1+FLOAT(IL1-1)*DINC
      WEND  (2)=DIGS2+FLOAT(IL2-1)*DINC
      WEND  (3)=DIGS1+FLOAT(IL3-1)*DINC
      WEND  (4)=DIGS2+FLOAT(IL4-1)*DINC
      DO 101 I=1,4
      DSTART(I)=WSTART(I)
      DEND  (I)=WEND  (I)
  101 CONTINUE
C
   11 CALL MNMODE
      LINE1 = TITLE1
      LINE2 = TITLE2
      ERROR=.FALSE.
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'STANDARDIZE WELL LOG VALUES')
      CALL TXTCLR(ICOLOR(3))
C
C...  REFERENCE SHALE LOG
C
      CALL GTEXTS( 3,4,'RS - STANDARDIZE REFERENCE SHALE LOG')
      CALL GTXTRJ(75,4,STATUS(IRSOPT))
      CALL GTEXTS( 3,5,
     1     'S2 - STARTING DEPTH FOR REFERENCE SHALE LOG')
      CALL GTXTRL(75,5,DSTART(3),2)
      CALL GTEXTS( 3,6,
     1     'E2 - ENDING DEPTH FOR REFERENCE SHALE LOG')
      CALL GTXTRL(75,6,DEND(3),2)
      IF ((IRSOPT .EQ. 1) .AND. (DSTART(3) .GE. DEND(3))) ERROR=.TRUE.
C
C...  REFERENCE CORRELATION LOG
C
      CALL GTEXTS( 3,8,'RC - STANDARDIZE REFERENCE CORRELATION LOG')
      CALL GTXTRJ(75,8,STATUS(IRCOPT))
      CALL GTEXTS( 3,9,
     1     'S1 - STARTING DEPTH FOR REFERENCE CORRELATION LOG')
      CALL GTXTRL(75,9,DSTART(1),2)
      CALL GTEXTS( 3,10,
     1    'E1 - ENDING DEPTH FOR REFERENCE CORRELATION LOG')
      CALL GTXTRL(75,10,DEND(1),2)
      IF ((IRCOPT .EQ. 1) .AND. (DSTART(1) .GE. DEND(1))) ERROR=.TRUE.
C
C...  MATCHING SHALE LOG
C
      CALL GTEXTS( 3,12,'MS - STANDARDIZE MATCHING SHALE LOG')
      CALL GTXTRJ(75,12,STATUS(IMSOPT))
      CALL GTEXTS( 3,13,'S4 - STARTING DEPTH FOR MATCHING SHALE LOG')
      CALL GTXTRL(75,13,DSTART(4),2)
      CALL GTEXTS( 3,14,'E4 - ENDING DEPTH FOR MATCHING SHALE LOG')
      CALL GTXTRL(75,14,DEND(4),2)
      IF ((IMSOPT .EQ. 1) .AND. (DSTART(4) .GE. DEND(4))) ERROR=.TRUE.
C
C...  MATCHING CORRELATION LOG
C
      CALL GTEXTS( 3,16,
     1     'MC - STANDARDIZE MATCHING CORRELATION LOG')
      CALL GTXTRJ(75,16,STATUS(IMCOPT))
      CALL GTEXTS( 3,17,
     1     'S3 - STARTING DEPTH FOR MATCHING CORRELATION LOG')
      CALL GTXTRL(75,17,DSTART(2),2)
      CALL GTEXTS( 3,18,
     1     'E3 - ENDING DEPTH FOR MATCHING CORRELATION LOG')
      CALL GTXTRL(75,18,DEND(2),2)
      IF ((IMCOPT .EQ. 1) .AND. (DSTART(2) .GE. DEND(2))) ERROR=.TRUE.
C
      CALL GTEXTS( 3,20,'RE - RETURN TO PREVIOUS MENU')
      CALL GTEXTS( 3,21,'GO - STANDARDIZE LOGS')
C
      NEXTL=23
      IF (ERROR) THEN
         CALL TXTCLR(ICOLOR(2))
         CALL TXTCUR(2,NEXTL)
         CALL GTEXTX('STARTING DEPTH GREATER THAN ENDING DEPTH')
         NEXTL=NEXTL + 1
      ENDIF
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,NEXTL,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,NEXTL)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
      ITEST=IRSOPT+IRCOPT+IMSOPT+IMCOPT
      IF (ERROR) ITEST=10
      IF ((ITEST .LT. 8 ) .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'RS') THEN
         CALL AGETST(ANS,2)
         IF (ANS .EQ. 'YE') IRSOPT=1
         IF (ANS .EQ. 'NO') IRSOPT=2
        ENDIF
      IF (OPTION .EQ. 'RC') THEN
         CALL AGETST(ANS,2)
         IF (ANS .EQ. 'YE') IRCOPT=1
         IF (ANS .EQ. 'NO') IRCOPT=2
        ENDIF
      IF (OPTION .EQ. 'MS') THEN
         CALL AGETST(ANS,2)
         IF (ANS .EQ. 'YE') IMSOPT=1
         IF (ANS .EQ. 'NO') IMSOPT=2
        ENDIF
      IF (OPTION .EQ. 'MC') THEN
         CALL AGETST(ANS,2)
         IF (ANS .EQ. 'YE') IMCOPT=1
         IF (ANS .EQ. 'NO') IMCOPT=2
        ENDIF
      IF (OPTION(1:1) .EQ. 'S') THEN
         ICC=ICHAR(OPTION(2:2))-48
         IF ((ICC .GE. 1) .AND. (ICC .LE. 4)) THEN
            CALL AGETRL(TEMP,ERROR)
            IF (.NOT. ERROR) THEN
               IF ((TEMP .GE. WSTART(ICC)) .AND. (TEMP .LE. WEND(ICC)))
     1             DSTART(ICC)=TEMP
              ENDIF
           ENDIF
         ENDIF
      IF (OPTION(1:1) .EQ. 'E') THEN
         ICC=ICHAR(OPTION(2:2))-48
         IF ((ICC .GE. 1) .AND. (ICC .LE. 4)) THEN
            CALL AGETRL(TEMP,ERROR)
            IF (.NOT. ERROR) THEN
               IF ((TEMP .GE. WSTART(ICC)) .AND. (TEMP .LE. WEND(ICC)))
     1             DEND  (ICC)=TEMP
              ENDIF
           ENDIF
        ENDIF
      GO TO 15
   51 I1STIM = 1
      IF (IRSOPT .EQ. 1) CALL STANDR(RLOG3,IL3,DIGS1,1,DINC,
     1                   DSTART(3),DEND(3))
      IF (IRCOPT .EQ. 1) CALL STANDR(RLOG1,IL1,DIGS1,2,DINC,
     1                   DSTART(1),DEND(1))
      IF (IMSOPT .EQ. 1) CALL STANDR(RLOG4,IL4,DIGS2,3,DINC,
     1                   DSTART(4),DEND(4))
      IF (IMCOPT .EQ. 1) CALL STANDR(RLOG2,IL2,DIGS2,4,DINC,
     1                   DSTART(2),DEND(2))
      CALL ANMODE
      WRITE(QTEKOT,9001)
 9001 FORMAT(///32X,'PARAMETERS BEFORE THE STANDARDIZATION'/
     1          32X,'*************************************'//
     2       26X,'REFERENCE WELL LOGS           MATCHING WELL LOGS'/
     3 20X,'      SHALE      CORRELATION        SHALE      CORRELATION'/
     4 20X,4(' --------------')/)
      WRITE(QTEKOT,9002) LINE1
      WRITE(QTEKOT,9002) LINE2
 9002 FORMAT(1X,A80)
      CALL RETKEY
      RETURN
      END
C***********************************************************************
C
C          SUBTRACTS THE MEAN AND SCALES BY THE STANDARD DEVIATION.
C
C***********************************************************************
C
      SUBROUTINE STANDR(RLOG,IL,DIGS,K,DINC,DS,DE)
C
      INCLUDE 'log.inc'
C
      REAL*4 RLOG(LOG_LENGTH)
      CHARACTER*15 BUFF
      CHARACTER*80 LINE1,LINE2
      COMMON /LN1LN2/ LINE1,LINE2
C
      ILS=(DS-DIGS)/DINC+1.01
      ILE=(DE-DIGS)/DINC+1.01
      IF (ILE .GT. IL) ILE=IL
      SX=0.0
      SXX=0.0
      DO 727 I=ILS,ILE
      X=RLOG(I)
      SX=SX+X
      SXX=SXX+X*X
  727 CONTINUE
      ILD=ILE-ILS+1
      RM=SX/FLOAT(ILD)
      RS=SQRT((SXX-SX*SX/FLOAT(ILD))/FLOAT(ILD-1))
C
      IPCOL=19+(K - 1)*15
      WRITE(BUFF,'(F15.4)') RM
      LINE1 = LINE1(1:IPCOL)//BUFF
      WRITE(BUFF,'(F15.4)')RS
      LINE2 = LINE2(1:IPCOL)//BUFF
C
      DO 728 I=ILS,ILE
      RLOG(I)=(RLOG(I)-RM)/RS
  728 CONTINUE
      RETURN
      END
      SUBROUTINE CLLOGS(I1STIM)
C
C     CLIP LOGS
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CHARACTER*80 LINE
      CHARACTER*9 BLANKS /'         '/
      CHARACTER*15 PARAM(4)/4*'               '/
      CHARACTER*2 OPTION
      CHARACTER*2 CODES(4)/'RC','MC','RS','MS'/
      LOGICAL ERROR
C          MAXIMUM VALUES FOR OPTIONAL DEFINITION BY THE USER.
      REAL RLMXNW(4)
      DATA RLMXNW/4*1.0E30/
C          DEFAULT MAXIMUM VALUES
      REAL RLMXC(4)
      COMMON/CLIPAR/ RLMXC
C          EXTREMES VALUES IN THE ORIGINAL LOGS.
      REAL RLMIN(4),RLMAX(4)
      COMMON/EXTRE/ RLMIN,RLMAX
C         FIND THE EXTREME LOG VALUES.
      IF( I1STIM .EQ. 0) THEN
         DO 101 I=1,4
         RLMIN(I)=+1.0E+30
         RLMAX(I)=-1.0E+30
  101    CONTINUE
         DO 102 I=1,IL1
         RLMIN(1)=AMIN1(RLOG1(I),RLMIN(1))
         RLMAX(1)=AMAX1(RLOG1(I),RLMAX(1))
  102    CONTINUE
         DO 103 I=1,IL2
         RLMIN(2)=AMIN1(RLOG2(I),RLMIN(2))
         RLMAX(2)=AMAX1(RLOG2(I),RLMAX(2))
  103    CONTINUE
         DO 104 I=1,IL3
         RLMIN(3)=AMIN1(RLOG3(I),RLMIN(3))
         RLMAX(3)=AMAX1(RLOG3(I),RLMAX(3))
  104    CONTINUE
         DO 105 I=1,IL4
         RLMIN(4)=AMIN1(RLOG4(I),RLMIN(4))
         RLMAX(4)=AMAX1(RLOG4(I),RLMAX(4))
  105    CONTINUE
         DO 106 I=1,4
         RLMXC(I)=RLMAX(I)
  106    CONTINUE
      END IF
C
   11 CALL MNMODE
      ERROR=.FALSE.
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'TRUNCATE HIGHEST WELL LOG VALUES')
      CALL TXTCLR(ICOLOR(5))
      CALL TXTCUR(3,4)
      WRITE (LINE,2001) RLMIN(3),RLMAX(3)
      CALL GTEXTX(LINE)
      CALL TXTCUR(3,5)
      WRITE (LINE,2002) RLMIN(1),RLMAX(1)
      CALL GTEXTX(LINE)
      CALL TXTCUR(3,6)
      WRITE (LINE,2003) RLMIN(4),RLMAX(4)
      CALL GTEXTX(LINE)
      CALL TXTCUR(3,7)
      WRITE (LINE,2004) RLMIN(2),RLMAX(2)
      CALL GTEXTX(LINE)
 2001 FORMAT ('ORIGINAL RANGE FOR REFERENCE SHALE LOG IS       ',
     1         F8.2,' TO ',F8.2)
 2002 FORMAT ('ORIGINAL RANGE FOR REFERENCE CORRELATION LOG IS ',
     1         F8.2,' TO ',F8.2)
 2003 FORMAT ('ORIGINAL RANGE FOR MATCHING SHALE LOG IS        ',
     1         F8.2,' TO ',F8.2)
 2004 FORMAT ('ORIGINAL RANGE FOR MATCHING CORRELATION LOG IS  ',
     1         F8.2,' TO ',F8.2)
C
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,10,'RS - TRUNCATE REFERENCE SHALE LOG AT')
      IF ( AMIN1(RLMXC(3),RLMXNW(3)) .LT. RLMAX(3))
     1 CALL TXTCLR(ICOLOR(6))
      CALL GTXTRL(60,10,AMIN1(RLMXC(3),RLMXNW(3)),2)
      IF ( AMIN1(RLMXC(3),RLMXNW(3)) .LT. RLMAX(3))
     1 CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,11,'RC - TRUNCATE REFERENCE CORRELATION LOG AT')
      IF ( AMIN1(RLMXC(1),RLMXNW(1)) .LT. RLMAX(1))
     1 CALL TXTCLR(ICOLOR(6))
      CALL GTXTRL(60,11,AMIN1(RLMXC(1),RLMXNW(1)),2)
      IF ( AMIN1(RLMXC(1),RLMXNW(1)) .LT. RLMAX(1))
     1 CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,12,'MS - TRUNCATE MATCHING SHALE LOG AT')
      IF ( AMIN1(RLMXC(4),RLMXNW(4)) .LT. RLMAX(4))
     1 CALL TXTCLR(ICOLOR(6))
      CALL GTXTRL(60,12,AMIN1(RLMXC(4),RLMXNW(4)),2)
      IF ( AMIN1(RLMXC(4),RLMXNW(4)) .LT. RLMAX(4))
     1 CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,13,'MC - TRUNCATE MATCHING CORRELATION LOG AT')
      IF ( AMIN1(RLMXC(2),RLMXNW(2)) .LT. RLMAX(2))
     1 CALL TXTCLR(ICOLOR(6))
      CALL GTXTRL(60,13,AMIN1(RLMXC(2),RLMXNW(2)),2)
      IF ( AMIN1(RLMXC(2),RLMXNW(2)) .LT. RLMAX(2))
     1 CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3,15,'RE - RETURN TO PREVIOUS MENU')
      CALL TXTCUR(3,18)
      CALL GTEXTS( 3,16,'GO - EXECUTE THE TRUNCATIONS')
C
      CALL TXTCLR(ICOLOR(4))
      CALL TXTCUR(3,18)
      CALL GTEXTX('PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,18)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF ( OPTION .EQ. 'GO') GO TO 51
      IF (OPTION .EQ. 'RE') RETURN
      DO 44 I = 1,4
      IF (OPTION .EQ. CODES(I)) THEN
         CALL AGETRL(RLMXNW(I),ERROR)
         IF (.NOT. ERROR) THEN
            IF ( RLMXNW(I) .GT. RLMXC(I) ) THEN
               CALL TXTCLR(ICOLOR(6))
               CALL GTEXTS(30,22,'***** THE NEW THRESHOLD CANNOT BE')
               CALL GTEXTS(36,23,'LARGER THAN THE OLD THRESHOLD')
               CALL SCHOLD
            END IF
            IF ( RLMXNW(I) .LE. RLMIN(I) ) THEN
               CALL TXTCLR(ICOLOR(6))
               CALL GTEXTS(30,22,'***** THE NEW THRESHOLD MUST BE')
               CALL GTEXTS(36,23,'LARGER THAN THE MINIMUM VALUE')
               CALL SCHOLD
            END IF
         END IF
      END IF
   44 CONTINUE
      GO TO 15
C         COMMIT THE CHANGES
   51 IF (RLMXNW(1) .LT. RLMAX(1)) THEN
         CALL CLIP(RLOG1,IL1,RLMXNW(1))
         RLMXC(1)=RLMXNW(1)
         WRITE(PARAM(1),'(5X,F10.2)') RLMXNW(1)
      ENDIF
      IF (RLMXNW(2) .LT. RLMAX(2)) THEN
         CALL CLIP(RLOG2,IL2,RLMXNW(2))
         RLMXC(2)=RLMXNW(2)
         WRITE(PARAM(2),'(5X,F10.2)') RLMXNW(2)
      ENDIF
      IF (RLMXNW(3) .LT. RLMAX(3)) THEN
         CALL CLIP(RLOG3,IL3,RLMXNW(3))
         RLMXC(3)=RLMXNW(3)
         WRITE(PARAM(3),'(5X,F10.2)') RLMXNW(3)
      ENDIF
      IF (RLMXNW(4) .LT. RLMAX(4)) THEN
         CALL CLIP(RLOG4,IL4,RLMXNW(4))
         RLMXC(4)=RLMXNW(4)
         WRITE(PARAM(4),'(5X,F10.2)') RLMXNW(4)
      ENDIF
      CALL ANMODE
      WRITE(QTEKOT,9001) BLANKS//PARAM(3)//PARAM(1)//PARAM(4)//PARAM(2)
 9001 FORMAT(///23X,'NEW MAXIMUM VALUES AFTER TRUNCATION'/
     1          23X,'***********************************'//
     2       17X,'REFERENCE WELL LOGS           MATCHING WELL LOGS'/
     3 11X,'      SHALE      CORRELATION        SHALE      CORRELATION'/
     4 11X,4(' --------------')//
     5     A69)
      CALL RETKEY
      I1STIM = 1
      GO TO 11
      END
C***********************************************************************
C
      SUBROUTINE CLIP(RLOG,IL,RLMAX)
C
C                    TRUNCATES HIGHEST WELL LOG VALUES.
C
C***********************************************************************
C
C         WELL LOG DATA.
C
      INCLUDE 'log.inc'
C
      REAL*4 RLOG(LOG_LENGTH)
C
      DO 714 I=1,IL
      IF (RLOG(I) .GT. RLMAX) RLOG(I)=RLMAX
  714 CONTINUE
      RETURN
      END
      SUBROUTINE RTLOGS(I1STIM)
C***********************************************************************
C
C**   REMOVE TREND FROM LOGS
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /RLOGS/ RLOG1(LOG_LENGTH),IL1,RLOG3(LOG_LENGTH),IL3,
     X               RLOG2(LOG_LENGTH),IL2,RLOG4(LOG_LENGTH),IL4
      COMMON /CODINC/ DINC
      COMMON /DIGS/ DIGS1,DIGS2
      COMMON /DIGZ12/ DIGZS1,DIGZS2
      COMMON /COLOPT/ ICOLOR(6)
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
C
      CHARACTER*80 LINE
      CHARACTER*3 STATUS(2)
      CHARACTER*2 OPTION,ANS
      CHARACTER*2 PODEG(4) /'P1','P2','P3','P4'/
      REAL*4 ZDIGR(2),ZDIGM(2)
      INTEGER*4 IREGN(4)
      LOGICAL ERROR
      DATA STATUS/'YES','NO '/
C
      IRSOPT=1
      IRCOPT=1
      IMSOPT=1
      IMCOPT=1
      DO 10 I = 1,4
   10 IREGN(I) =1
      ZDIGR(1) = DIGZS1
      ZDIGR(2) = DIGS1
      ZDIGM(1) = DIGZS2
      ZDIGM(2) = DIGS2
C
   11 CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'REMOVE TREND FROM LOGS')
      LINEC=2
      CALL STENDE(ZDIGR,ZDIGM,2,LINEC)
C
      CALL TXTCLR(ICOLOR(3))
      CALL TXTCUR(3,8)
      WRITE (LINE,2011) STATUS(IRSOPT)
 2011 FORMAT ('RS - REMOVE TREND FROM REFERENCE SHALE LOG',20X,A3)
      CALL GTEXTX(LINE)
      CALL TXTCUR(3,9)
      WRITE (LINE,2015) IREGN(1)
 2015 FORMAT ('P1 - POLYNOMIAL DEGREE FOR REFERENCE SHALE LOG',16X,I3)
      CALL GTEXTX(LINE)
C
      CALL TXTCUR(3,11)
      WRITE (LINE,2012) STATUS(IRCOPT)
 2012 FORMAT ('RC - REMOVE TREND FROM REFERENCE CORRELATION LOG',
     1        14X,A3)
      CALL GTEXTX(LINE)
      CALL TXTCUR(3,12)
      WRITE (LINE,2016) IREGN(2)
 2016 FORMAT ('P2 - POLYNOMIAL DEGREE FOR REFERENCE ',
     1        'CORRELATION LOG',10X,I3)
      CALL GTEXTX(LINE)
C
      CALL TXTCUR(3,14)
      WRITE (LINE,2013) STATUS(IMSOPT)
 2013 FORMAT ('MS - REMOVE TREND FROM MATCHING SHALE LOG',21X,A3)
      CALL GTEXTX(LINE)
      CALL TXTCUR(3,15)
      WRITE (LINE,2017) IREGN(3)
 2017 FORMAT ('P3 - POLYNOMIAL DEGREE FOR MATCHING SHALE LOG',17X,I3)
      CALL GTEXTX(LINE)
C
      CALL TXTCUR(3,17)
      WRITE (LINE,2014) STATUS(IMCOPT)
 2014 FORMAT ('MC - REMOVE TREND FROM MATCHING CORRELATION LOG',
     1        15X,A3)
      CALL GTEXTX(LINE)
      CALL TXTCUR(3,18)
      WRITE (LINE,2018) IREGN(4)
 2018 FORMAT ('P4 - POLYNOMIAL DEGREE FOR MATCHING ',
     1        'CORRELATION LOG',11X,I3)
      CALL GTEXTX(LINE)
C
      CALL TXTCUR(3,20)
      CALL GTEXTX('RE - RETURN TO PREVIOUS MENU')
      CALL TXTCUR(3,21)
      CALL GTEXTX('GO - REMOVE TRENDS')
C
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS(3,23,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,23)
   15 CALL AGETST(OPTION,2)
C
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN
      ITEST=IRSOPT+IRCOPT+IMSOPT+IMCOPT
      IF ((ITEST .LT. 8) .AND. (OPTION .EQ. 'GO')) GO TO 51
C
      IF (OPTION .EQ. 'RS') THEN
         CALL AGETST(ANS,2)
         IF (ANS .EQ. 'YE') IRSOPT=1
         IF (ANS .EQ. 'NO') IRSOPT=2
        ENDIF
      IF (OPTION .EQ. 'RC') THEN
         CALL AGETST(ANS,2)
         IF (ANS .EQ. 'YE') IRCOPT=1
         IF (ANS .EQ. 'NO') IRCOPT=2
        ENDIF
      IF (OPTION .EQ. 'MS') THEN
         CALL AGETST(ANS,2)
         IF (ANS .EQ. 'YE') IMSOPT=1
         IF (ANS .EQ. 'NO') IMSOPT=2
        ENDIF
      IF (OPTION .EQ. 'MC') THEN
         CALL AGETST(ANS,2)
         IF (ANS .EQ. 'YE') IMCOPT=1
         IF (ANS .EQ. 'NO') IMCOPT=2
        ENDIF
      DO 30 I = 1,4
      IF (OPTION .EQ. PODEG(I) ) THEN
         CALL AGETIN(IVAL,ERROR)
         IF (.NOT. ERROR) THEN
            IF ((IVAL .GE. 0) .AND. (IVAL .LT. 20)) IREGN(I)=IVAL
           ENDIF
        ENDIF
   30 CONTINUE
      GO TO 15
   51 I1STIM = 1
      CALL ANMODE
      IF( (IRSOPT+IRCOPT+IMSOPT+IMCOPT) . GT. 0) WRITE (QTEKOT,9001)
 9001 FORMAT(///25X,'PARAMETERS BEFORE REMOVING THE TREND'/
     1          25X,'************************************'//)
      IF (IRSOPT .EQ. 1) CALL RLTFL(RLOG3,IL3,DIGS1,DINC,IREGN(1),3)
      IF (IRCOPT .EQ. 1) CALL RLTFL(RLOG1,IL1,DIGS1,DINC,IREGN(2),1)
      IF (IMSOPT .EQ. 1) CALL RLTFL(RLOG4,IL4,DIGS2,DINC,IREGN(3),4)
      IF (IMCOPT .EQ. 1) CALL RLTFL(RLOG2,IL2,DIGS2,DINC,IREGN(4),2)
      CALL RETKEY
      RETURN
      END
C***********************************************************************
C
      SUBROUTINE RLTFL(RLOG,IL,DIGS,DINC,IREGN,ITYPE)
C
C          REMOVES TREND FROM LOGS.
C
C***********************************************************************
C
      INCLUDE 'log.inc'
C
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /DLOGSX/ D(LOG_LENGTH,5)
             REAL*8 D
C
      INTEGER*4 REGN
      REAL*4 RLOG(LOG_LENGTH)
      REAL*8 B(20,20)
      REAL*8 C(20)
      REAL*8 XP(20)
      REAL*8 XXP,YYP,SY,SSR,SST,R
      CHARACTER*25 TITLE(4) /'REFERENCE CORRELATION LOG',
     1                       'MATCHING CORRELATION  LOG',
     2                       '   REFERENCE SHALE LOG   ',
     3                       '   MATCHING  SHALE LOG   '/
C
      REGN = IREGN + 1
C          COEFFICIENT MATRIX.
      DO 101 I = 1,IL
         II = I
         D(I,1) = SEQDEP(II,DIGS,DINC)
         D(I,2) = RLOG(I)
  101  CONTINUE
      CALL SUMREG(D,B,C,XP,IL,REGN)
C          SOLVE THE SYSTEM OF EQUATIONS.
      CALL SLED(B,C,REGN,20,1.0D-35,IERR)
C          AVERAGE
      SY = 0.0D0
      DO 102 I = 1,IL
         SY = SY + D(I,2)
  102  CONTINUE
      SY = SY/IL
C          REMOVE TREND.
      SST = 0.0D0
      SSR = 0.0D0
      DO 143 I=1,IL
      XXP = 1.0D0
      YYP = 0.0D0
         DO  144 J = 1,REGN
            YYP = YYP + XXP*C(J)
            XXP = XXP*D(I,1)
  144      CONTINUE
      RLOG(I)=RLOG(I)-YYP
C          STATISTICAL ANALYSIS.
      SST = SST + (D(I,2) - SY)*(D(I,2) - SY)
      SSR = SSR + (YYP - SY)*(YYP - SY)
  143 CONTINUE
      R=DSQRT(SSR/SST)
C
      WRITE(QTEKOT,9002) TITLE(ITYPE)
      WRITE(QTEKOT,9004)
      CALL PRINTD(C,1,REGN,1,20)
      WRITE (QTEKOT,9001) IL,SSR,SST,R
      RETURN
 9001 FORMAT(//10X,'NUMBER OF SAMPLES                     : ',I9/
     3        10X,'SUMS OF SQUARES DUE TO REGRESSION     : ',G15.5/
     4        10X,'TOTAL SUMS OF SQUARES                 : ',G15.5/
     5        10X,'CORRELATION COEFFICIENT               : ',G15.5//)
9002  FORMAT(/25X,A25/25X,25('*')/)
9004  FORMAT(/10X,'COEFFICIENTS OF THE REGRESSION EQUATION')
      END
C***********************************************************************
C
C               CONVERTS UNIT OF LENGTH FLAG INTO A TITLE.
C
C***********************************************************************
C
      CHARACTER*4 FUNCTION BOMU(BOM)
C
      CHARACTER*1 BOM
C
         IF ( BOM .NE. 'M' ) THEN
            BOMU = 'FEET'
           ELSE
            BOMU = '  M '
         END IF
      RETURN
      END
C
      SUBROUTINE MARFIL(J1STIM)
C
C                  PREPARES A MARKER FILE.
C
C***********************************************************************
C
      CHARACTER*4 HEMA /'MARK'/
C
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
C            NUMBER OF ELEVATION TO TRACE ACROSS.
             INTEGER*4 NETRA
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            CORRELATION MATRIX COLUMN FOR TRACE STARTING.
             INTEGER*4 CTT
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
      COMMON /MAFICH/ PAR1,PAR5,PAR6
         CHARACTER*40 PAR1
         CHARACTER*10 PAR5
         CHARACTER*1 PAR6
      COMMON /MAFINUM/ PAR2,PAR3,PAR4,PAR7,PAR8,PAR9
         INTEGER*4 PAR2,PAR4,PAR8,PAR9
         REAL*4 PAR3,PAR7
C
C         READ PARAMETERS
C
   11 CALL OPMAFI(J1STIM,*900)
C
C         START A NEW FILE
C
      IF ( PAR2 .EQ. 1) THEN
         CALL OPEND(68,PAR1,-1,31)
         K = 0
         NSTT = 0
         WRITE (68,9000,REC=1) HEMA,SNSW,K,NSTT
       ELSE IF ( PAR2 .EQ. 2) THEN
         READ (68,9000,REC=1) HEMA,SNSW,K,NSTT
         WRITE (68,9000,REC=1) HEMA,SNSW,K+1,NSTT
         WRITE (68,9001,REC=K+2) PAR3,PAR4,PAR6,PAR5
       ELSE
         READ (68,9000,REC=1) HEMA,SNSW,K,NSTT
         WRITE (68,9000,REC=1) HEMA,SNSW,K,NSTT+1
         WRITE (68,9002,REC=K+2) NSTT+1
         WRITE (68,9003,REC=3+K+NSTT) PAR7,PAR8,PAR9
      END IF
      CALL RPMAFI
      CLOSE (68,STATUS='KEEP')
      IF (PAR2 .EQ. 1 ) PAR2 = 2
      GO TO 11
  900 RETURN
 9000 FORMAT (A4,11X,3I5)
 9001 FORMAT (F10.2,1X,I4,3X,A1,1X,A10)
 9002 FORMAT ('MODIFICATIONS',12X,I5)
 9003 FORMAT (F10.2,2(5X,I5))
      END
      SUBROUTINE OPMAFI(J1STIM,*)
C
C                   OPTIONS FOR COMMAND 'PM'.
C
C**********************************************************************
C
      include 'pen.inc'
C
      LOGICAL FLAG
      CHARACTER*1 ANS
      CHARACTER*2 OPTION
      CHARACTER*7 SOA(3) /'START','PRIMARY','MODIFY'/
      CHARACTER*4 HEMA 
      CHARACTER*4 BOMU
C
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*15 DATUM
C            LOG DATA FILE NAME AND WELL DATA FILE
             CHARACTER*40 FYLES
C            REFERENCE WELL NAME.
             CHARACTER*20 NAME1
C            MATCHING WELL NAME.
             CHARACTER*20 NAME2
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
         CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/  ICOLOR(6)
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
C            NUMBER OF ELEVATION TO TRACE ACROSS.
             INTEGER*4 NETRA
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            CORRELATION MATRIX COLUMN FOR TRACE STARTING.
             INTEGER*4 CTT
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
      COMMON /MAFICH/ PAR1,PAR5,PAR6
         CHARACTER*40 PAR1
         CHARACTER*10 PAR5
         CHARACTER*1 PAR6
      COMMON /MAFINUM/ PAR2,PAR3,PAR4,PAR7,PAR8,PAR9
         INTEGER*4 PAR2,PAR4,PAR8,PAR9
         REAL*4 PAR3,PAR7
      COMMON /CICKERR/ ICKERR
C
      LOGICAL ERROR
C
      IF (J1STIM .EQ. 0) THEN
         NETRA = 0
         SNSW = 1
         PAR1 = '*????*'
         PAR2 = 1
         PAR3 = 0.0
         PAR4 = 10
         PAR5 = '*????*'
         PAR6 = 'L'
         PAR7 = 0.0
         PAR8 = 1
         PAR9 = 1
         ICKERR = 3
      END IF
C
C        MENU
C
   11 FLAG = .FALSE.
      CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,'PREPARATION OF A MARKER FILE')
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3, 4,'FN - NAME OF THE MARKER FILE')
      CALL GTXTRJ(75, 4,PAR1)
      LINE = 4
      IF ( PAR1 .NE. '*????*' ) THEN
         IF (NSTT .EQ. 0) THEN
            IF (ICKERR .EQ. 0) THEN
               CALL GTEXTS( 3, 5,
     1    'SA - START A NEW FILE (S), ENTER PRIMARY INFORMATION (P),')
            CALL GTEXTS( 9, 6,
     1    'OR ENTER INFORMATION TO MODIFY PRIMARY TRACING (M)')
             ELSE
               CALL GTEXTS( 3, 5,'SA - START A NEW FILE (S)')
            END IF
          ELSE
            CALL GTEXTS( 3, 5,
     1         'SA - START A NEW FILE (S) OR ENTER INFORMATION')
            CALL GTEXTS( 9, 6, ' TO MODIFY PRIMARY TRACING (M)')      
         END IF
         CALL GTXTRJ(75, 5,SOA(PAR2))
         LINE = 7
         IF ( PAR2 .EQ. 1 ) THEN
            CALL GTEXTS( 3,7,
     1      'SN - SEQUENTIAL NUMBER FOR THE WELL TO START THE TRACING')
            CALL GTXTIN(75,7,SNSW)
            LINE = LINE + 1
          ELSE IF ( PAR2 .EQ. 2) THEN
            CALL GTEXTS( 3, 7,
     1  'DM - DEPTH TO THE MARKER, '//BOMU(BOM)//' BELOW '// DATUM)
            CALL GTXTRL(75, 7,PAR3,2)
           CALL GTEXTS( 3, 8,'PN - PEN NUMBER')
            CALL GTXTIN(75, 8,PAR4)
            CALL GTEXTS( 3,9,
     1                  'MP - PAINT CORRELATIONS BETWEEN MARKERS (P),')
            CALL GTEXTS( 8,10,'DRAW MARKER LINES (L), OR DO BOTH (B)')
            CALL GTXTRJ(75,9,PAR6)
            CALL GTEXTS( 3,11,'RM - UP TO A 10-CHARACTER REMARK')
            CALL GTXTRJ(75,11,PAR5)
            LINE = LINE + 5
          ELSE
            CALL GTEXTS( 3,LINE,
     1       'PO - SEQUENTIAL NUMBER FOR THE WELL PAIR TO OVERRIDE')
            CALL GTXTIN(75,LINE,PAR8)
            CALL GTEXTS( 3,LINE+1,
     1       'MO - SEQUENTIAL NUMBER FOR THE MARKER TO OVERRIDE')
            CALL GTXTIN(75,LINE+1,PAR9)
            CALL GTEXTS( 3, LINE+2,
     1  'DO - OVERRULING DEPTH,' // BOMU(BOM) // ' BELOW ' // DATUM)
            CALL GTXTRL(75, LINE+2,PAR7,2)
            LINE = LINE + 3
         END IF
      END IF
C
      CALL GTEXTS( 3,LINE+1,'RE - RETURN TO PREVIOUS MENU')
      IF ( PAR1 .NE. '*????*'  .AND.  (ICKERR .EQ. 0  .OR.
     1    (ICKERR .NE. 0   .AND.  PAR2 .EQ. 1)))
     2   CALL GTEXTS( 3,LINE+2,'GO - UPDATE THE MARKER FILE')
C
      LINE = LINE + 4
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN 1
C
      IF (PAR1 .NE. '*????*'  .AND.  (ICKERR .EQ. 0  .OR. 
     1    (ICKERR .NE. 0   .AND.  PAR2 .EQ. 1))  .AND.
     2     OPTION .EQ. 'GO') GO TO 51
C
      IF (OPTION .EQ. 'FN') THEN
         CALL AGETST(PAR1,40)
         CALL CHKOTY(68,PAR1,0,31,2,LINE+2,ICKERR)      ! 11/2002
         IF ( ICKERR .NE. 0 ) THEN
             GO TO 11
          ELSE
            READ (68,9000,REC=1) HEMA,SNSW,NETRA,NSTT
            IF (NSTT .NE. 0) THEN
               CALL TXTCLR(ICOLOR(6))
                CALL GTEXTS(10,LINE+4,'***** WARNING: '//
     1             'FILE ALREADY HAS INFORMATION TO MODIFY ZONES.')
               CALL SCHOLD
            END IF
         END IF
      END IF
      IF (OPTION .EQ. 'SA') THEN
         CALL AGETST(ANS,1)
         IF (ANS .EQ. 'S') PAR2 = 1
         IF (ANS .EQ. 'P') PAR2 = 2
         IF (ANS .EQ. 'M') PAR2 = 3
         IF (PAR2 .EQ. 1) PAR11 = 0
      END IF
      IF (OPTION .EQ. 'DM') CALL AGETRL(PAR3,ERROR)
      IF (OPTION .EQ. 'PN') CALL AGETIN(PAR4,ERROR)
      IF (OPTION .EQ. 'RM') CALL AGETTX(PAR5)
      IF (OPTION .EQ. 'MP') THEN
         CALL AGETTX(PAR6)
         IF (PAR6 .EQ. 'b') PAR6 = 'B'
         IF (PAR6 .EQ. 'l') PAR6 = 'L'
         IF (PAR6 .EQ. 'p') PAR6 = 'P'
      END IF
      IF (OPTION .EQ. 'SN') CALL AGETIN(SNSW,ERROR)
      IF (OPTION .EQ. 'DO') CALL AGETRL(PAR7,ERROR)
      IF (OPTION .EQ. 'PO') CALL AGETIN(PAR8,ERROR)
      IF (OPTION .EQ. 'MO') CALL AGETIN(PAR9,ERROR)
      GO TO 15
C
C          PARAMETER CHECKING.
C
   51 CALL TXTCLR(ICOLOR(6))
      IF (SNSW .LE. 0)  THEN
         CALL GTEXTS(15,LINE+2,
     1   '***** SEQUENTIAL WELL NUMBER TO START TRACING LESS THAN ONE.')
         FLAG = .TRUE.
         GO TO 800
      END IF
      IF (PAR2 .EQ. 2  .AND.  NSTT .GT. 0)  THEN
         CALL GTEXTS(10,LINE+2,
     1         '***** IT IS NOT ALLOWED TO ADD PRIMARY INFORMATION ')
         CALL GTEXTS(16,LINE+3,
     1         'TO A FILE WITH MODIFICATIONS.')
         FLAG = .TRUE.
         GO TO 800
      END IF
      IF ( PAR2 .EQ. 1 ) THEN
         CALL CHKOLF(68,PAR1,31,2,LINE+2,ICKERR,*11)
       ELSE
        CALL OPEND(68,PAR1,0,31)
         READ (68,9000,REC=1) HEMA,SNSW,NETRA,NSTT
         IF ( NETRA .GE. 201) THEN
            CALL GTEXTS(15,LINE+2,
     1       '***** THE MAXIMUM NUMBER OF MARKERS IS 201.')
            LINE = LINE + 1
            FLAG = .TRUE.
         END IF
        IF ( PAR2 .EQ. 2 ) THEN
         IF ( PAR4 .LT. 1 ) THEN
            CALL GTEXTS(15,LINE+2,
     1       '***** THE PEN NUMBER MUST BE LARGER THAN ZERO.')
            LINE = LINE + 1
            FLAG = .TRUE.
         END IF
         IF ( PAR4 .GT. NRGB ) THEN
            CALL GTEXTS(15,LINE+2,
     1       '***** THE PEN NUMBER CANNOT BE GREATER THAN   .')
            CALL GTXTIN(60,LINE+2,NRGB)
            LINE = LINE + 1
            FLAG = .TRUE.
         END IF
         IF (.NOT.( PAR6 .EQ. 'L'  .OR.   PAR6 .EQ. 'P'  .OR.
     1        PAR6 .EQ. 'P' )) THEN
            CALL GTEXTS(15,LINE+2,
     1       "***** DRAW OPTION MUST BE 'L', 'P', OR 'B'.")
            LINE = LINE + 1
            FLAG = .TRUE.
         END IF
         IF ( SNSW .LE. 0 ) THEN
            CALL GTEXTS(15,LINE+2,
     1   '***** SEQUENTIAL WELL NUMBER TO START TRACING LESS THAN ONE.')
            LINE = LINE + 1
            FLAG = .TRUE.
         END IF
       ELSE
            IF ( PAR2 .EQ. 3  .AND. NETRA .LE. 0 ) THEN
               CALL GTEXTS(15,LINE+2,
     1   '***** NO ZONES TO MODIFY')
            FLAG = .TRUE.
            GO TO 800
         END IF
         IF ( PAR2 .EQ. 3   .AND.  PAR8 .LE. 0 ) THEN
            CALL GTEXTS(15,LINE+2,
     1   '***** SEQUENTIAL PAIR NUMBER TO MODIFY LESS THAN ONE.')
            LINE = LINE + 1
            FLAG = .TRUE.
         END IF
          IF ( PAR2 .EQ. 3   .AND.  PAR8 .GT. 20 ) THEN
            CALL GTEXTS(15,LINE+2,
     1   '***** SEQUENTIAL PAIR NUMBER TO MODIFY LARGER THAN 20.')
            FLAG = .TRUE.
            LINE = LINE + 1
         END IF
          IF ( PAR2 .EQ. 3   .AND.  PAR9 .GT. NETRA ) THEN
            CALL GTEXTS(15,LINE+2,
     1   '***** MARKER TO OVERRIDE LARGER THAN'//
     1          ' NUMBER OF MARKERS TO TRACE.')
            FLAG = .TRUE.
         END IF
          IF ( PAR2 .EQ. 3   .AND.  PAR9 .LE. 0 ) THEN
            CALL GTEXTS(15,LINE+2,
     1   '***** ZONE TO OVERRIDE LESS THAN ZERO.')
            FLAG = .TRUE.
          END IF
       END IF
      END IF
  800 IF ( FLAG ) THEN
         CALL SCHOLD
         GO TO 11
      END IF
C
      J1STIM = 1
      RETURN
 9000 FORMAT (A4,11X,3I5)
      END
      SUBROUTINE RPMAFI
C
C                 DISPLAY CONTENT OF MARKER FILE.
C
C***********************************************************************
C
C
      CHARACTER*1 DRAWING
      CHARACTER*10 REMARK
      CHARACTER*4 BOMU
      CHARACTER*4 HEMA
C
      COMMON /MAFICH/ PAR1,PAR5,PAR6
         CHARACTER*40 PAR1
         CHARACTER*10 PAR5
         CHARACTER*1 PAR6
      COMMON /INTRA/ SNSW,NETRA,CTT,NSTT
C            NUMBER OF ELEVATION TO TRACE ACROSS.
             INTEGER*4 NETRA
C            SEQUENTIAL NUMBER FOR THE STARTING WELL.
             INTEGER*4 SNSW
C            CORRELATION MATRIX COLUMN FOR TRACE STARTING.
             INTEGER*4 CTT
C            NUMBER OF TRACED ELEVATIONS TO MODIFY
             INTEGER*4 NSTT
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
             INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
             CHARACTER*1 BOM,SCLSHL,SCLCOL
C
      CALL ANMODE
      READ (68,9000,REC=1) HEMA,SNSW,NMARK,NSTT
      WRITE (QTEKOT,9001) PAR1,SNSW,NMARK
      IF ( NMARK .EQ. 0 ) GO TO 999
      WRITE(QTEKOT,9002) BOMU(BOM)
      DO 100 I = 1,NMARK
      K = I
      READ(68,9003,REC=K+1) DEPTH, IPEN,DRAWING,REMARK
      WRITE(QTEKOT,9004) K,DEPTH,IPEN,DRAWING,REMARK
  100 CONTINUE
      IF (NSTT .EQ. 0) GO TO 999
      WRITE(QTEKOT,9005) NSTT, BOMU(BOM)
      DO 200 I = 1, NSTT
      K = 2 + I + NMARK
      READ(68,9007,REC=K) DEPTHM, MPAIR,MMARK
      WRITE(QTEKOT,9006) I,DEPTHM, MPAIR,MMARK
  200 CONTINUE
  999 CALL RETKEY
      RETURN
 9000 FORMAT (A4,11X,3I5)
 9001 FORMAT (///,34X,'MARKER FILE',/,
     1            34X,'***********',///,
     2        1X,'MARKER FILE NAME',22X,A40/
     3        1X,'SEQUENTIAL NUMBER FOR STARTING WELL',I4/
     4        1X,'NUMBER OF MARKERS IN THE FILE', 5X,I5////)
 9002 FORMAT(///30X,'DEPTH', 5X,'PEN',3X,'DRAWING',3X,'REMARKS'/
     1       31X,A4/
     2       26X,39('-'),/)
 9003 FORMAT (F10.2,1X,I4,3X,A1,1X,A10)
 9004 FORMAT (20X,I4,2X,F10.2,2X,I4,7X,A1,6X,A10)
 9005 FORMAT (//'TRACES TO BE OVERRIDDEN',12X,I5//
     1          30X,'DEPTH', 4X,'PAIR',3X,'MARKER'/
     2          31X,A4/
     3          26X,39('-'),/)
 9006 FORMAT (20X,I4,2X,F10.2,1X,I5,3X,I5)
 9007 FORMAT (F10.2,2(5X,I5))
      END
      SUBROUTINE ASTRAC(J1STIM)
C
C               PREPARES A FILE WITH INFORMATION TO
C               MAKE ANNOTATIONS IN A STRATIGRAPHIC COLUMN.
C
C*******************************************************************
C
      CHARACTER*1 LASTCHAR
      CHARACTER*4 HESC /'SCOL'/
      CHARACTER*40 RCH
C
      COMMON /STRACOLCH/ PAR1, PAR3, PAR4, PAR7
         CHARACTER*40 PAR1
         CHARACTER*40 PAR3
         CHARACTER*1 PAR4
         CHARACTER*1 PAR7
      COMMON /STRACOLNU/ PAR2, PAR5, PAR6
         INTEGER*4 PAR2, PAR5
         REAL*4 PAR6
      COMMON /STRATCOM/ SNAW
C            SEQUENTIAL NUMBER FOR THE WELL FOR WHICH
C            THE STRATIGRAPHIC COLUMN PERTAINS.
         INTEGER*4 SNAW
C
C         READ PARAMETERS
C
   11 CALL OPSTRAC(J1STIM,*900)
C
C         START A NEW FILE
C
      IF ( PAR2 .EQ. 1) THEN
         CALL OPEND(68,PAR1,-1,51)
         K = 0
         NUMREC = 1
         WRITE (68,9000,REC=1) HESC,SNAW,K,NUMREC
C
C        APPEND
C
       ELSE IF ( PAR2 .EQ. 2) THEN
         READ (68,9000,REC=1) HESC,SNAW,K,NUMREC
         WRITE (68,9000,REC=1) HESC,SNAW,K+1,NUMREC+1
         WRITE (68,9001,REC=NUMREC+1) PAR3,0,PAR5,PAR4
       ELSE IF ( PAR2 .EQ. 3) THEN
         READ (68,9000,REC=1) HESC,SNAW,K,NUMREC
         WRITE (68,9000,REC=1) HESC,SNAW,K,NUMREC+1
         DO 100 I = NUMREC,1,-1
         K = I
         READ (68,9003,REC=K) LASTCHAR
         IF ( LASTCHAR .EQ. 'H'  .OR.  LASTCHAR .EQ. 'V') THEN
            READ (68,9001,REC=K) RCH,NROW,LAN,PAR4
            IF (PAR4 .EQ. 'H' ) LAN = MAX0(LAN,PAR5)
            WRITE (68,9001,REC=K) RCH,NROW+1,LAN,PAR4
            GO TO 200
         END IF
  100    CONTINUE
  200    WRITE (68,9002,REC=NUMREC+1) PAR3,PAR6,PAR7
      END IF
      CALL RPSCOL
      CLOSE (68,STATUS='KEEP')
      IF (PAR2 .EQ. 2 ) PAR2 = 3
      IF (PAR2 .EQ. 1 ) PAR2 = 2
      GO TO 11
  900 RETURN
 9000 FORMAT (A4,31X,3I5)
 9001 FORMAT (A40,2I4,1X,1A1)
 9002 FORMAT (A40,F9.2,1A1)
 9003 FORMAT (49X,1A1)
      END
      SUBROUTINE OPSTRAC(J1STIM,*)
C
C                   OPTIONS FOR COMMAND 'PA'.
C
C**********************************************************************
C
      INCLUDE 'log.inc'
C
      LOGICAL ERROR
      LOGICAL FLAG
      LOGICAL DTFLAG
      INTEGER TITLEN
      CHARACTER*1 SOW
      CHARACTER*2 NUMAN
      CHARACTER*4 BOMU
      CHARACTER*1 ANS
      CHARACTER*1 LASTCHAR
      CHARACTER*2 OPTION
      CHARACTER*10 D1, D2
      CHARACTER*8 SOA(3) /'START','COLUMN', 'ANNOTATE'/
      COMMON /CHARH/   FYLES,DATUM,NAME1,NAME2
             CHARACTER*15 DATUM
C            LOG DATA FILE NAME AND WELL DATA FILE
             CHARACTER*40 FYLES
C            REFERENCE WELL NAME.
             CHARACTER*20 NAME1
C            MATCHING WELL NAME.
             CHARACTER*20 NAME2
      COMMON /USCAL/ BOM,SCLSHL,SCLCOL
         CHARACTER*1 BOM,SCLSHL,SCLCOL
      COMMON /COLOPT/  ICOLOR(6)
      COMMON /STRATCOM/ SNAW
C            SEQUENTIAL NUMBER FOR THE WELL FOR WHICH
C            THE STRATIGRAPHIC COLUMN PERTAINS.
         INTEGER*4 SNAW
      COMMON /STRACOLCH/ PAR1, PAR3, PAR4, PAR7
         CHARACTER*40 PAR1
         CHARACTER*40 PAR3
         CHARACTER*1 PAR4
         CHARACTER*1 PAR7
      COMMON /STRACOLNU/ PAR2, PAR5, PAR6
         INTEGER*4 PAR2, PAR5
         REAL*4 PAR6
C
      IF (J1STIM .EQ. 0) THEN
         PAR1 = '*????*'
         PAR2 = 1
         PAR3 = ' '
         PAR4 = 'H'
         PAR5 = 0
         PAR6 = 0.0
         PAR7 = 'S'
      END IF
C
C        MENU
C
   11 FLAG = .FALSE.
      DTFLAG = .TRUE.
      CALL MNMODE
      CALL TXTCLR(ICOLOR(2))
      CALL GTEXTC(40,2,
     1   'PREPARATION OF FILE WITH STRATIGRAPHIC COLUMN SUBDIVISIONS')
      CALL TXTCLR(ICOLOR(3))
      CALL GTEXTS( 3, 4,'FN - NAME OF THE SUBDIVISION FILE')
      CALL GTXTRJ(75, 4,PAR1)
      LINE = 4
      IF ( PAR1 .NE. '*????*' ) THEN
         CALL GTEXTS( 3, 5,
     1'SA - START A NEW FILE (S), ADD A COLUMN HEADING TO AN EXISTING')
         CALL GTXTRJ(75, 5,SOA(PAR2))
         CALL GTEXTS( 8, 6,
     1    'FILE (C) OR ANNOTATE LAST COLUMN OF AN EXISTING FILE (A)')
         LINE = 6
         IF ( PAR2 .EQ. 1 ) THEN
            CALL GTEXTS( 3,LINE+1,
     1  'SN - WELL SEQUENTIAL NUMBER FOR WHICH THE COLUMN APPLIES')
            CALL GTXTIN(75,LINE+1,SNAW)
            LINE = LINE + 1
          ELSE IF ( PAR2 .EQ. 2 ) THEN
            CALL GTEXTS( 3,LINE+1,
     1      'VH - ANNOTATION DISPLAY-HORIZONTAL(H) OR VERTICAL(V)')
            CALL GTXTRJ(75,LINE+1,PAR4)
            CALL GTEXTS( 3, LINE+2,
     1      'HD - UP TO A 40-CHARACTER COLUMN HEADING')
            CALL GTXTRJ(75, LINE+2,PAR3)
            LINE = LINE + 2
          ELSE IF ( PAR2 .EQ. 3 ) THEN
            CALL GTEXTS( 3, LINE+1,
     1           'DT - DEPTH TO TOP OF INTERVAL, ' // BOMU(BOM) //
     2           ' BELOW ' // DATUM  // ',')
            CALL GTXTRL(75, LINE+1,PAR6,2)
            CALL GTEXTS( 8, LINE+2,
     1           'FROM SHALLOWEST TO DEEPEST')
            CALL GTEXTS( 3,LINE+3,
     1      'LT - TYPE OF LINE FOR TOP-STRAIGHT(S) OR WEAVY(W)')
            CALL GTXTRJ(75,LINE+3,PAR7)
            CALL GTEXTS( 3, LINE+4,
     1      'AN - UP TO A 40-CHARACTER ANNOTATION')
            CALL GTXTRJ(75, LINE+4,PAR3)
            LINE = LINE +4
         END IF
      END IF
C
      CALL GTEXTS( 3,LINE+2,'RE - RETURN TO PREVIOUS MENU')
      IF ( .NOT.((PAR1 .EQ. '*????*') .OR. (PAR1 .EQ. ' '))  )
     1   CALL GTEXTS( 3,LINE+3,'GO - UPDATE THE FILE')
C
      LINE = LINE + 5
      CALL TXTCLR(ICOLOR(4))
      CALL GTEXTS( 3,LINE,'PLEASE ENTER YOUR SELECTIONS:')
      CALL AINPUT(33,LINE)
   15 CALL AGETST(OPTION,2)
      IF (OPTION .EQ. '  ') GO TO 11
C
      IF (OPTION .EQ. 'RE') RETURN 1
C
      IF (.NOT.((PAR1 .EQ. '*????*') .OR. (PAR1 .EQ. ' '))  .AND. 
     1                (OPTION .EQ. 'GO')) GO TO 51
C
C           PARAMETER READING
C
      IF (OPTION .EQ. 'FN') CALL AGETST(PAR1,40)
      IF (OPTION .EQ. 'SA') THEN
         CALL AGETST(ANS,1)
         IF (ANS .EQ. 'S') PAR2 = 1
         IF (ANS .EQ. 'C') PAR2 = 2
         IF (ANS .EQ. 'A') PAR2 = 3
      ENDIF
      IF (OPTION .EQ. 'HD'   .OR. OPTION .EQ. 'AN') THEN
         CALL AGETTX(PAR3)
         PAR5 = TITLEN(PAR3)
      END IF
      IF (OPTION .EQ. 'VH') CALL AGETST(PAR4,1)
      IF (OPTION .EQ. 'SN') CALL AGETIN(SNAW,ERROR)
      IF (OPTION .EQ. 'DT') CALL AGETRL(PAR6,ERROR)
      IF (OPTION .EQ. 'LT') CALL AGETST(PAR7,1)
      GO TO 15
C
C          PARAMETER CHECKING.
C
   51 CALL TXTCLR(ICOLOR(6))
      IF ( PAR2 .NE. 1 ) THEN
         CALL CHKOTY(68,PAR1,0,51,8,LINE+2,ICKERR)
         IF ( ICKERR .NE. 0 ) GO TO 11
      END IF
      IF ( PAR2 .EQ. 2 ) THEN
         IF (PAR4 .EQ. 'h' .OR. PAR4 .EQ. 'H') THEN           
            PAR4 = 'H'                                       
          ELSE IF (PAR4 .EQ. 'v' .OR. PAR4 .EQ. 'V') THEN      
            PAR4 = 'V'                                       
          ELSE                                               
            CALL GTEXTS(15,LINE+2,                          
     1               '***** HV MUST BE H OR V.')         
            LINE = LINE + 1                                 
            FLAG = .TRUE.
         END IF 
       ELSE IF ( PAR2 .EQ. 3 ) THEN
         READ (68,9000,REC=1) NUMREC
         DO 70 I = NUMREC,2,-1
         K = I
         READ (68,9003,REC=K) LASTCHAR
         IF ( LASTCHAR .EQ. 'H'  .OR.  LASTCHAR .EQ. 'V') THEN
             READ (68,9001,REC=K) NROW
             GO TO 80
         END IF
   70    CONTINUE
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** THERE IS NO COLUMN HEADING.')
            FLAG = .TRUE.
            GO TO 90
   80    IF ( NROW .GE. ANNOT_LENGTH ) THEN
            WRITE(NUMAN,'(I2)') ANNOT_LENGTH
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(5,LINE+2,
     1   '***** MODIFY FILE log.inc TO MAKE MORE THAN '  //
     2    NUMAN // ' ANNOTATIONS PER COLUMN.')
            FLAG = .TRUE.
            LINE = LINE + 1  
         END IF   
         IF (PAR7 .EQ. 's' .OR. PAR7 .EQ. 'S') THEN           
            PAR7 = 'S'                                       
          ELSE IF (PAR7 .EQ. 'w' .OR. PAR7 .EQ. 'W') THEN      
            PAR7 = 'W'                                       
          ELSE                                               
            CALL GTEXTS(15,LINE+2,                          
     1               '***** LT MUST BE S OR W.')         
            LINE = LINE + 1                                 
            FLAG = .TRUE.
         END IF 
         IF ( PAR6 .LT. -99999.99 ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** DEPTH TOO SMALL.')
            FLAG = .TRUE.
            LINE = LINE + 1  
         END IF
          IF ( PAR6 .GT. 999999.99 ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+2,
     1   '***** DEPTH TOO LARGE.')
            FLAG = .TRUE.
            LINE = LINE + 1  
         END IF
         READ (68,9002,REC=NUMREC) PDEPTH, SOW
         IF ( SOW .EQ. 'S'  .OR. SOW .EQ. 'W' ) THEN 
            IF ( PAR6 .LT. PDEPTH) THEN
               WRITE(D1,'(F10.2)') PAR6
               WRITE(D2,'(F10.2)') PDEPTH
  111          CALL TXTCLR(ICOLOR(6))
               CALL GTEXTS(15,LINE+2,
     1       '***** WARNING:  DEPTH ' // D1 // ' SHALLOWER THAN ')
               CALL GTEXTS(20,LINE+3,
     1     ' PREVIOUS DEPTH OF '  // D2 // ' ' // BOMU(BOM) // '.')
               CALL GTEXTS(21,LINE+5,
     1           'RE -- IGNORE THE VALUE.')
               CALL GTEXTS(21,LINE+6,
     1           'GO -- KEEP THE VALUE')
               CALL GTEXTS(21,LINE+8,
     1           'PLEASE ENTER YOUR SELECTIONS:')
               CALL AINPUT(51,LINE+8)
  151          CALL AGETST(OPTION,2)
               IF (OPTION .EQ. '  ') GO TO 111
               IF (OPTION .EQ. 'RE') GO TO 11
               IF (OPTION .EQ. 'GO') THEN
                  DTFLAG = .FALSE.
                  GO TO 90
               END IF
               GO TO 151
            END IF
         END IF
      ELSE
         CALL CHKOLF(68,PAR1,51,8,LINE+2,ICKERR,*11) 
         IF ( SNAW .LE. 0 ) THEN
            CALL TXTCLR(ICOLOR(6))
            CALL GTEXTS(15,LINE+10,
     1   '***** SEQUENTIAL WELL NUMBER LESS THAN ONE.')
            FLAG = .TRUE.
            LINE = LINE + 1  
         END IF
      END IF
   90 IF ( FLAG ) THEN
         IF ( DTFLAG ) CALL SCHOLD
         GO TO 11
      END IF
C
      J1STIM = 1
      RETURN
 9000 FORMAT (45X,I5)
 9001 FORMAT (40X,I4)
 9002 FORMAT (40X,F9.0,1A1)
 9003 FORMAT (49X,1A1)
      END
      INTEGER FUNCTION TITLEN(TITLE)
C
C                 ACTUAL LENGTH OF A TITLE NOT COUNTING TRAILING BLANKS.
C
C     INTEGER*4 TITLEN
      CHARACTER*(*) TITLE
C
      DO 100 I = LEN(TITLE),1,-1
      TITLEN = I
      IF ( TITLE(I:I) .NE. ' ') GO TO 200
  100 CONTINUE
      TITLEN = 0
  200 RETURN
      END
      SUBROUTINE RPSCOL
C
C               SCREEN PRINTING OF REPORT FOR COMMAND 'PA'.
C
C*******************************************************************
C
      CHARACTER*1 HOV
      CHARACTER*4 HESC
      CHARACTER*40 TIT
      INTEGER*4 SNAW
      CHARACTER*10 HOVCHA(2) /'HORIZONTAL', 'VERTICAL'/
      CHARACTER*8 LINETYP(2) /'STRAIGHT', 'WEAVY'/
      COMMON /UNITNM/ QTEKIN,QTEKOT,ITERMQ
      INTEGER QTEKIN,QTEKOT,ITERMQ
      COMMON /STRACOLCH/ PAR1, PAR3, PAR4, PAR7
         CHARACTER*40 PAR1
         CHARACTER*40 PAR3
         CHARACTER*1 PAR4
         CHARACTER*1 PAR7
C
      CALL ANMODE
      READ (68,9000,REC=1) HESC,SNAW,NK,NUMREC
      WRITE (QTEKOT,9001) PAR1,SNAW,NK,NUMREC
      IF ( NK .EQ. 0 ) GO TO 999
      K = 2
      DO 150 I = 1,NK
      READ(68,9002,REC=K) TIT,NROW,LAN,HOV
      IF ( HOV .EQ. 'H' ) THEN
         IHOV = 1
       ELSE
         IHOV = 2
      END IF
      WRITE (QTEKOT,9003) TIT,HOVCHA(IHOV),NROW,LAN
      K = K + 1
      IF ( NROW .GT. 0 ) THEN
         WRITE (QTEKOT,9006)
         DO 100 II = 1,NROW
         READ(68,9004,REC=K) TIT,DEPTH,HOV
         IF ( HOV .EQ. 'S' ) THEN
            ILT = 1
          ELSE
            ILT = 2
         END IF
         WRITE (QTEKOT,9005) TIT,DEPTH,LINETYP(ILT)
         K = K + 1
  100    CONTINUE
      END IF
  150 CONTINUE
C
  999 CALL RETKEY
      RETURN
 9000 FORMAT (A4,31X,3I5)
 9001 FORMAT (///,25X,'STRATIGRAPHIC COLUMN SUBDIVISION FILE',/,
     1            25X,'*************************************',///,
     2        1X,'FILE NAME',31X,A40/
     3        1X,'SEQUENTIAL NUMBER FOR ANNOTATED WELL',1X,I4/
     4        1X,'NUMBER OF COLUMNS IN THE ANNOTATION', 2X,I4/
     5        1X,'NUMBER OF RECORDS IN THE FILE', 8X,I4/)
 9002 FORMAT (A40,2I4,1X,1A1)
 9003 FORMAT (//8X,'COLUMN HEADING',30X,A40/
     1        8X,'ORIENTATION OF ANNOTATIONS',18X, A10/
     2        8X,'NUMBER OF ANNOTATIONS',21X,I4/
     3        8X,'NUMBER OF CHARACTERS IN WIDEST ANNOTATION',1X,I4/)
 9004 FORMAT (A40,F9.2,1A1)
 9005 FORMAT (5X,A40,1X,F9.2,1X,1A8)
 9006 FORMAT ( 20X,'ANNOTATIONS',18X,'DEPTH',4X,'LINE'/
     5        5X,59('-'))
      END
